program funkt3d;
{$E+}{$N+}
uses crt,dos,dreid,init3d,vga;
const erstesmal:boolean=true;
var ein:char;
    oldex:pointer;
const fx1:string='Sin(x)*cos(y)';
      fx2:string='x/10';
      fx3:string='y/10';
      fx4:string='fx1';
      xmax:real=10;
      ymax:real=10;
      xmin:real=-10;
      ymin:real=-10;
      x:byte=20;
      y:byte=20;
      gesaved:boolean=true;

{$I BERECHNE.INC}
{$I MISCHE.INC}

procedure putcolor(x,y:word;c:real);
var z:real;
begin
  with _wrkarr.m[x]^[y] do begin
    z:=round((c+1)*127.5);
    a.c.r:=(cos(z / 40)   *31+32)/63;
    a.c.g:=(cos((z+ 84) / 40)   *31+32)/63;
    a.c.b:=(cos((z+168) / 40)   *31+32)/63;
  end;
end;

procedure funk3d(n1,n2:byte;xmin,ymin,xmax,ymax:real;fx1,fx2,fx3,fx4:string);
var p:vertex;
    x,y:byte;
    xdist,ydist,xf,yf,xfd,yfd:real;
begin
  _wrkarr.volume.x:=1;
  _wrkarr.volume.y:=1;
  _wrkarr.volume.z:=1;
  _wrkarr.xmax:=n1;
  _wrkarr.ymax:=n2;
  xf:=xmin;
  xfd:=(xmax-xmin) / n1;
  yfd:=(ymax-ymin) / n2;
  p.nrm.x:=0;p.nrm.y:=0;p.nrm.z:=1;
  for x:=0 to n1 do begin
    yf:=ymin;
    for y:=0 to n2 do begin
      p.crd.x:=berechne(fx1,xf,yf);
      p.crd.y:=berechne(fx2,xf,yf);
      p.crd.z:=berechne(fx3,xf,yf);
      putinmesh(x,y,p.crd,p.nrm);
      if ((upcase(fx4[1])='F') and (upcase(fx4[2])='X')) then begin
        case fx4[3] of
          '1':putcolor(x,y,p.crd.x);
          '2':putcolor(x,y,p.crd.y);
          '3':putcolor(x,y,p.crd.z);
          else error('Fehler in fx4:'+fx4);
        end;
      end else putcolor(x,y,berechne(fx4,xf,yf));
      yf:=yf+yfd;
    end;
    xf:=xf+xfd;
  end;
  norm(flaeche);
end;

procedure funktionseingabe(var f:string;fun:char);
var falt:string;
begin
  writeln;
  textcolor(lightmagenta);
  if f<>'' then writeln('Alte Funktion: fx'+fun+'(x,y): '+f);
  falt:=f;
  textcolor(yellow);
  writeln('Gebe die Funktion fx'+fun+'(x,y) ein (maximal 255 Zeichen lang) !');
  writeln('Dabei darf man Konstanten und folgende Zeichen verwenden:');
  writeln('SIN( ) COS( ) TAN( ) LN( ) EXP( ) SQRT( ) SQR() SGN() ABS( ) ARCTAN( ) FRAC( )');
  writeln('TRUNC( )');
  writeln('+ - * / ({[]}) X Y PI E');
  textcolor(lightgreen);
  readln(f);
  if upcase(f[1])='Q' then error('');
  if (f='') and (falt<>'') then begin
    gotoxy(1,pred(wherey));
    writeln(falt);
    f:=falt;
  end;
end;

procedure sichereebene(name:namestr);
var f:text;
    suche:searchrec;
begin
  assign(f,name+'.EBN');
  rewrite(f);
    writeln(f,fx1);
    writeln(f,fx2);
    writeln(f,fx3);
    writeln(f,fx4);
    writeln(f,xmax:6:3);
    writeln(f,ymax:6:3);
    writeln(f,xmin:6:3);
    writeln(f,ymin:6:3);
    writeln(f,x);
    writeln(f,y);
    writeln(f,VRP.x:6:3);
    writeln(f,VRP.y:6:3);
    writeln(f,VRP.z:6:3);
    writeln(f,NRP.x:6:3);
    writeln(f,NRP.y:6:3);
    writeln(f,NRP.z:6:3);
    writeln(f,VUP.x:6:3);
    writeln(f,VUP.y:6:3);
    writeln(f,VUP.z:6:3);
    writeln(f,xmin :6:3);
    writeln(f,ymin :6:3);
    writeln(f,xsize:6:3);
    writeln(f,VPD  :6:3);
    writeln(f,FPD  :6:3);
    writeln(f,BPD  :6:3);
  close(f);
end;

procedure ladeebene(name:namestr);
var f:text;
    suche:searchrec;
begin
  findfirst(name+'.EBN',$3f,suche);
  if doserror<>0 then begin
    writeln(name+'.EBN nicht gefunden !');
    repeat until keypressed;
    halt(1);
  end;
  assign(f,name+'.EBN');
  reset(f);
  readln(f,fx1);
  readln(f,fx2);
  readln(f,fx3);
  readln(f,fx4);
  readln(f,xmax);
  readln(f,ymax);
  readln(f,xmin);
  readln(f,ymin);
  readln(f,x);
  readln(f,y);
  readln(f,VRP.x);
  readln(f,VRP.y);
  readln(f,VRP.z);
  readln(f,NRP.x);
  readln(f,NRP.y);
  readln(f,NRP.z);
  readln(f,VUP.x);
  readln(f,VUP.y);
  readln(f,VUP.z);
  readln(f,xmin );
  readln(f,ymin );
  readln(f,xsize);
  readln(f,VPD  );
  readln(f,FPD  );
  readln(f,BPD  );
  close(f);
end;

procedure laden;
var name:namestr;
    suche:searchrec;
begin
  suche.name:='*.EBN';
  findfirst('*.EBN',$3f,suche);
  while (doserror=0) do begin
    write(suche.name:20);
    findnext(suche);
  end;
  writeln;
  write('Geben Sie den Bilddateinamen ein (ohne Extension) : ');
  readln(name);
  if name<>'' then ladeebene(name);
end;

procedure sichern;
var name:namestr;
begin
  gesaved:=true;
  write('Wie soll die Ebene heien (ohne Erweiterung) ? ');
  readln(name);
  sichereebene(name);
end;

{$F+}
procedure ownex;
begin
  if not gesaved then begin
    writeln('Die Ebene ist nicht gesichert. Sichern ? [J/N]');
    repeat
      ein:=upcase(readkey);
    until (ein='J') or (ein='N');
    if ein='J' then sichern;
  end;
end;
{$F-}

begin
  oldex:=exitproc;
  exitproc:=@ownex;
  flipareaenabled:=true;
  vup.x:=1;vup.y:=0;vup.z:=0;
  nrp.x:=3;nrp.y:=1;nrp.z:=1;
  repeat
    textbackground(blue);
    textcolor(yellow);
    clrscr;
    writeln('*** Ebenen im 4 Dimensionalen Raum ***':50);
    writeln;
    textcolor(yellow);
    write('1) x1=fx1(x,y) = ');
    textcolor(lightmagenta);
    writeln(fx1);
    textcolor(yellow);
    write('2) x2=fx2(x,y) = ');
    textcolor(lightmagenta);
    writeln(fx2);
    textcolor(yellow);
    write('3) x3=fx3(x,y) = ');
    textcolor(lightmagenta);
    writeln(fx3);
    textcolor(yellow);
    write('4) Farbe=fx4(x,y) = ');
    textcolor(lightmagenta);
    writeln(fx4);
    textcolor(yellow);
    write('5) Xmin = ');
    textcolor(lightmagenta);
    writeln(xmin:6:3);
    textcolor(yellow);
    write('6) Xmax = ');
    textcolor(lightmagenta);
    writeln(xmax:6:3);
    textcolor(yellow);
    write('7) Ymin = ');
    textcolor(lightmagenta);
    writeln(ymin:6:3);
    textcolor(yellow);
    write('8) Ymax = ');
    textcolor(lightmagenta);
    writeln(ymax:6:3);
    textcolor(yellow);
    write('9) Xanz = ');
    textcolor(lightmagenta);
    writeln(x);
    textcolor(yellow);
    write('0) Yanz = ');
    textcolor(lightmagenta);
    writeln(y);
    textcolor(yellow);
    writeln('A) Transformationsdaten');
    writeln('B) Anzeigen');
    writeln('C) Laden');
    writeln('D) Speichern');
    writeln('E) Ende');
    writeln;
    repeat
      ein:=upcase(readkey);
    until ein in['0'..'E'];
    gesaved:=gesaved and (ein in['A'..'E']);
    case ein of
    '1':funktionseingabe(fx1,'1');
    '2':funktionseingabe(fx2,'2');
    '3':funktionseingabe(fx3,'3');
    '4':funktionseingabe(fx4,'4');
    '5':xmin:=getreal(xmin,'xmin: ');
    '6':xmax:=getreal(xmax,'xmax: ');
    '7':ymin:=getreal(ymin,'ymin: ');
    '8':ymax:=getreal(ymax,'ymax: ');
    '9':repeat
          write('Gebe die Anzahl der Punkte in x-Richtung ein (2-',succ(maxpnts),') :');
          readln(x);
        until (x>1) and (x<=succ(maxpnts));
     '0':repeat
           write('Gebe die Anzahl der Punkte in y-Richtung ein (2-',succ(maxpnts),') :');
           readln(y);
         until (y>1) and (y<=succ(maxpnts));
    'A':maske;
    'B':begin
          writeln('Ich berechne die Funktion und die Normalen !');
          funk3d(pred(x),pred(y),xmin,ymin,xmax,ymax,fx1,fx2,fx3,fx4);
          grafikbegin;
          if erstesmal then begin
            addambls(0,true,1,1,1);
            addinfls(1,true,2,2,2,-1,-1,-1);
            changesurfaceproperty(0.5,0.5,0,1,1,1,15,1,1,1,0);
          end;
          erstesmal:=false;
          while dolocalinit do begin
            pushtrafs;
            mesh;
            poptrafs;
          end;
          write(^G);
          if name<>'' then savebild;
          repeat until keypressed;
          while keypressed do ein:=readkey;
          grafikende;
        end;
      'C':laden;
      'D':sichern;
    end;
  until ein='E';
end.