program getobt;
{$M 16000,0,0}
uses crt,dos,vga;
var oldint:pointer;
    name:pathstr;
const nummer:char='A';
      int=$05;
      rotation:byte=0;
      zeronotused:boolean=true;

  procedure saveobjekt(dx,dy:word;gx,gy:byte;name:pathstr);
  var objektfile:file;
      palette:TPalette;
      x,y:byte;
      notused:byte;
      nr:word;
      hilfb:byte;
  const s1:single=1;

     procedure schreibepixel;
     begin
       blockwrite(objektfile,palette[getpixel(dx+x,dy+y)],3);
     end;

     procedure schreibeNotUsed;
     begin
       if getpixel(dx+x,dy+y)=$F
       then notused:=notused+($80 shr (nr mod 8));
       if (nr mod 8)=7
       then begin
         blockwrite(objektfile,notused,1);
         notused:=0;
       end;
       inc(nr);
     end;

  begin
    if zeronotused then hilfb:=16+128 else hilfb:=16;
    assign(objektfile,name+'.OBT');
    rewrite(objektfile,1);
    if ioresult<>0 then write(^G) else begin
      farbblocklesen(0,256,Ppalette(@palette));
      for x:=0 to 255 do for y:=0 to 2 do palette[x,y]:=palette[x,y]*4;
      blockwrite(objektfile,hilfb,1);
      case rotation of
        0,2:begin
          blockwrite(objektfile,gx,1);
          blockwrite(objektfile,gy,1);
        end else begin
          blockwrite(objektfile,gy,1);
          blockwrite(objektfile,gx,1);
        end;
      end;
      blockwrite(objektfile,s1,4);
      blockwrite(objektfile,s1,4);
      blockwrite(objektfile,s1,4);
      case rotation of
        0:for y:=0 to gy do for x:=0 to gx do schreibepixel;
        1:for x:=0 to gx do for y:=0 to gy do schreibepixel;
        2:for y:=gy downto 0 do for x:=gx downto 0 do schreibepixel;
        3:for x:=gx downto 0 do for y:=gy downto 0 do schreibepixel;
      end;
      if zeronotused then begin
        notused:=0;
        nr:=0;
        case rotation of
          0:for y:=0 to gy do for x:=0 to gx do SchreibeNotUsed;
          1:for x:=0 to gx do for y:=0 to gy do SchreibeNotUsed;
          2:for y:=gy downto 0 do for x:=gx downto 0 do SchreibeNotUsed;
          3:for x:=gx downto 0 do for y:=gy downto 0 do SchreibeNotUsed;
        end;
        for x:=1 to 7 do schreibenotused;{Restliche Bits fllen und schreiben}
      end;
      close(objektfile);
    end;
  end;

  procedure neuint;interrupt;
  const dx:word=140;
        dy:word=75;
        gx:byte=50;
        gy:byte=50;
        modus:boolean=true;
  var dxalt,dyalt,hx,hy:word;
      ein:char;
      gxalt,gyalt,n:byte;

    procedure ramen(dx,dy:word;gx,gy:byte;seite:byte);
    var x,y:byte;

      procedure xorput(x,y:word;atrib:byte);
      begin
        plot(x,y,getpixel(x,y) xor atrib);
      end;

    begin
      for x:=0 to gx do if seite=0 then xorput(x+dx,dy,$F) else xorput(x+dx,dy,$FF);
      for x:=0 to gx do if seite=2 then xorput(x+dx,dy+gy,$F) else xorput(x+dx,dy+gy,$FF);
      for x:=1 to pred(gy) do if seite=1 then xorput(dx,x+dy,$F) else xorput(dx,x+dy,$FF);
      for x:=1 to pred(gy) do if seite=3 then xorput(dx+gx,x+dy,$F) else xorput(dx+gx,x+dy,$FF);
    end;

    procedure tasteauswerten(ein:char;var x,y:word;x1,y1,x2,y2:word);
    begin
      case ein of
        #71,#72,#73:if y>y1 then dec(y);
        #79,#80,#81:if y<y2 then inc(y);
      end;
      case ein of
        #71,#75,#79:if x>x1 then dec(x);
        #73,#77,#81:if x<x2 then inc(x);
      end;
      case ein of
        #55,#56,#57:if y>y1+9 then dec(y,10);
        #49,#50,#51:if y<y2-9 then inc(y,10);
      end;
      case ein of
        #55,#52,#49:if x>x1+9 then dec(x,10);
        #57,#54,#51:if x<x2-9 then inc(x,10);
      end;
    end;

  begin
    repeat
      ramen(dx,dy,gx,gy,rotation);
      dxalt:=dx; dyalt:=dy;
      gxalt:=gx; gyalt:=gy;
      repeat until keypressed;
      while keypressed do ein:=upcase(readkey);
      if modus then tasteauswerten(ein,dx,dy,0,0,269,149) else begin
        hx:=gx;hy:=gy;
        tasteauswerten(ein,hx,hy,1,1,50,50);
        gx:=hx;gy:=hy;
      end;
      ramen(dxalt,dyalt,gxalt,gyalt,rotation);
      if (ein=' ') then begin
        modus:=not modus;
        write(^G);
      end else
      if (ein='R') then begin
        inc(rotation); if rotation>3 then rotation:=0;
        for n:=0 to rotation do begin
          write(^G);
          delay(100);
        end;
      end;
    until (ein=#13) or (ein=#27);
    if ein=#13 then begin
      saveobjekt(dx,dy,gx,gy,name+nummer);
      inc(nummer);
    end;
  end;

  procedure getname;
  var dir:dirstr;
      na:namestr;
      ext:extstr;
  begin
    fsplit(paramstr(1),dir,na,ext);
    name:=dir+copy(na,1,7);
    zeronotused:=paramcount=1;
  end;


{  VAR N:WORD;}

  procedure anleitung;
  begin
    writeln('Wenn Sie einen Bildschirmausschnitt abfotografieren wollen,');
    writeln('drcken Sie PRINT SCREEN, whlen mit den CURSOR Tasten (SHIFT+CURSOR Tasten)');
    writeln('den Ausschnitt bzw die Gre des Ausschnitts. Zwischen diesen beiden Modi');
    writeln('schalten Sie mit SPACE um. Rotieren mit R.');
    writeln('Zum Schlu drcken Sie ENTER oder ESC.');
  end;

begin
  if paramcount=0 then begin
    writeln('Dieses Programm dient dazu Texturen aus Bildern im 320*200*256 Modus in eine');
    writeln('*.OBT-Datei zu speichern. Rufen Sie es folgendermaen auf:');
    writeln('  GETTEX Name [Alles speichern]');
    writeln('Wird kein zweiter Parameter angegeben, so gilt die Farbe mit dem Paletten-');
    writeln('eintrag $F(=16.Farbe) als nicht genutztes Pixel');
    writeln('GETTEX gibt dann wieder an DOS zurck.');
    writeln('Um es zu deinstallieren geben Sie im DOS EXIT ein.');
    anleitung;
  end else begin
    getname;
    if paramcount>1 then writeln('Alle Pixel werden als benutzt gespeichert')
    else writeln('Alle Pixel der Farbe $F werden als unbenutzt gespeichert');
    writeln('Tippen Sie EXIT<Ľ um das Programm ganz zu verlassen');
    anleitung;
    {videomodus($13);
    randomize;
    for n:=1 to 1000 do plot(random(320),random(200),random(256));
    neuint;}
    swapvectors;
    getintvec(int,oldint);
    setintvec(int,@neuint);
    Exec(GetEnv('COMSPEC'),'');
    setintvec(int,oldint);
    swapvectors;
    writeln('Sie haben ',byte(nummer)-65,' Texturen in die Dateien ');
    writeln(name+'?.OBT abfotografiert!');
    writeln('GETTEX ist nun nicht mehr resident.');
  end;
end.