unit inter;
interface
uses crt,dos,graph,dreid,objekte,lampen,rotation,write3d,obtfast
     {fak3d,fakobjek,faklampe,fakrotat,fakwrite,fakobt};

procedure interpretiere(datname:pathstr;start:word);
procedure transdaten(datname:pathstr);
const koordinaten:boolean=false;
      xz:boolean=false;
      YZ:boolean=false;
      XY:boolean=false;
      gesamt:boolean=false;
      interaktiv:boolean=false;
      eingabemaus:boolean=false;
      eingabejoystick:boolean=false;
      variablenanzeigen:boolean=false;
      mass:real=3;
var varreal:array[65..90] of real;

implementation
const r:real=1;
      g:real=1;
      b:real=1;
      gleichezeileweiter:boolean=false;
var befehl,argumente:string;
    f:text;
    riss:umrisstyp;
    zeile:word;
    cliplevel:byte;
    varint:array[65..90] of integer;
    lampen1,lampen2:byte;
    lampev1,lampev2,lampev3:single;
    lampe:boolean;

procedure zeilenerror(s:string);
var buf:string[4];
begin
  str(zeile,buf);
  error(s+' in Zeile '+buf);
end;

{$I BERECHNE.INC}

function id(bef,s:string):boolean;
var gleich:boolean;
    n,k:byte;
begin
  gleich:=true;
  while (' '=bef[length(bef)]) do delete(bef,length(bef),1);
  K:=length(bef);
  if k=0 then k:=1;
  n:=length(s);
  if n<k then k:=n;
  n:=1;
  repeat
    bef[n]:=upcase(bef[n]);
    case bef[n] of
      '':bef[n]:='';
      '':bef[n]:='';
      '':bef[n]:='';
    end;
    gleich:=gleich and (s[n]=bef[n]);
    inc(n);
  until (not gleich) or (n>k);
  id:=gleich;
end;

function gleich(bef,s:string):boolean;
var glei:boolean;
    n,k:byte;
begin
  glei:=true;
  while (' '=bef[length(bef)]) do delete(bef,length(bef),1);
  K:=length(bef);
  n:=length(s);
  if n<>k then begin
    gleich:=false;
    exit;
  end;
  n:=1;
  repeat
    bef[n]:=upcase(bef[n]);
    case bef[n] of
      '':bef[n]:='';
      '':bef[n]:='';
      '':bef[n]:='';
    end;
    glei:=glei and (s[n]=bef[n]);
    inc(n);
  until (not glei) or (n>k);
  gleich:=glei;
end;

function calculate(s:string):real;
var buf,hilf:string;
    intzahl:boolean;
    n:byte;
    funk:shortint;

  procedure datevar(nr:byte);
  var date:array[0..3] of word;
  begin
    funk:=-1;
    getdate(date[0],date[1],date[2],date[3]);
    str(date[nr]:4,buf);
    while pos(' ',buf)=1 do delete(buf,1,1);
    hilf:=hilf+buf;
  end;

  procedure timevar(nr:byte);
  var time:array[0..3] of word;
  begin
    funk:=-1;
    gettime(time[0],time[1],time[2],time[3]);
    str(time[nr]:2,buf);
    while pos(' ',buf)=1 do delete(buf,1,1);
    hilf:=hilf+buf;
  end;

  procedure setvar(v:single);
  begin
    funk:=-1;
    str(v:10,buf);
    while pos(' ',buf)=1 do delete(buf,1,1);
    hilf:=hilf+buf;
  end;

  function getmcwc(nr:byte):single;
  begin
    getmcwc:=mc_wc[0][succ(nr)]/mc_wc[0][0];
  end;

begin
  hilf:='';
  if pos(' ',s)<>0 then s:=copy(s,1,pred(pos(' ',s)));
  intzahl:=false;
  for n:=1 to length(s) do begin
    if (s[n]<>'$') and ((upcase(s[n])<'A') or (upcase(s[n])>'Z')) then hilf:=hilf+s[n] else begin
      if s[n]='$' then intzahl:=true else begin
        if intzahl then setvar(varint[byte(upcase(s[n]))])
        else begin
          funk:=0;
          if pos('(',copy(s,n,succ(length(s)-n)))<>0 then begin
            buf:=copy(s,n,pred(pos('(',copy(s,n,succ(length(s)-n)))));
            if ((length(buf)=2) and gleich(buf,'LN')) or
               ((length(buf)=3) and ((gleich(buf,'EXP') or
               gleich(buf,'SIN') or gleich(buf,'COS') or
               gleich(buf,'TAN') or gleich(buf,'COT') or
               gleich(buf,'ABS') or gleich(buf,'SGN') or
               gleich(buf,'SQR'))) or
               ((length(buf)=4) and (gleich(buf,'SQRT') or
               gleich(buf,'FRAC'))) or
               ((length(buf)=5) and (gleich(buf,'TRUNC') or gleich(buf,'ROUND'))) or
               ((length(buf)=6) and gleich(buf,'ARCTAN'))) then funk:=length(buf);
          end else if gleich(copy(s,n,2),'PI') then funk:=2 else
          if gleich(copy(s,n,3),'RND') then funk:=3 else
          if gleich(copy(s,n,3),'TAG') then begin datevar(0); inc(n,2); end else
          if gleich(copy(s,n,5),'MONAT') then begin datevar(1); inc(n,4); end else
          if gleich(copy(s,n,4),'JAHR') then begin datevar(2); inc(n,3); end else
          if gleich(copy(s,n,6),'STUNDE') then begin timevar(0); inc(n,5); end else
          if gleich(copy(s,n,6),'MINUTE') then begin timevar(1); inc(n,5); end else
          if gleich(copy(s,n,7),'SEKUNDE') then begin timevar(2); inc(n,6); end else
          if gleich(copy(s,n,5),'MESHX') then begin setvar(_wrkarr.xmax); inc(n,4); end else
          if gleich(copy(s,n,5),'MESHY') then begin setvar(_wrkarr.ymax); inc(n,4); end else
          if gleich(copy(s,n,3),'MCX') then begin setvar(getmcwc(0)); inc(n,2); end else
          if gleich(copy(s,n,3),'MCY') then begin setvar(getmcwc(1)); inc(n,2); end else
          if gleich(copy(s,n,3),'MCZ') then begin setvar(getmcwc(2)); inc(n,2); end;
          if funk>=0 then begin
            if funk=0 then begin
              str(varreal[byte(upcase(s[n]))]:10:8,buf);
              while pos(' ',buf)=1 do delete(buf,1,1);
              hilf:=hilf+buf;
            end else begin
              hilf:=hilf+copy(s,n,funk);
              inc(n,pred(funk));
            end;
          end;
        end;
        intzahl:=false;
      end;
    end
  end;
  calculate:=berechne(hilf,0,0);
end;

function zahl:integer;
var h,err:integer;
    hilf:string[6];
begin
  while pos(' ',argumente)=1 do delete(argumente,1,1);
  argumente:=argumente+' ';
  val(copy(argumente,1,pred(pos(' ',argumente))),h,err);
  if err<>0 then zahl:=round(calculate(argumente)) else zahl:=h;
  delete(argumente,1,pos(' ',argumente));
end;

function realzahl:real;
var h:real;
    err:integer;
begin
  while pos(' ',argumente)=1 do delete(argumente,1,1);
  argumente:=argumente+' ';
  val(copy(argumente,1,pred(pos(' ',argumente))),h,err);
  if err<>0 then realzahl:=calculate(argumente) else realzahl:=h;
  delete(argumente,1,pos(' ',argumente));
end;

procedure upword(var tex:string);
var n:byte;
begin
  for n:=1 to length(tex) do begin
    tex[n]:=upcase(tex[n]);
    case tex[n] of
      '':tex[n]:='';
      '':tex[n]:='';
      '':tex[n]:='';
    end;
  end;
end;

procedure lesezeile;
begin
  while pos(' ',argumente)=1 do delete(argumente,1,1);
  if length(argumente)<>0 then befehl:=argumente else begin
    readln(f,befehl);
    inc(zeile);
  end;
  while pos(' ',befehl)=1 do delete(befehl,1,1);
  argumente:=befehl;
  argumente:=argumente+' ';
  delete(argumente,1,pos(' ',argumente));
  befehl:=befehl+' ';
  delete(befehl,pos(' ',befehl),length(befehl)-pos(' ',befehl));
end;

procedure delarg(n:byte);
var z:byte;
begin
  z:=0;
  argumente:=argumente+' ';
  repeat
    while (' '=argumente[1]) and (length(argumente)>0) do delete(argumente,1,1);
    if (length(argumente)>0) then delete(argumente,1,pos(' ',argumente));
    inc(z);
  until (z=n) or (length(argumente)=0);
end;

procedure deltext;
var s:byte;
begin
  s:=pos('"',argumente);
  if s<>0 then delete(argumente,1,s) else zeilenerror('Kein "');
  s:=pos('"',argumente);
  if s<>0 then delete(argumente,1,s) else zeilenerror('Kein 2. "');
end;

function getstring(n:byte):string;
var buf:string;
begin
  argumente:=argumente+' ';
  while ' '=argumente[1] do delete(argumente,1,1);
  if (length(argumente)>0) then begin
    buf:=copy(argumente,1,pred(pos(' ',argumente)));
    delete(argumente,1,pos(' ',argumente));
  end else zeilenerror('Textargument fehlt');
  getstring:=copy(buf,1,n);
end;

procedure transdaten(datname:pathstr);
var ende:boolean;
    r:real;
    suche:searchrec;
    hilf:string[6];
    n:byte;
begin
  argumente:='';
  koordinaten:=false;
  lampe:=false;
  findfirst(datname+'.WIZ',$3f,suche);
  if doserror=0 then begin
    assign(f,datname+'.WIZ');
    reset(f);
    zeile:=0;
    ende:=false;
    while not (eof(f) or ende) do begin
      lesezeile;
      if keypressed and (not interaktiv) then begin
        str(zeile:6,hilf);
        error('Unterbrochen in Zeile '+hilf+':'+befehl+argumente+':(Transdaten)');
      end;
      if id(befehl,'{') then begin
        repeat
          lesezeile;
        until (pos('}',befehl)<>0) or (pos('}',argumente)<>0) or eof(f);
        if eof(f) then zeilenerror('Bemerkungsklammer { nicht geschlossen ');
        argumente:='';
      end else if not (
         id(befehl,':')  or 
         id(befehl,'WRFEL') or (befehl=' ') or id(befehl,'POPTRAFS') or
         id(befehl,'PUSHTRAFS') or id(befehl,'RETURN') or id(befehl,'MESH') or
         id(befehl,'ENDCLIPBOX') or id(befehl,'LICHT') or 
         id(befehl,'LINIE') or id(befehl,'ANFANGCLIPBOX') or id(befehl,'MESH'))
      then if (id(befehl,'COLOR') or id(befehl,'PAL') or
               id(befehl,'LADEROTATIONSKRPER') or
               id(befehl,'ZIEHKRPER') or id(befehl,'LADESCHRIFT') or
               id(befehl,'NORMIEREN') or id(befehl,'LET') or id(befehl,'SHIFTL') or
               id(befehl,'SHIFTR') or id(befehl,'$SHIFTL') or id(befehl,'$SHIFTR'))
           then delarg(1)
      else if (id(befehl,'LADEOBJEKT') or id(befehl,'ROTIEREN') or
               id(befehl,'KUGEL') or id(befehl,'SULE') or id(befehl,'EBENE') or
               id(befehl,'NOTUSED') or id(befehl,'EXTENSIONS') or id(befehl,'TON') or
               id(befehl,'SULE') or id(befehl,'ROTATIONSKRPER'))
           then delarg(2)
      else if (id(befehl,'UMGEBUNGSLICHT') or id(befehl,'VERGRERN') or
               id(befehl,'VERSCHIEBEN') or id(befehl,'ZYLINDER')) then delarg(3)
      else if (id(befehl,'TORUS') or id(befehl,'GESCHWINDIGKEIT'))
           then delarg(4)
      else if (id(befehl,'TEXTUR')) then delarg(5)
      else if (id(befehl,'SONNENLICHT')) then delarg(6)
      else if (id(befehl,'SCHREIBE')) then begin
        delText;
        delarg(6);
      end else if (id(befehl,'GLHLAMPE') or id(befehl,'SCHACHBRETT') or
               id(befehl,'PUTINMESH')) then delarg(8)
      else if (id(befehl,'DREIECK')) then delarg(9)
      else if (id(befehl,'OBERFLCHE')) then delarg(11)
      else if (id(befehl,'VIERECK')) then delarg(12)
      else if (id(befehl,'SPOT')) then delarg(13)
      else if (id(befehl,'PARAM')) then delarg(25)
      else if (id(befehl,'GOSUB') or id(befehl,'GOTO') or
               id(befehl,'CLIPGOSUB')) then argumente:=''
      else if id(befehl,'IF') then argumente:=''
      else if id(befehl,'KOORDINATEN') then
        koordinaten:=true
      else if pos(';',befehl)<>0 then
        argumente:=''
      else if id(befehl,'ZX') then begin
        mass:=realzahl;
        xz:=true
      end else if id(befehl,'YZ') then begin
        mass:=realzahl;
        YZ:=true
      end else if id(befehl,'XY') then begin
        mass:=realzahl;
        XY:=true
      end else if id(befehl,'GESAMTPLAN') then begin
        mass:=realzahl;
        gesamt:=true
      end else if id(befehl,'SCHWARZWEI') then begin
        farbig:=farbebw64;
        for n:=0 to 3 do begin
          greytab[n].r:=zahl;greytab[n].g:=zahl;greytab[n].b:=zahl;
        end;
      end else if id(befehl,'SW256') then farbig:=farbebw256
      else if id(befehl,'RAM') then begin
        grafmode:=-1;
        ram:=true;
        Truecolor:=false;
        Magic:=false;
        _xmaxglobal:=pred(zahl);
        _ymaxglobal:=pred(zahl);
      end else if id(befehl,'MAGICPICTURE') then begin
        grafmode:=-1;
        ram:=true;
        Truecolor:=false;
        Magic:=true;
        _xmaxglobal:=pred(zahl);
        _ymaxglobal:=pred(zahl);
      end else if id(befehl,'TRUECOLOR') then begin
        grafmode:=-1;
        ram:=false;
        truecolor:=true;
        _xmaxglobal:=pred(zahl);
        _ymaxglobal:=pred(zahl);
      end else if id(befehl,'FARBIG') then farbig:=farbergb
      else if id(befehl,'INTERAKTIV') then begin
        interaktiv:=true;
        hilf:=getstring(4);
        eingabemaus:=id(hilf,'MAUS') or id(hilf,'JOYMAUS');
        eingabejoystick:=id(hilf,'JOYSTICK') or id(hilf,'JOYMAUS');
        variablenanzeigen:=id(getstring(5),'DATEN');
      end else if id(befehl,'XSIZE') then
        xsize:=realzahl
      else if id(befehl,'XMIN') then
        xmin:=realzahl
      else if id(befehl,'YMIN') then
        ymin:=realzahl
      else if id(befehl,'STANDPUNKT') then begin
        NRP.X:=realzahl;NRP.Y:=realzahl;NRP.Z:=realzahl;
      end else if id(befehl,'BLICKPUNKT') then begin
        VRP.X:=realzahl;VRP.y:=realzahl;VRP.z:=realzahl;
      end else if id(befehl,'ACHSENRICHTUNG') then begin
        VUP.X:=realzahl;VUP.y:=realzahl;VUP.z:=realzahl;
      end else if id(befehl,'BILDDATEI') then begin
        name:=getstring(8);
      end else if id(befehl,'ABSTAND') then
        vpd:=realzahl
      else if id(befehl,'FPD') then
        FPD:=realzahl
      else if id(befehl,'BPD') then
        bpd:=realzahl
      else if id(befehl,'RCKFLCHEN') then
        flipareaenabled:=true
      else if id(befehl,'3D-BRILLE') then begin
        brille:=true;
        augendist:=realzahl;
      end else if id(befehl,'RAHMEN') then
        frame:=true
      else if id(befehl,'LAMPEN') then begin
        lampe:=true;
        lampen1:=zahl;lampen2:=zahl;
        lampev1:=realzahl;lampev2:=realzahl;lampev3:=realzahl;
      end else if id(befehl,'HINTERGRUND') then
        backgroundcolor(realzahl,realzahl,realzahl)
      else if id(befehl,'NEBEL') then
        setnebel(realzahl,realzahl,realzahl,realzahl)
      else if id(befehl,'CLIPWRFEL') then
        clipcube:=true
      else if id(befehl,'SCQ') then grafmode:=-2
      else if id(befehl,'IBM') then grafmode:=-1
      else if id(befehl,'DRAHTGITTER') then grafmode:=0
      else if id(befehl,'ENDE') then ende:=true
      else begin
        str(zeile,hilf);
        error('Unbekannter Befehl in Zeile '+hilf+':'+befehl+': (Transdaten)');
      end;
    end;
    close(f);
    if byte(koordinaten)+byte(XZ)+byte(YZ)+byte(XY)+byte(gesamt)>1 then
     zeilenerror('Es knnen nicht mehrere Ansichten gleichzeitig dargestellt werden');
  end else error('Ich konnte '+name+'.WIZ nicht laden !');
  if XZ or YZ or XY or gesamt then grafmode:=0;
  if interaktiv then grafmode:=1;
  wireframe:=grafmode>=0;
  if not (ram or Truecolor) then wireframe:=wireframe or (not VGAvorhanden);
  if wireframe and (grafmode<0) then grafmode:=0;
end;

procedure interpretiere(datname:pathstr;start:word);
var ende:boolean;
    n,hilfzeile:word;
    suche:searchrec;
    h,v:byte;
    hilf:string[6];
    a,e:vct3;
    x,y:byte;
    p:vertex;

  procedure findesprung;
  begin
    n:=pos(' ',argumente);
    if n<>0 then argumente:=copy(argumente,1,n) else begin
      argumente:=argumente;
      argumente:='';
    end;
    upword(argumente);
    argumente:=':'+argumente;
    close(f);
    reset(f);
    n:=0;
    repeat
      readln(f,befehl);
      inc(n);
      while pos(' ',befehl)=1 do delete(befehl,1,1);
      if pos(' ',befehl)<>0 then
       befehl:=copy(befehl,1,pred(pos(' ',befehl)));
    until eof(f) or id(befehl,argumente);
    if eof(f) then zeilenerror('Label '+argumente+' nicht gefunden (Interpretiere)');
    argumente:='';
  end;

  procedure ifinter;
  var entsch:boolean;
      a,b:real;
      l,art,elsepos:byte;
      tex:string;
  begin
    l:=1;
    while (not (argumente[l] in ['=','>','<'])) and (l<length(argumente)) do inc(l);
    if l=length(argumente) then zeilenerror('< > = <> >= <= erwartet');
    tex:=copy(argumente,1,pred(l));
    a:=calculate(tex);
    delete(argumente,1,pred(l));
    if argumente[1]='>' then art:=1 else
    if argumente[1]='<' then art:=2 else
    if argumente[1]='=' then art:=3;
    if argumente[2]='>' then art:=4 else
    if argumente[2]='=' then inc(art,4);
    delete(argumente,1,1);
    if art>=4 then delete(argumente,1,1);
    while pos(' ',argumente)=1 do delete(argumente,1,1);
    tex:=copy(argumente,1,pos(' ',argumente));
    b:=calculate(tex);
    delete(argumente,1,pos(' ',argumente));
    while pos(' ',argumente)=1 do delete(argumente,1,1);
    case art of
      1:entsch:=a>b;
      2:entsch:=a<b;
      4:entsch:=a<>b;
      5:entsch:=a>=b;
      6:entsch:=a<=b;
      else entsch:=a=b;
    end;
    upword(argumente);
    elsepos:=pos('ELSE',argumente);
    if elsepos<>0 then begin
      if entsch then argumente:=copy(argumente,1,pred(elsepos))
      else argumente:=copy(argumente,elsepos+4,length(argumente)-elsepos-3);
    end else begin
      if not entsch then argumente:='';
    end;
  end;

  procedure letinter;
  var intzahl:boolean;
      nummer:byte;
  begin
    intzahl:=argumente[1]='$';
    if intzahl then delete(argumente,1,1);
    nummer:=byte(upcase(argumente[1]));
    if (nummer>byte('Z')) or (nummer<byte('A'))
    then zeilenerror('Fehlerhafte Variable');
    delete(argumente,1,pos('=',argumente));
    while pos(' ',argumente)=1 do delete(argumente,1,1);
    if intzahl then
      varint[nummer]:=round(calculate(copy(argumente,1,pos(' ',argumente))))
    else varreal[nummer]:=calculate(copy(argumente,1,pos(' ',argumente)));
    delete(argumente,1,pos(' ',argumente));
  end;

  procedure schreibeinter;
  var tex,tex2:string;
      buf:string[10];
      mark1,mark2:byte;
  begin
    delete(argumente,1,pos('"',argumente));
    tex:=copy(argumente,1,pred(pos('"',argumente)));
    delete(argumente,1,pos('"',argumente));
    mark1:=pos('+''',tex);
    tex2:='';
    n:=1;
    while (n<length(tex)) and (mark1<>0) do begin
      tex[mark1]:=' ';
      if mark1-n>0 then tex2:=tex2+copy(tex,n,mark1-n);
      mark2:=pos('''+',tex);
      tex[mark2]:=' ';
      str(calculate(copy(tex,mark1+2,mark2-mark1-2)):10:0,buf);
      while pos(' ',buf)<>0 do delete(buf,pos(' ',buf),1);
      tex2:=tex2+buf;
      n:=mark2+2;
      mark1:=pos('+''',tex);
    end;
    if n<length(tex) then tex2:=tex2+copy(tex,n,succ(length(tex)-n));
    schreibe3d(tex2,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl);
  end;

  procedure ladeobtinter;
  var name:string[8];
  begin
    h:=zahl;
    name:=getstring(8);
    if ((loadobjekt(name,h) and h)=0) then begin
      str(zeile,hilf);
      error('Ich konnte '+name+'.OBT in Zeile '+hilf+' nicht laden (Interpretiere) !');
    end;
  end;

  procedure gosubinter;
  begin
    findesprung;
    close(f);
    hilfzeile:=zeile;
    interpretiere(datname,n);
    assign(f,datname+'.WIZ');
    reset(f);
    start:=0;
    zeile:=0;
    while hilfzeile<>zeile do begin
      readln(f,befehl);
      inc(zeile);
    end;
  end;

begin
  argumente:='';
  if (start=0) and (not interaktiv) then begin
    fillchar(varint,sizeof(varint),#0);
    fillchar(varreal,sizeof(varreal),#0);
  end;
  findfirst(datname+'.WIZ',$3f,suche);
  if doserror=0 then begin
    assign(f,datname+'.WIZ');
    reset(f);
    zeile:=0;
    while start<>zeile do begin
      inc(zeile);
      readln(f,befehl);
    end;
    ende:=false;
    while not (eof(f) or ende) do begin
      lesezeile;
      if keypressed and (not interaktiv) then begin
        str(zeile:6,hilf);
        error('Unterbrochen in Zeile '+hilf+':'+befehl+argumente+':(Interpretiere)');
      end;
      if ram or truecolor then writeln(befehl,argumente);
      if id(befehl,'{') then begin
        repeat
          lesezeile;
        until (pos('}',befehl)<>0) or (pos('}',argumente)<>0) or eof(f);
        if eof(f) then zeilenerror('Bemerkungsklammer { nicht geschlossen');
        argumente:='';
      end else if (id(befehl,'INTERAKTIV') or id(befehl,'TRUECOLOR') or
         id(befehl,'RAM') or id(befehl,'MAGICPICTURE')) then delarg(2)
      else if not (id(befehl,':') or (befehl=' ') or
         id(befehl,'KOORDINATEN') or id(befehl,'FARBIG') or
         id(befehl,'RCKFLCHEN') or id(befehl,'RAHMEN') or
         id(befehl,'CLIPWRFEL') or id(befehl,'SCQ') or id(befehl,'IBM') or
         id(befehl,'DRAHTGITTER') or
         id(befehl,'SW256'))
      then if (id(befehl,'XY') or id(befehl,'ZX') or id(befehl,'YZ') or
          id(befehl,'XSIZE') or id(befehl,'XMIN') or id(befehl,'YMIN') or
          id(befehl,'ABSTAND') or id(befehl,'FPD') or id(befehl,'BPD')  or
          id(befehl,'BILDDATEI') or
          id(befehl,'GESAMTPLAN') or id(befehl,'3D-BRILLE'))
          then delarg(1)
      else if (id(befehl,'STANDPUNKT') or id(befehl,'BLICKPUNKT') or
         id(befehl,'ACHSENRICHTUNG') or id(befehl,'HINTERGRUND'))
         then delarg(3)
      else if id(befehl,'NEBEL') then delarg(4)
      else if id(befehl,'LAMPEN') then delarg(5)
      else if (id(befehl,'SCHWARZWEI')) then delarg(12)
      else if pos(';',befehl)<>0 then
        argumente:=''
      else if id(befehl,'UMGEBUNGSLICHT') then
        addambls(succ(maxls),true,realzahl,realzahl,realzahl)
      else if id(befehl,'ANFANGCLIPBOX') then begin
        defineclipvolume(realzahl,realzahl,realzahl,r,g,b);
        cliplevel:=1;
        if clipmode=outside then begin
          repeat
            readln(f,befehl);
            inc(zeile);
            if id(befehl,'ENDCLIPBOX') then dec(cliplevel) else
             if id(befehl,'ANFANGCLIPBOX') then inc(cliplevel);
          until (cliplevel=0) or eof(f);
          if eof(f) then zeilenerror('Mehr ClipBoxen geffnet als geschlossen');
        end;
      end else if id(befehl,'ENDCLIPBOX') then undefclipvolume
      else if id(befehl,'LICHT') then setzelichter
      else if id(befehl,'SONNENLICHT') then
        addinfls(succ(maxls),true,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl)
      else if id(befehl,'GLHLAMPE') then
        addposls(succ(maxls),true,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl)
      else if id(befehl,'SPOT') then
        addsptls(succ(maxls),true,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl,
                 realzahl,realzahl,realzahl)
      else if id(befehl,'GESCHWINDIGKEIT') then
        changespeed(realzahl,realzahl,realzahl,realzahl)
      else if id(befehl,'PUSHTRAFS') then pushtrafs
      else if id(befehl,'POPTRAFS') then poptrafs
      else if id(befehl,'VERGRERN') then
        scale(realzahl,realzahl,realzahl)
      else if id(befehl,'VERSCHIEBEN') then
        translate(realzahl,realzahl,realzahl)
      else if id(befehl,'ROTIEREN') then
        rotate(zahl,realzahl)
      else if id(befehl,'GESCHWINDIGKEIT') then
        changespeed(realzahl,realzahl,realzahl,realzahl)
      else if id(befehl,'WRFEL') then
        wuerfel(r,g,b)
      else if id(befehl,'KUGEL') then
        kugel(zahl,zahl,r,g,b)
      else if id(befehl,'EBENE') then
        ebene(zahl,zahl,r,g,b)
      else if id(befehl,'TORUS') then
        torus(realzahl,realzahl,zahl,zahl,r,g,b)
      else if id(befehl,'PUTINMESH') then begin
        x:=zahl;y:=zahl;
        p.crd.x:=realzahl;p.crd.y:=realzahl;p.crd.z:=realzahl;
        p.nrm.x:=realzahl;p.nrm.y:=realzahl;p.nrm.z:=realzahl;
        putinmesh(x,y,p.crd,p.nrm)
      end else if id(befehl,'NOTUSED') then
        putnotused(zahl,zahl)
      else if id(befehl,'EXTENSIONS') then
        meshextensions(zahl,zahl)
      else if id(befehl,'MESH') then
        mesh
      else if id(befehl,'PAL') then
        aktgrey:=64*zahl
      else if id(befehl,'NORMIEREN') then begin
        norm(id(getstring(6),'FLCHE'))
      end else if id(befehl,'COLOR') then begin
        if wireframe then setcolor(zahl) else delarg(1)
      end else if id(befehl,'SHIFTL') then begin
        x:=zahl;
        for y:=x to 25 do varreal[y+byte('A')]:=varreal[y-x+byte('A')];
      end else if id(befehl,'SHIFTR') then begin
        x:=zahl;
        for y:=25-x downto 0 do varreal[y+x+byte('A')]:=varreal[y+byte('A')];
        for y:=0 to pred(x) do varreal[y+byte('A')]:=0;
      end else if id(befehl,'$SHIFTL') then begin
        x:=zahl;
        for y:=x to 25 do varint[y+byte('A')]:=varint[y-x+byte('A')];
      end else if id(befehl,'$SHIFTR') then begin
        x:=zahl;
        for y:=25-x downto 0 do varint[y+x+byte('A')]:=varint[y+byte('A')];
        for y:=0 to pred(x) do varint[y+byte('A')]:=0;
      end else if id(befehl,'SULE') then
        saule(zahl,zahl,r,g,b)
      else if id(befehl,'ZYLINDER') then
        zylinder(zahl,zahl,zahl,r,g,b)
     {else if id(befehl,'LINIE') then
        a.x:=realzahl;a.y:=realzahl;a.z:=realzahl;
        e.x:=realzahl;e.y:=realzahl;e.z:=realzahl;
        linie3d(a,e);
      end }
      else if id(befehl,'SCHACHBRETT') then
        schachbrett(zahl,zahl,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl)
      else if id(befehl,'DREIECK') then
        dreieck(realzahl,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl)
      else if id(befehl,'VIERECK') then
        viereck(realzahl,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl,realzahl)
      else if id(befehl,'MESH') then mesh
      else if id(befehl,'SCHREIBE') then schreibeinter
      else if id(befehl,'LADESCHRIFT') then
        ladeschrift(getstring(8))
      else if id(befehl,'ROTATIONSKRPER') then
        rotationskoerper(zahl,riss,zahl,normen)
      else if id(befehl,'ZIEHKRPER') then
        zylinderkoerper(zahl,riss,normen)
      else if id(befehl,'LADEROTATIONSKRPER') then
        ladeumriss(getstring(8),riss)
      else if id(befehl,'LADEOBJEKT') then ladeobtinter
      else if id(befehl,'TEXTUR') then begin
        h:=zahl;v:=zahl;
        r:=realzahl;g:=realzahl;b:=realzahl;
        textur(h,v,r,g,b);
      end else if id(befehl,'TON') then begin
        sound(zahl);delay(zahl);nosound;
      end else if id(befehl,'OBERFLCHE') then
        changesurfaceproperty(realzahl,realzahl,realzahl,realzahl,realzahl,
             realzahl,realzahl,realzahl,realzahl,realzahl,realzahl)
      else if id(befehl,'PARAM') then begin
        h:=zahl;v:=zahl;
        r:=realzahl;g:=realzahl;b:=realzahl;
        textur(h,v,r,g,b);
        changesurfaceproperty(realzahl,realzahl,realzahl,realzahl,realzahl,
             realzahl,realzahl,realzahl,realzahl,realzahl,realzahl);
        translate(realzahl,realzahl,realzahl);
        rotate(1,realzahl);
        rotate(2,realzahl);
        rotate(3,realzahl);
        scale(realzahl,realzahl,realzahl);
      end else if id(befehl,'LET') then letinter
      else if id(befehl,'IF') then ifinter
      else if id(befehl,'GOTO') then begin
        findesprung;
        zeile:=n;
      end else if id(befehl,'GOSUB') then gosubinter
      else if id(befehl,'CLIPGOSUB') then begin
        if clipcube then begin
          defineclipvolume(1,1,1,1,1,1);
          argumente:='';
        end else gosubinter;
      end else if id(befehl,'ENDE') or id(befehl,'RETURN') then ende:=true
      else begin
        str(zeile,hilf);
        error('Unbekannter Befehl in Zeile '+hilf+':'+befehl+': (Interpretiere)');
      end;
    end;
    if lampe and (start=0) then lampenzeigen(lampen1,lampen2,lampev1,lampev2,lampev3);
    close(f);
  end else error('Ich konnte '+name+'.WIZ nicht laden !');
  if maxls<0 then Setzelichter;
end;

begin
  fillchar(varint,sizeof(varint),#0);
  fillchar(varreal,sizeof(varreal),#0);
  randomize;
end.
