type lbyte=array[0..3] of byte;

const Form:array[1..4] of char=('F','O','R','M');
      ILBMBMHD:array[1..12] of char=('I','L','B','M','B','M','H','D',#0,#0,#0,#$14);
      Head2:record
        bhi,blo,hhi,hlo:byte;
        x,y:integer;
        bit,mask,komp,fill:byte;
        trans:word;
        dx,dy:byte;
        ubhi,ublo,uhhi,uhlo:byte;
      end=(bhi:1;blo:$40;hhi:0;hlo:$c8;x:0;y:0;bit:8;mask:0;komp:0;fill:0;trans:0;dx:1;dy:1;ubhi:1;ublo:$40;uhhi:0;uhlo:$c8);
      CMAP:array[1..8] of char=('C','M','A','P',#0,#0,#3,#0);
      BODY:array[1..4] of char=('B','O','D','Y');

procedure SaveMagic(name:namestr);
var x,y:word;
    f:file;
    l:longint;
begin
  assign(f,name+'.LBM');
  rewrite(f);
  blockwrite(f,form,sizeof(form));
  l:=((__xmaxglobalglobal+7) div 8)*8*__ymaxglobalglobal+8+256*3+8+28+4;
  blockwrite(f,lbyte(l)[3],1);
  blockwrite(f,lbyte(l)[2],1);
  blockwrite(f,lbyte(l)[1],1);
  blockwrite(f,lbyte(l)[0],1);
  blockwrite(f,ILBMBMHD,sizeof(ILBMBMHD));
  head2.bhi:=hi(_xmaxglobal);
  head2.blo:=lo(_xmaxglobal);
  head2.ubhi:=hi(_xmaxglobal);
  head2.ublo:=lo(_xmaxglobal);
  head2.hhi:=hi(_ymaxglobal);
  head2.hlo:=lo(_ymaxglobal);
  head2.uhhi:=hi(_ymaxglobal);
  head2.uhlo:=lo(_ymaxglobal);
  blockwrite(f,head2,sizeof(head2));
  blockwrite(f,CMAP,sizeof(CMAP));
  scq:=palnr and scqsave>0;
  palnr:=palnr and not scqsave;
  case palnr of
    1:calcclutnormal;
    2:calcclutrgb;
    3:calcclutsw256;
    4:calcclut3d;
  end;
  for x:=0 to 255 do for y:=0 to 2 do pal^[x,y]:=pal^[x,y] shl 2;
  blockwrite(f,pal^,sizeof(pal^));
  blockwrite(f,BODY,sizeof(BODY));
  l:=((_xmaxglobal+7) div 8)*8*_ymaxglobal;
  blockwrite(f,lbyte(l)[3],1);
  blockwrite(f,lbyte(l)[2],1);
  blockwrite(f,lbyte(l)[1],1);
  blockwrite(f,lbyte(l)[0],1);
  getmem(buf,_xmaxglobal);
  write('  0 %');
  for y:=1 to _ymaxglobal do begin
    gotoxy(1,wherey);
    write(round(y/_ymaxglobal*100):3);
    blockread(f,buf^,_xmaxglobal);
    for n:=0 to 7 do begin
      hilf:=1 shl n;
      for x:=0 to pred(_xmaxglobal) do
       BitF^.bit((bytearray(buf^)[x] and hilf)>0);
      BitF^.NewLine;
    end;
  end;
  dispose(BitF,close);
end;