program malebild;
{$N+}{$E+}
uses crt,dos,graph,dreid,inter,koords,maus,joystick,wizinfo{,sichern};
const abstand=10;
      seite:byte=0;
      maxx=640;
      maxy=350;
var datname:pathstr;
    suche:searchrec;
    ein:char;
    jmaxx,jmaxy,mittex,mittey:integer;
    tasten,xpos,ypos:word;
    buf:string[4];
    richtvar:array[0..1,0..1,0..1,0..1] of byte;

  procedure bildname;
  var dir:dirstr;
      name:namestr;
      ext:extstr;
  begin
    if paramcount<>0 then datname:=paramstr(1) else
    if getinfo<>'' then begin
      fsplit(getinfo,dir,name,ext);
      datname:=dir+name;
    end else begin
      textbackground(blue);
      textcolor(yellow);
      clrscr;
      writeln('Malebild');
      writeln;
      writeln('Folgende Bilder knnen Sie laden:');
      writeln;
      suche.name:='*.WIZ';
      findfirst('*.WIZ',$3f,suche);
      if (Doserror<>0) then writeln('keine':10);
      while (doserror=0) do begin
        write(suche.name:20);
        findnext(suche);
      end;
      writeln;
      write('Geben Sie den Bildnamen ein (ohne Extension) : ');
      readln(datname);
    end;
    suche.name:='*.WIZ';
    findfirst(datname+'.WIZ',$3f,suche);
    if doserror<>0 then error(datname+'.WIZ nicht gefunden !')
    else setinfo(datname+'.WIZ');
  end;

  procedure interaktiverror(s:string);far;
  begin
    if s<>'' then begin
      grafikende;
      textcolor(yellow);
      textbackground(blue);
      write(#7,s);
      repeat readkey until not keypressed;
      repeat until keypressed;
      halt;
    end;
  end;

  procedure initinteraktiv;
  begin
    fillchar(richtvar,sizeof(richtvar),#0);
    error:=interaktiverror;
    if eingabemaus then begin
      mausminmaxx(5,maxx-5);
      mausminmaxy(5,maxy);
      maussetpos(maxx div 2,maxy div 2);
    end;
    if eingabejoystick then begin
      initjoysticktext(0);
      jmaxx:=(maxpos[0,0,1]-maxpos[0,0,0]) div 2;
      mittex:=maxpos[0,0,0]+jmaxx;
      jmaxy:=(maxpos[0,1,1]-maxpos[0,1,0]) div 2;
      mittey:=maxpos[0,1,0]+jmaxy;
    end;
  end;

  procedure zeichnen;
  begin
    MC_WC:=E;
    matschanged:=true;
    gezeichnet:=false;
    setviewglobal(VRP,NRP,VUP,xMin,yMin,xSize,vpd,FPd,bpd);
    setscreenglobal(0,_ymaxglobal div 2,_xmaxglobal div 2,0);
    while dolocalinit do begin
      interpretiere(datname,0);
      while maxls<>-1 do clearls(maxls);
    end;
  end;

  procedure rucksetzen;
  begin
    nrp.x:=0;nrp.y:=0;nrp.z:=0;
    vrp.x:=0;vrp.y:=0;vrp.z:=0;
    vup.x:=0;vup.y:=0;vup.z:=0;
    xsize:=abs(mass);
    xmin:=-xsize/2;
    ymin:=xmin*pysscrsizey/pysscrsizex;
    wireframe:=true;
  end;

  procedure datenausgabe;
  var jm,xy,t1,t2:byte;
  begin
    for jm:=0 to 1 do for xy:=0 to 1 do
    for t1:=0 to 1 do for t2:=0 to 1 do begin
      if richtvar[jm,xy,t1,t2]<>0 then begin
        str(varreal[richtvar[jm,xy,t1,t2]]:2:4,buf);
        outtextxy((t1*40+t2*20)*8,jm*20+xy*10,char(74+3*jm)+char(88+xy)+
        char(48+t1)+char(48+t2)+': '+char(richtvar[jm,xy,t1,t2])+'='+buf);
      end;
    end;
  end;

  procedure neuvar(jm:byte);
  var t1,t2:byte;
  begin
    if boolean(jm) then begin {Maus}
      maustastpos(tasten,xpos,ypos);
      t1:=tasten and 1;
      t2:=(tasten and 2) div 2;
    end else begin
      t1:=byte(switch(0));
      t2:=byte(switch(1));
    end;     {x=0 y=1}
    richtvar[jm,1,t1,t2]:=richtvar[jm,0,t1,t2];
    richtvar[jm,0,t1,t2]:=byte(upcase(ein));
  end;

  procedure tastaturauswerten;
  begin
    while keypressed do ein:=readkey;
    if ein=#13 then fillchar(richtvar,sizeof(richtvar),#0)
    else if ein=' ' then variablenanzeigen:=not variablenanzeigen
    else if (ein=#27) then begin
      grafikende;
      ende:=not koordinaten;
    end;
    if eingabemaus and eingabejoystick then begin
      if (byte(ein)>64) and (byte(ein)<91) then neuvar(0); {Joystick}
      if (byte(ein)>96) and (byte(ein)<123) then neuvar(1); {Maus}
    end else begin
      ein:=upcase(ein);
      if (byte(ein)>64) and (byte(ein)<91) then begin
        if eingabemaus then neuvar(1) else neuvar(0);
      end;
    end;
  end;

  procedure eingabeauswerten;
  var t1,t2:byte;
  begin
    if eingabemaus then begin
      maustastpos(tasten,xpos,ypos);
      t1:=tasten and 1;
      t2:=(tasten and 2) div 2;
      if richtvar[1,0,t1,t2]<>0 then varreal[richtvar[1,0,t1,t2]]:=(xpos-maxx div 2)/(maxx div 2);
      if richtvar[1,1,t1,t2]<>0 then varreal[richtvar[1,1,t1,t2]]:=(maxy div 2 - ypos)/(maxy div 2);
    end;
    if eingabejoystick then begin
      t1:=byte(switch(0));
      t2:=byte(switch(1));
      if richtvar[0,0,t1,t2]<>0 then varreal[richtvar[0,0,t1,t2]]:=(paddle(0)-mittex)/jmaxx;
      if richtvar[0,1,t1,t2]<>0 then varreal[richtvar[0,1,t1,t2]]:=(mittey-paddle(1))/jmaxy;
    end;
  end;

begin
  bildname;
  transdaten(datname);
  if interaktiv then initinteraktiv;
  ein:=#27;
  repeat
    if (koordinaten and (not interaktiv)) or
       (koordinaten and interaktiv and (ein=#27)) then while abfrage do begin
      interpretiere(datname,0);
      while maxls<>-1 do clearls(maxls);
    end;
    if interaktiv then begin
      grafmode:=1;
      wireframe:=true;
      if ein=#27 then grafikbegin;
      seite:=byte(not boolean(seite));
      setactivepage(seite);
      setvisualpage(byte(not boolean(seite)));
      cleardevice;
    end;
    ein:='!';
    if not ende then begin
      if xy or xz or yz then rucksetzen;
      if XY then begin
        nrp.z:=abstand;
        vup.y:=1;
      end else if XZ then begin
        nrp.y:=abstand;
        vup.z:=1;
      end else if YZ then begin
        nrp.x:=abstand;
        vup.y:=1;
      end;
      if gesamt then begin
        frame:=true;
        if not interaktiv then init;
        setviewport(0,getmaxy div 2,getmaxx div 2,getmaxy,true);
        outtextxy(3,3,'3D');
        zeichnen;
        rucksetzen;
        nrp.z:=abstand;
        vup.y:=1;
        setviewport(getmaxx div 2,getmaxy div 2,getmaxx,getmaxy,true);
        outtextxy(3,3,'XY');
        zeichnen;
        nrp.z:=0;
        vup.y:=0;
        nrp.y:=abstand;
        vup.z:=1;
        setviewport(0,0,getmaxx,getmaxy,true);
        outtextxy(3,3,'XZ');
        zeichnen;
        nrp.y:=0;
        vup.z:=0;
        nrp.x:=abstand;
        vup.y:=1;
        setviewport(getmaxx div 2,0,getmaxx,getmaxy div 2,true);
        outtextxy(3,3,'YZ');
        zeichnen;
        setviewport(0,0,getmaxx,getmaxy,true);
        if variablenanzeigen then datenausgabe;
      end else begin
        if not interaktiv then grafikbegin;
        while dolocalinit do begin
          interpretiere(datname,0);
          while maxls<>-1 do clearls(maxls);
        end;
        if variablenanzeigen then datenausgabe;
      end;
      if interaktiv then begin
        tastaturauswerten;
        eingabeauswerten;
      end else begin
        write(^G);
        if (name<>'') and (not wireframe) then begin
          savebild;
          if (paramcount>1) or ram or TrueColor then ende:=true;
        end;
        repeat until ende or keypressed or mauskeypressed;
        grafikende;
        while keypressed do ein:=readkey;
        if ein=#27 then ende:=true;
      end;
    end;
  until ende;
end.