program Menu2;

{$M 8192,8192,655360}
{$X+,S-}

uses Crt, Dos, Objects, Drivers, Memory, Views, Menus, Dialogs,
  StdDlg, MsgBox, App, Calc, Buffers, WizEdit, WizInfo;

const
  HeapSize = 32 * (1024 div 16);

const
  siDesksichern = 1;
  cmOpen       = 100;
  cmNew        = 101;
  cmChangeDir  = 102;
  cmDosShell   = 103;
  cmCalculator = 104;
  cmShowClip   = 105;
  cmauswahl    = 106;
  cmOpenmat    = 107;
  cmOpendat    = 108;
  cmOpenscn    = 109;
  cmOpenpos    = 110;
  cmMalebild   = 201;
  cmumriss  =    202;
  cmWizArt  =    203;
  cmshowpick =   204;
  cmmaterial =   205;
  cmpacken =     206;
  cmfunktion =   207;
  cmtrans =      208;
  cmradio =      209;
  cmhandbuch =   210;
  cmautosave =   211;

type
  TAutosavedata = record
                   sichern:word
                 end;
  PEditorApp = ^TEditorApp;
  TEditorApp = object(TApplication)
    save:TAutoSavedata;
    constructor Init;
    destructor Done; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure InitMenuBar; virtual;
    procedure InitStatusLine; virtual;
    procedure OutOfMemory; virtual;
    procedure auswahldialog;
    procedure autosavedialog;
    procedure RestoreDeskTop;
    procedure SaveDeskTop;
  end;

const doscode:word=0;

var
  EditorApp: TEditorApp;
  ClipWindow: PEditWindow;

procedure TEditorapp.autosavedialog;
var
  D: Pdialog;
  Control: word;
  R: TRect;
  bruce:PView;
  f : file;
begin
  R.Assign(40, 4, 66, 12);
  D := New(PDialog, Init(R, 'Sichern'));
  with D^ do
  begin
    R.assign(2,3,23,4);
    bruce:=new(PCheckBoxes,init(r,newsitem('~A~rbeitsflche',nil)));
    insert(bruce);
    R.Assign(2,2,23,3);
    Insert(New(PLabel, Init(R,'Dies wird gesichert:',bruce)));
    R.Assign(2, 5, 12, 7);
    Insert(New(PButton, Init(R, 'O~K', cmOk, bfDefault)));
    R.Assign(14 ,5, 24, 7);
    Insert(New(PButton, Init(R, 'C~a~ncel', cmCancel, bfDefault)));
  end;
  if ValidView(D) <> nil then
  begin
    d^.setdata(save);
    control:=Desktop^.ExecView(D);
    if control<>cmcancel then d^.getdata(save);
    Dispose(D, Done);
  end;
  if (save.sichern and sidesksichern)=0 then begin
    assign(f,'WIZMENU.DSK');
    erase(f);
  end;
end;

procedure TEditorapp.auswahldialog;
var
  D: Pdialog;
  R: TRect;
begin
  R.Assign(0, 0, 39, 23);
  D := New(PDialog, Init(R, 'Auswahl'));
  with D^ do
  begin
    Options := Options or ofCentered;
    R.Assign(1, 4, 37, 6);
    Insert(New(PButton, Init(R, 'CAD fr ~R~otationskrper', cmumriss, bfNormal)));
    R.Assign(1, 6, 37, 8);
    Insert(New(PButton, Init(R, '~W~izArt', cmWizart, bfNormal)));
    R.Assign(1, 8, 37,10);
    Insert(New(PButton, Init(R, 'Bild ~A~nzeigen', cmshowpick, bfNormal)));
    R.Assign(1,10, 37, 12);
    Insert(New(PButton, Init(R, '~M~aterial Editor', cmmaterial, bfNormal)));
    R.Assign(1, 12, 37,14);
    Insert(New(PButton, Init(R, '~P~acken', cmpacken, bfNormal)));
    R.Assign(1, 14, 37,16);
    Insert(New(PButton, Init(R, '~3~D Funktionen', cmfunktion, bfNormal)));
    R.Assign(1, 16, 37,18);
    Insert(New(PButton, Init(R, '~~bersetze .WIZ -> .SCN', cmtrans, bfNormal)));
    R.Assign(1, 18, 37,20);
    Insert(New(PButton, Init(R, 'Radio~s~ity', cmradio, bfNormal)));
    R.Assign(1, 20, 37,22);
    Insert(New(PButton, Init(R, '~H~andbuch', cmhandbuch, bfNormal)));
    R.Assign(1, 2, 37, 4);
    Insert(New(PButton, Init(R, '~B~ild berechnen', cmMalebild, bfDefault)));
  end;
  desktop^.insert(d);
end;

function ExecDialog(P: PDialog; Data: Pointer): Word;
var
  Result: Word;
begin
  Result := cmCancel;
  P := PDialog(Application^.ValidView(P));
  if P <> nil then
  begin
    if Data <> nil then P^.SetData(Data^);
    Result := DeskTop^.ExecView(P);
    if (Result <> cmCancel) and (Data <> nil) then P^.GetData(Data^);
    Dispose(P, Done);
  end;
  ExecDialog := Result;
end;

function CreateFindDialog: PDialog;
var
  D: PDialog;
  Control: PView;
  R: TRect;
begin
  R.Assign(0, 0, 38, 12);
  D := New(PDialog, Init(R, 'Find'));
  with D^ do
  begin
    Options := Options or ofCentered;

    R.Assign(3, 3, 32, 4);
    Control := New(PInputLine, Init(R, 80));
    Insert(Control);
    R.Assign(2, 2, 15, 3);
    Insert(New(PLabel, Init(R, '~T~ext to find', Control)));
    R.Assign(32, 3, 35, 4);
    Insert(New(PHistory, Init(R, PInputLine(Control), 10)));

    R.Assign(3, 5, 35, 7);
    Insert(New(PCheckBoxes, Init(R,
      NewSItem('~C~ase sensitive',
      NewSItem('~W~hole words only', nil)))));

    R.Assign(14, 9, 24, 11);
    Insert(New(PButton, Init(R, 'O~K~', cmOk, bfDefault)));
    Inc(R.A.X, 12); Inc(R.B.X, 12);
    Insert(New(PButton, Init(R, 'Cancel', cmCancel, bfNormal)));

    SelectNext(False);
  end;
  CreateFindDialog := D;
end;

function CreateReplaceDialog: PDialog;
var
  D: PDialog;
  Control: PView;
  R: TRect;
begin
  R.Assign(0, 0, 40, 16);
  D := New(PDialog, Init(R, 'Replace'));
  with D^ do
  begin
    Options := Options or ofCentered;

    R.Assign(3, 3, 34, 4);
    Control := New(PInputLine, Init(R, 80));
    Insert(Control);
    R.Assign(2, 2, 15, 3);
    Insert(New(PLabel, Init(R, '~T~ext to find', Control)));
    R.Assign(34, 3, 37, 4);
    Insert(New(PHistory, Init(R, PInputLine(Control), 10)));

    R.Assign(3, 6, 34, 7);
    Control := New(PInputLine, Init(R, 80));
    Insert(Control);
    R.Assign(2, 5, 12, 6);
    Insert(New(PLabel, Init(R, '~N~ew text', Control)));
    R.Assign(34, 6, 37, 7);
    Insert(New(PHistory, Init(R, PInputLine(Control), 11)));

    R.Assign(3, 8, 37, 12);
    Insert(New(PCheckBoxes, Init(R,
      NewSItem('~C~ase sensitive',
      NewSItem('~W~hole words only',
      NewSItem('~P~rompt on replace',
      NewSItem('~R~eplace all', nil)))))));

    R.Assign(17, 13, 27, 15);
    Insert(New(PButton, Init(R, 'O~K~', cmOk, bfDefault)));
    R.Assign(28, 13, 38, 15);
    Insert(New(PButton, Init(R, 'Cancel', cmCancel, bfNormal)));

    SelectNext(False);
  end;
  CreateReplaceDialog := D;
end;

function DoEditDialog(Dialog: Integer; Info: Pointer): Word; far;
var
  R: TRect;
  T: TPoint;
begin
  case Dialog of
    edOutOfMemory:
      DoEditDialog := MessageBox('Not enough memory for this operation.',
        nil, mfError + mfOkButton);
    edReadError:
      DoEditDialog := MessageBox('Error reading file %s.',
        @Info, mfError + mfOkButton);
    edWriteError:
      DoEditDialog := MessageBox('Error writing file %s.',
        @Info, mfError + mfOkButton);
    edCreateError:
      DoEditDialog := MessageBox('Error creating file %s.',
        @Info, mfError + mfOkButton);
    edSaveModify:
      DoEditDialog := MessageBox('%s has been modified. Save?',
        @Info, mfInformation + mfYesNoCancel);
    edSaveUntitled:
      DoEditDialog := MessageBox('Save untitled file?',
        nil, mfInformation + mfYesNoCancel);
    edSaveAs:
      DoEditDialog := ExecDialog(New(PFileDialog, Init('*.*',
        'Save file as', '~N~ame', fdOkButton, 101)), Info);
    edFind:
      DoEditDialog := ExecDialog(CreateFindDialog, Info);
    edSearchFailed:
      DoEditDialog := MessageBox('Search string not found.',
        nil, mfError + mfOkButton);
    edReplace:
      DoEditDialog := ExecDialog(CreateReplaceDialog, Info);
    edReplacePrompt:
      begin
        { Avoid placing the dialog on the same line as the cursor }
        R.Assign(0, 1, 40, 8);
        R.Move((Desktop^.Size.X - R.B.X) div 2, 0);
        Desktop^.MakeGlobal(R.B, T);
        Inc(T.Y);
        if TPoint(Info).Y <= T.Y then
          R.Move(0, Desktop^.Size.Y - R.B.Y - 2);
        DoEditDialog := MessageBoxRect(R, 'Replace this occurence?',
          nil, mfYesNoCancel + mfInformation);
      end;
  end;
end;

function OpenEditor(FileName: FNameStr; Visible: Boolean): PEditWindow;
var
  P: PView;
  R: TRect;
begin
  DeskTop^.GetExtent(R);
  P := Application^.ValidView(New(PEditWindow,
    Init(R, FileName, wnNoNumber)));
  if not Visible then P^.Hide;
  DeskTop^.Insert(P);
  OpenEditor := PEditWindow(P);
end;

constructor TEditorApp.Init;
var
  H: Word;
  R: TRect;
begin
  save.sichern:=0;
  H := PtrRec(HeapEnd).Seg - PtrRec(HeapPtr).Seg;
  if H > HeapSize then BufHeapSize := H - HeapSize else BufHeapSize := 0;
  InitBuffers;
  TApplication.Init;
  DisableCommands([cmSave, cmSaveAs, cmCut, cmCopy, cmPaste, cmClear,
    cmUndo, cmFind, cmReplace, cmSearchAgain]);
  EditorDialog := DoEditDialog;
  ClipWindow := OpenEditor('', False);
  if ClipWindow <> nil then
  begin
    Clipboard := ClipWindow^.Editor;
    Clipboard^.CanUndo := False;
  end;
  registerObjects;
  registerViews;
  registerMenus;
  registerDialogs;
  RegisterApp;
  RegisterCalc;
  RegisterEditors;
end;

destructor TEditorApp.Done;
begin
  TApplication.Done;
  DoneBuffers;
end;

procedure TEditorApp.HandleEvent(var Event: TEvent);

procedure FileOpen(ext:extstr);
var
  FileName: FNameStr;
begin
  FileName := '*.'+ext;
  if ExecDialog(New(PFileDialog, Init('*.'+ext, 'Open file',
    '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then
    OpenEditor(FileName, True);
end;

procedure FileNew;
begin
  OpenEditor('', True);
end;

procedure ChangeDir;
begin
  ExecDialog(New(PChDirDialog, Init(cdNormal, 0)), nil);
end;

procedure DosShell;
begin
  DoneSysError;
  DoneEvents;
  DoneVideo;
  DoneMemory;
  SetMemTop(Ptr(BufHeapPtr, 0));
  PrintStr('Type EXIT to return to TVEDIT...');
  SwapVectors;
  Exec(GetEnv('COMSPEC'), '');
  SwapVectors;
  SetMemTop(Ptr(BufHeapEnd, 0));
  InitMemory;
  InitVideo;
  InitEvents;
  InitSysError;
  Redraw;
end;

procedure ShowClip;
begin
  ClipWindow^.Select;
  ClipWindow^.Show;
end;

procedure Tile;
var
  R: TRect;
begin
  Desktop^.GetExtent(R);
  Desktop^.Tile(R);
end;

procedure Cascade;
var
  R: TRect;
begin
  Desktop^.GetExtent(R);
  Desktop^.Cascade(R);
end;

procedure Calculator;
begin
  DeskTop^.Insert(ValidView(New(PCalculator, Init)));
end;

begin
  TApplication.HandleEvent(Event);
  case Event.What of
    evCommand:
      case Event.Command of
        cmOpen: FileOpen('*');
        cmOpenmat: FileOpen('MAT');
        cmOpendat: FileOpen('WIZ');
        cmOpenpos: FileOpen('POS');
        cmOpenscn: FileOpen('SCN');
        cmNew: FileNew;
        cmChangeDir: ChangeDir;
        cmDosShell: DosShell;
        cmCalculator: Calculator;
        cmShowClip: ShowClip;
        cmTile: Tile;
        cmCascade: Cascade;
        cmAutoSave: autosavedialog;
        cmauswahl: auswahldialog;
        cmmalebild..cmradio: begin
          doscode:=event.command-200;
          endmodal(cmquit);
        end;
        cmhandbuch: openeditor('HANDBUCH.TXT',true);
      else
        Exit;
      end;
  else
    Exit;
  end;
  ClearEvent(Event);
end;

procedure TEditorApp.InitMenuBar;
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu('~F~ile', hcNoContext, NewMenu(
      NewItem('~O~pen *.*', 'F3', kbF3, cmOpen, hcNoContext,
      NewItem('O~p~en *.WIZ', '', kbnokey, cmOpendat, hcNoContext,
      NewItem('Op~e~n *.SCN', '', kbNoKey, cmOpenscn, hcNoContext,
      NewItem('Ope~n~ *.MAT', '', kbNoKey, cmOpenmat, hcNoContext,
      NewItem('Open *.~P~OS', '', kbNoKey, cmOpenpos, hcNoContext,
      NewItem('~N~ew', '', kbNoKey, cmNew, hcNoContext,
      NewItem('~S~ave', 'F2', kbF2, cmSave, hcNoContext,
      NewItem('S~a~ve as...', '', kbNoKey, cmSaveAs, hcNoContext,
      NewLine(
      NewItem('~C~hange dir...', '', kbNoKey, cmChangeDir, hcNoContext,
      NewItem('~D~OS shell', '', kbNoKey, cmDosShell, hcNoContext,
      NewItem('E~x~it', 'Alt-X', kbAltX, cmQuit, hcNoContext,
      nil))))))))))))),
    NewSubMenu('~E~dit', hcNoContext, NewMenu(
      NewItem('~U~ndo', '', kbNoKey, cmUndo, hcNoContext,
      NewLine(
      NewItem('Cu~t~', 'Shift-Del', kbShiftDel, cmCut, hcNoContext,
      NewItem('~C~opy', 'Ctrl-Ins', kbCtrlIns, cmCopy, hcNoContext,
      NewItem('~P~aste', 'Shift-Ins', kbShiftIns, cmPaste, hcNoContext,
      NewItem('~S~how clipboard', '', kbNoKey, cmShowClip, hcNoContext,
      NewLine(
      NewItem('~C~lear', 'Ctrl-Del', kbCtrlDel, cmClear, hcNoContext,
      nil))))))))),
    NewSubMenu('~S~earch', hcNoContext, NewMenu(
      NewItem('~F~ind...', '', kbNoKey, cmFind, hcNoContext,
      NewItem('~R~eplace...', '', kbNoKey, cmReplace, hcNoContext,
      NewItem('~S~earch again', '', kbNoKey, cmSearchAgain, hcNoContext,
      nil)))),
    NewSubMenu('~W~indows', hcNoContext, NewMenu(
      NewItem('~S~ize/move','Ctrl-F5', kbCtrlF5, cmResize, hcNoContext,
      NewItem('~Z~oom', 'F5', kbF5, cmZoom, hcNoContext,
      NewItem('~T~ile', '', kbNoKey, cmTile, hcNoContext,
      NewItem('C~a~scade', '', kbNoKey, cmCascade, hcNoContext,
      NewItem('~N~ext', 'F6', kbF6, cmNext, hcNoContext,
      NewItem('~P~revious', 'Shift-F6', kbShiftF6, cmPrev, hcNoContext,
      NewItem('~C~lose', 'Alt-F3', kbAltF3, cmClose, hcNoContext,
      NewLine(
      NewItem('~A~uswahl', '', kbNoKey, cmauswahl, hcNoContext,
      NewItem('Ca~l~culator', '', kbNoKey, cmCalculator, hcNoContext,
      nil))))))))))),
    NewSubMenu('~O~ptions', hcNoContext, NewMenu(
      NewItem('~A~uto Save','', kbNoKey, cmAutoSave, hcNoContext,
      nil)),
    nil))))))));
end;

procedure TEditorApp.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
    NewStatusDef(0, $FFFF,
      NewStatusKey('~F2~ Save', kbF2, cmSave,
      NewStatusKey('~F3~ Open', kbF3, cmOpen,
      NewStatusKey('~Alt-F3~ Close', kbAltF3, cmClose,
      NewStatusKey('~F5~ Zoom', kbF5, cmZoom,
      NewStatusKey('~F6~ Next', kbF6, cmNext,
      NewStatusKey('~F10~ Menu', kbF10, cmMenu,
      NewStatusKey('', kbCtrlF5, cmResize,
      nil))))))),
    nil)));
end;

procedure TEditorApp.OutOfMemory;
begin
  MessageBox('Not enough memory for this operation.',
    nil, mfError + mfOkButton);
end;

procedure TEditorApp.RestoreDeskTop;
var Savefile:TBufStream;
    Temp:PDeskTop;
begin
  SaveFile.Init('WIZMENU.DSK',stopenRead,1024);
  Temp:=PDesktop(Savefile.Get);
  Savefile.read(save.sichern,sizeof(save.sichern));
  If Temp<>nil then begin
    dispose(Desktop,Done);
    Desktop:=Temp;
    Insert(Desktop);
    DeskTop^.DrawView;
  end else begin
    auswahldialog;
    if (getinfo<>'') then OpenEditor(getinfo, True);
  end;
end;

procedure TEditorApp.SaveDeskTop;
var Savefile:TBufStream;
    hilfdia:PEditWindow;
begin
  if (save.sichern and siDesksichern)<>0 then begin
    Savefile.Init('WIZMENU.DSK',stcreate,1024);
    Savefile.Put(Desktop);
    Savefile.write(save.sichern,sizeof(save.sichern));
    Savefile.Done;
  end;
  if InfoDa then begin
    hilfdia:=message(desktop,evbroadcast,cmEditDa,nil);
    if hilfdia<>nil then setinfo(hilfdia^.gettitle(52)) else setinfo('');
  end;
end;

begin
  while keypressed do readkey;
  EditorApp.Init;
  Editorapp.RestoreDeskTop;
  EditorApp.Run;
  EditorApp.SaveDeskTop;
  EditorApp.Done;
  halt(doscode);
end.
