{$M 16384,0,0}
program showpick;
uses crt,dos,vga,farbreg,wizinfo;
const zippfad='';
const zip:boolean=false;
var datei : file;
    datname:namestr;
    ein:char;
    suche:searchrec;
    n:byte;
    muell:array[0..44] of byte;
    y:word;
const headlength=15;
Type THeader=array[0..headlength] of char;
const TrueColor=0;
      NormalPal=1;
      RGBPal=2;
      SW256Pal=3;
      Pal3D=4;
      SCQSave=8;
      header:THeader=('W','i','z','A','r','t',' ','P','i','c','t','u','r','e',#$00,#$1A);

procedure setclutrgb;
var r,b,g,redi,greeni,bluei,colorindex:integer;
begin
  for r:=0 to 7 do begin
    redi:=r*9;
    for g:=0 to 7 do begin
      greeni:=g*9;
      for b:=0 to 3 do begin
        bluei:=b*21;
        colorindex:=(r shl 3 or g) shl 2 or b;
        farbe(colorindex,redi,greeni,bluei);
      end;
    end;
  end;
end;

procedure setclutnormal;
var f:byte;
begin
  for f:=0 to 63 do farbe(f,f,0,0);
  for f:=0 to 63 do farbe(f+64,0,f,0);
  for f:=0 to 63 do farbe(f+128,0,0,f);
  for f:=0 to 63 do farbe(f+192,f,f,f);
end;

procedure setclutgrey;
var f:byte;
begin
  for f:=0 to 63 do farbe(f,f,f,f);
end;

procedure bildname;
var dir:dirstr;
    nam,name:namestr;
    ext:extstr;
    such2,suche:searchrec;
begin
  if paramcount<>0 then datname:=copy(paramstr(1),1,pred(length(paramstr(1)))) else
  if getinfo<>'' then begin
    fsplit(getinfo,dir,name,ext);
    datname:=dir+copy(name,1,pred(length(name)));
  end else begin
    textbackground(blue);
    textcolor(yellow);
    clrscr;
    writeln('***  Show 3D  ***');
    writeln;
    writeln('Zeigt Bilder, die aus zwei Perspektiven berechnet wurden und als');
    writeln('NAMEL.PIC und NAMER.PIC als 360*480*256 Bilder vorhanden sind so,');
    writeln('da man sie ber eine Spiegelbrille farbig dreidimensional sehen kann.');
    writeln('NAMEL mu aus der Perspektive des linken Auges berechnet sein und darf');
    writeln('nur die linke Bildhlfte einnehme. Entsprechend NAMER.');
    writeln;
    writeln('Folgende Bilder knnen Sie laden:');
    writeln;
    suche.name:='*.PIC';
    findfirst('*.PIC',$3f,suche);
    if (Doserror<>0) then writeln('keine':10);
    while (doserror=0) do begin
      fsplit(suche.name,dir,nam,ext);
      if upcase(nam[length(nam)])='L' then begin
        such2.name:=copy(nam,1,pred(length(nam)))+'R.PIC';
        findfirst(such2.name,$3f,such2);
        if doserror=0 then write(copy(nam,1,pred(length(nam))):20);
      end;
      findnext(suche);
    end;
    writeln;
    write('Geben Sie den Bildnamen ein (ohne Extension) : ');
    readln(datname);
  end;
  suche.name:=datname+'L.PIC';
  findfirst(datname+'L.PIC',$3f,suche);
  if doserror<>0 then begin
    writeln(datname+'L.PIC nicht gefunden !');
    halt(1);
  end
  else setinfo(datname+'L.PIC');
end;

var f:file;
    dir:dirstr;
    nam:namestr;
    ext:extstr;
    xmax,ymax:word;
    wizpic:boolean;
    head:theader;
    palnr:byte;
begin
  bildname;
  nosound;
  fsplit(datname,dir,nam,ext);
  assign(f,dir+nam+'L.PIC');
  reset(f,1);
  blockread(f,head,sizeof(head));
  wizpic:=true;
  for n:=0 to headlength do wizpic:=wizpic and (head[n]=header[n]);
  if wizpic then begin
    blockread(f,palnr,sizeof(palnr));
    blockread(f,xmax,sizeof(xmax));
    blockread(f,ymax,sizeof(ymax));
    if palnr and SCQSave>0 then begin
      scqmode;
      setclutrgb;
      for n:=0 to 3 do begin
        map(16-(1 shl n));
        readmap(n);
        blockread(f,mem[$A000:0],43200{64000});
      end;
    end else begin
      close(f);
      halt(1);
    end;
  end else begin
    close(f);
    halt(1);
  end;
  fsplit(datname,dir,nam,ext);
  assign(f,dir+nam+'L.PIC');
  reset(f,1);
  blockread(f,head,sizeof(head));
  wizpic:=true;
  for n:=0 to headlength do wizpic:=wizpic and (head[n]=header[n]);
  if wizpic then begin
    blockread(f,palnr,sizeof(palnr));
    blockread(f,xmax,sizeof(xmax));
    blockread(f,ymax,sizeof(ymax));
    for n:=0 to 3 do begin
      map(16-(1 shl n));
      for y:=0 to 479 do begin
        blockread(f,muell,45);
        blockread(f,mem[$A000:y*90+45],45);
      end;
    end;
  end;
  close(f);
  repeat
    repeat until keypressed;
    ein:=readkey;
    if ein=#0 then ein:=readkey;
    case ein of
    '1':setclutrgb;
    '2':setclutnormal;
    '3':setclutgrey;
    '4':farberegeln;
    end;
  until  ein=#27;
  vgaende;
end.