program showTrueColor;
uses crt,dos,wizinfo,TrueColo;

function bildname:pathstr;
var dir:dirstr;
    name:namestr;
    ext:extstr;
    suche:searchrec;
    nam:pathstr;
begin
  if paramcount<>0 then nam:=paramstr(1) else
  if getinfo<>'' then begin
    fsplit(getinfo,dir,name,ext);
    nam:=dir+name;
  end else begin
    textbackground(blue);
    textcolor(yellow);
    clrscr;
    writeln('ShowTrueColor');
    writeln;
    writeln('Folgende Bilder knnen Sie in TrueColor ausgeben:');
    writeln;
    suche.name:='*.PIC';
    findfirst('*.PIC',$3f,suche);
    if (Doserror<>0) then writeln('keine':10);
    while (doserror=0) do begin
      if suche.size=640*480*3+21 then write(suche.name:20);
      findnext(suche);
    end;
    writeln;
    suche.name:='*.ZIP';
    findfirst('*.ZIP',$3f,suche);
    if (Doserror<>0) then writeln('keine gepackten Bilder':10);
    while (doserror=0) do begin
      write(suche.name:20);
      findnext(suche);
    end;
    writeln;
    write('Geben Sie den Bildnamen ein (ohne Extension) : ');
    readln(nam);
  end;
  suche.name:='*.PIC';
  findfirst(nam+'.PIC',$3f,suche);
  if doserror<>0 then begin
    writeln(nam+'.PIC nicht gefunden !');
    halt(0);
  end else setinfo(nam+'.WIZ');
  bildname:=nam;
end;

const headlength=15;
Type THeader=array[0..headlength] of char;
     TData=array[0..19,0..639,0..2] of byte;
var f:file;
    name:pathstr;
    head:THeader;
    palnr:byte;
    xmax,ymax:word;
    wizpic:boolean;
    Data:TData;
    x,y,n:word;
const TrueColor=0;
      NormalPal=1;
      RGBPal=2;
      SW256Pal=3;
      Pal3D=4;
      SCQSave=8;
      header:THeader=('W','i','z','A','r','t',' ','P','i','c','t','u','r','e',#$00,#$1A);
begin
  name:=bildname;
  assign(f,name+'.PIC');
  reset(f,1);
  blockread(f,head,sizeof(header));
  wizpic:=true;
  for n:=0 to headlength do wizpic:=wizpic and (head[n]=header[n]);
  if wizpic then begin
    blockread(f,palnr,sizeof(palnr));
    blockread(f,xmax,sizeof(xmax));
    blockread(f,ymax,sizeof(ymax));
    if (palnr=TrueColor) and (TrueColo.TrueColor) then begin
      for n:=0 to 23 do begin
        blockread(f,Data,sizeof(data));
        for y:=0 to 19 do for x:=0 to 640 do TCPlot(x,y+n*20,data[y,x,0],data[y,x,1],data[y,x,2]);
        if keypressed then begin
          Modus(3);
          halt;
        end;
      end;
      repeat until keypressed;
      MODUS(3);
    end else writeln('TrueColor konnte nicht eingeschalten werden (BIOS nicht GENOA 7900 kompatibel)');
  end else writeln('Kein WizArt 640*480 TrueColor Bild');
  close(f);
end.