unit TrueColo;
interface
Uses Dos;

procedure TCplot(x,y:word;r,g,b:byte);
function truecolor:boolean;
Procedure Modus(modus:integer);

implementation
Var ylauf,xlauf:word;

Procedure Modus(modus:integer);
var reg:registers;
begin
  reg.ah:=0;
  reg.al:=modus;
  intr($10,reg);
end;


function truecolor:boolean;
var reg:registers;
    adr:longint;
    flg:byte;
    n:word;
    segment:byte;
begin
  reg.ax:=$10f0;
  reg.bx:=$FF3e;
  intr($10,reg);
  if reg.ax<>$10 then modus(3);
  truecolor:=reg.ax=$10;
end;

procedure TCplot(x,y:word;r,g,b:byte);
const bpl:Longint=2048;
var index:Longint;
    sindex:word;
    segment:byte;
begin
  index:=(bpl*y)+3*x;
  segment:=index shr 16;
  sindex:=index and $FFFF;
  port[$3cd]:=segment;
  mem[$a000:sindex]:=b;
  mem[$a000:sindex+1]:=g;
  mem[$a000:sindex+2]:=r;
end;

END.


