unit ULoadPic;
interface
uses dos,vga;
const headlength=15;
Type THeader=array[0..headlength] of char;
const TrueColor=0;
      NormalPal=1;
      RGBPal=2;
      SW256Pal=3;
      Pal3D=4;
      SCQSave=8;
      header:THeader=('W','i','z','A','r','t',' ','P','i','c','t','u','r','e',#$00,#$1A);
var pblack:ppalette;

function LoadBild(name:pathstr;var palnr:byte):boolean;

implementation
var head:THeader;

function LoadBild(name:pathstr;var palnr:byte):boolean;
var f:file;
    n:byte;
    dir:dirstr;
    nam:namestr;
    ext:extstr;
    xmax,ymax:word;
    wizpic:boolean;
begin
  fsplit(name,dir,nam,ext);
  assign(f,dir+nam+'.PIC');
  reset(f,1);
  blockread(f,head,sizeof(head));
  wizpic:=true;
  for n:=0 to headlength do wizpic:=wizpic and (head[n]=header[n]);
  if wizpic then begin
    blockread(f,palnr,sizeof(palnr));
    blockread(f,xmax,sizeof(xmax));
    blockread(f,ymax,sizeof(ymax));
    LoadBild:=true;
    if palnr and SCQSave>0 then begin
      {setmode(R640x400);}
      scqmode;
      setpalette(pblack);
      for n:=0 to 3 do begin
        map(16-(1 shl n));
        readmap(n);
        blockread(f,mem[$A000:0],43200{64000});
      end;
    end else if (xmax=320) and (palnr<>TrueColor) then begin
      videomodus($13);
      setpalette(pblack);
      blockread(f,mem[$a000:0],64000);
    end else LoadBild:=false;
    close(f);
    palnr:=palnr and not SCQSave;
  end else LoadBild:=false;
end;

begin
  new(pblack);
  fillchar(pblack^,sizeof(pblack^),#0);
end.