program umrissmachen;
{$N+}{$E+}
uses crt,dos,graph,vga,mausb{IFopt D-},dreid,rotation,koords,init3d,materie{ENDIF};
const erstesmal:boolean=true;
      aktcolor:rgbb=(r:32;g:32;b:32);
{IFopt D+
      bgipath='';
      maxpnts=50;
      pysscrsizex=24.0;
      pysscrsizey=17.0;
      name:pathstr='';
      type koord2d=record x,y:real; end;
      RGBb = record r,g,b:byte; end;
     umrisstyp=record
                 punkt:array[0..maxpnts] of record
                         crd,nrm:koord2d;
                         color:rgbb;
                       end;
                 xmax,ymin,ymax:real;
                 punktanzahl:shortint;
                 ka,kd,ks,osr,osg,osb,oe,odr,odg,odb,otrans:real;
                 color:rgbb;
               end;

Endif}

var n:byte;
    umriss:umrisstyp;
    xzuy:real;
    grafikan,gesaved,vorhanden:boolean;
    tastenanzahl:word;
    ein:char;
    suche:searchrec;
    editormauspos,menumauspos:array[0..1] of word;
    oldex:Pointer;

{IFopt D+
procedure error(s:string);
begin
  writeln(s);
  halt(1);
end;

procedure umrissfarbe(r,g,b:real;var umriss:umrisstyp);
var z:byte;
begin
  for z:=0 to umriss.punktanzahl do with umriss.punkt[z] do begin
    color.r:=trunc(r*63);
    color.g:=trunc(g*63);
    color.b:=trunc(b*63);
  end;
end;


procedure ladeumriss(name:pathstr;var umriss:umrisstyp);
var umrissfile:file of umrisstyp;
    suche:searchrec;
begin
  findfirst(name+'.RIS',$3f,suche);
  if doserror=0 then begin
    assign(umrissfile,name+'.RIS');
    reset(umrissfile);
    read(umrissfile,umriss);
    close(umrissfile);
  end else error('Ich konnte '+name+'.RIS nicht laden !');
end;

procedure sichereumriss(name:pathstr;var umriss:umrisstyp);
var umrissfile:file of umrisstyp;
begin
  if name<>'' then begin
    assign(umrissfile,name+'.RIS');
    rewrite(umrissfile);
    write(umrissfile,umriss);
    close(umrissfile);
  end;
end;

function getreal(r:real;s:string):real;
var s1:string;
    rh:real;
    err:integer;
begin
  textcolor(lightgreen); write(s:55,'? ');
  textcolor(lightmagenta); write('[',r:8:4,']');
  readln(s1);
  if s1='' then getreal:=r else begin
    val(s1,rh,err);
    if err<>0 then begin
      if upcase(s1[1])='Q' then error('Auf Wiedersehen !');
      getreal:=r;
    end else getreal:=rh;
  end;
end;


Endif}

procedure mischefarbe(var r,g,b:real);
var color:array[0..2] of shortint;
    altcol,nr:shortint;
    n:byte;
    altefarbe:array[0..3,0..2] of byte;
    buf:pointer;
    tasten,xpos,ypos,bufgrose:word;

  procedure balkengrafik(nr:byte);
  var n:byte;
      s:string[2];
{  Type TTransLate=array[0..15] of byte;
  const TransLate:TTransLate= (0,1,2,3,4,5,20,7,56,57,58,59,60,61,62,63);}
  begin
    mausunsicht;
    gotoxy(1,wherey-3);
    farbe({8}56,color[0],color[1],color[2]);
    case nr of
      0:begin farbe({9}57,color[0],0,0);setfillstyle(solidfill,9); end;
      1:begin farbe({11}59,0,color[1],0);setfillstyle(solidfill,11); end;
      2:begin farbe({12}60,0,0,color[2]);setfillstyle(solidfill,12); end;
    end;
    bar(298,succ(226+14*nr),color[nr]+298,pred(226+14*succ(nr)));
    setfillstyle(solidfill,lightgray);
    bar(succ(298+color[nr]),succ(226+14*nr),362,pred(226+14*succ(nr)));
    bar(280,succ(226+14*nr),296,pred(226+14*succ(nr)));
    str(color[nr]:2,s);
    setcolor(lightgreen);
    outtextxy(280,succ(226+14*nr),s);
    maussicht;
  end;

  procedure window(x1,y1,x2,y2:word);
  begin
    bufgrose:=imagesize(x1,y1,x2,y2);
    if maxavail>=bufgrose then begin
      getmem(buf,bufgrose);
      getimage(x1,y1,x2,y2,buf^);
    end else bufgrose:=0;
    setfillstyle(solidfill,lightgray);
    bar(x1,y1,x2,y2);
    setcolor(blue);
    moveto(x1+1,y1+1);
    lineto(x2-1,y1+1);
    lineto(x2-1,y2-1);
    lineto(x1+1,y2-1);
    lineto(x1+1,y1+1);
  end;

begin
  mausunsicht;
  mausgrafikcursor(5,5,kleinkreuz);
  window(275,210,365,270);
  for n:=0 to 3 do lesefarbe(2+n,altefarbe[n,0],altefarbe[n,1],altefarbe[n,2]);
  setfillstyle(solidfill,8);
  bar(280,213,360,225);
  Maussicht;
  color[0]:=round(r*63);
  color[1]:=round(g*63);
  color[2]:=round(b*63);
  for n:=0 to 2 do balkengrafik(n);

  repeat until not mauskeypressed;
  repeat
    repeat
      maustastpos(tasten,xpos,ypos);
    until tasten<>0;
    if (tasten<>2) and (ypos>=226) then begin
      nr:=(ypos-226) div 14;
      if nr>2 then nr:=2;
      altcol:=color[nr];
      color[nr]:=xpos-295;
      if color[nr]<0 then color[nr]:=0;
      if color[nr]>63 then color[nr]:=63;
      if altcol<>color[nr] then balkengrafik(nr);
    end;
  until (tasten=2);

  r:=color[0] / 63;
  g:=color[1] / 63;
  b:=color[2] / 63;
  Mausunsicht;
  if bufgrose>0 then begin
    putimage(275,210,buf^,normalput);
    freemem(buf,bufgrose);
  end;
  Maussicht;
  for n:=0 to 3 do farbe(2+n,altefarbe[n,0],altefarbe[n,1],altefarbe[n,2]);
end;

procedure ediere;
var z:byte;
    mausxyae:array[0..1,0..1] of word;
    xalt,yalt,x,y,hilf,ax,ay,by:real;
    graphdriver,graphmode:integer;
    CADende:boolean;
    punktanzahlbegin,maxx,maxy,tasten,hohe,breite,ybegin,xbegin,xpos,ypos,hilfw:word;

  procedure dateneingabe;
  begin
    textbackground(blue);
    textcolor(yellow);
    clrscr;
    writeln('CAD fr Rotationskrper':50);
    writeln;
    with umriss do begin
      xmax:=getreal(1,'Wie gro soll der Radius sein (xmax) ');
      ymin:=getreal(-1,'Wo soll das Objekt auf der y-Achse beginnen (ymin) ');
      ymax:=getreal(1,'Wo soll das Objekt auf der y-Achse enden (ymax) ');
      if ymin>ymax then begin
        hilf:=ymin;
        ymin:=ymax;
        ymax:=hilf;
      end;
      repeat
        xzuy:=getreal(xmax/(ymax-ymin),'X/Y auf dem Monitor ');
      until xzuy<>0;
    end;
  end;

  procedure koordinatenanzeigen;
  var buffer:string[7];
  begin
    setcolor(lightmagenta);
    if x<>xalt then begin
      str(x:2:4,buffer);
      setfillstyle(solidfill,blue);
      if (ypos<15) and (xpos>xbegin-5) then mausunsicht;
      bar(xbegin,0,breite+xbegin,hohe);
      outtextxy(xbegin,0,buffer);
      maussicht;
      xalt:=x;
    end;
    if y<>yalt then begin
      str(y:2:4,buffer);
      setfillstyle(solidfill,blue);
      if (ypos<15) and (xpos>xbegin-5) then mausunsicht;
      bar(ybegin,0,breite+ybegin,hohe);
      outtextxy(ybegin,0,buffer);
      maussicht;
      yalt:=y;
    end;
  end;

  procedure punkanzahlanzeigen;
  var buffer:string[2];
  begin
    setcolor(lightmagenta);
    str(umriss.punktanzahl+1:2,buffer);
    setfillstyle(solidfill,blue);
    if (ypos<15) then mausunsicht;
    bar(punktanzahlbegin,0,textwidth('22')+punktanzahlbegin,hohe);
    outtextxy(punktanzahlbegin,0,buffer);
  end;

  procedure setzepunkt;
  begin
    with umriss do begin
      inc(punktanzahl);
      if punktanzahl>maxpnts then error('So viele Punkte darf ein Umriss nicht haben !');
      mausunsicht;
      if punktanzahl>0 then begin
        setcolor(lightmagenta);
        line(round(punkt[pred(punktanzahl)].nrm.x),
             round(punkt[pred(punktanzahl)].nrm.y),xpos,ypos);
        putpixel(round(punkt[pred(punktanzahl)].nrm.x),
                 round(punkt[pred(punktanzahl)].nrm.y),lightcyan);
      end;
      putpixel(xpos,ypos,lightcyan);
      punkanzahlanzeigen;
      maussicht;
      maussicht;
      punkt[punktanzahl].crd.x:=x;
      punkt[punktanzahl].crd.y:=y;
      punkt[punktanzahl].nrm.x:=xpos;
      punkt[punktanzahl].nrm.y:=ypos;
      setcolor(yellow);
      repeat until not mauskeypressed;
      gesaved:=false;
    end;
  end;

  procedure gitter;
  var z:byte;
      pos,distx,disty:word;
  begin
    with umriss do begin
      hilf:=pysscrsizex/pysscrsizey;
      if xzuy<hilf then begin
       maxy:=getmaxy;
       maxx:=trunc(xzuy*getmaxx/hilf);
      end else begin
       maxx:=getmaxx;
       maxy:=trunc(getmaxy*hilf/xzuy);
      end;

      disty:=round((maxy-20)/((ymax-ymin)*10));
      distx:=round((maxx-20)/(xmax*10));
      hilfw:=10+round(xmax*10)*distx;
      pos:=10;
      setcolor(green);
      for z:=0 to round((ymax-ymin)*10) do begin
       line(10,round(pos),hilfw,round(pos));
       pos:=pos+disty;
      end;
      pos:=pos-disty;
      mausminmaxy(11,succ(round(pos)));
      mausxyae[1,0]:=11;
      mausxyae[1,1]:=succ(round(pos));
      ay:=(ymax-ymin)/(pos-9);

      hilfw:=10+round((ymax-ymin)*10)*disty;
      pos:=10;
      setcolor(green);
      for z:=0 to round(xmax*10) do begin
       line(round(pos),10,round(pos),hilfw);
       pos:=pos+distx;
      end;
      pos:=pos-distx;
      mausminmaxx(10,round(pos));
      mausxyae[0,0]:=10;
      mausxyae[0,1]:=round(pos);
      ax:=xmax/(pos-10);

      setcolor(yellow);
      line(10,0,10,maxy);
      hilfw:=10+round(ymax*10)*disty;
      line(0,hilfw,maxx,hilfw);
      outtextxy(0,0,'Y');
      outtextxy(maxx-textwidth('X'),hilfw+3,'X');
      ybegin:=textwidth('Y:  0.0000');
      xbegin:=getmaxx-2*ybegin;
      ybegin:=getmaxx-ybegin;
      outtextxy(xbegin,0,'X: 0.0000 Y: 0.0000');
      hohe:=textheight('X');
      breite:=textwidth('X:');
      xbegin:=xbegin+breite;
      ybegin:=ybegin+breite;
      breite:=textwidth(' 0.0000');
      outtextxy(getmaxx div 3,0,'verbrauchte Punkte:');
      punktanzahlbegin:=getmaxx div 3+textwidth('verbrauchte Punkte:');
      punkanzahlanzeigen;
      koordinatenanzeigen;
    end;
  end;

  procedure neuaufbau;
  var z:byte;
  begin
    with umriss do begin
      setcolor(lightmagenta);
      if punktanzahl>=1 then for z:=1 to punktanzahl do begin
        line(round(punkt[z].nrm.x),round(punkt[z].nrm.y),
             round(punkt[pred(z)].nrm.x),round(punkt[pred(z)].nrm.y));
        putpixel(round(punkt[pred(z)].nrm.x),
                 round(punkt[pred(z)].nrm.y),lightcyan);
      end;
      if punktanzahl>-1 then putpixel(round(punkt[punktanzahl].nrm.x),
               round(punkt[punktanzahl].nrm.y),lightcyan);
    end;
  end;

  procedure zeigemenu;
  var bildbuffer:pointer;
      pos1,pos2,pos3,xbegin,ybegin,yende:word;
      umrissverandert,ende:boolean;
      hilfpunkt:shortint;
      hilfr,hilfg,hilfb:real;
      mischen2mal:boolean;

  procedure menuan;
  begin
    if (maxx>=xbegin) then begin
      getmem(bildbuffer,imagesize(xbegin,ybegin,maxx,yende));
      mausunsicht;
      getimage(xbegin,ybegin,maxx,yende,bildbuffer^);
      maussicht;
    end;
    setfillstyle(solidfill,white);
    setcolor(black);
    mausunsicht;
    mausgrafikcursor(1,1,grospfeil);
    bar(xbegin,ybegin,getmaxx-10,yende);
    if umriss.punktanzahl>=0 then setcolor(black) else setcolor(lightgray);
    outtextxy(xbegin+2,ybegin+2,'Farbe Lsche Verschiebe ');
    setcolor(black);
    outtextxy(pos3,ybegin+2,'Ende');
    mausminmaxx(0,getmaxx);
    mausminmaxy(0,getmaxy);
    if menumauspos[0]<65000 then maussetpos(menumauspos[0],menumauspos[1]);
    maussicht;
  end;

  procedure menuaus;
  begin
    if (maxx>=xbegin) then begin
      mausunsicht;
      putimage(xbegin,ybegin,bildbuffer^,normalput);
      maussicht;
      freemem(bildbuffer,imagesize(xbegin,ybegin,maxx,yende));
    end else begin
      mausunsicht;
      setfillstyle(solidfill,blue);
      bar(xbegin,ybegin,getmaxx-10,yende);
      maussicht;
    end;
  end;

  function welcherpunkt:shortint;
  const maxreal=1.7e38;
  var tast,xp,yp:word;
      hilf:shortint;
  begin
    mausunsicht;
    maustastpos(tasten,menumauspos[0],menumauspos[1]);
    if editormauspos[0]<65000 then maussetpos(editormauspos[0],editormauspos[1]);
    mausgrafikcursor(5,5,kleinkreuz);
    maussicht;
    while mauskeypressed do;
    repeat until mauskeypressed;
    maustastpos(tast,xp,yp);
    hilf:=-1;
    with umriss do if (tast=1) and (punktanzahl>=0) then begin
      for tast:=0 to punktanzahl do with punkt[tast].nrm do
      if (abs(x-xp)<2) and (abs(y-yp)<2) then hilf:=tast;
    end;
    if hilf=-1 then begin
      sound(100);delay(100);nosound;
    end;
    welcherpunkt:=hilf;
  end;

  function whichpoint(xp,yp:word):shortint;
  const maxreal=1.7e38;
  var hilf:shortint;
      tast:word;
  begin
    hilf:=-1;
    with umriss do if (punktanzahl>=0) then begin
      for tast:=0 to punktanzahl do with punkt[tast].nrm do
      if (abs(x-xp)<2) and (abs(y-yp)<2) then hilf:=tast;
    end;
    if hilf=-1 then begin
      sound(100);delay(100);nosound;
    end;
    whichpoint:=hilf;
  end;

  begin
    maustastpos(tasten,editormauspos[0],editormauspos[1]);
    ende:=false; umrissverandert:=false;
    xbegin:=getmaxx - 16 - textwidth('Farbe Lsche Verschiebe Ende');
    pos1:=getmaxx - 16 - textwidth('Lsche Verschiebe Ende');
    pos2:=getmaxx - 16 - textwidth('Verschiebe Ende');
    pos3:=getmaxx - 16 - textwidth('Ende');
    ybegin:=getmaxy div 10;
    mischen2mal:=false;
    yende:=ybegin+textheight('F')+4;
    menuan;
    while mauskeypressed do;
    repeat
      maustastpos(tasten,xpos,ypos);
      if tasten=1 then begin
        if mausinxy(xbegin,ybegin,pos1,yende,false) then begin
          if mischen2mal then begin
            ende:=true;
          end else begin
            mischen2mal:=true;
            menuaus;
            with aktcolor do begin
              hilfr:=r/63;
              hilfg:=g/63;
              hilfb:=b/63;
              mischefarbe(hilfr,hilfg,hilfb);
              r:=round(hilfr*63);
              g:=round(hilfg*63);
              b:=round(hilfb*63);
            end;
            gesaved:=false;
          end;
        end else if mausinxy(pos1,ybegin,pos2,yende,false) then begin
          if (umriss.punktanzahl>-1) then begin
            dec(umriss.punktanzahl);
            ende:=true;
            umrissverandert:=true;
            gesaved:=false;
          end;
        end else if mausinxy(pos2,ybegin,pos3,yende,false) then begin
          menuaus;
          hilfpunkt:=welcherpunkt;
          if (hilfpunkt<>-1) then begin
            while mauskeypressed do;
            mausunsicht;
            maustastpos(tasten,menumauspos[0],menumauspos[1]);
            if editormauspos[0]<65000 then maussetpos(editormauspos[0],editormauspos[1]);
            mausgrafikcursor(5,5,kleinkreuz);
            maussicht;
            repeat until mauskeypressed;
            maustastpos(tasten,xpos,ypos);
            with umriss do begin
              y:=(ymax-ymin)-(ypos-10)*ay+ymin;
              x:=(xpos-10)*ax;
              punkt[hilfpunkt].crd.x:=x;
              punkt[hilfpunkt].crd.y:=y;
              punkt[hilfpunkt].nrm.x:=xpos;
              punkt[hilfpunkt].nrm.y:=ypos;
            end;
            gesaved:=false;
            ende:=true;
            umrissverandert:=true;
          end else menuan;
        end else if mausinxy(pos3,ybegin,getmaxx-10,yende,false) then begin
          cadende:=true;
          ende:=true;
        end else begin
          if mischen2mal then begin
            editormauspos[0]:=xpos;
            editormauspos[1]:=ypos;
            hilfpunkt:=whichpoint(xpos,ypos);
            if hilfpunkt>=0 then begin
              sound(1000);
              with umriss.punkt[hilfpunkt].color do begin
                r:=aktcolor.r;
                g:=aktcolor.g;
                b:=aktcolor.b;
              end;
              umrissverandert:=true;
              gesaved:=false;
              delay(50);
              nosound;
            end;
          end else ende:=true;
        end;
        while mauskeypressed do;
      end;
      if tasten=2 then begin
        ende:=true;
        while mauskeypressed do;
      end;
    until ende;
    maustastpos(tasten,menumauspos[0],menumauspos[1]);
    if umrissverandert then begin
      menuaus;
      mausunsicht;
      clearviewport;
      gitter;
      neuaufbau;
      maussicht;
    end else begin
      menuaus;
      mausunsicht;
      mausminmaxx(mausxyae[0,0],mausxyae[0,1]);
      mausminmaxy(mausxyae[1,0],mausxyae[1,1]);
      maussicht;
      setcolor(yellow);
    end;
    if editormauspos[0]<65000 then maussetpos(editormauspos[0],editormauspos[1]);
    mausgrafikcursor(5,5,kleinkreuz);
    maussicht;
  end;

begin
  CADende:=false;
  with umriss do begin
    if umriss.punktanzahl=-1 then dateneingabe else
    with umriss do xzuy:=xmax/(ymax-ymin);
{    graphdriver:=ega;
    graphmode:=egahi;}
    graphdriver:=detect;
    initgraph(graphdriver,graphmode,bgipath);
    grafikan:=true;
    setbkcolor(blue);
    gitter;
    if umriss.punktanzahl<>-1 then neuaufbau;
    mausgrafikcursor(5,5,kleinkreuz);
    if editormauspos[0]<65000 then maussetpos(editormauspos[0],editormauspos[1]);

    maussicht;
    repeat
      maustastpos(tasten,xpos,ypos);
      x:=(xpos-10)*ax;
      y:=(ymax-ymin)-(ypos-10)*ay+ymin;
      koordinatenanzeigen;
      if tasten=1 then setzepunkt;
      if tasten=2 then zeigemenu;
    until CADende;
  end;
  closegraph;
  grafikan:=false;
end;

procedure laden;
var umrissname:namestr;
begin
  suche.name:='*.RIS';
  findfirst('*.RIS',$3f,suche);
  while (doserror=0) do begin
    write(suche.name:20);
    findnext(suche);
  end;
  writeln;
  write('Geben Sie den Bilddateinamen ein (ohne Extension) : ');
  readln(name);
  if name<>'' then ladeumriss(name,umriss);
end;

procedure sichern;
var umrissname:namestr;
    umrissfile:file of umrisstyp;
    suche:searchrec;
begin
  write('Wie soll der Umriss heien (ohne Erweiterung) ? ');
  readln(umrissname);
  suche.name:=umrissname+'.RIS';
  findfirst(umrissname+'.RIS',$3f,suche);
  if doserror=0 then begin
    writeln(umrissname+'.RIS existiert schon. berschreiben (J/N) ?');
    repeat until keypressed;
    if upcase(readkey)<>'J' then exit;
  end;
  sichereumriss(umrissname,umriss);
  gesaved:=true;
end;

{IFOPT D-}
procedure eigenschaften;
var neuobr,neuog,neuob,z:byte;
    hilfr,hilfg,hilfb:real;

begin
  with mater do begin
    ka:=round(umriss.ka*63);
    kd:=round(umriss.kd*63);
    ks:=round(umriss.ks*63);
    spec.r:=round(umriss.osr*63);
    spec.g:=round(umriss.osg*63);
    spec.b:=round(umriss.osb*63);
    oe:=round(umriss.oe);
    difc.r:=round(umriss.odr*63);
    difc.g:=round(umriss.odg*63);
    difc.b:=round(umriss.odb*63);
    ambc.r:=umriss.color.r;
    ambc.g:=umriss.color.g;
    ambc.b:=umriss.color.b;
    alpha:=round(umriss.otrans*63);
    facetten:=n;
  end;
  materialmischen(false);
  with mater do begin
    umriss.ka:=ka/63;
    umriss.kd:=kd/63;
    umriss.ks:=ks/63;
    umriss.osr:=spec.r /63;
    umriss.osg:=spec.g /63;
    umriss.osb:=spec.b /63;
    umriss.oe:=oe;
    umriss.odr:=difc.r /63;
    umriss.odg:=difc.g /63;
    umriss.odb:=difc.b /63;
  end;
  with umriss.color do begin
    neuobr:=mater.ambc.r;
    neuog:=mater.ambc.g;
    neuob:=mater.ambc.b;
    for z:=0 to maxpnts do
    if (r=umriss.punkt[z].color.r) and (g=umriss.punkt[z].color.g) and
       (b=umriss.punkt[z].color.b) then begin
      umriss.punkt[z].color.r:=neuobr; umriss.punkt[z].color.g:=neuog;
      umriss.punkt[z].color.b:=neuob;
    end;
  end;
  umriss.color.r:=neuobr; umriss.color.g:=neuog; umriss.color.b:=neuob;
  umriss.otrans:=mater.alpha /63;
  n:=mater.facetten;
  vgaende;
end;


procedure zeichne;
var z:byte;
begin
  dreid.name:='';
  textur(50,50,1,1,1);
  with umriss do changesurfaceproperty(ka,kd,ks,osr,osg,osb,oe,odr,odg,odb,otrans);
  VRP.x:=0; VRP.y:=0; VRP.z:=0; NRP.x:=-1.5; NRP.y:=0.5; NRP.z:=1;
  VUP.x:=0; vup.Y:=0; VUP.z:=1; XMIN:=-2; YMIN:=-1.3; XSIZE:=4;
  VPD:=6; FPD:=5; BPD:=-5;
  repeat
    while abfrage do rotationskoerper(n,umriss,360,normen);
    if koords.ende then exit;
    grafikbegin;
    addambls(0,true,1,1,1);
    addinfls(1,true,1,1,1,-1,-1,-1);
    addinfls(2,true,1,1,1,1,-1,-1);
    addinfls(3,true,1,1,1,-1,1,-1);
    addinfls(4,true,1,1,1,-1,-1,1);
    addinfls(5,true,1,1,1,-1,1,1);
    while dolocalinit do begin
      with umriss do changesurfaceproperty(ka,kd,ks,osr,osg,osb,oe,odr,odg,odb,otrans);
      rotationskoerper(n,umriss,360,normen);
    end;
    for z:=0 to maxls do clearls(z);
    write(^G);
    if dreid.name<>'' then savebild;
    repeat until keypressed or mauskeypressed;
    ein:=readkey;
    if ein=#0 then ein:=readkey;
    grafikende;
  until ein=#27;
end;
{ENDIF}

procedure ownex;far;
begin
  if grafikan then closegraph;
  grafikan:=false;
  exitproc:=oldex;
  if (not gesaved) and (umriss.punktanzahl<>-1) then begin
    writeln;
    writeln('Das Objekt ist nicht gesichert. Sichern ? [J/N]');
    repeat
      ein:=upcase(readkey);
    until (ein='J') or (ein='N');
    if ein='J' then sichern;
  end;
end;

{$L EGAVGA}
procedure EGAVGAdriver;external;

begin
  if (registerbgidriver(@EGAVGAdriver)<0) then
     error('Fehler beim Anmelden der Grafiktreiber!');
  grafikan:=false;
  oldex:=exitproc;
  exitproc:=@ownex;
  mausinit(vorhanden,tastenanzahl);
  umriss.punktanzahl:=maxpnts;
  editormauspos[0]:=65000;menumauspos[0]:=65000;
  editormauspos[1]:=65000;menumauspos[1]:=65000;
  with umriss do begin
    ka:=0.05;kd:=0.8;ks:=0.05;osr:=1;osg:=1;osb:=1;
    oe:=5;odr:=1;odg:=1;odb:=1;otrans:=0;
    with color do begin
      r:=63;g:=63;b:=63;
      umrissfarbe(r/63,g/63,b/63,umriss);
    end;
  end;
  n:=30;umriss.punktanzahl:=-1;
  if paramcount<>0 then ladeumriss(paramstr(1),umriss);
  repeat;
    textbackground(blue);
    textcolor(yellow);
    clrscr;
    writeln('CAD fr Rotationskrper':50);
    writeln;
    if not vorhanden then textcolor(lightgray);
    writeln('A) Objekt edieren');
    textcolor(yellow);
    writeln('B) Objekt laden');
    if umriss.punktanzahl=-1 then textcolor(lightgray);
    writeln('C) Objekt sichern');
    textcolor(yellow);
    writeln('D) Objekteigenschaften festlegen');
    if umriss.punktanzahl=-1 then textcolor(lightgray);
    writeln('E) Objekt anschauen');
    textcolor(yellow);
    writeln('F) Neu');
    writeln('G) Ende');
    repeat until keypressed;
    ein:=upcase(readkey);
    if ein=#0 then ein:=readkey;
    case ein of
      'A':if vorhanden then ediere else begin
            textcolor(red);
            writeln('Keine Maus gefunden !',^G);
            delay(1000);
          end;
      'B':laden;
      'C':if umriss.punktanzahl>-1 then sichern else begin
            textcolor(red);
            writeln('Keine Objekt geladen !',^G);
            delay(1000);
          end;
      'D':{IFOPT D-}eigenschaften{ENDIF};
      'E':if umriss.punktanzahl>-1 then {IFOPT D-}zeichne{Endif} else begin
            textcolor(red);
            writeln('Keine Objekt geladen !',^G);
            delay(1000);
          end;
      'F':begin
            if not gesaved then begin
              write('Wollen Sie das jetzige Objekt wirklich lschen ?');
              if upcase(readkey)='J' then gesaved:=true;
            end;
            if gesaved then begin
              umriss.punktanzahl:=maxpnts;
              with umriss do begin
                ka:=1/3;kd:=1/3;ks:=1/3;osr:=0.5;osg:=0.5;osb:=0.5;
                oe:=0.5;odr:=0.5;odg:=0.5;odb:=0.5;
                with color do begin
                  r:=30;g:=30;b:=30;
                  umrissfarbe(r/63,g/63,b/63,umriss);
                end;
              end;
              n:=30;umriss.punktanzahl:=-1;
            end;
          end;
    end;
  until ein='G';
{  if (not gesaved) and (umriss.punktanzahl>-1) then begin
    writeln('Das Objekt ist nicht gesichert. Sichern ? (J/N)');
    if upcase(readkey)<>'N' then sichern;
  end;}
end.