unit trans3d;
interface
uses crt,dos;
const genauigkeit:word=1024;
      bgipath='';
      epsilon=1E-10;
      maxpnts=50;
      pysscrsizex=24.0;
      pysscrsizey=17.0;
      colrange = 64;
      xdat=1;
      ydat=2;
      zdat=4;
      nrmdat=8;
      texturdat=16;
      materialdat=32;
      realdat=64;
      kartemaxx=359;
      kartemaxy=479;
      flaeche=true;
      koerper=false;
      normal=0;
      isvis=1;
      isinnpc=2;
      isinwc=4;
      isindc=8;
      notused=16;
      gouraud=true;
      flat=false;

{$ifopt N+} type real=single; {$endif}
type fix = record case boolean of
             true:(fix:longint);
             false:(f:word;i:integer);
           end;
     RGB  = record r,g,b:real; end;
     RGBb = record r,g,b:byte; end;
     RGBi = record r,g,b:integer; end;
     RGBf = record r,g,b:fix; end;
     mat4=array[0..3,0..3] of real;
     vct3=record x,y,z:real; end;
     vct4=record w,x,y,z:real; end;
     vertex=record
       crd,nrm:vct3;
       c:RGB;
     end;
     polyobjtyp=array[0..maxpnts] of vertex;
     trafstackptr=^trafstacktyp;
     trafstacktyp = record
                      mc_wc,mc_npc,mc_dc,
                      wc_mc,wc_dc,wc_npc,
                      npc_mc,npc_dc:mat4;
                      vor,nach:trafstackptr;
                    end;
     shd_vtx= record x,y,z:integer; c:RGBb; end;
     polyscrtyp=array[0..maxpnts] of shd_vtx;
     zbufferspan=array[0..kartemaxx] of integer;
     spanptr=^zbufferspan;
     lstype=(ambient,infinite,positional,spot);
     surfacepropertytyp=record
                          ka,kd,ks,oe:real;os,od:rgb;
                          alpha:real;
                        end;
     plsentry = ^lsentry;
     lsentry= record
                nr:integer; typ:lstype; active:boolean;
                lc,kalc,kdlc,ksoslc:rgb;
                c1,c2,le,cosash:real;
                ld,lp:vct3;
                next,pred,
                nextactthistyp,
                predactthistyp: plsentry;
              end;
     meshpnttyp = record
                     flags:byte;
                     a:vertex;
                     h:vct4;
                     l:shd_vtx;
                   end;
     meshlinetyp=array[0..maxpnts] of meshpnttyp;
     meshtyp=record
               m:array[0..maxpnts] of ^meshlinetyp;
               xmax,ymax:byte;
               volume:vct3;
             end;
     intptr=^integer;
const MaxPnts2=3000; MaxAreas=3000;
type fourIndTyp=array[0..3] of integer;
     aInfTyp=record
               pInd:fourIndTyp;
               c,energie:rgb;
             end;
     paInfTyp=^aInfTyp;

var pArr:array[0..MaxPnts2] of ^Vct3;
    aArr:array[0..MaxAreas] of paInfTyp;
const pCnt:integer=-1;
      aCnt:integer=-1;
      normals:boolean=true;
      inverss:boolean=false;

const e:mat4=((1.0,0.0,0.0,0.0), (0.0,1.0,0.0,0.0),
              (0.0,0.0,1.0,0.0), (0.0,0.0,0.0,1.0));

      e_z: vct3=(x:0.0;y:0.0;z:1.0);
      me_z:vct3=(x:0.0;y:0.0;z:-1.0);
      flipareaenabled:boolean=false;
      wireframe:boolean=false;
      trifillenable : boolean=true;
      shadingmethod : boolean = gouraud;
      surfaceproperty: surfacepropertytyp= (ka:1/3; kd:1/3; ks:1/3;
                                            oe:10; os:(r:1;g:1;b:1);
                                                   od:(r:1;g:1;b:1);
                                                   alpha:0.5);
      clipmode:(inside,outside,toclip)=toclip;
      volclipcode:integer=$FF;
      clipcube:boolean=false;
      bkcolor:rgbb=(r:0;g:0;b:0);
      bkcolorr:rgb=(r:0.0;g:0.0;b:0.0);
      energie:rgb=(r:0.0;g:0.0;b:0.0);
      nebel:boolean=false;
      ende:integer=0;
      ender:real=0;
      VRP:vct3=(x:0;y:0;z:0);
      NRP:vct3=(x:1;y:1;z:1);
      VUP:vct3=(x:0;y:0;z:1);
      XMIN:real=-1.5;
      YMIN:real=-1.1;
      XSIZE:real=3;
      VPD:real=6;
      FPD:real=5;
      BPD:real=-5;
      speicherplatz:word=$8000;
      lichtgesch:boolean=false;
      durchsichtig:boolean=false;
      p:real=0.99;
      v:vct3=(x:1;y:1;z:1);
      lichtberechnet:boolean=false;
      name:namestr='';
      brille:boolean=false;
      mapcolor:byte=15;
      augendist:real=0.5;
      frame:boolean=false;


var MC_WC:mat4;
    xwinsize,ywinsize:real;
    xwinofs,ywinofs:integer;
    MatsChanged:boolean;
    eyepoint:vct3;
    trafstack:trafstackptr;
    zbuffer:array[0..kartemaxy] of spanptr;
    _pixelhochzubreit:real;
    grafmode:integer;
    amblsdefined:boolean;
    amblsc:rgb;
    lslistroot,lslistend,
    firstinf,lastinf,
    firstpos,lastpos,
    firstspt,lastspt:plsentry;
    _VRP,_NRP,_VUP: vct3;
    _VPD,_FPD,_BPD,_xMin,
    _ymin,_xsize,_ysize:real;
    _lux,_luy,_rox,_roy:real;
    _ysubu,_ysubo,
    _spanmemsize,
    _xmaxglobal,
    _ymaxglobal: integer;
    _wrkarr:meshtyp;
    datei : file;
    gezeichnet:boolean;
    augenvector,hilfnrp:vct3;
    _ZRM:real;
    emshandle:word;
    totalpages:word;
    _useems:boolean;
    emsbufbegin:longint;

procedure Rotate(achse:integer;w:real); {x=1;y=2;z=3; w in Grad gegen Uhrzeigersinn}
procedure translate(xv,yv,zv:real);
procedure Scale(scx,scy,scz:real);
procedure pushtrafs;
procedure poptrafs;
procedure copytrafs;
procedure savebild;
procedure changesurfaceproperty(newka,newkd,newks:real;
                                newosr,newosg,newosb:real;
                                newoe:real;
                                newodr,newodg,newodb:real;
                                newalpha:real);
procedure changespeed(newp,newvx,newvy,newvz:real);
procedure norm(ebene:boolean);
procedure textur(x1,y1:byte;cr,cg,cb:real);
procedure setzelichter;
procedure addambls(nr:integer; active: boolean; lcr,lcg,lcb:real);
procedure addinfls(nr:integer; active:boolean; lcr,lcg,lcb:real; ldx,ldy,ldz:real);
procedure addposls(nr:integer; active:boolean; lcr,lcg,lcb:real; lpx,lpy,lpz,
                   c1,c2:real);
procedure addsptls(nr:integer; active:boolean; lcr,lcg,lcb:real; ldx,ldy,ldz,
                   lpx,lpy,lpz,c1,c2,le,as:real);
procedure switchls(nr:integer; on:boolean);
procedure clearls(nr:integer);
function lsnrexists(nr:integer; var lsp:plsentry):boolean;
function maxls:integer;
procedure backgroundcolor(r,g,b:real);
procedure setnebel(unsichtbar,r,g,b:real);
procedure initmesh;
procedure putinmesh(x,y:integer; var crd,nrm:vct3);
procedure putnotused(x,y:integer);
procedure mesh;
procedure meshextensions(x,y:byte);
procedure grafikende;
procedure grafikbegin;
procedure error(s:string);
{procedure MCtoDCi(a:vct3; var x,y:integer);
procedure MCtoDC(a:vct3; var x,y:real);}
function VGAvorhanden:boolean;
function donorm(var v:vct3):boolean;
{procedure init;}
procedure SichereSCN(datname:pathstr);
procedure defineclipvolume(xm,ym,zm,r,g,b:real);
procedure undefclipvolume;

implementation

var _a,_b,_c,_t:real;
    _flip:boolean;
    max:longint;
procedure backgroundcolor(r,g,b:real);
begin
  bkcolorr.r:=r*colrange;
  bkcolorr.g:=g*colrange;
  bkcolorr.b:=b*colrange;
  bkcolor.r:=round(r*pred(colrange));
  bkcolor.g:=round(g*pred(colrange));
  bkcolor.b:=round(b*pred(colrange));
  if bkcolor.r>pred(colrange) then bkcolor.r:=pred(colrange);
  if bkcolor.g>pred(colrange) then bkcolor.g:=pred(colrange);
  if bkcolor.b>pred(colrange) then bkcolor.b:=pred(colrange);
end;

procedure changesurfaceproperty(newka,newkd,newks:real;
                                newosr,newosg,newosb:real;
                                newoe:real;
                                newodr,newodg,newodb:real;
                                newalpha:real);begin end;

procedure changespeed(newp,newvx,newvy,newvz:real);begin end;
procedure addambls(nr:integer; active: boolean; lcr,lcg,lcb:real);begin end;
procedure addinfls(nr:integer; active:boolean; lcr,lcg,lcb:real; ldx,ldy,ldz:real);begin end;
procedure addposls(nr:integer; active:boolean; lcr,lcg,lcb:real; lpx,lpy,lpz,
                   c1,c2:real);begin end;
procedure addsptls(nr:integer; active:boolean; lcr,lcg,lcb:real; ldx,ldy,ldz,
                   lpx,lpy,lpz,c1,c2,le,as:real);begin end;
procedure switchls(nr:integer; on:boolean);      begin end;
procedure clearls(nr:integer);                   begin end;
function lsnrexists(nr:integer; var lsp:plsentry):boolean;begin end;
function maxls:integer;begin end;
procedure setnebel(unsichtbar,r,g,b:real);begin end;

(*-A-*)
procedure line2d(x1r,y1r,x2r,y2r:real);
begin
 { map(mapcolor);
  line(round(x1r),round(y1r),round(x2r),round(y2r));}
end;
(*-E-*)

procedure error(s:string);
var c:char;
begin
{  if grafmode<0 then vgaende else closegraph;}
  if s<>'' then begin
    textcolor(yellow);
    textbackground(blue);
    write(#7,s);
    c:=readkey;
  end else write(#7);
  halt;
end;

(*$I TransVIE.INC  *)
(*$I MESHMCWC.INC     *)

function VGAvorhanden:boolean;
var mode,driver:integer;
begin
{  detectgraph(mode,driver);}
  VGAvorhanden:=false;{mode=9;}
end;

{PROCEDURE INIT;
VAR zahler:byte;
    graphdriver,grapherror: integer;
begin
  case grafmode of
  -1:begin
       videomodus($13);
       _xmaxglobal:=319; _ymaxglobal:=199;
       setclutrgb;
     end;
  -2:begin
       scqmode;
       _xmaxglobal:=359; _ymaxglobal:=479;
       setclutrgb;
     end;
  else begin
         graphdriver:=detect;
         initgraph(graphdriver,grafmode,bgipath);
         grapherror:=graphresult;
         if (grapherror<>GrOK) then begin
           clrscr;
           textcolor(red);
           writeln('Grafik Fehler:');
           writeln(GraphErrorMsg(grapherror));
           repeat until keypressed;
           halt(1);
         end;
         _xmaxglobal:=getmaxx; _ymaxglobal:=getmaxy;
       end;
  end;
  _pixelhochzubreit:=((pysscrsizey/succ(_ymaxglobal)) /
                      (pysscrsizex/succ(_xmaxglobal)));
  MC_WC:=E;
  trafstack:=nil;
  lslistroot:=nil;
  if brille then begin
    for zahler:=0 to 15 do
     farbe(zahler+14*byte(zahler=6)+48*byte(zahler>7),(zahler mod 4)*21,(zahler div 4)*21,0);
  end;
  if ((bkcolor.r<>0) or (bkcolor.g<>0) or (bkcolor.b<>0)) and (grafmode<0) then begin
    zahler:=((bkcolor.r shl 2) and $e0) or ((bkcolor.g shr 1) and $1C) or (bkcolor.b shr 4);
    map($F);
    fillchar(mem[$A000:0],$FFFF,zahler);
  end;
end;}

procedure savebild;
{var n:byte;}
begin
{  if grafmode=-1 then begin
    assign(datei,name+'.PIC');
    rewrite(datei,1);
    blockwrite(datei,mem[$A000:0],64000);
    close(datei);
  end;
  if grafmode=-2 then begin
    assign(datei,name+'.PIC');
    rewrite(datei,1);
    for n:=0 to 3 do begin
      readmap(n);
      blockwrite(datei,mem[$A000:0],43200);
    end;
    close(datei);
  end;}
end;

procedure setzelichter;
begin
  addambls(succ(maxls),true,1,1,1);
  addinfls(succ(maxls),true,1,1,1,-1,-1,-1);
  addinfls(succ(maxls),true,1,1,1,1,-1,-1);
  addposls(succ(maxls),true,1,1,1,        -0.9,0,0.7,1,0);
end;

procedure grafikende;
begin
{  if grafmode<0 then vgaende else closegraph;}
end;

procedure grafikbegin;
begin
{  while keypressed do readkey;
  init;
  gezeichnet:=false;
  if brille then begin
    calcaugenvector(nrp,vrp,vup,augendist,augenvector);
    hilfnrp:=nrp;
    nrp.x:=nrp.x+augenvector.x;
    nrp.y:=nrp.y+augenvector.y;
    nrp.z:=nrp.z+augenvector.z;
    mapcolor:=3;
  end;
  setviewglobal(VRP,NRP,VUP,xMin,yMin,xSize,vpd,FPd,bpd);
  setscreenglobal(0,_ymaxglobal,_xmaxglobal,0);}
end;

begin
  wireframe:=not VGAvorhanden;
  if wireframe then grafmode:=0 else grafmode:=-1;
  initmesh;
  textur(_wrkarr.xmax,_wrkarr.ymax,1,1,1);
  clipcube:=false;
  _useems:=false;
end.