unit USzene;
interface
uses crt,graph,dos,Maus,Objects,TGDriver,TGViews,TGDialog,Matrizen,TGApp,TGMouse,
     TGstdDlg,TGMsgBox,WizView;
const dsKoorSys=1;
      dsObjekt=2;
      dsKoorEcken=4;
      dsMeshEcken=8;
      af3D=0;
      afXYZ=1;
      cmGetSzene=900;
      cmSichern=901;
      cmLoeschen=902;
      cmNextObj=903;
      cmLastObj=904;
      cmUpObj=905;
      cmDownObj=906;
      cmObjektParameter=907;
      cmSzenenParameter=908;
      cmLadeMaterial=909;
      cmSichereMaterial=910;
      cmLadeTextur=911;
      cmUpdateLister=999;
      obKugel=1;
      obTorus=2;
      obEbene=3;
      obSaule=4;
      obDreieck=5;
      obViereck=6;
      obRotationskoerper=7;
      obDose=8;
      obZiehkoerper=9;
      cmKugel=1001;
      cmTorus=1002;
      cmEbene=1003;
      cmSaule=1004;
      cmDreieck=1005;
      cmViereck=1006;
      cmRotationskoerper=1007;
      cmDose=1008;
      cmZiehkoerper=1009;
      cmChangeds3D=1050;
      cmChangedsXYZ=1051;
      hcGruppe=1048;
      hcWurzel=1049;
      scKreuz=1001;
      scRingKreuz=1002;
      scUhr=1003;

      sfFlipAreaEnabled=1;
      sfWireFrame=2;
      sfTrifillenabled=4;
      sfshadingmethod=8;
      sfLampe=16;
      sfclipcube=32;
      sfNebel=64;
      sfbrille=128;
      sfframe=256;
      sffarbig=512;
      sfsw256=1024;
      sfInteraktivMaus=2048;
      sfInteraktivJoystick=4096;
      sfVariablenAnzeigen=8192;
      sfAutoSave=16384;
      sfHintergrund=32768;

      dfkoordinaten=0;
      dfxz=1;
      dfYZ=2;
      dfXY=3;
      dfgesamt=4;
      dfHigh=5;
      dfLow=6;

      amNormal=0;
      amXor=1;
      smLang=0;
      smKurz=1;
      asSzene=1;
      asDesk=2;

      dx0=0;
      dy0=0;
      zoom0=100;
      qxy=10;
      qzoom=60;

      maxpnts=50;

Type TOptions = record
       SpeicherModus:word;
       AnzeigeModus:word;
       Autosave:word;
       Verzeichnis:pathstr;
     end;
const WizOpt:TOptions=(
        SpeicherModus:smLang;
        AnzeigeModus:amXOR;
        Autosave:asDesk+asSzene;
        Verzeichnis:'C:\TP\3D\');
Type rgb=record r,g,b:single; end;
     TGreyTab=array[0..3] of rgb;
     PDaten=^TDaten;
     TDaten=record
       Flag:Word;
       Darstellung:Word;
       XMIN:real;
       YMIN:real;
       XSIZE:real;
       VPD:real;
       FPD:real;
       BPD:real;
       mass:real;
       augendist:real;
       Nebel:integer;
       Lampen1,Lampen2:byte;
       LampeSkalierung:T3DPoint;
       bkcolor,nebelcolor:rgb;
       GreyTab:TGreyTab;
       VRP,NRP,VUP:T3DPoint;
     end;

const edaten:tdaten=(Flag:sfFlipAreaEnabled+sfTrifillenabled+sfshadingmethod+
                          sffarbig;
                     Darstellung:dfHigh;
        XMIN:-1.5;YMIN:-1.1;XSIZE:3;
        VPD:6;FPD:5;BPD:-5;mass:3;augendist:0.5;
        Nebel:0;Lampen1:10;Lampen2:10;
        LampeSkalierung:(x:1;y:1;z:1);
        bkcolor:(r:0.0;g:0.0;b:0.0);
        nebelcolor:(r:0.0;g:0.0;b:0.0);
        greytab:((r:1;g:1;b:1),(r:1;g:0;b:0),(r:0;g:1;b:0),(r:0;g:0;b:1));
        VRP:(x:0;y:0;z:0);
        NRP:(x:1;y:1;z:1);
        VUP:(x:0;y:0;z:1));

Type PMesh=^TMesh;
     TMesh=object(TObject)
       x,y:byte;
       Points:Pointer;
       Erzeuger:word;
       Nutzer:word;
       constructor init(ax,ay:byte);
       destructor done; virtual;
       function PointAt(ax,ay:byte):P3DPoint;
       procedure putin(ax,ay:byte;var p:T3dPoint);
       procedure changeSize(ax,ay:byte);
     end;

     PPoint=^TPoint;

     P2DLine=^T2DLine;
     T2DLine=object(TObject)
       x:byte;
       Points:Pointer;
       constructor init(ax:byte);
       destructor done; virtual;
       function PointAt(ax:byte):PPoint;
       procedure putin(ax:byte;var p:T3dPoint);
     end;

     P3DGroup = ^T3DGroup;
     P3DView = ^T3DView;

     P2DMesh=^T2DMesh;
     T2DMesh=object(TObject)
       x,y:byte;
       Points:Pointer;
       objekt:P3DView;
       constructor init(ax,ay:byte;Aobjekt:P3DView);
       destructor done; virtual;
       function PointAt(ax,ay:byte):PPoint;
       procedure putin(ax,ay:byte;var p:TPoint);
     end;

     PEcke=^TEcke;
     TEcke=object(TView)
       procedure Handleevent(var event:TEvent); virtual;
       procedure draw; virtual;
     end;

     PEcken=^TEcken;
     TEcken=object(TGroup)
       objekt:P3DView;
       Flag:Boolean;
       constructor initKoorSys(KoorSys:TKoorSys;Aobjekt:P3DView);
       procedure Changekoorsys(Koorsys:TKoorsys);
       constructor initMeshs(mesh:TMesh;Aobjekt:P3DView);
       procedure ChangeMeshs(Mesh:Tmesh);
       function GetPositionctx:word; virtual;
     end;

     Psicht=^TSicht;
     TSicht=object(TGroup)
       OriginalWC_DC,WC_DC:TMatrix;
       Art:Word;
       Puffer:P2DMesh;
       constructor init(Bounds:TRect;AWC_DC:TMatrix);
       constructor load(var s:TStream);
       destructor done; virtual;
       procedure store(var s:TStream);
       procedure Handleevent(var event:TEvent); virtual;
       procedure maleMesh(Mesh:PMesh;Buffer:PMesh;OldMC_WC,MC_WC:PMatrix;
                   objekt:P3DView;var erste,imPuffer:boolean;remove:boolean);
       procedure MaleKoor(OldMC_WC,MC_WC:PMAtrix;objekt:P3DView);
       function getpalette:PPalette; virtual;
       procedure setstate(Astate:word;enable:boolean); virtual;
       procedure Draw; virtual;
       procedure DrawKoorSys(var KoorSys:TKoorSys;loschen:boolean);
       procedure RemoveKoorSys(AObjekt:P3DView);
       Function GetKoorsys(AObjekt:P3DView):PEcken;
       procedure AddKoorSys(KoorSys:TKoorSys;AObjekt:P3DView);
       procedure RemoveMeshs(AObjekt:P3DView);
       Function GetMeshs(AObjekt:P3DView):PEcken;
       procedure AddMeshs(Mesh:TMesh;AObjekt:P3DView);
       procedure newWC_DC(var AWC_DC:TMatrix);
       procedure setbounds(bounds:TRect;xmin,ymin,zoom:single); virtual;
       procedure DrawMesh(Mesh:PMesh;Buffer:PMesh;var erste,imPuffer:boolean;loschen:boolean); virtual;
       function GetPositionctx:word; virtual;
     end;

     Pyzsicht=^TYZSicht;
     TYZSicht=object(TSicht)
       constructor init(Bounds:TRect);
{       procedure maleMesh(Mesh:PMesh;Buffer:PMesh;OldMC_WC,MC_WC:PMatrix;objekt:P3DView;var erste,imPuffer:boolean); virtual;}
     end;

     PXZSicht=^TXZSicht;
     TXZSicht=object(TSicht)
       constructor init(Bounds:TRect);
{       procedure maleMesh(Mesh:PMesh;Buffer:PMesh;OldMC_WC,MC_WC:PMatrix;objekt:P3DView;var erste,imPuffer:boolean); virtual;}
     end;

     PXYSicht=^TXYSicht;
     TXYSicht=object(TSicht)
       constructor init(Bounds:TRect);
{       procedure maleMesh(Mesh:PMesh;Buffer:PMesh;OldMC_WC,MC_WC:PMatrix;objekt:P3DView;var erste,imPuffer:boolean); virtual;}
     end;

     PAnsicht=^TAnsicht;
     TAnsicht=object(TWindow)
       Sicht:PSicht;
       ZoomScroll,XScroll,Yscroll:PScrollbar;
       constructor init(var bounds:TRect;Atitel:TTitleStr;Asicht:Psicht);
       constructor load(var s:TStream);
       procedure store(var s:TStream);
       procedure Handleevent(var event:TEvent); virtual;
       function getpalette:PPalette; virtual;
       procedure InitFrame; virtual;
     end;

     PLister=^TLister;
     TLister=object(TDialog)
       Objekte:P3DGroup;
       constructor init(var bounds:TRect;AObjekte:P3DGroup);
       function getpalette:PPalette; virtual;
     end;

     PParamDiag=^TParamDiag;
     TParamDiag=object(TDialog)
     end;


     PRoot=^TRoot;

     PSzene=^TSzene;
     TSzene=object(TWindow)
       gesichert:boolean;
       Sichten:PCollection;
       Lister:PLister;
       Paramdiag:PParamDiag;
       AktGruppe:P3dGroup;
       Root:PRoot;
       name:pathstr;
       val:boolean;
       Daten:TDaten;
       currentobjekt:P3DView;
       constructor init;
       constructor lade(Aname:pathstr);
       constructor load(var s:TStream);
       destructor done; virtual;
       procedure Store(var s:TStream); virtual;
       procedure draw; virtual;
       procedure handleevent(var event:TEvent); virtual;
       procedure Male;
       procedure MaleSicht(sicht:PSicht);
       Procedure sichern;
       function getpalette:PPalette; virtual;
       procedure SetTitle(ATitle:TTitlestr);
       procedure SetName(Aname:Pathstr);
       procedure setCurObj(obj:P3DView);
       function Valid(Command: Word): Boolean; virtual;
       procedure error(s:string);
       procedure zeilenerror(s:string);
       procedure interpretiere(datname:pathstr;start:word);
       procedure transdaten(datname:pathstr);
     end;

     
     PObjektCollection=^TObjektCollection;
     TObjektCollection=object(TCollection)
       function vorhanden(x,y:byte;p:word):PMesh;
       procedure losche(x,y:byte;p:word);
       function neu(x,y:byte;p:word):PMesh;
     end;

     TRGB=record r,g,b:single; end;
     TMaterial=record
       ka:single;
       oa:TRgb;
       kd:single;
       od:TRgb;
       ks:single;
       os:TRgb;
       alpha:single;
       oe:single;
     end;

     PParamdata=^TParamData;
     TParamdata=record
       MaterialName:Namestr;
       Textur:NameStr;
       Material:TMaterial;
       x,y:byte;
       Translation:T3DPoint; {Ursprungspunkt}
       Scalierung:T3DPoint;  {Verzerrung in x,y,z-Richtung}
       Rotation:T3DPoint;    {Rotation um x,y,z-Achse}
       Darstellung:word;
     end;

     TData=record
       x,y:byte;
       M:TMaterial;
       Materialname:Namestr;
       textur:Pathstr;
       Darstellung:word;
       case word of
         obKugel: ();
         obEbene: ();
         obTorus: (
           r1,r2:single);
         obSaule: ();
         obDose:  (
           n3:byte);
     end;

     PObjektParameterDialog=^TObjektParameterDialog;
     TObjektParameterDialog=object(TDialog)
       TexturName,MaterialName:PInputLine;
       InputZahl:array[0..13] of PInputLine;
       procedure HandleEvent(var Event: TEvent); virtual;
     end;

     T3DView = object(TView)
       Szene:PSzene;
       MC_WC:TMatrix;
       Mesh:PMesh;
       paramdata:TParamdata; {Paramdata mu die letzte Variable bleiben!}
       constructor Init(var pos: T3DRect;aszene:PSzene;ax,ay:byte);
       constructor Load(Var S: TStream);
       destructor Done; virtual;
       procedure HandleEvent(var Event: TEvent); virtual;
       procedure Store(var S: TStream);
       procedure CalcObjekt; virtual;
       function Calc:boolean; virtual;
       procedure Draw; virtual;
       procedure ReDraw(OldMC_WC,NewMC_WC:PMatrix;remove:boolean);
       procedure maleSicht(Sicht:PSicht);
       procedure DrawView; virtual;
       function RegNr:word; virtual;
       {procedure select; virtual;
       procedure unfocus; virtual;
       procedure focus; virtual;
       procedure setselect; virtual;
       procedure setunfocus; virtual;
       procedure setfocus; virtual;
       procedure setstate(Astate:word;enable:boolean); virtual;}
       procedure EckePressed(anr:byte); virtual;
       procedure MeshPressed(anr:byte); virtual;
       procedure sichern(var f:text); virtual;
       {constructor lade(var f:text;aszene:Pszene);}
       procedure ChangeDarstellung(ADarstellung:word);
       procedure SetParam(AData:TData); virtual;
       function ObjektDialog(name:pathstr;hohe:byte):PObjektParameterDialog; virtual;
       procedure ExecObjektDialog; virtual;
     end;

     Groupstr=string[15];

     T3DGroup = object(TGroup)
       szene:PSzene;
       name:groupstr;
       constructor Init(Aname:groupstr;ASzene:PSzene);
       procedure HandleEvent(var Event: TEvent); virtual;
       procedure SetState(astate:word;enable:boolean); virtual;
       procedure Focus3DGroup;
       procedure draw; virtual;
       procedure ReDraw; virtual;
       procedure maleSicht(Sicht:PSicht);
       procedure sichern(var f:text); virtual;
       procedure ChangeDarstellung(ADarstellung:word);
       procedure SetName(Aname:groupstr);
     end;

     PBewege=^TBewege;
     TBewege = object(TDialog)
       constructor init(var Bounds:TRect;ATitle:TTitlestr);
       destructor done; virtual;
       function Move(obj:P3DView;o:TPoint;event:TEvent):boolean; virtual;
     end;

     PVerschiebe=^TVerschiebe;
     TVerschiebe = object(TBewege)
       constructor init(var Bounds:TRect);
       function Move(obj:P3DView;o:TPoint;event:TEvent):boolean; virtual;
     end;

     PDrehe=^TDrehe;
     TDrehe = object(TBewege)
       constructor init(var Bounds:TRect);
       function Move(obj:P3DView;o:TPoint;event:TEvent):boolean; virtual;
     end;

     PDehne=^TDehne;
     TDehne = object(TBewege)
       constructor init(var Bounds:TRect);
       function Move(obj:P3DView;o:TPoint;event:TEvent):boolean; virtual;
     end;

     PKugel=^TKugel;
     TKugel=object(T3dview)
       constructor Init(var pos: T3DRect;aszene:PSzene;ax,ay:byte);
       procedure CalcObjekt; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
     end;

     PTorus=^TTorus;
     TTorus=object(T3dview)
       r1,r2:single;
       constructor Init(var pos: T3DRect;aszene:PSzene;ar1,ar2:single;ax,ay:byte);
       procedure CalcObjekt; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
     end;

     PEbene=^TEbene;
     TEbene=object(T3dview)
       constructor Init(var pos: T3DRect;aszene:PSzene;ax,ay:byte);
       procedure CalcObjekt; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
     end;

     PSaule=^TSaule;
     TSaule=object(T3dview)
       constructor Init(var pos: T3DRect;aszene:PSzene;ax,ay:byte);
       procedure CalcObjekt; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
     end;

     PDose=^TDose;
     TDose=object(T3dview)
       n3:byte;
       constructor Init(var pos: T3DRect;aszene:PSzene;ax,ay,an3:byte);
       procedure CalcObjekt; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
     end;

     PDreieck=^TDreieck;
     TDreieck=object(T3dview)
       nr:word;
       constructor Init(var pos: T3DRect;aszene:PSzene;p1,p2,p3:T3DPoint);
       procedure CalcObjekt; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
       procedure Meshpressed(anr:byte); virtual;
     end;

     PViereck=^TViereck;
     TViereck=object(TDreieck)
       constructor Init(var pos: T3DRect;aszene:PSzene;p1,p2,p3,p4:T3DPoint);
       procedure CalcObjekt; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
     end;

     PRotationskoerper=^TRotationskoerper;
     TRotationskoerper=object(T3dview)
       name:pathstr;
       Winkel:word;
       nr:word;
       constructor Init(var pos: T3DRect;aszene:PSzene;aname:Pathstr;ay:byte;awinkel:word);
       procedure CalcObjekt; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
       {procedure SetParam(AData:TData); virtual;}
     end;

     PZiehKoerper=^TZiehKoerper;
     TZiehKoerper=object(T3dview)
       name:pathstr;
       winkel:word;
       nr:word;
       constructor Init(var pos: T3DRect;aszene:PSzene;aname:Pathstr;ay:byte);
       procedure CalcObjekt; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
     end;

     TRoot=object(T3DGroup)
       Hilf,Objekte,Licht:P3DGroup;
       constructor init(ASzene:PSzene);
       procedure sichern(var f:text); virtual;
     end;

procedure Register3DViews;
function ExecDialog(P: PDialog; Data: Pointer): Word;

implementation
var ObjektCollection:PObjektCollection;
const Bewegung:PBewege=nil;
      maxrotationskoerper:word=0;
      maxziehkoerper:word=0;
      maxdreieck:word=0;
      maxviereck:word=0;
      eMaterial:TMAterial=(ka:0.05;oa:(r:1;g:1;b:1);
                           kd:0.8;od:(r:1;g:1;b:1);
                           ks:0.05;os:(r:1;g:1;b:1);
                           alpha:0;oe:5);
      pd1:T3DPoint=(x:1;y:0;z:0);
      pd2:T3DPoint=(x:0;y:1;z:0);
      pd3:T3DPoint=(x:0;y:0;z:1);
      pv1:T3DPoint=(x:0;y:0;z:1);
      pv2:T3DPoint=(x:0;y:1;z:1);
      pv3:T3DPoint=(x:1;y:1;z:0);
      pv4:T3DPoint=(x:1;y:0;z:0);

procedure Register3DViews;
const R3DView:TStreamRec = (
        ObjType:1001;
        VmtLink: Ofs(TypeOf(T3DView)^);
        Load: @T3DView.Load;
        Store: @T3DView.Store);
      RSzene:TStreamRec = (
        ObjType:1002;
        VmtLink: Ofs(TypeOf(TSzene)^);
        Load: @TSzene.Load;
        Store: @TSzene.Store);
      RSicht:TStreamRec = (
        ObjType:1003;
        VmtLink: Ofs(TypeOf(TSicht)^);
        Load: @TSicht.Load;
        Store: @TSicht.Store);
      RAnSicht:TStreamRec = (
        ObjType:1004;
        VmtLink: Ofs(TypeOf(TAnSicht)^);
        Load: @TAnSicht.Load;
        Store: @TAnSicht.Store);
begin
  RegisterType(R3DView);
  RegisterType(RSzene);
  RegisterType(RSicht);
  RegisterType(RAnSicht);
end;

function ExecDialog(P: PDialog; Data: Pointer): Word;
var
  Result: Word;
begin
  Result := cmCancel;
  P := PDialog(Application^.ValidView(P));
  if P <> nil then
  begin
    if Data <> nil then P^.SetData(Data^);
    Result := DeskTop^.ExecView(P);
    if (Result <> cmCancel) and (Data <> nil) then P^.GetData(Data^);
    Dispose(P, Done);
  end;
  ExecDialog := Result;
end;

procedure TSicht.Draw;
var r:TRect;
begin
  getextent(r);
  feld(r.a.x,r.a.y,r.b.x,r.b.y,false,getcolor(1*256+2));
end;

constructor TSicht.init(Bounds:TRect;AWC_DC:TMatrix);
begin
  TGroup.Init(bounds);
  WC_DC:=AWC_DC;
  OriginalWC_DC:=AWC_DC;
  Art:=af3D;
  puffer:=nil;
end;

constructor TSicht.load(var s:TStream);
begin
end;

destructor TSicht.done;
begin
end;

procedure TSicht.setstate(Astate:word;enable:boolean);
begin
  TView.SetState(AState,enable);
end;

procedure TSicht.store(var s:TStream);
begin
end;

procedure TSicht.maleMesh(Mesh:PMesh;Buffer:PMesh;OldMC_WC,MC_WC:PMatrix;
  objekt:P3DView;var erste,imPuffer:boolean;remove:boolean);
{Diese Prozedur wird nur von der 3DView aufgerufen wenn sie bewegt, zum
 ersten oder letzten Mal dargestellt wird}
var Meshs:Pecken;
begin
  if objekt^.paramdata.darstellung and dsMeshecken>0 then Meshs:=GetMeshs(Objekt);
  if OldMC_WC<>nil then begin
    setMC_WC(OldMC_WC^);
    setWC_DC(WC_DC);
    DrawMesh(Mesh,Buffer,erste,imPuffer,true);
  end;
  if MC_WC<>nil then begin
    objekt^.MC_WC:=MC_WC^;
    setMC_WC(MC_WC^);
    setWC_DC(WC_DC);
    DrawMesh(Mesh,Buffer,erste,imPuffer,false);
    if objekt^.paramdata.darstellung and dsMeshecken>0 then begin
      if Meshs=nil then AddMeshs(Mesh^,objekt)
      else Meshs^.changeMeshs(Mesh^);
    end;
  end else if (objekt^.paramdata.darstellung and dsMeshecken>0) and
      (Meshs<>nil) and remove then RemoveMeshs(objekt);
end;

procedure TSicht.DrawMesh(Mesh:PMesh;Buffer:PMesh;var erste,imPuffer:boolean;loschen:boolean);
var x,y:byte;
    color:word;
    p1,p2,p3:T3DPoint;
    HLine:P2DLine;
begin
  correctviewport;
  color:=getcolor(3*256+4);
  if WizOpt.AnzeigeModus=amNormal then begin
    if loschen then color:=0;
  end else setwritemode(xorput);
  setcolor(lo(color) and $f);
  HideMouse;
  new(HLine,init(mesh^.y));
  if HLine^.points=nil then begin
    for x:=0 to pred(mesh^.x) do for y:=0 to pred(mesh^.y) do begin
      calcpoint(mesh^.pointat(x,y)^,p1);
      calcpoint(mesh^.pointat(succ(x),y)^,p2);
      calcpoint(mesh^.pointat(x,succ(y))^,p3);
      graph.Line(round(p1.x),round(p1.y),round(p2.x),round(p2.y));
      graph.Line(round(p1.x),round(p1.y),round(p3.x),round(p3.y));
    end;
  end else begin
    for y:=0 to mesh^.y do begin
      calcpoint(mesh^.pointat(0,y)^,p1);
      HLine^.Putin(y,p1);
    end;
    for x:=1 to mesh^.x do begin
      for y:=0 to pred(mesh^.y) do begin
        graph.Line(HLine^.pointat(y)^.x,HLine^.pointat(y)^.y,
                   HLine^.pointat(succ(y))^.x,HLine^.pointat(succ(y))^.y);
        calcpoint(mesh^.pointat(x,y)^,p1);
        graph.Line(HLine^.pointat(y)^.x,HLine^.pointat(y)^.y,
                   round(p1.x),round(p1.y));
        HLine^.putin(y,p1);
      end;
      calcpoint(mesh^.pointat(x,mesh^.y)^,p1);
      graph.Line(HLine^.pointat(mesh^.y)^.x,HLine^.pointat(mesh^.y)^.y,
                   round(p1.x),round(p1.y));
      HLine^.putin(mesh^.y,p1);
    end;
    for y:=0 to pred(mesh^.y) do
      graph.Line(HLine^.pointat(y)^.x,HLine^.pointat(y)^.y,
                 HLine^.pointat(succ(y))^.x,HLine^.pointat(succ(y))^.y);
    dispose(HLine,done);
  end;
  setwritemode(normalput);
  showmouse;
end;

function TSicht.GetPositionctx:word;
var Mousev:PView;

  function MausInView(Item:PView):boolean;far;

    function MausOnEcke(Item:PView):boolean;far;
    begin
      MausOnEcke:=Item^.MouseInView(MouseWhere);
    end;

  begin
    if (TypeOf(Item^)=TypeOf(TEcken)) and (Pecken(Item)^.Subviews<>nil)
    then MausInView:=(PEcken(Item)^.Subviews^.LastThat(@MausOnEcke)<>nil)
    else MausInView:=False;
  end;

begin
  MouseV:=SubViews^.lastthat(@MausInView);
  if (MouseV<>nil)
  then getPositionctx:=MouseV^.getPositionctx
  else GetPositionCtx:=scKreuz;
end;


procedure TEcke.Handleevent(var event:TEvent);
{Wenn der Mauscursor auf eine Ecke zeigt, wird diese Prozedur aufgerufen.
 Sobald die Maustaste gedrckt wird, wird die Methode EckePressed der
 zugehrigen 3DView, mit der Nummer der Ecke als Parameter, aufgerufen}
begin
  if event.what and evmousedown>0 then
    if PEcken(owner)^.flag then PEcken(owner)^.objekt^.EckePressed(owner^.subviews^.IndexOf(@self))
    else PEcken(owner)^.objekt^.MeshPressed(owner^.subviews^.IndexOf(@self));
  clearevent(event);
end;

procedure TEcke.Draw;
begin
end;

constructor TEcken.initKoorSys(KoorSys:TKoorSys;Aobjekt:P3DView);
{Es werden gleichzeigig mit dem Verweis auf das Objekt die 7 Eckpunkte als
 TViews eingerichtet}
var r:TRect;
    n,x,y:byte;
    p:t3dPoint;
begin
  r.assign(0,0,0,0);
  TGroup.Init(r);
  Options:=options and (not ofselectable);
  flag:=true;
  objekt:=aobjekt;
  for n:=0 to 6 do begin
    r.assign(pred(round(Koorsys[n].x)),pred(round(Koorsys[n].y)),
             succ(round(Koorsys[n].x)),succ(round(Koorsys[n].y)));
    insert(new(Pecke,init(r)));
  end;
end;

constructor TEcken.initMeshs(Mesh:TMesh;Aobjekt:P3DView);
{Es werden gleichzeigig mit dem Verweis auf das Objekt die Ecken des Meshes
 als TViews eingerichtet}
var r:TRect;
    n,x,y:byte;
    p:t3dPoint;
begin
  r.assign(0,0,0,0);
  TGroup.Init(r);
  Options:=options and (not ofselectable);
  flag:=false;
  objekt:=aobjekt;
  for x:=0 to mesh.x do for y:=0 to mesh.y do begin
    calcpoint(mesh.pointat(x,y)^,p);
    r.assign(pred(round(p.x)),pred(round(p.y)),
             succ(round(p.x)),succ(round(p.y)));
    insert(new(Pecke,init(r)));
  end;
end;


function TEcken.GetPositionctx:word;
begin
  GetPositionCtx:=scRingKreuz;
end;

procedure TEcken.Changekoorsys(Koorsys:TKoorsys);
var n,x,y:byte;
    r:TRect;
    p:t3dPoint;
begin
  for n:=0 to 6 do begin
    r.assign(pred(round(Koorsys[n].x)),pred(round(Koorsys[n].y)),
             succ(round(Koorsys[n].x)),succ(round(Koorsys[n].y)));
    PView(Subviews^.at(n))^.setbounds(r);
  end;
end;

procedure TEcken.ChangeMeshs(mesh:TMesh);
var n,x,y:byte;
    r:TRect;
    p:t3dPoint;
begin
  for x:=0 to mesh.x do for y:=0 to mesh.y do begin
    calcpoint(mesh.pointat(x,y)^,p);
    r.assign(pred(round(p.x)),pred(round(p.y)),
             succ(round(p.x)),succ(round(p.y)));
    PView(Subviews^.at(x*succ(mesh.y)+y))^.setbounds(r);
  end;
end;


procedure TSicht.Handleevent(var event:TEvent);
{Da mehrere Subviews sich berschneiden, aber nicht zu bestimmen ist, in
 welcher die angecklickte Ecke liegt, mssen alle TEcken abgesucht werden.
 Dazu mu der Handleevent Mechanismus abgendert werden}

  procedure handle(item:Pecken);far;
  begin
    if event.what<>evnothing then item^.handleevent(event);
  end;

begin
  if event.what and positionalevents>0 then subviews^.foreach(@handle)
  else TGroup.Handleevent(event);
end;

procedure TSicht.RemoveKoorSys(AObjekt:P3DView);
var ecken:PEcken;
begin
  ecken:=getkoorsys(aobjekt);
  if ecken<>nil then ecken^.done;
end;

function TSicht.GetKoorSys(AObjekt:P3DView):PEcken;

  function obj(item:PEcken):boolean;far;
  begin
    obj:=(item^.objekt=AObjekt) and item^.flag;
  end;

begin
  GetKoorSys:=subviews^.firstthat(@obj);
end;

procedure TSicht.AddKoorSys(KoorSys:TKoorSys;AObjekt:P3DView);
{Jede Sicht speichert in ihren Subviews die 3DObjekte, die sie darstellt.
 Die 7 Subviews von TEcken speichern die Koordinaten der Eck- und Mittelpunkte
 der KoordiantenSysteme des 3DObjekts. Wenn sie angeklickt werden, aktivieren
 sie das Objekt}
begin
  insert(new(Pecken,initKoorsys(KoorSys,AObjekt)));
end;

procedure TSicht.RemoveMeshs(AObjekt:P3DView);
var ecken:PEcken;
begin
  ecken:=getMeshs(aobjekt);
  if ecken<>nil then ecken^.done;
end;

function TSicht.GetMeshs(AObjekt:P3DView):PEcken;

  function obj(item:PEcken):boolean;far;
  begin
    obj:=(item^.objekt=AObjekt) and not item^.flag;
  end;

begin
  GetMeshs:=subviews^.firstthat(@obj);
end;

procedure TSicht.AddMeshs(Mesh:TMesh;AObjekt:P3DView);
{Jede Sicht speichert in ihren Subviews die 3DObjekte, die sie darstellt.
 Die 7 Subviews von TEcken speichern die Koordinaten der Eck- und Mittelpunkte
 der KoordiantenSysteme des 3DObjekts. Wenn sie angeklickt werden, aktivieren
 sie das Objekt}
begin
  insert(new(Pecken,initMeshs(Mesh,AObjekt)));
end;


procedure Tsicht.DrawKoorSys(var KoorSys:TKoorSys;loschen:boolean);
var color:word;
begin
  correctviewport;
  color:=getcolor(3*256+4);
  if WizOpt.AnzeigeModus=amNormal then begin
    if loschen then color:=0;
  end else setwritemode(xorput);
  setcolor(hi(color) shr 4);
  HideMouse;
  graph.line(round(koorsys[1].x),round(koorsys[1].y),round(koorsys[2].x),round(koorsys[2].y));
  setcolor(hi(color) and $f);
  graph.line(round(koorsys[3].x),round(koorsys[3].y),round(koorsys[4].x),round(koorsys[4].y));
  setcolor(lo(color) shr 4);
  graph.line(round(koorsys[5].x),round(koorsys[5].y),round(koorsys[6].x),round(koorsys[6].y));
  ShowMouse;
  setwritemode(normalput);
end;

procedure TSicht.newWC_DC(var AWC_DC:TMatrix);
{Wenn WC_DC gendert werden soll, so mu dies ber diese Methode geschehen.
 Sie berechnet WC_DC neu und stellt dann die komplette Sicht neu dar.}
begin
  WC_DC:=AWC_DC;
  OriginalWC_DC:=AWC_DC;
  CalcWC_DC(WC_DC,(PAnSicht(Owner)^.XScroll^.Value)/qxy,
                    (PAnSicht(Owner)^.YScroll^.Value)/qxy,
                    exp(PAnSicht(Owner)^.ZoomScroll^.Value/qzoom),size.x,size.y);
  drawview;{Gibt den Hintergrund neu aus}
  Pszene(Owner^.Owner)^.root^.malesicht(@self);{stellt die Objekte neu dar}
end;

procedure TSicht.setbounds(bounds:TRect;xmin,ymin,zoom:single);
begin
  TGroup.setbounds(bounds);
  WC_DC:=OriginalWC_DC;
  CalcWC_DC(WC_DC,xmin,ymin,zoom,size.x,size.y);
end;

procedure TSicht.MaleKoor(OldMC_WC,MC_WC:PMAtrix;objekt:P3DView);
{Diese Prozedur wird nur von der 3DView aufgerufen wenn sie bewegt, zum
 ersten oder letzten Mal dargestellt wird}
var KoorSys:TKoorSys;
    Koors:PEcken;
begin
  if objekt^.paramdata.darstellung and dskoorecken>0 then Koors:=GetKoorsys(Objekt);
  if OldMC_WC<>nil then begin
    setMC_WC(OldMC_WC^);
    setWC_DC(WC_DC);
    CalcKoorSys(KoorSys);
    DrawKoorSys(KoorSys,true);
  end;
  if MC_WC<>nil then begin
    objekt^.MC_WC:=MC_WC^;
    setMC_WC(MC_WC^);
    setWC_DC(WC_DC);
    CalcKoorSys(KoorSys);
    DrawKoorSys(KoorSys,false);
    if objekt^.paramdata.darstellung and dskoorecken>0 then begin
      if Koors=nil then AddKoorSys(KoorSys,objekt)
      else Koors^.changeKoorSys(KoorSys);
    end;
  end else if (objekt^.paramdata.darstellung and dsKoorecken>0) and
      (Koors<>nil) then RemoveKoorsys(objekt);
end;

function TSicht.GetPalette: PPalette;
const
  CSicht = {#43}#38#42#79#80;
  PSicht: String[length(CSicht)] = CSicht;
begin
  getpalette:= @PSicht;
end;


constructor TYZSicht.init(Bounds:TRect);
begin
  TSicht.Init(bounds,YZMatrix);
  art:=afxyz;
end;

{procedure TYZSicht.DrawMesh(Mesh:PMesh;Buffer:PMesh;OldMC_WC,MC_WC:PMatrix;
   objekt:P3DView;var erste,imPuffer:boolean;loschen:boolean);
begin
end;}


constructor TXZSicht.init(Bounds:TRect);
begin
  TSicht.Init(bounds,XZMatrix);
  art:=afxyz;
end;

{procedure TXZSicht.DrawMesh(Mesh:PMesh;Buffer:PMesh;OldMC_WC,MC_WC:PMatrix;
  objekt:P3DView;var erste,imPuffer:boolean;loschen:boolean);
begin
end;}


constructor TXYSicht.init(Bounds:TRect);
begin
  TSicht.Init(bounds,xyMatrix);
  art:=afxyz;
end;

{procedure TXYSicht.DrawMesh(Mesh:PMesh;Buffer:PMesh;OldMC_WC,MC_WC:PMatrix;
  objekt:P3DView;var erste,imPuffer:boolean;loschen:boolean);
begin
end;}


constructor TAnsicht.init(var bounds:TRect;Atitel:TTitleStr;Asicht:Psicht);
var r:TRect;
begin
  TWindow.init(bounds,'',0);
  
  getextent(r);
  r.a.x:=2;
  r.a.y:=13;
  dec(r.b.x,13);
  dec(r.b.y,13);
  sicht:=asicht;
  sicht^.setbounds(r,dx0/qxy,dy0/qxy,exp(zoom0/qzoom));
  insert(sicht);

  r.assign(15,2,31,11);
  insert(new(PStaticText,init(r,Atitel)));

  getextent(bounds);
  r.assign(bounds.b.x div 2,2,bounds.b.x-15,11);
  new(ZoomScroll,init(r));
  ZoomScroll^.setparams(zoom0,1,200,10,1);
  insert(ZoomScroll);

  r.assign(2,bounds.b.y-11,bounds.b.x-15,bounds.b.y-2);
  new(XScroll,init(r));
  xScroll^.setparams(dx0,-500,500,10,1);
  insert(XScroll);

  r.assign(bounds.b.x-11,15,bounds.b.x-2,bounds.b.y-15);
  new(Yscroll,init(r));
  yScroll^.setparams(dy0,-500,500,10,1);
  insert(YScroll);
end;

constructor TAnsicht.load(var s:TStream);
begin
end;

{destructor TAnsicht.done;
begin
  dispose(xscroll,done);
  dispose(yscroll,done);
  dispose(zoomscroll,done);
  TWindow.done;
end;}

procedure TAnsicht.store(var s:TStream);
begin
end;

procedure TAnsicht.Handleevent(var event:TEvent);
begin
  TWindow.Handleevent(event);
  if (event.what=evBroadCast) and (event.command=cmScrollBarChanged) then begin
    if (event.infoPtr=ZoomScroll) or (event.infoPtr=XScroll) or
       (event.infoPtr=YScroll) then begin
      clearevent(event);
      Sicht^.newWC_DC(Sicht^.OriginalWC_DC);
    end;
  end;
end;

function TAnsicht.getpalette:PPalette;
begin
  getpalette:=nil;
end;

procedure TAnsicht.InitFrame;
var b,r:TRect;
begin
  r.assign(0,0,size.x,size.y);
  b.assign(13,2,13,13);
  new(Frame,Init(r,b));
  insert(frame);
end;

constructor TLister.init(var bounds:TRect;AObjekte:P3DGroup);
begin
  TDialog.init(bounds,'Objekt Lister');
  Objekte:=AObjekte;
end;

function TLister.getpalette:PPalette;
begin
  getpalette:=nil;
end;

constructor TSzene.init;
var HAnsicht:PAnsicht;
    r:TRect;
    y0,y1,y2,y3,x0,x1,x2:word;
    b:PView;
begin
  r.assign(100,1,pred(screenwidth),screenheight-28);
  TWindow.init(r,'NONAME.WIZ',0);
  gesichert:=true;
  currentobjekt:=nil;
  val:=true;
  eventmask:=eventmask or evcommand or evbroadcast;
  options:=options or ofpreProcess;

  y0:=15;
  y1:=(screenheight-101) div 2 +15;
  y2:=screenheight-86;
  y3:=screenheight-21;
  x0:=4;
  x1:=(screenwidth-119) div 2 +4;
  x2:=screenwidth-116;

  New(Sichten,init(4,16));

  r.assign(x0,y0,pred(x1),pred(y1));
  HAnsicht:=PAnSicht(Application^.ValidView(new(PAnsicht,init(r,'YZ',new(PYZSicht,init(r))))));
  if HAnsicht<>nil then begin
    Sichten^.insert(HAnsicht^.Sicht);
    Insert(HAnsicht);
  end else begin val:=false; exit; end;

  r.assign(x1,y0,x2,pred(y1));
  HAnsicht:=PAnSicht(Application^.ValidView(new(PAnsicht,init(r,'YX',new(PXYSicht,init(r))))));
  if HAnsicht<>nil then begin
    Sichten^.insert(HAnsicht^.Sicht);
    Insert(HAnsicht);
  end else begin val:=false; exit; end;

  r.assign(x0,y1,pred(x1),pred(y2));
  HAnsicht:=PAnSicht(Application^.ValidView(new(PAnsicht,init(r,'3D',new(PSicht,init(r,Matrix3d))))));
  if HAnsicht<>nil then begin
    Sichten^.insert(HAnsicht^.Sicht);
    Insert(HAnsicht);
  end else begin val:=false; exit; end;

  r.assign(x1,y1,x2,pred(y2));
  HAnsicht:=PAnSicht(Application^.ValidView(new(PAnsicht,init(r,'XZ',new(PXZSicht,init(r))))));
  if HAnsicht<>nil then begin
    Sichten^.insert(HAnsicht^.Sicht);
    Insert(HAnsicht);
  end else begin val:=false; exit; end;
  Lister:=nil;
  ParamDiag:=nil;
  name:=WizOpt.Verzeichnis+'NONAME.WIZ';
  daten:=edaten;
  Root:=new(PRoot,init(@self));
  if root<>nil then insert(root) else begin val:=false; exit; end;
  aktGruppe:=PRoot(root)^.Objekte;
{  r.assign(x0,y2,pred(x1),y3);
  new(Lister,init(r,objekte));}
end;

function TSzene.Valid(Command: Word): Boolean;
begin
  valid:=val;
end;

{$I WizTrans.INC}
{I WizKurz.INC}

constructor TSzene.lade(Aname:pathstr);
{var f:text;}
begin
  TSzene.Init;
  MouseCursor^.Update(scuhr,scnormalshape);
  Setname(aname);
  Transdaten(AName);
  Interpretiere(AName,0);
end;

constructor TSzene.load(var s:TStream);
begin
end;

destructor TSzene.done;
begin
  if root<>nil then begin
    root^.state:=state and not sfvisible;
    root^.done;
  end;
  while Sichten^.count>0 do Sichten^.atdelete(0);
  Dispose(Sichten,Done);
  TWindow.Done;
end;

procedure TSzene.Store(var s:TStream);
begin
end;

Procedure TSzene.sichern;
var f:text;
    n:byte;
    dir:dirstr;
    nam:namestr;
    ext:extstr;
begin
  MouseCursor^.Update(scuhr,scnormalshape);
  fsplit(name,dir,nam,ext);
  assign(f,name);
  rewrite(f);
  with daten do begin
    if (flag and sfAutoSave)>0 then writeln(f,'BildDatei ',Nam)
    else writeln(f,';Bild ',nam);
    writeln(f,'XMin ',xmin:5:3,' YMin ',ymin:5:3,' XSize ',xsize:5:3);
    writeln(f,'Abstand ',vpd:5:3,' FPD ',fpd:5:3,' BPD ',bpd:5:3);
    writeln(f,'Blickpunkt ',VRP.x:5:3,' ',VRP.y:5:3,' ',VRP.z:5:3);
    writeln(f,'Standpunkt ',NRP.x:5:3,' ',NRP.y:5:3,' ',NRP.z:5:3);
    writeln(f,'Achsenrichtung ',vup.x:5:3,' ',vup.y:5:3,' ',vup.z:5:3);
    if (flag and sfFlipAreaEnabled)>0 then writeln(f,'Rckflchen');
    if (flag and sfWireFrame)>0 then writeln(f,'DrahtGitter');
    if (flag and sfTrifillenabled)>0 then {writeln(f,'')};
    if (flag and sfshadingmethod)>0 then {writeln(f,'')};
    if (flag and sfLampe)>0 then writeln(f,'Lampen ',lampen1:2,' ',lampen2:2,
      ' ',lampeskalierung.x:5:3,' ',lampeskalierung.y:5:3,' ',lampeskalierung.z:5:3);
    if (flag and sfclipcube)>0 then writeln(f,'ClipWrfel');
    if (flag and sfNebel)>0 then writeln(f,'Nebel ',Nebel:2,
             nebelcolor.r:5:3,' ',nebelcolor.g:5:3,' ',nebelcolor.b:5:3);
    if (flag and sfbrille)>0 then writeln(f,'3D-Brille ',augendist:5:3);
    if (flag and sfframe)>0 then writeln(f,'Ramen');
    if (flag and sffarbig)=0 then
    if (flag and sfsw256)<>0 then writeln(f,'SW256') else begin
      write(f,'SchwarzWei ');
      for n:=0 to 3 do writeln(f,GreyTab[n].r:5:3,' ',GreyTab[n].g:5:3,' ',GreyTab[n].b:5:3,' ');
      writeln(f);
    end;
    if (flag and sfHintergrund)>0 then writeln(f,'Hintergrund ',bkcolor.r:5:3,' ',bkcolor.g:5:3,' ',bkcolor.b:5:3);
    if (flag and (sfInteraktivMaus or sfInteraktivJoystick))>0 then begin
      write(f,'Interaktiv ');
      if (flag and (sfInteraktivMaus or sfInteraktivJoystick)=(sfInteraktivMaus or sfInteraktivJoystick))
      then write(f,'JoyMaus ')
      else if (flag and sfInteraktivMaus)>0
      then write(f,'Maus ')
      else if (flag and sfInteraktivJoystick)>0
      then write(f,'Joystick ');
      if (flag and sfVariablenAnzeigen)>0 then write(f,'Daten') else write(f,'Nichts');
      writeln(f,'');
    end;
    case Darstellung of
      dfkoordinaten:writeln(f,'Koordinaten');
      dfxz:write(f,'ZX');
      dfYZ:write(f,'YZ');
      dfXY:write(f,'XY');
      dfgesamt:write(f,'Gesamtplan');
      dfHigh:writeln(f,'SCQ');
      dfLow:writeln(f,'IBM');
    end;
    case Darstellung of
      dfxz,dfYZ,dfXY,dfgesamt:writeln(f,' ',mass:5:3);
    end;
  end;
  writeln(f,'Licht');{Nur provisorisch}
  writeln(f,'GoSub Objekte');
  writeln(f,'Ende');
  Root^.sichern(f);
  system.close(f);
end;

procedure TSzene.SetTitle(ATitle:TTitlestr);
begin
  disposestr(title);
  title:=newstr(ATitle);
  {NeuMalen mu hier noch programmiert werden}
end;

procedure TSzene.SetName(Aname:Pathstr);
var Dir:DirStr;
    Ext: ExtStr;
begin
  Name:=AName;
  FSplit(AName,Dir,AName,Ext);
  SetTitle(AName+Ext);
  root^.setname(aname);
end;

function TSzene.getpalette:PPalette;
const PSzene: String[length(CDialog)] = CDialog;
begin
  getpalette:=@PSzene;
end;

procedure TSzene.handleevent(var event:TEvent);
var myevent:boolean;
    hcurrentobjekt:P3DView;

  procedure LadeRotationskoerper;
  var
    FileName: FNameStr;
  begin
    FileName := '*.RIS';
    if ExecDialog(New(PFileDialog, Init('*.RIS', 'Suche den Rotationskrper aus',
      '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then begin
      hcurrentobjekt:=new(PRotationskoerper,init(e3DRect,@self,FileName,10,360));
    end else hcurrentobjekt:=nil;
  end;

  procedure LadeZiehkoerper;
  var
    FileName: FNameStr;
  begin
    FileName := '*.RIS';
    if ExecDialog(New(PFileDialog, Init('*.RIS', 'Suche den Ziehkrper aus',
      '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then begin
      hcurrentobjekt:=new(PZiehKoerper,init(e3DRect,@self,FileName,10));
    end else hcurrentobjekt:=nil;
  end;

  procedure change(w:word);
  begin
    if (currentobjekt<>nil) and (currentobjekt^.state and sffocused>0)
    then currentobjekt^.ChangeDarstellung(w)
    else if (aktgruppe<>nil) and (aktgruppe^.state and sffocused>0)
    then aktgruppe^.ChangeDarstellung(w);
  end;

begin
  TWindow.handleevent(event);
  if event.what and evcommand>0 then begin
    myevent:=true;
    case event.command of
      cmGetSzene:;
      cmChangeds3D:change(dsobjekt);
      cmChangedsXYZ:change(dsKoorsys);
      cmSichern:sichern;
      else myevent:=false;
    end;
    if myevent then clearevent(event)
    else begin
      myevent:=true;
      case event.command of
        cmkugel:hcurrentobjekt:=new(PKugel,init(e3DRect,@self,10,10));
        cmEbene:hcurrentobjekt:=new(PEbene,init(e3DRect,@self,10,10));
        cmSaule:hcurrentobjekt:=new(PSaule,init(e3DRect,@self,10,10));
        cmDose:hcurrentobjekt:=new(PDose,init(e3DRect,@self,10,10,2));
        cmTorus:hcurrentobjekt:=new(PTorus,init(e3DRect,@self,1,0.2,10,6));
        cmDreieck:hcurrentobjekt:=new(PDreieck,init(e3DRect,@self,pd1,pd2,pd3));
        cmViereck:hcurrentobjekt:=new(PViereck,init(e3DRect,@self,pv1,pv2,pv3,pv4));
        cmRotationskoerper:ladeRotationskoerper;
        cmZiehKoerper:ladeZiehKoerper;
        else myevent:=false;
      end;
      if myevent then begin {Neues Objekt einfgen}
        clearevent(event);
        if Application^.Validview(hcurrentobjekt)<>nil then begin
          currentobjekt:=hcurrentobjekt;
          aktgruppe^.insert(hcurrentobjekt);
          hcurrentobjekt^.drawview;
          gesichert:=false;
        end;
      end;
    end;
  end;
end;

procedure TSzene.draw;
begin
  TWindow.Draw;
{  Male;}
end;

procedure Tszene.Male;
begin
  if root<>nil then root^.draw;
end;

procedure TSzene.MaleSicht(sicht:PSicht);
begin
  if root<>nil then root^.MaleSicht(sicht);
end;

procedure TSzene.setCurObj(obj:P3DView);
begin
  currentObjekt:=obj;
  aktGruppe:=P3DGroup(obj^.owner);
end;

constructor T3DView.Init(var pos: T3DRect;aszene:PSzene;ax,ay:byte);
var r:TRect;
begin
  r.assign(0,0,0,0);
  TView.init(r);
  options:=options or ofselectable;
  szene:=aszene;
  with ParamData do begin
    Translation:=pos.T;
    Rotation:=pos.r;
    Scalierung:=pos.s;
    x:=ax;
    y:=ay;
    darstellung:=dsKoorSys or dsKoorEcken;
    Textur:='';
    material:=eMaterial;
    materialname:='Papier';
  end;
  mesh:=nil;
  CalcMC_WC(MC_WC,pos);
end;

destructor T3DView.Done;
begin
  if mesh<>nil then
    Objektcollection^.losche(mesh^.x,mesh^.y,RegNr); {Objekt existiert und wird geloscht, oder die Nutzerzahl dekrementiert}
  TView.Done;
end;

procedure T3DView.Store(var S: TStream);
var obj:boolean;
begin
  TView.Store(s);
  s.write(ParamData,sizeof(ParamData));
  obj:=mesh<>nil;
  s.write(obj,sizeof(obj));
end;

constructor T3DView.Load(Var S: TStream);
var obj:boolean;
    pos:T3dRect;
    x,y:byte;
begin
  TView.load(s);
  s.read(ParamData,sizeof(ParamData));
  s.read(obj,sizeof(obj));
  if obj then calc else mesh:=nil;
  with paramdata do begin
    pos.t:=Translation;
    pos.s:=scalierung;
    pos.r:=rotation;
  end;
  CalcMC_WC(MC_WC,pos);
end;

procedure T3DView.HandleEvent(var Event: TEvent);
var myevent:boolean;
begin
  TView.Handleevent(event);
  if event.what and evcommand>0 then begin
    myevent:=true;
    case event.command of
      cmLoeschen:begin
                   done;
                   dispose(@self);
                 end;
      cmObjektParameter:ExecObjektDialog;
      else myevent:=false;
    end;
    if myevent then clearevent(event)
  end;
end;

procedure T3DView.DrawView;
begin
  if exposed and Getstate({sfexposed+}sfvisible) then begin
    draw;
  end;
end;

procedure T3DView.Draw;
{Stellt die 3DView in allen Sichten dar.
 Und gibt die Daten im Lister und im ParamDiag neu aus
 wenn ntig}
begin
  if getstate(sfvisible) then redraw(nil,@mC_WC,true) else redraw(@MC_WC,nil,true);
  if szene^.paramdiag<>nil then szene^.paramdiag^.setdata(paramdata);
  if szene^.lister<>nil then message(szene^.lister,evCommand,cmUpdateLister,@self);
end;

procedure T3DView.ReDraw(OldMC_WC,NewMC_WC:PMatrix;remove:boolean);
{Stellt die 3DView in allen Sichten dar. Und lscht die alte Ansicht}
var erste,imPuffer:boolean;
    buffer:PMesh;

  procedure MaleKoorsys(item:PSicht);far;
  begin
    if paramdata.darstellung and dsKoorSys>0 then item^.malekoor(OldMC_WC,NewMC_WC,@self);
    if paramdata.darstellung and dsObjekt>0 then item^.maleMesh(Mesh,buffer,OldMC_WC,NewMC_WC,@self,erste,imPuffer,remove);
  end;

begin
  erste:=true;
  imPuffer:=false;
  if mesh<>nil then new(buffer,init(mesh^.x,mesh^.y)) else buffer:=nil;
  {mu vermutlich anders geschrieben werden ^ }
  Szene^.sichten^.foreach(@Malekoorsys);
  if mesh<>nil then dispose(buffer,done);
end;


procedure T3DView.Malesicht(sicht:Psicht);
{Stellt die 3DView in Sicht dar}
var erste,imPuffer:boolean;
    buffer:PMesh;
begin
  erste:=true;
  imPuffer:=false;
  if mesh<>nil then new(buffer,init(mesh^.x,mesh^.y)) else buffer:=nil;
  {mu vermutlich anders geschrieben werden ^ }
  if paramdata.darstellung and dsKoorSys>0 then sicht^.malekoor(nil,@MC_WC,@self);
  if paramdata.darstellung and dsObjekt>0 then sicht^.maleMesh(Mesh,buffer,nil,@MC_WC,@self,erste,imPuffer,true);
  if mesh<>nil then dispose(buffer,done);
end;


procedure T3DView.CalcObjekt;
begin
  abstract;
end;

function T3DView.Calc:boolean;
begin
  if paramdata.x<1 then paramdata.x:=1;
  if paramdata.y<1 then paramdata.y:=1;
  if mesh<>nil then begin
    if (mesh^.x=paramdata.x) and (mesh^.y=paramdata.y) then exit;
    {es wurde versucht, genau dasselbe Objekt nochmal zu berechnen}
    Objektcollection^.losche(mesh^.x,mesh^.y,RegNr);
    {Objekt existiert und wird geloscht, oder die Nutzerzahl dekrementiert}
  end;
  mesh:=Objektcollection^.vorhanden(paramdata.x,paramdata.y,RegNr);
  calc:=true;
  if mesh=nil then begin
    mesh:=objektcollection^.neu(paramdata.x,paramdata.y,RegNr);
    if mesh<>nil then CalcObjekt else begin
      Application^.OutOfMemory;
      calc:=false;
    end;
  end;
end;

function T3DView.RegNr:word;
begin
  abstract;
end;

procedure T3DView.Eckepressed(anr:byte);
var event:TEvent;
    o:TPoint;
    OldMC_WC:TMatrix;
begin
  Focus;
  Szene^.setcurobj(@self);
  Hidemouse;
  o:=MouseWhere;
  repeat
    repeat
      getmouseevent(event);
    until event.what<>evnothing;
    if Bewegung<>nil then begin
      OldMc_WC:=Mc_WC;
      if Bewegung^.Move(@self,O,event) then Redraw(@OldMc_WC,@MC_WC,true);
    end;
  until Mousebuttons=0;
  ShowMouse;
end;

procedure T3DView.Meshpressed(anr:byte);
begin
  abstract;
end;
procedure T3DView.sichern(var f:text);

  function hexw(w:word):string;
  const tab:array[0..15] of char='0123456789ABCDEF';
  begin
    hexw:=tab[hi(w) shr 4]+tab[hi(w) and $F]+tab[lo(w) shr 4]+tab[lo(w) and $F];
  end;

  function hexb(w:word):string;
  const tab:array[0..15] of char='0123456789ABCDEF';
  begin
    hexb:=tab[lo(w) shr 4]+tab[lo(w) and $F];
  end;

  function notzahl(r:single;a:byte):boolean;
  begin
    notzahl:=round(r*100)<>a;
  end;

  function notzahlvct(v:T3dPoint;a:byte):boolean;
  begin
    notzahlvct:=notzahl(v.x,a) or notzahl(v.y,a) or notzahl(v.z,a);
  end;

begin
  with paramdata do begin
    writeln(f,'Push');
    writeln(f,'  ;Wiz'+hexb(RegNr)+hexw(Darstellung));
    with paramdata,paramdata.material do if WizOpt.speichermodus=smKurz then
    writeln(f,'  Param ',x:2,' ',y:2,' ',oa.r:3:2,' ',oa.g:3:2,' ',oa.b:3:2,' ', {TEXTUR}
                        ka:3:2,' ',kd:3:2,' ',ks:3:2,' ',os.r:3:2,' ',
              os.g:3:2,' ',os.b:3:2,' ',oe:2:0,' ',od.r:3:2,' ',od.g:3:2,' ',
              od.b:3:2,' ',alpha:3:2,' ', {OBERFLCHE}
              Translation.x:3:2,' ',Translation.y:3:2,' ',Translation.z:3:2,' ', {VERSCHIEBEN}
              Rotation.x:3:2,' ',Rotation.y:3:2,' ',Rotation.z:3:2,' ',{ROTIEREN}
              Scalierung.x:3:2,' ',Scalierung.y:3:2,' ',Scalierung.z:3:2,' ;',Materialname)    {VERGRERN}
    else begin
      if textur='' then writeln(f,'  Textur ',x:2,' ',y:2,' ',oa.r:3:2,' ',oa.g:3:2,' ',oa.b:3:2); {TEXTUR}
      writeln(f,'  Oberflche ',ka:3:2,' ',kd:3:2,' ',ks:3:2,' ',os.r:3:2,' ',
              os.g:3:2,' ',os.b:3:2,' ',oe:2:0,' ',od.r:3:2,' ',od.g:3:2,' ',
              od.b:3:2,' ',alpha:3:2,' ;',Materialname); {OBERFLCHE}
      if notzahlvct(Translation,0)
      then writeln(f,'  Verschieben ',Translation.x:3:2,' ',Translation.y:3:2,' ',Translation.z:3:2); {VERSCHIEBEN}
      if notzahl(Rotation.x,0) then writeln(f,'  Rotieren 1 ',Rotation.x:3:2);
      if notzahl(Rotation.y,0) then writeln(f,'  Rotieren 2 ',Rotation.y:3:2);
      if notzahl(Rotation.z,0) then writeln(f,'  Rotieren 3 ',Rotation.z:3:2); {ROTIEREN}
      if notzahlvct(Scalierung,100)
      then writeln(f,'  Vergrern ',Scalierung.x:3:2,' ',Scalierung.y:3:2,' ',Scalierung.z:3:2);    {VERGRERN}
    end;
    if Textur<>'' then writeln(f,'  LadeObjekt 16 ',Textur);
  end;
end;

procedure T3DView.ChangeDarstellung(ADarstellung:word);
var hdar:word;
begin
  adarstellung:=paramdata.darstellung xor adarstellung;
  if (paramdata.darstellung and dsObjekt)<>(adarstellung and dsObjekt) then begin
    hdar:=paramdata.darstellung;
    paramdata.darstellung:=dsObjekt or (paramdata.darstellung and ($F-3));
    {MeshEcken und Koorecken sollen behandelt werden wie zuvor}
    if aDarstellung and dsObjekt>0 then begin
      if not calc then begin
        paramdata.darstellung:=hdar;
        exit;
      end;
      draw;
    end else redraw(@MC_WC,nil,true);
    paramdata.darstellung:=hdar;
  end;
  if (paramdata.darstellung and dsKoorSys)<>(adarstellung and dsKoorSys) then begin
    hdar:=paramdata.darstellung;
    paramdata.darstellung:=dsKoorSys or (paramdata.darstellung and ($F-3));;
    if adarstellung and dsKoorsys>0 then draw else redraw(@MC_WC,nil,true);
  end;
  paramdata.darstellung:=Adarstellung;
end;

procedure T3DView.SetParam(AData:TData);
begin
  With paramdata do begin
    Material:=adata.M;
    MaterialName:=adata.Materialname;
    textur:=adata.textur;
    Darstellung:=adata.darstellung;
  end;
end;

function T3dView.ObjektDialog(name:pathstr;hohe:byte):PObjektParameterDialog;
var b:PView;
    r:TRect;
    h:PObjektParameterdialog;
    n:byte;

  procedure zahl(s:pathstr;ho:word);
  begin
    with h^ do begin
      r.assign(80,ho,160,ho+14);
      Inputzahl[n]:=new(PInputZahl,init(r,typsingle,1,2,0,1));
      insert(Inputzahl[n]);
      r.assign(10,ho,80,ho+14);
      insert(new(PLabel,init(r,s,Inputzahl[n])));
      inc(n);
    end;
  end;

  procedure farbe(s:pathstr;h:word);
  begin
    zahl(s,h);
    zahl('Rot',h+15);
    zahl('Grn',h+30);
    zahl('Blau',h+45);
  end;


  procedure posin(s:pathstr;ho:word);

    Function zahl(s:pathstr;x,y:word):PView;
    var b:Pview;
    begin
      with h^ do begin
        r.assign(x+10,y,x+80,y+14);
        b:=new(PInputZahl,init(r,typsingle,2,3,-10000,10000));
        insert(b);
        r.assign(x,y,x+10,y+14);
        insert(new(PLabel,init(r,s,b)));
      end;
      zahl:=b;
    end;

  begin
    b:=zahl('X',200,ho+15);
    r.assign(200,ho,400,ho+15);
    h^.insert(new(PLabel,init(r,s,b)));
    zahl('Y',290,ho+15);
    zahl('Z',380,ho+15);
  end;

begin
  r.assign(0,0,500,hohe*10);
  new(h,init(r,Name));
  with h^ do begin
    options:=options or ofcentered;
    r.assign(80,25,160,40);
    Materialname:=new(PInputline,init(r,pred(sizeof(nameStr))));
    insert(Materialname);
    r.assign(10,25,90,40);
    insert(new(PLabel,init(r,'~M~aterial:',materialname)));
    r.assign(200,25,270,40);
    insert(new(PButton,init(r,'~L~aden',cmLadeMaterial,bfnormal)));
    r.assign(290,25,360,40);
    insert(new(PButton,init(r,'S~i~chern',cmSichereMaterial,bfnormal)));
    r.assign(80,45,160,60);
    texturname:=new(PInputline,init(r,pred(sizeof(nameStr))));
    insert(texturname);
    r.assign(10,45,90,60);
    insert(new(PLabel,init(r,'~T~extur:',texturname)));
    r.assign(200,45,270,60);
    insert(new(PButton,init(r,'Lad~e~n',cmLadeTextur,bfnormal)));
    n:=0;
    farbe('~A~mbient',65);
    farbe('~D~iffus',125);
    farbe('~S~pekular',185);
    zahl('~T~ransparenz',245);
    with h^ do begin
      r.assign(80,260,160,260+14);
      Inputzahl[n]:=new(PInputZahl,init(r,typsingle,1,2,0,100));
      insert(Inputzahl[n]);
      r.assign(10,260,80,260+14);
      insert(new(PLabel,init(r,'Glan~z~',Inputzahl[n])));
      inc(n);
    end;

    r.assign(270,65,320,80);
    b:=new(PInputZahl,init(r,typbyte,2,0,2,50));
    insert(b);
    r.assign(200,65,270,80);
    insert(new(PLabel,init(r,'~B~reite:',b)));
    r.assign(400,65,450,80);
    b:=new(PInputZahl,init(r,typbyte,2,0,2,50));
    insert(b);
    r.assign(330,65,400,80);
    insert(new(PLabel,init(r,'~H~he:',b)));

    posin('Tra~n~slation',95);
    posin('Ska~l~ierung',140);
    posin('R~o~tation',185);

    r.assign(200,245,385,265);
    b:=New(PCheckBoxes,init(r,newsItem('~G~itter',newsitem('Koors~y~s',nil))));
    insert(b);
    r.assign(200,235,385,250);
    insert(new(PLabel,init(r,'Darstell~u~ng',b)));

    r.assign(200,280,280,300);
    Insert(new(PButton,init(r,'O~k~',cmOk,bfdefault)));
    r.assign(290,280,370,300);
    Insert(new(PButton,init(r,'~C~ancel',cmCancel,bfnormal)));
  end;
  ObjektDialog:=h;
end;

procedure T3dView.ExecObjektDialog;
begin
  ExecDialog(Objektdialog('Parameter',32),@Paramdata);
end;

procedure TObjektParameterDialog.HandleEvent(var Event: TEvent);
var myevent:boolean;

  procedure LadeTextur;
  var
    FileName: FNameStr;
    dir:dirstr;
    name:namestr;
    ext:extstr;
  begin
    FileName := '*.OBT';
    if ExecDialog(New(PFileDialog, Init('*.OBT', 'Suche die Textur aus',
      '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then begin
      fsplit(filename,dir,name,ext);
      texturname^.setdata(name);
    end;
  end;

  const tabelle:array[0..10] of byte=(0,4,8,9,10,11,13,5,6,7,12);
  {OBERFLCHE ka kd ks osr osg osb oe odr odg odb alpha}

  procedure LadeMaterial;
  var
    FileName: FNameStr;
    dir:dirstr;
    name:namestr;
    ext:extstr;
    s:string;
    si:single;
    n:byte;
    err:integer;

  procedure singlezahl(var s:single;var err:integer);
  begin
    while pos(' ',argumente)=1 do system.delete(argumente,1,1);
    argumente:=argumente+' ';
    system.val(copy(argumente,1,pred(pos(' ',argumente))),s,err);
    system.delete(argumente,1,pos(' ',argumente));
  end;

  begin
    FileName := '*.MAT';
    if ExecDialog(New(PFileDialog, Init('*.MAT', 'Suche ein Material aus',
      '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then begin
      fsplit(filename,dir,name,ext);
      materialname^.setdata(name);
      assign(f,filename);
      reset(f);
      argumente:='';
      while not eof(f) do begin
        lesezeile;
        if id(befehl,'TEXTUR') then begin
          delarg(2);
          for n:=1 to 3 do begin
            singlezahl(si,err);
            if err=0 then inputzahl[n]^.setdata(si);
          end;
        end else if id(befehl,'OBERFLCHE') then begin
          for n:=0 to 10 do begin
            singlezahl(si,err);
            if err=0 then inputzahl[tabelle[n]]^.setdata(si);
          end;
        end;
      end;
      system.close(f);
    end;
  end;

  procedure SichereMaterial;
  var aktszene:PSzene;
      FileName: FNameStr;
      dir:dirstr;
      name:namestr;
      ext:extstr;
      s:string;
      n:byte;
      si:single;
  begin
    Materialname^.getdata(FileName);
    Filename:=Filename+'.MAT';
    if ExecDialog(New(PFileDialog, Init(filename, 'Material speichern unter',
      '~N~ame', fdOkButton, 101)), @FileName) <> cmCancel then begin
      fsplit(filename,dir,name,ext);
      materialname^.setdata(name);
      assign(f,filename);
      rewrite(f);
      write(f,'TEXTUR 50 50');
      for n:=1 to 3 do begin
        inputzahl[n]^.getdata(si);
        write(f,si:1:3,' ');
      end;
      writeln(f);
      write(f,'OBERFLCHE');
      for n:=0 to 10 do begin
        inputzahl[tabelle[n]]^.getdata(si);
        write(f,si:1:3,' ');
      end;
      system.close(f);
    end;
  end;


begin
  TDialog.Handleevent(event);
  if event.what and evcommand>0 then begin
    myevent:=true;
    case event.command of
      cmLadeMaterial:LadeMaterial;
      cmSichereMaterial:SichereMaterial;
      cmLadeTextur:LadeTextur;
      else myevent:=false;
    end;
    if myevent then clearevent(event)
  end;
end;

constructor T3DGroup.Init(AName:Groupstr;ASzene:PSzene);
var b:TRect;
begin
  b.assign(0,0,0,0);
  TGroup.Init(b);
  Szene:=ASzene;
  options:=options or ofselectable;
  helpCtx:=hcGruppe;
  name:=AName;
end;

function no3DGroup(h:PView):boolean;
begin
  no3DGroup:=(Typeof(h^)<>Typeof(TRoot)) and (TypeOf(h^)<>TypeOf(T3DGroup));
end;

procedure T3DGroup.HandleEvent(var Event: TEvent);
var h:PView;
begin
  TGroup.Handleevent(event);
  if (current<>nil) and (current^.state and sffocused>0) and
     (Event.What = evCommand) then
  begin
    case Event.Command of
      cmNextObj: SelectNext(False);
      cmLastObj: SelectNext(True);
      cmUpObj: begin Focus3DGroup;szene^.aktgruppe:=@self; end;
      cmDownObj: if current<>nil then begin
        current^.focus;
        szene^.aktgruppe:=P3dGroup(current);
        h:=getfocused;
        if No3DGroup(h) then szene^.currentobjekt:=P3DView(h);
      end;
    else
      Exit;
    end;
    case event.command of
      cmNextObj,cmLastObj:begin
        if not No3DGroup(current) then szene^.aktgruppe:=P3DGroup(current);
        h:=getfocused;
        if No3DGroup(h) then szene^.currentobjekt:=P3DView(h);
      end;
    end;
    ClearEvent(Event);
  end;
end;

procedure T3DGroup.SetState(astate:word;enable:boolean);
begin
  if astate and sffocused>0 then TView.Setstate(astate,enable)
  else TGroup.Setstate(astate,enable);
end;

procedure T3DGroup.Focus3DGroup;
begin
  TView.Focus;
end;

procedure T3DGroup.draw;
{sorgt dafr, da in jeder Ansicht der Inhalt der Sicht ausgegeben wird}

  procedure mal(item:PView);far;
  begin
    if Typeof(item^)=Typeof(T3dGroup) then P3dGroup(item)^.draw
    else P3dView(item)^.draw;
  end;

begin
  if subviews<>nil then subviews^.foreach(@mal);
end;

procedure T3DGroup.Redraw;
{sorgt dafr, da in jeder Ansicht der Inhalt der Sicht ausgegeben wird}

  procedure mal(item:PView);far;
  begin
    if Typeof(item^)=Typeof(T3dGroup) then P3dGroup(item)^.redraw
    else P3dView(item)^.redraw(@P3dView(item)^.MC_WC,@P3dView(item)^.MC_WC,true);
  end;

begin
  if subviews<>nil then subviews^.foreach(@mal);
end;


procedure T3DGroup.maleSicht(Sicht:PSicht);
{Stellt alle Unterobjekte in einer Sicht dar}

  procedure mal(item:PView);far;
  begin
    if TypeOf(Item^)=TypeOf(T3dGroup) then
    P3dGroup(item)^.malesicht(sicht) else P3DView(item)^.malesicht(sicht);
  end;

begin
  if subviews<>nil then subviews^.foreach(@mal);
end;

procedure T3DGroup.sichern(var f:text);
{Speichert alle Subviews}
 
  procedure speicher3dViews(item:PView);far;
  begin
    if TypeOf(Item^)<>TypeOf(T3dGroup) then P3DView(item)^.sichern(f);
  end;

  procedure speicher3dGroupsGosub(item:PView);far;
  begin
    if TypeOf(Item^)=TypeOf(T3dGroup) then writeln(f,'GOSUB ',P3dGroup(item)^.name);
  end;

  procedure speicher3dGroups(item:PView);far;
  begin
    if TypeOf(Item^)=TypeOf(T3dGroup) then P3dGroup(item)^.sichern(f);
  end;

begin
  writeln(f);
  writeln(f,':',name);
  if subviews<>nil then subviews^.foreach(@speicher3dViews);
  if subviews<>nil then subviews^.foreach(@speicher3dGroupsGosub);
  writeln(f,'Return');
  if subviews<>nil then subviews^.foreach(@speicher3dGroups);
end;

procedure T3DGroup.ChangeDarstellung(ADarstellung:word);

  procedure setd(item:PView);far;
  begin
    if no3dGroup(item) then P3dView(item)^.ChangeDarstellung(adarstellung)
    else P3dGroup(item)^.ChangeDarstellung(adarstellung);
  end;

begin
  if subviews<>nil then subviews^.foreach(@setd);
end;

procedure T3DGroup.SetName(AName:GroupStr);
begin
  Name:=AName;
end;

constructor TMesh.init(ax,ay:byte);
{initialisiert mesh mit Punkten von x=0..ax und y=0..ay
 Dieses Mesh wird gebraucht um die Meshs von 3DViews darin zu speichern
 wenn gengend Hauptspeicher vorhanden ist. Dies beschleunigt die
 Bildschirmausgabe}
begin
  x:=ax;
  y:=ay;
  erzeuger:=0;
  nutzer:=0;
  if maxavail>succ(x)*succ(y)*sizeof(T3dPoint) then begin
   getmem(points,succ(x)*succ(y)*sizeof(T3dPoint));
   fillchar(points^,succ(x)*succ(y)*sizeof(T3dPoint),#0);
  end else points:=nil;
end;

destructor TMesh.done;
begin
  if points<>nil then freemem(points,succ(x)*succ(y)*sizeof(T3dPoint));
end;

procedure TMesh.changeSize(ax,ay:byte);
begin
  if points<>nil then freemem(points,succ(x)*succ(y)*sizeof(T3dPoint));
  x:=ax;
  y:=ay;
  if maxavail>succ(x)*succ(y)*sizeof(T3dPoint) then begin
   getmem(points,succ(x)*succ(y)*sizeof(T3dPoint));
   fillchar(points^,succ(x)*succ(y)*sizeof(T3dPoint),#0);
  end else begin
    points:=nil;
    Application^.OutOfMemory;
  end;
end;

function TMesh.PointAt(ax,ay:byte):P3DPoint;
begin
  PointAt:=P3DPoint(@meml[seg(points^):
                          ofs(points^)+(ay*succ(x)+ax)*sizeof(T3dPoint)]);
end;

procedure TMesh.putin(ax,ay:byte;var p:T3dPoint);
begin
  if (ax<=x) and (ay<=y) then begin
    pointat(ax,ay)^:=p;
  end;
end;

constructor T2DLine.init(ax:byte);
{initialisiert 2DLine mit Punkten von x=0..ax
 Dieses 2DLine wird gebraucht um eine Zeile eines Transformierten Meshs
 zwischenzuspeichern dies beschleunigt die Bildschirmausgabe}
begin
  x:=ax;
  if maxavail>succ(x)*sizeof(TPoint) then begin
   getmem(points,succ(x)*sizeof(TPoint));
   fillchar(points^,succ(x)*sizeof(TPoint),#0);
  end else begin
    Application^.OutOfMemory;
    points:=nil;
  end;
end;

destructor T2DLine.done;
begin
  if points<>nil then freemem(points,succ(x)*sizeof(TPoint));
end;

function T2DLine.PointAt(ax:byte):PPoint;
begin
  PointAt:=PPoint(@meml[seg(points^):
                          ofs(points^)+ax*sizeof(TPoint)]);
end;

procedure T2DLine.putin(ax:byte;var p:T3DPoint);
var HPoint:PPoint;
begin
  if (ax<=x) then begin
    HPoint:=Pointat(ax);
    hpoint^.x:=round(p.x);
    hpoint^.y:=round(p.y);
  end;
end;


constructor T2dMesh.init(ax,ay:byte;Aobjekt:P3DView);
{initialisiert mesh mit Punkten von x=0..ax und y=0..ay zum
 zwischenspeichern der angezeigten Meshs. Nur die focussierte 3DView wird
 zwischengespeichert, die anderen immer neu berechnet}
begin
  x:=ax;
  y:=ay;
  objekt:=AObjekt;
  if maxavail>succ(x)*succ(y)*sizeof(TPoint) then begin
    getmem(points,succ(x)*succ(y)*sizeof(TPoint));
    fillchar(points^,succ(x)*succ(y)*sizeof(TPoint),#0);
  end else points:=nil;
end;

destructor T2dMesh.done;
begin
  if points<>nil then freemem(points,succ(x)*succ(y)*sizeof(TPoint));
end;

function T2dMesh.PointAt(ax,ay:byte):PPoint;
begin
  PointAt:=PPoint(@meml[seg(points^):
                          ofs(points^)+(ay*succ(x)+ax)*sizeof(TPoint)]);
end;

procedure T2DMesh.putin(ax,ay:byte;var p:TPoint);
begin
  if (ax<=x) and (ay<=y) then begin
    pointat(ax,ay)^:=p;
  end;
end;


function TObjektCollection.vorhanden(x,y:byte;p:word):PMesh;

  function gleich(item:Pointer):boolean;far;
  begin
    gleich:=(PMesh(Item)^.x=x) and (PMesh(Item)^.y=y) and (PMesh(Item)^.erzeuger=p);
  end;

begin
  vorhanden:=firstthat(@gleich);
end;

procedure TObjektCollection.losche(x,y:byte;p:word);
var objekt:PMesh;
begin
  objekt:=vorhanden(x,y,p);
  if (objekt<>nil) then begin
    if (objekt^.nutzer>0) then dec(objekt^.nutzer);
    if (objekt^.nutzer=0) then AtDelete(IndexOf(objekt));
  end;
end;

function TObjektCollection.neu(x,y:byte;p:word):PMesh;
var h:PMesh;
begin
  new(h,init(x,y));
  if (h<>nil) then begin
    if (h^.points<>nil) then insert(h) else begin
      dispose(h,done);
      h:=nil;
    end;
  end;
  neu:=h;
end;

constructor TBewege.init(var Bounds:TRect;Atitle:TTitleStr);
begin
  if bewegung<>nil then begin
    bewegung^.getbounds(bounds);
    bewegung^.done;
  end;
  TDialog.Init(Bounds,Atitle);
  bewegung:=@self;
end;

destructor TBewege.done;
begin
  bewegung:=nil;
  setstate(sfvisible,false);
  TDialog.Done;
end;

function TBewege.Move(obj:P3DView;o:TPoint;event:TEvent):boolean;
begin
  Move:=false;
end;

constructor TVerschiebe.init(var Bounds:TRect);
begin
  TBewege.init(Bounds,'Schieben');
end;

function TVerschiebe.Move(obj:P3DView;o:TPoint;event:TEvent):boolean;
var pos:T3DRect;
begin
  if event.what and evmousemove>0 then with obj^.paramdata.translation do begin
    y:=y+(o.y-event.where.y)/100;
    if mouseButtons and 2>0 then begin
      z:=z+(o.x-event.where.x)/100;
    end else begin
      x:=x-(o.x-event.where.x)/100;
    end;
    maussetpos(o.x,o.y);
    Move:=true;
    with obj^.paramdata do begin
      pos.t:=Translation;
      pos.s:=scalierung;
      pos.r:=rotation;
    end;
    CalcMC_WC(obj^.MC_WC,pos);
  end else Move:=false;
end;

constructor TDrehe.init(var Bounds:TRect);
begin
  TBewege.init(Bounds,'Drehen');
end;

function TDrehe.Move(obj:P3DView;o:TPoint;event:TEvent):boolean;
var pos:T3DRect;
begin
  if event.what and evmousemove>0 then with obj^.paramdata.Rotation do begin
    y:=y+(o.y-event.where.y)/10;
    if mouseButtons and 2>0 then begin
      z:=z+(o.x-event.where.x)/10;
    end else begin
      x:=x-(o.x-event.where.x)/10;
    end;
    maussetpos(o.x,o.y);
    Move:=true;
    with obj^.paramdata do begin
      pos.t:=Translation;
      pos.s:=scalierung;
      pos.r:=rotation;
    end;
    CalcMC_WC(obj^.MC_WC,pos);
  end else Move:=false;
end;


constructor TDehne.init(var Bounds:TRect);
begin
  TBewege.init(Bounds,'Dehnen');
end;

function TDehne.Move(obj:P3DView;o:TPoint;event:TEvent):boolean;
var pos:T3DRect;
begin
  if event.what and evmousemove>0 then with obj^.paramdata.Scalierung do begin
    y:=y+(o.y-event.where.y)/200;
    if mouseButtons and 2>0 then begin
      z:=z+(o.x-event.where.x)/200;
    end else begin
      x:=x-(o.x-event.where.x)/200;
    end;
    maussetpos(o.x,o.y);
    Move:=true;
    with obj^.paramdata do begin
      pos.t:=Translation;
      pos.s:=scalierung;
      pos.r:=rotation;
    end;
    CalcMC_WC(obj^.MC_WC,pos);
  end else Move:=false;
end;


const e_z: T3DPoint=(x:0.0;y:0.0;z:1.0);
      me_z:T3DPoint=(x:0.0;y:0.0;z:-1.0);

constructor TKugel.Init(var pos: T3DRect;aszene:PSzene;ax,ay:byte);
begin
  T3DView.Init(pos,aszene,ax,ay);
  Helpctx:=cmKugel;
end;

function TKugel.RegNr:Word;
begin
  RegNr:=obKugel;
end;

procedure TKugel.calcobjekt;
var st,ct,sa,ca,
    cth,cah,dct,dst,dca,dsa:real;
    ps,p,pn:T3dPoint;
    a,t:integer;
begin
  mesh^.Erzeuger:=obKugel;
  dct:=cos(2*PI/mesh^.x); dst:=sqrt(1-dct*dct);
  dca:=cos(2*PI/(2*mesh^.y)); dsa:=sqrt(1-dca*dca);
  ca:=dct; sa:=dst; ct:=sa; st:=0.0;
  for a:=1 to pred(mesh^.y) do begin
    for t:=0 to mesh^.x do with p do begin
      x:=ct; y:=st; z:=ca;
      mesh^.putin(t,a,p);
      cth:=ct;
      ct:=ct*dct-st*dst;
      st:=st*dct+cth*dst;
    end;
    cah:=ca;
    ca:=ca*dca-sa*dsa;
    sa:=sa*dca+cah*dsa;
    ct:=sa; st:=0.0;
  end;
  pn:=e_z;
  ps:=me_z;
  for t:=0 to mesh^.x do begin
    mesh^.putin(t,0,pn);
    mesh^.putin(t,mesh^.y,ps);
  end;
end;

procedure TKugel.sichern(var f:text);
begin
  T3DView.Sichern(f);
  with paramdata do writeln(f,'  Kugel ',x:2,' ',y:2);
  writeln(f,'Pop');
end;

constructor TTorus.Init(var pos: T3DRect;aszene:PSzene;ar1,ar2:single;ax,ay:byte);
begin
  T3DView.Init(pos,aszene,ax,ay);
  r1:=ar1;
  r2:=ar2;
  Helpctx:=cmTorus;
end;

function TTorus.RegNr:Word;
begin
  RegNr:=obTorus;
end;

procedure TTorus.calcobjekt;
var cth,cah,dct,dst,st,ct,ct1,st1,dca,dsa,ca,sa: real;
    p: T3DPoint;
    a,t: integer;
begin
  mesh^.Erzeuger:=obTorus;
  dct:=cos(2.0*pi/mesh^.x);  dst:=sqrt(1.0-(dct*dct));
  dca:=cos(2.0*pi/mesh^.y);  dsa:=sqrt(1.0-(dca*dca));
  ca:=r2; sa:=0.0;
  for a:=0 to mesh^.y do begin
    ct:=r1+sa; st:=0.0;
    for t:=0 to mesh^.x do with p do begin
      x:=ct; y:=st; z:=ca;
      mesh^.putin(t,a,p);
      cth:=ct;
      ct:=ct * dct - st * dst;
      st:=st * dct + cth * dst;
    end;
    cah:=ca;
    ca:=ca*dca-sa*dsa;
    sa:=sa*dca+cah*dsa;
  end;
end;

procedure TTorus.sichern(var f:text);
begin
  T3DView.Sichern(f);
  with paramdata do writeln(f,'  Torus ',r1:3:2,' ',r2:3:2,' ',x:2,' ',y:2);
  writeln(f,'Pop');
end;

{procedure TTorus.SetParam(Adata:TData);
begin
  T3dView.Setparam(adata);
  r1:=adata.r1;
  r2:=adata.r2;
end;
}

constructor TEbene.Init(var pos: T3DRect;aszene:PSzene;ax,ay:byte);
begin
  T3DView.Init(pos,aszene,ax,ay);
  Helpctx:=cmEbene;
end;

function TEbene.RegNr:Word;
begin
  RegNr:=obEbene;
end;

procedure TEbene.calcobjekt;
var p:T3DPoint;
    x,y:byte;
    xdist,ydist:real;
begin
  mesh^.Erzeuger:=obEbene;
  xdist:=2 / mesh^.x;
  ydist:=2 / mesh^.y;
  p.z:=0;
  p.x:=-1;
  for x:=0 to mesh^.x do begin
    p.y:=-1;
    for y:=0 to mesh^.y do begin
      mesh^.putin(x,y,p);
      p.y:=p.y+ydist;
    end;
    p.x:=p.x+xdist;
  end;
end;

procedure TEbene.sichern(var f:text);
begin
  T3DView.Sichern(f);
  with paramdata do writeln(f,'  Ebene ',x:2,' ',y:2);
  writeln(f,'Pop');
end;

constructor TSaule.Init(var pos: T3DRect;aszene:PSzene;ax,ay:byte);
begin
  T3DView.Init(pos,aszene,ax,ay);
  Helpctx:=cmSaule;
end;

function Tsaule.RegNr:Word;
begin
  RegNr:=obsaule;
end;

procedure Tsaule.calcobjekt;
var p:T3DPoint;
    a,t:byte;      {n1:sttzpunkte im kreis;n2:sp von S zu N}
    dc,ds,st,ct,sn,cn,ch:real;
    crdx,crdy,nrmx,nrmy:real;
begin
  mesh^.Erzeuger:=obsaule;
  dc:=cos(2*PI/mesh^.x); ds:=sqrt(1-dc*dc);
  ct:={ds}1;st:=0;
  for a:=0 to mesh^.x do begin
    p.x:=ct; p.y:=st;
    for t:=0 to mesh^.y do with p do begin
      z:=(2*t/mesh^.y)-1;
      mesh^.putin(a,t,p);
    end;
    ch:=ct;
    ct:=ct*dc-st*ds;
    st:=st*dc+ch*ds;
  end;
end;

procedure Tsaule.sichern(var f:text);
begin
  T3DView.Sichern(f);
  with paramdata do writeln(f,'  sule ',x:2,' ',y:2);
  writeln(f,'Pop');
end;

constructor TDose.Init(var pos: T3DRect;aszene:PSzene;ax,ay,an3:byte);
begin
  if an3*2>=ax then ax:=an3*2+1;
  T3DView.Init(pos,aszene,ax,ay);
  n3:=an3;
  HelpCtx:=cmDose;
end;

function TDose.RegNr:Word;
begin
  RegNr:=obDose;
end;

procedure TDose.calcobjekt;
var p:T3DPoint;
    a,t:byte; {n1:sttzpunkte im kreis;n2:sp von S zu N;n3:sp im deckel}
    dc,ds,st,ct,ch:real;
    crdx,crdy,nrmx,nrmy:real;
begin
  mesh^.Erzeuger:=obDose;
  dc:=cos(2*PI/mesh^.x); ds:=sqrt(1-dc*dc);
  for a:=0 to mesh^.x do begin
    if a<=n3 then begin
      crdy:=1; crdx:=a/n3;
    end else if a<(mesh^.x-n3) then begin
      crdy:=1-(a-n3)*2/(succ(mesh^.x)-2*succ(n3)); crdx:=1;
    end else begin
      crdy:=-1; crdx:=(mesh^.x-a)/n3;
    end;
    p.z:=crdy;
    st:=0;
    ct:=crdx;
    for t:=0 to mesh^.y do with p do begin
      x:=ct; y:=st;
      mesh^.putin(a,t,p);
      ch:=ct;
      ct:=ct*dc-st*ds;
      st:=st*dc+ch*ds;
    end;
  end;
end;

procedure TDose.sichern(var f:text);
begin
  T3DView.Sichern(f);
  with paramdata do writeln(f,'  Zylinder ',x:2,' ',y:2,' ',n3:2);
  writeln(f,'Pop');
end;

constructor TDreiEck.Init(var pos: T3DRect;aszene:PSzene;p1,p2,p3:T3DPoint);
begin
  T3DView.Init(pos,aszene,1,1);
  HelpCtx:=cmDreieck;
  paramdata.darstellung:=dsObjekt or dsMeshEcken or dsKoorecken;
  nr:=obDreieck+(maxdreieck shl 6);
  inc(maxdreieck);
  mesh:=objektcollection^.neu(paramdata.x,paramdata.y,Nr);
  if mesh<>nil then begin
    mesh^.putin(0,0,p1);
    mesh^.putin(0,1,p2);
    mesh^.putin(1,1,p3);
    mesh^.putin(1,0,p3);
  end else Application^.OutOfMemory;
end;

function TDreieck.RegNr:Word;
begin
  RegNr:=Nr;
end;

procedure TDreieck.calcobjekt;
begin
end;

procedure TDreieck.sichern(var f:text);
var p1:P3DPoint;
begin
  T3DView.Sichern(f);
  p1:=mesh^.pointat(0,0);
  with paramdata do write(f,'  Dreieck ',p1^.x:5:3,' ',p1^.y:5:3,' ',p1^.z:5:3);
  p1:=mesh^.pointat(0,1);
  write(f,' ',p1^.x:5:3,' ',p1^.y:5:3,' ',p1^.z:5:3);
  p1:=mesh^.pointat(1,1);
  writeln(f,' ',p1^.x:5:3,' ',p1^.y:5:3,' ',p1^.z:5:3);
  writeln(f,'Pop');
end;

procedure TDreieck.Meshpressed(anr:byte);
var event:TEvent;
    o:TPoint;
begin
  Focus;
  Szene^.setcurobj(@self);
  Hidemouse;
  o:=MouseWhere;
  repeat
    repeat
      getmouseevent(event);
    until event.what<>evnothing;
    if event.what and evmousemove>0
    then with mesh^.pointat((anr) div succ(mesh^.y),(anr) mod succ(mesh^.y))^ do begin
      redraw(@MC_WC,nil,false);
      y:=y+(o.y-event.where.y)/100;
      if mouseButtons and 2>0 then begin
        z:=z+(o.x-event.where.x)/100;
      end else begin
        x:=x-(o.x-event.where.x)/100;
      end;
      if (Typeof(self)=TypeOf(TDreiEck)) and (anr=3) then begin
        mesh^.Pointat(1,0)^.y:=y;
        mesh^.Pointat(1,0)^.x:=x;
        mesh^.Pointat(1,0)^.z:=z;
      end;
      maussetpos(o.x,o.y);
      Redraw(nil,@Mc_WC,false);
    end;
  until Mousebuttons=0;
  ShowMouse;
end;


constructor TViereck.Init(var pos: T3DRect;aszene:PSzene;p1,p2,p3,p4:T3DPoint);
begin
  T3DView.Init(pos,aszene,1,1);
  HelpCtx:=cmViereck;
  paramdata.darstellung:=dsObjekt or dsMeshEcken or dsKoorEcken;
  nr:=obViereck+(maxViereck shl 6);
  inc(maxViereck);
  mesh:=objektcollection^.neu(paramdata.x,paramdata.y,Nr);
  if mesh<>nil then begin
    mesh^.putin(0,0,p1);
    mesh^.putin(1,0,p2);
    mesh^.putin(1,1,p3);
    mesh^.putin(0,1,p4);
  end else Application^.OutOfMemory;
end;

function TViereck.RegNr:Word;
begin
  RegNr:=Nr;
end;

procedure TViereck.calcobjekt;
begin
end;

procedure TViereck.sichern(var f:text);
var p1:P3DPoint;
begin
  T3DView.Sichern(f);
  p1:=mesh^.pointat(0,0);
  with paramdata do write(f,'  Viereck ',p1^.x:5:3,' ',p1^.y:5:3,' ',p1^.z:5:3);
  p1:=mesh^.pointat(1,0);
  write(f,' ',p1^.x:5:3,' ',p1^.y:5:3,' ',p1^.z:5:3);
  p1:=mesh^.pointat(1,1);
  writeln(f,' ',p1^.x:5:3,' ',p1^.y:5:3,' ',p1^.z:5:3);
  p1:=mesh^.pointat(0,1);
  writeln(f,' ',p1^.x:5:3,' ',p1^.y:5:3,' ',p1^.z:5:3);
  writeln(f,'Pop');
end;


constructor TRotationskoerper.Init(var pos: T3DRect;aszene:PSzene;aname:Pathstr;ay:byte;awinkel:word);
var dir:dirstr;
    nam:namestr;
    ext:extstr;
begin
  T3DView.Init(pos,aszene,10,ay);
  HelpCtx:=cmRotationskoerper;
  fsplit(aname,dir,nam,ext);
  if length(ext)<4 then name:=nam+'.RIS' else name:=aname;
  nr:=obRotationskoerper+(maxrotationskoerper shl 6);
  inc(maxrotationskoerper);
  winkel:=awinkel;
end;

function TRotationskoerper.RegNr:Word;
begin
  RegNr:=nr;
end;

procedure TRotationskoerper.calcobjekt;
type koord2d=record x,y:single; end;
     umrisstyp=record
                 punkt:array[0..maxpnts] of record
                         crd,nrm:koord2d;
                         color:array[0..2] of byte;
                       end;
                 xmax,ymin,ymax:single;
                 punktanzahl:shortint;
                 ka,kd,ks,osr,osg,osb,oe,odr,odg,odb,otrans:single;
                 color:array[0..2] of byte;
               end;
var umriss:^umrisstyp;
    yvol,betrag,dc,ds,st,ct,ch:single;
    p:T3DPoint;
    a,t:integer;
    umrissfile:file of umrisstyp;
    suche:searchrec;
begin
  findfirst(name,$3f,suche);
  if doserror=0 then begin
    if maxavail>sizeof(umriss^) then new(umriss) else begin
      Application^.outofmemory;
      exit;
    end;
    assign(umrissfile,name);
    reset(umrissfile);
    read(umrissfile,umriss^);
    close(umrissfile);
    with umriss^ do begin
      mesh^.Erzeuger:=nr;
      if punktanzahl>0 then begin
        if mesh^.x<>punktanzahl then mesh^.changesize(punktanzahl,mesh^.y);
        paramdata.x:=punktanzahl;
        dc:=cos(2*PI*winkel/360/mesh^.y); ds:=sqrt(1-dc*dc);
        for a:=0 to mesh^.x do with punkt[a] do begin
          p.z:=crd.y;st:=0;ct:=crd.x;
          for t:=0 to mesh^.y do with p do begin
            x:=ct; y:=st;
            mesh^.putin(a,t,p);
            ch:=ct;
            ct:=ct*dc-st*ds;
            st:=st*dc+ch*ds;
          end;
        end;
      end else szene^.error('Der Umriss fr den Rotationskrper besteht nur aus einem Punkt !');
    end;
    dispose(umriss);
  end else szene^.error('Ich konnte '+name+' nicht laden !');
end;

procedure TRotationskoerper.sichern(var f:text);
var nam:namestr;
    dir:dirstr;
    ext:extstr;
begin
  T3DView.Sichern(f);
  fsplit(name,dir,nam,ext);
  with paramdata do writeln(f,'  Laderotationskrper ',nam);
  writeln(f,'  Rotationskrper ',paramdata.y:2,' ',winkel:3);
  writeln(f,'Pop');
end;

constructor TZiehKoerper.Init(var pos: T3DRect;aszene:PSzene;aname:Pathstr;ay:byte);
var dir:dirstr;
    nam:namestr;
    ext:extstr;
begin
  T3DView.Init(pos,aszene,10,ay);
  HelpCtx:=cmZiehkoerper;
  fsplit(aname,dir,nam,ext);
  if length(ext)<4 then name:=nam+'.RIS' else name:=aname;
  nr:=obZiehKoerper+(maxZiehKoerper shl 6);
  inc(maxZiehKoerper);
end;

function TZiehKoerper.RegNr:Word;
begin
  RegNr:=nr;
end;

procedure TZiehKoerper.calcobjekt;
type koord2d=record x,y:single; end;
     umrisstyp=record
                 punkt:array[0..maxpnts] of record
                         crd,nrm:koord2d;
                         color:array[0..2] of byte;
                       end;
                 xmax,ymin,ymax:single;
                 punktanzahl:shortint;
                 ka,kd,ks,osr,osg,osb,oe,odr,odg,odb,otrans:single;
                 color:array[0..2] of byte;
               end;
var umriss:^umrisstyp;
    yvol,betrag,ch,dc,ds,st,ct,sn,cn:single;
    p:T3DPoint;
    a,t:integer;
    umrissfile:file of umrisstyp;
    suche:searchrec;
begin
  findfirst(name,$3f,suche);
  if doserror=0 then begin
    if maxavail>sizeof(umriss^) then new(umriss) else begin
      Application^.outofmemory;
      exit;
    end;
    assign(umrissfile,name);
    reset(umrissfile);
    read(umrissfile,umriss^);
    close(umrissfile);
    with umriss^ do begin
      mesh^.Erzeuger:=nr;
      if punktanzahl>0 then begin
        if mesh^.x<>punktanzahl then mesh^.changesize(punktanzahl,mesh^.y);
        paramdata.x:=punktanzahl;
        for a:=0 to punktanzahl do with punkt[a].crd do begin
          p.x:=x;
          p.y:=y;
          for t:=0 to mesh^.Y do with p do begin
            z:=2*(t/mesh^.y)-1;
            mesh^.putin(a,t,p);
          end;
        end;
      end else szene^.error('Der Umriss fr den Ziehkrper besteht nur aus einem Punkt !');
    end;
    dispose(umriss);
  end else szene^.error('Ich konnte '+name+' nicht laden !');
end;

procedure TZiehKoerper.sichern(var f:text);
var nam:namestr;
    dir:dirstr;
    ext:extstr;
begin
  T3DView.Sichern(f);
  fsplit(name,dir,nam,ext);
  with paramdata do writeln('Laderotationskrper ',nam);
  writeln(f,'  Ziehkrper ',paramdata.y:2);
  writeln(f,'Pop');
end;

{procedure TRotationskoerper.SetParam(Adata:TData);
begin
  T3dView.Setparam(adata);
  name:=adata.name;
end;
}

constructor TRoot.init(ASzene:PSzene);
begin
  T3DGroup.Init(Aszene.name,ASzene);
  helpctx:=hcWurzel;
  new(hilf,init('Hilfobjekte',ASzene));
  insert(hilf);
  new(objekte,init('Objekte',ASzene));
  insert(objekte);
  new(licht,init('Lichter',ASzene));
  insert(licht);
end;


procedure TRoot.sichern(var f:text);
begin
  objekte^.sichern(f);
end;

const KreuzShape:TShape = (relx:7;rely:7;
      shape : (screen : ($FFFF,$FEFF,$FEFF,$FEFF,
                         $FC7F,$FEFF,$F7DF,$8383,
                         $F7DF,$FEFF,$FC7F,$FEFF,
                         $FEFF,$FEFF,$FFFF,$FFFF);
               mask   : ($0000,$0100,$0100,$0100,
                         $0380,$0100,$0820,$7C7C,
                         $0820,$0100,$0380,$0100,
                         $0100,$0100,$0000,$0000));
          number:scKreuz);

      RingKreuzShape:TShape = (relx:7;rely:7;
      shape : (screen : ($FFFF,$FEFF,$F29F,$EEEF,
                         $DEF7,$DEF7,$FFFF,$8383,
                         $FFFF,$DEF7,$DEF7,$EEEF,
                         $F29F,$FEFF,$FFFF,$FFFF);
               mask   : ($0000,$0100,$0D60,$1110,
                         $2108,$2108,$0000,$7C7C,
                         $0000,$2108,$2108,$1110,
                         $0D60,$0100,$0000,$0000));
          number:scRingKreuz);
      UhrShape:TShape = (relx:7;rely:7;
      shape : (screen : ($0001,$BFFB,$9FF3,$AFEB,
                         $AFEB,$B7DB,$BBBB,$BD7B,
                         $BD7B,$BBBB,$B7DB,$AFEB,
                         $AFEB,$9FF3,$BFFB,$0001);
               mask   : ($FFFE,$4004,$600C,$5014,
                         $5014,$4C64,$47C4,$4384,
                         $4384,$4544,$4924,$5114,
                         $57D4,$7FFC,$7FFC,$FFFE));
          number:scUhr);
begin
  MouseCursor^.RegisterShape(@KreuzShape);
  MouseCursor^.RegisterShape(@RingKreuzShape);
  MouseCursor^.RegisterShape(@UhrShape);
  new(ObjektCollection,init(50,500));
end.