program PrWizArt;
uses dos,Memory,Objects,Drivers,TGDriver,TGViews,TGMenus,TGApp,TGdialog,
     tgStdDlg,tgMsgBox,USzene,WizInfo;
const cmOpen=2000;
      cmChangeDir=2001;
      cmNeu=2002;
      cmSave=2003;
      cmSaveAs=2004;
      cmVerschiebenXYZ=2100;
      cmDrehenXYZ=2101;
      cmDehnenXYZ=2102;
      cmOptionen=2103;
      cmMalebild   = 2201;
      cmumriss  =    2202;
      cmEditor  =    2203;
      cmshowpick =   2204;
      cmmaterial =   2205;
      cmpacken =     2206;
      cmfunktion =   2207;
      cmtrans =      2208;
      cmradio =      2209;
      cmhandbuch =   2210;

      DosCode:byte=0;

{schwarz}    { 0 }
{grau0}      { 1 }
{grau1}      { 2 }
{grau2}      { 3 }
{rot}        { 4 }
{grn}       { 5 }
{blau}       { 6 }
{cyan}       { 7 }
{gelb}       { 8 }
{magenta}    { 9 }
{dunkelgrn} { A }
             { B }
             { C }
             { D }
             { E }
{wei}       { F }

  CWizColor = CColor+
      {79}  #$4a#$68{#$2C#$EE};{Rot Grn Blau fr x,y,z der Koordinatenachsen(ber Xor mit blau verknpft)}
             {4A  88 xor 66}
  CWizBlackWhite = CBlackWhite+
      {79}  #0;
  CWizMonochrome = CMonochrome+
      {79}  #0;

type TWizArt = object(TApplication)
       procedure initMenuBar; virtual;
       procedure HandleEvent(var Event: TEvent); virtual;
       procedure InitStatusLine; virtual;
       function getpalette:PPalette; virtual;
       procedure OutOfMemory; virtual;
       procedure RestoreDesktop;
       procedure SaveDesktop;
     end;

     POptionDialog=^TOptionDialog;
     TOptionDialog = object(TDialog)
       constructor init;
     end;

constructor TOptionDialog.Init;
var b:PView;
    r:TRect;
begin
  r.assign(0,0,300,200);
  TDialog.init(r,'Optionen');
  options:=options or ofcentered;
  r.assign(10,25,290,45);
  b:=New(PRadioButtons,init(r,newsItem('~A~usfhrlich',newsitem('~K~urz',nil))));
  Insert(b);
  r.assign(10,15,290,25);
  insert(new(PLabel,init(r,'~D~ateiformat beim abspeichern:',b)));
  r.assign(10,65,290,85);
  b:=New(PRadioButtons,init(r,newsItem('~~berschreiben',newsitem('~I~nvertieren',nil))));
  Insert(b);
  r.assign(10,55,290,65);
  insert(new(PLabel,init(r,'D~a~rstellung:',b)));
  r.assign(10,105,290,125);
  b:=New(PCheckBoxes,init(r,newsItem('~S~zenen',newsitem('~B~enutzeroberflche',nil))));
  Insert(b);
  r.assign(10,95,290,105);
  insert(new(PLabel,init(r,'~A~utomatisch abspeichern:',b)));
  r.assign(10,145,290,157);
  b:=New(PInputLine,init(r,pred(sizeof(WizOpt.Verzeichnis))));
  Insert(b);
  r.assign(10,135,290,145);
  insert(new(PLabel,init(r,'~S~zenen Verzeichnis:',b)));
  r.assign(10,165,90,185);
  Insert(new(PButton,init(r,'~O~k',cmOk,bfdefault)));
  r.assign(100,165,190,185);
  Insert(new(PButton,init(r,'~C~ancel',cmCancel,bfnormal)));
end;

procedure TWizArt.OutOfMemory;
begin
  MessageBox('Nicht gengend Hauptspeicher'#13'fr diese Operation.',
    nil, mfError + mfOkButton);
end;

function TWizArt.getpalette:PPalette;
const
  P: array[apColor..apMonochrome] of string[Length(CWizColor)] =
    (CWizColor, CWizBlackWhite, CWizMonochrome);
begin
  GetPalette := @P[AppPalette];
end;

procedure TWizArt.initMenuBar;
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 12;
  MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu('~D~atei', hcNoContext, NewMenu(
      NewItem('~~ffnen...', 'F3', kbF3, cmOpen, hcNoContext,
      NewItem('~N~eu', '', kbNoKey, cmNeu, hcNoContext,
      NewItem('~S~ichern', 'F2', kbF2, cmSave, hcNoContext,
      NewItem('S~i~chern als...', '', kbNoKey, cmSaveAs, hcNoContext,
      NewLine(
      NewItem('~V~erzeichnis...', '', kbNoKey, cmChangeDir, hcNoContext,
      NewItem('E~n~de', 'Alt-X', kbAltX, cmQuit, hcNoContext,
      nil)))))))),
    NewSubMenu('~O~bjekte', hcNoContext, NewMenu(
      NewItem('~K~ugel', '', kbNoKey, cmKugel, hcNoContext,
      NewItem('~T~orus', '', kbNoKey, cmTorus, hcNoContext,
      NewItem('~E~bene', '', kbNoKey, cmEbene, hcNoContext,
      NewItem('~S~ule', '', kbNoKey, cmSaule, hcNoContext,
      NewItem('~D~ose', '', kbNoKey, cmDose, hcNoContext,
      NewItem('~D~reieck', '', kbNoKey, cmDreieck, hcNoContext,
      NewItem('~V~iereck', '', kbNoKey, cmViereck, hcNoContext,
      NewItem('~R~otationskrper', '', kbNoKey, cmRotationskoerper, hcNoContext,
      NewItem('~Z~iehkrper', '', kbNoKey, cmZiehkoerper, hcNoContext,
      nil)))))))))),
    NewSubMenu('~E~ditieren', hcNoContext, NewMenu(
      NewItem('~V~erschieben XYZ', '', kbNoKey, cmVerschiebenXYZ, hcNoContext,
      NewItem('~D~rehen XYZ', '', kbNoKey, cmDrehenXYZ, hcNoContext,
      NewItem('~D~ehnen XYZ', '', kbNoKey, cmDehnenXYZ, hcNoContext,
      NewLine(
      NewItem('~L~schen', '', kbNoKey, cmLoeschen, hcNoContext,
      NewLine(
      NewItem('~O~bjektparameter', '', kbNoKey, cmObjektParameter, hcNoContext,
      nil)))))))),
    NewSubMenu('~D~arstellung', hcNoContext, NewMenu(
      NewItem('~M~esh', '', kbNoKey, cmChangeds3D, hcNoContext,
      NewItem('~K~oordinaten', '', kbNoKey, cmChangedsXYZ, hcNoContext,
      NewLine(
      NewItem('~S~zenenparameter', '', kbNoKey, cmSzenenParameter, hcNoContext,
      nil))))),
    NewItem('~O~ptionen', '', kbNoKey, cmOptionen, hcNoContext,
    NewSubMenu('~B~efehle', hcNoContext, NewMenu(
      NewItem('~B~ild berechnen', '', kbNoKey, cmMalebild , hcNoContext,
      NewItem('CAD fr ~R~otationskrper', '', kbNoKey, cmumriss, hcNoContext,
      NewItem('~E~ditor',  '', kbNoKey,cmEditor , hcNoContext,
      NewItem('Bild ~A~nzeigen',  '', kbNoKey,cmshowpick , hcNoContext,
      NewItem('~M~aterial Editor',  '', kbNoKey,cmmaterial , hcNoContext,
      NewItem('~P~acken',  '', kbNoKey, cmpacken, hcNoContext,
      NewItem('~3~D Funktionen',  '', kbNoKey,cmfunktion , hcNoContext,
      NewItem('~~bersetze .WIZ -> .SCN',  '', kbNoKey,cmtrans , hcNoContext,
      NewItem('Radio~s~ity',  '', kbNoKey,cmradio , hcNoContext,
      NewItem('~H~andbuch',  '', kbNoKey,cmhandbuch , hcNoContext,
      nil))))))))))),
    nil)))))))));
end;

procedure TWizArt.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 12;
  New(StatusLine, Init(R,
    NewStatusDef(0, 1000,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('~F10~ Menu', kbF10, cmMenu,
      NewStatusKey('', kbAltF3, cmClose,
      NewStatusKey('', kbF5, cmZoom,
      NewStatusKey('', kbCtrlF5, cmResize,
      NewStatusKey('', kbF6, cmNext, nil)))))),
    NewStatusDef(cmKugel, cmKugel,
      NewStatusKey('<', kbNoKey, cmLastObj,
      NewStatusKey('Kugel', kbNoKey, cmValid,
      NewStatusKey(#24, kbNoKey, cmUpObj,
      NewStatusKey('>', kbNoKey, cmNextObj,
      nil)))),
    NewStatusDef(cmTorus, cmTorus,
      NewStatusKey('<', kbNoKey, cmLastObj,
      NewStatusKey('Torus', kbNoKey, cmValid,
      NewStatusKey(#24, kbNoKey, cmUpObj,
      NewStatusKey('>', kbNoKey, cmNextObj,
      nil)))),
    NewStatusDef(cmEbene, cmEbene,
      NewStatusKey('<', kbNoKey, cmLastObj,
      NewStatusKey('Ebene', kbNoKey, cmValid,
      NewStatusKey(#24, kbNoKey, cmUpObj,
      NewStatusKey('>', kbNoKey, cmNextObj,
      nil)))),
    NewStatusDef(cmSaule, cmSaule,
      NewStatusKey('<', kbNoKey, cmLastObj,
      NewStatusKey('Sule', kbNoKey, cmValid,
      NewStatusKey(#24, kbNoKey, cmUpObj,
      NewStatusKey('>', kbNoKey, cmNextObj,
      nil)))),
    NewStatusDef(cmDreieck, cmDreieck,
      NewStatusKey('<', kbNoKey, cmLastObj,
      NewStatusKey('Dreieck', kbNoKey, cmValid,
      NewStatusKey(#24, kbNoKey, cmUpObj,
      NewStatusKey('>', kbNoKey, cmNextObj,
      nil)))),
    NewStatusDef(cmViereck, cmViereck,
      NewStatusKey('<', kbNoKey, cmLastObj,
      NewStatusKey('Viereck', kbNoKey, cmValid,
      NewStatusKey(#24, kbNoKey, cmUpObj,
      NewStatusKey('>', kbNoKey, cmNextObj,
      nil)))),
    NewStatusDef(cmRotationskoerper, cmRotationskoerper,
      NewStatusKey('<', kbNoKey, cmLastObj,
      NewStatusKey('Rotationskrper', kbNoKey, cmValid,
      NewStatusKey(#24, kbNoKey, cmUpObj,
      NewStatusKey('>', kbNoKey, cmNextObj,
      nil)))),
    NewStatusDef(cmDose, cmDose,
      NewStatusKey('<', kbNoKey, cmLastObj,
      NewStatusKey('Dose', kbNoKey, cmValid,
      NewStatusKey(#24, kbNoKey, cmUpObj,
      NewStatusKey('>', kbNoKey, cmNextObj,
      nil)))),
    NewStatusDef(cmZiehkoerper, cmZiehkoerper,
      NewStatusKey('<', kbNoKey, cmLastObj,
      NewStatusKey('Ziehkrper', kbNoKey, cmValid,
      NewStatusKey(#24, kbNoKey, cmUpObj,
      NewStatusKey('>', kbNoKey, cmNextObj,
      nil)))),
    NewStatusDef(hcGruppe, hcGruppe,
      NewStatusKey('<', kbNoKey, cmLastObj,
      NewStatusKey(#25, kbNoKey, cmDownObj,
      NewStatusKey('Gruppe', kbNoKey, cmValid,
      NewStatusKey(#24, kbNoKey, cmUpObj,
      NewStatusKey('>', kbNoKey, cmNextObj,
      nil))))),
    NewStatusDef(hcWurzel, hcWurzel,
      NewStatusKey('<', kbNoKey, cmLastObj,
      NewStatusKey(#25, kbNoKey, cmDownObj,
      NewStatusKey('Wurzel', kbNoKey, cmValid,
      NewStatusKey('>', kbNoKey, cmNextObj,
      nil)))),
    NewStatusDef(1050, $FFFF,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('~F10~ Menu', kbF10, cmMenu,
      NewStatusKey('', kbAltF3, cmClose,
      NewStatusKey('', kbF5, cmZoom,
      NewStatusKey('', kbCtrlF5, cmResize,
      NewStatusKey('', kbF6, cmNext, nil)))))),
    nil)))))))))))))));
end;

procedure TWizArt.HandleEvent(var Event: TEvent);
var myevent:boolean;

  procedure neueszene;
  begin
    DeskTop^.Insert(ValidView(New(PSzene, Init)));
  end;

  procedure VerschiebenXYZ;
  var r:TRect;
  begin
    r.assign(0,screenheight div 2, 99,screenheight-27);
    DeskTop^.Insert(ValidView(New(PVerschiebe, Init(r))));
  end;

  procedure DehnenXYZ;
  var r:TRect;
  begin
    r.assign(0,screenheight div 2, 99,screenheight-27);
    DeskTop^.Insert(ValidView(New(PDehne, Init(r))));
  end;

  procedure DrehenXYZ;
  var r:TRect;
  begin
    r.assign(0,screenheight div 2, 99,screenheight-27);
    DeskTop^.Insert(ValidView(New(PDrehe, Init(r))));
  end;

  procedure FileOpen;
  var
    FileName: FNameStr;
  begin
    FileName := '*.WIZ';
    if ExecDialog(New(PFileDialog, Init('*.WIZ', 'ffne ein Bild',
      '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then begin
      DeskTop^.Insert(ValidView(New(PSzene, Lade(FileName))));
    end;
  end;

  procedure ChangeDir;
  begin
    ExecDialog(New(PChDirDialog, Init(cdNormal, 0)), nil);
  end;

  procedure Optionen;
  begin
    ExecDialog(New(POptionDialog, Init), @WizOpt);
  end;

  procedure SichernAls;
  var aktszene:PSzene;
      FileName: FNameStr;
  begin
    aktszene:=message(@self,evCommand,cmGetSzene,@self);
    if aktszene=nil then exit;
    FileName := aktszene^.name;
    if ExecDialog(New(PFileDialog, Init(aktszene^.name, 'Speichern unter',
      '~N~ame', fdOkButton, 101)), @FileName) <> cmCancel then begin
      aktszene^.setname(FileName);
      aktszene^.sichern;
    end;
  end;

  procedure Sichern;
  var aktszene:PSzene;
  begin
    aktszene:=message(@self,evCommand,cmGetSzene,@self);
    if aktszene=nil then exit;
    if aktszene^.name='NONAME.WIZ' then SichernAls else aktszene^.sichern;
  end;

begin
  TApplication.Handleevent(event);
  if event.what=evcommand then begin
    myevent:=true;
    case event.command of
      cmNeu: neueszene;
      cmChangeDir: ChangeDir;
      cmOpen: FileOpen;
      cmVerschiebenXYZ:VerschiebenXYZ;
      cmDrehenXYZ:DrehenXYZ;
      cmDehnenXYZ:DehnenXYZ;
      cmSave:Sichern;
      cmSaveAs:SichernAls;
      cmOptionen:Optionen;
      cmValid:;
      cmmalebild..cmradio: begin
        doscode:=event.command-2200;
        endmodal(cmquit);
      end;
      else myevent:=false;
    end;
    if myevent then clearevent(event) else
    write(^G);
  end;
end;

var WizArt:TWizArt;

procedure TWizArt.RestoreDeskTop;
begin
  if (getinfo<>'') then DeskTop^.Insert(ValidView(New(PSzene, Lade(GetInfo))));
end;

procedure TWizArt.savedesktop;
var hilfszene:PSzene;
begin
  if InfoDa then begin
    hilfszene:=message(desktop,evcommand,cmGetSzene,nil);
    if (hilfszene<>nil) then setinfo(copy(hilfszene^.name,1,52))
    else setinfo('');
  end;
end;

begin
  Randomize;
  WizArt.Init;
  WizArt.RestoreDeskTop;
  WizArt.State:=WizArt.State and not sffocused;
  WizArt.Run;
  WizArt.SaveDeskTop;
  WizArt.Done;
  Halt(DosCode);
end.