unit U3DViews;
interface
uses crt,graph,dos,Maus,Objects,TGDriver,TGViews,TGDialog,Matrizen,TGApp,
     TGMouse,TGstdDlg,TGMsgBox,WizView,UObjList,UUtils;
const dsKoorSys=1;
      dsObjekt=2;
      dsKoorEcken=4;
      dsMeshEcken=8;
      dsGruppiert=16;
      af3D=0;
      afXYZ=1;

      cmGetSzene=900;
      cmSichern=901;
      cmLoeschen=902;
      cmNextObj=903;
      cmLastObj=904;
      cmUpObj=905;
      cmDownObj=906;
      cmObjektParameter=907;
      cmSzenenParameter=908;
      cmLadeMaterial=909;
      cmSichereMaterial=910;
      cmLadeTextur=911;
      cm3DViewFocused=912;
      cm3DLineActive=913;
      cmRenObj=914;
      cmVerzeichnisneuanzeigen=915;
      cmGruppenBaumneuanzeigen=916;
      cmKopieGruppe=917;
      cmKopieObjekt=918;
      cmMoveGruppe=919;
      cmMoveObjekt=920;
      cmNeueGruppe=921;
      cmLoescheGruppe=922;
      cmLoescheObjekt=923;
      cmBewege=924;
      cmTestIsMySubGroup=925;
      cmRevAn=926;
      cmRevAus=927;
      cmUpdateLister=999;

      obKugel=1;
      obTorus=2;
      obEbene=3;
      obSaule=4;
      obDreieck=5;
      obViereck=6;
      obRotationskoerper=7;
      obDose=8;
      obZiehkoerper=9;
      obObjekt=10;
      obLicht=11;
      obMesh=12;

      cmKugel=1001;
      cmTorus=1002;
      cmEbene=1003;
      cmSaule=1004;
      cmDreieck=1005;
      cmViereck=1006;
      cmRotationskoerper=1007;
      cmDose=1008;
      cmZiehkoerper=1009;
      cmObjekt=1010;
      cmLicht=1011;
      cmMesh=1012;

      cms3Dan=1050;
      cms3Daus=1051;
      cmsXYZan=1052;
      cmsXYZaus=1053;
      cmGruppieren=1054;
      cmEntGruppieren=1055;

      hcGruppe=1048;
      hcWurzel=1049;
      scKreuz=1001;
      scRingKreuz=1002;
      scUhr=1003;


      sfFlipAreaEnabled=1;
      sfWireFrame=2;
      sfLampe=4;
      sfclipcube=8;
      sfbrille=16;
      sfframe=32;
      sffarbig=64;
      sfsw256=128;
      sfNebel=256;
      sfAutoSave=512;
      sfInteraktivMaus=1024;
      sfInteraktivJoystick=2048;
      sfVariablenAnzeigen=4096;
      sfTrifillenabled=8192;
      sfshadingmethod=16384;

      dfkoordinaten=1;
      dfxz=2;
      dfYZ=4;
      dfXY=8;
      dfgesamt=16;
      dfHigh=32;
      dfLow=64;
      dfRAM=128;
      dfTrueColor=256;
      dfMagicPic=512;

      amNormal=0;
      amXor=1;
      smLang=0;
      smKurz=1;
      smInfoDa=$80;
      {lmlang=0;
      lmSchnell=1;}
      asSzene=1;
      asDesk=2;

      dx0=0;
      dy0=0;
      zoom0=100;
      qxy=10;
      qzoom=60;

      ffX=1;
      ffY=2;
      ffZ=4;

      ogObjekt=0;
      ogGruppe=1;

      ekNormal=0;
      ekClick=1;
      ekAntiClick=2;

      maxpnts=50;

      AddSubGroups=true;
      NoSubGroups=false;


Type TOptions = record
       SpeicherModus:word;
       {LadeModus:word;}
       AnzeigeModus:word;
       Autosave:word;
       Verzeichnis:pathstr;
     end;
     TRGB=record r,g,b:single; end;

const WizOpt:TOptions=(
        SpeicherModus:smLang;
        {LadeModus:lmSchnell;}
        AnzeigeModus:amXOR;
        Autosave:0;
        Verzeichnis:'');
     Weiss:TRGB=(r:1;g:1;b:1);
     Schwarz:TRGB=(r:0;g:0;b:0);

Type TGreyTab=array[0..3] of Trgb;
     PDaten=^TDaten;
     TDaten=record
       Flag:Word;
       Darstellung:Word;
       XMIN:single;
       YMIN:single;
       XSIZE:single;
       VPD:single;
       FPD:single;
       BPD:single;
       mass:single;
       augendist:single;
       Nebel:single;
       Lampen1,Lampen2:byte;
       LampeSkalierung:Single;
       xmax,ymax:word;
       VRP,NRP,VUP:T3DPoint;
       bkcolor,nebelcolor,umgebungslicht:Trgb;
       GreyTab:TGreyTab;
     end;

const edaten:tdaten=(Flag:sffarbig;
                     Darstellung:dfHigh+dfkoordinaten;
        XMIN:-1.5;YMIN:-1.1;XSIZE:3;
        VPD:6;FPD:5;BPD:-5;mass:3;augendist:0.5;
        Nebel:0;Lampen1:10;Lampen2:10;
        LampeSkalierung:1;
        xmax:320;
        ymax:200;
        VRP:(x:0;y:0;z:0);
        NRP:(x:0;y:1;z:1);
        VUP:(x:0;y:1;z:0);
        bkcolor:(r:0.0;g:0.0;b:0.0);
        nebelcolor:(r:0.0;g:0.0;b:0.0);
        umgebungslicht:(r:0.0;g:0.0;b:0.0);
        greytab:((r:1;g:1;b:1),(r:1;g:0;b:0),(r:0;g:1;b:0),(r:0;g:0;b:1))
        );

Type PPString=^PString;

var TypeOfTSzene:pointer;
    ObjektText,GruppeText,WurzelText:PPString;

Type P3DGroup = ^T3DGroup;
     P3DView = ^T3DView;

     P2DMesh=^T2DMesh;
     T2DMesh=object(TObject)
       x,y:byte;
       Points:Pointer;
       objekt:P3DView;
       constructor init(ax,ay:byte;Aobjekt:P3DView);
       destructor done; virtual;
       function PointAt(ax,ay:byte):PPoint;
       procedure putin(ax,ay:byte;var p:TPoint);
     end;

     PEcke=^TEcke;
     TEcke=object(TView)
       constructor init(var r:TRect);
       procedure Handleevent(var event:TEvent); virtual;
       procedure draw; virtual;
     end;

     PEcken=^TEcken;
     TEcken=object(TGroup)
       objekt:PView;
       Flag:Boolean; {True falls initKoorSys benutzt wurde, bei initMeshs false}
       constructor initKoorSys(KoorSys:TKoorSys;Aobjekt:PView);
       procedure Changekoorsys(Koorsys:TKoorsys);
       constructor initMeshs(mesh:TMesh;Aobjekt:P3DView);
       procedure ChangeMeshs(Mesh:Tmesh);
       procedure ChangePoint(x,y,my:byte;p:P3DPoint);
       function GetPositionctx:word; virtual;
     end;

     P3DCursor=^T3DCursor;

     Psicht=^TSicht;
     TSicht=object(TGroup)
       OriginalWC_DC,WC_DC:TMatrix;
       Art:Word;
       Puffer:P2DMesh;
       constructor init(Bounds:TRect;AWC_DC:TMatrix);
       {constructor load(var s:TStream);}
       destructor done; virtual;
       {procedure store(var s:TStream);}
       procedure Handleevent(var event:TEvent); virtual;
       procedure maleMesh(Mesh:PMesh;Buffer:PMesh;OldOC_MC,OC_MC:PMatrix;
                   objekt:P3DView;var erste,imPuffer:boolean;remove:boolean);
       procedure MaleKoor(OldOC_MC,OC_MC:PMAtrix;objekt:PView;remove:boolean);
       procedure Male3DCursor(rev:P3DCursor;visible:boolean);
       function getpalette:PPalette; virtual;
       procedure setstate(Astate:word;enable:boolean); virtual;
       procedure Draw; virtual;
       procedure DrawKoorSys(var KoorSys:TKoorSys;loschen:boolean);
       procedure RemoveKoorSys(AObjekt:PView);
       Function GetKoorsys(AObjekt:PView):PEcken;
       procedure AddKoorSys(KoorSys:TKoorSys;AObjekt:PView);
       procedure RemoveMeshs(AObjekt:P3DView);
       Function GetMeshs(AObjekt:PView):PEcken;
       procedure AddMeshs(Mesh:TMesh;AObjekt:P3DView);
       procedure newWC_DC(var AWC_DC:TMatrix);
       procedure setbounds(bounds:TRect;xmin,ymin,zoom:single); virtual;
       procedure DrawMesh(Mesh:PMesh;Buffer:PMesh;var erste,imPuffer:boolean;loschen:boolean); virtual;
       procedure DrawPartMesh(Objekt:P3DView;x1,y1,x2,y2:byte;loschen:boolean);
       function GetPositionctx:word; virtual;
     end;

     Pyzsicht=^TYZSicht;
     TYZSicht=object(TSicht)
       constructor init(Bounds:TRect);
     end;

     PXZSicht=^TXZSicht;
     TXZSicht=object(TSicht)
       constructor init(Bounds:TRect);
     end;

     PXYSicht=^TXYSicht;
     TXYSicht=object(TSicht)
       constructor init(Bounds:TRect);
     end;

     PAnsicht=^TAnsicht;
     TAnsicht=object(TWindow)
       Sicht:PSicht;
       ZoomScroll,XScroll,Yscroll:PScrollbar;
       constructor init(var bounds:TRect;Atitel:TTitleStr;Asicht:Psicht);
       {constructor load(var s:TStream);
       procedure store(var s:TStream);}
       procedure Handleevent(var event:TEvent); virtual;
       function getpalette:PPalette; virtual;
       procedure InitFrame; virtual;
       procedure draw; virtual;
     end;

{     PLister=^TLister;
     TLister=object(TDialog)
       Objekte:P3DGroup;
       constructor init(var bounds:TRect;AObjekte:P3DGroup);
       function getpalette:PPalette; virtual;
     end;

     PParamDiag=^TParamDiag;
     TParamDiag=object(TDialog)
     end;}

     PRoot=^TRoot;
     

     PSzeneAbstract=^TSzeneAbstract;
     TSzeneAbstract=object(TWindow)
       gesichert:boolean;
       Sichten:PCollection;
       AktObjekt:PView;
       Root:PRoot;
       name:pathstr;
       val:boolean;
       Daten:TDaten;
       Rev:P3DCursor;
       function GetName:Pathstr; virtual;
       function error(s:string):word; virtual;
       procedure SetObjekt(o:PView); virtual;
     end;

     PObjektCollection=^TObjektCollection;
     TObjektCollection=object(TCollection)
       function vorhanden(x,y:byte;p:word):PMesh;
       procedure losche(x,y:byte;p:word);
       function neu(x,y:byte;p:word):PMesh;
       function kopiere(x,y:byte;p,neup:word):PMesh;
     end;

     
     TMaterial=record
       ka:single;
       oa:TRgb;
       kd:single;
       od:TRgb;
       ks:single;
       os:TRgb;
       alpha:single;
       oe:single;
     end;

     PParamdata=^TParamData;
     TParamdata=record
       MaterialName:Namestr;
       Textur:NameStr;
       Material:TMaterial;
       x,y:byte;
       Pos:T3DRect;
{       Translation:T3DPoint; (Ursprungspunkt)
       Scalierung:T3DPoint;  (Verzerrung in x,y,z-Richtung)
       Rotation:T3DPoint;    (Rotation um x,y,z-Achse)}
       Darstellung:word;
     end;

     TData=record
       x,y:byte;
       M:TMaterial;
       Materialname:Namestr;
       textur:Pathstr;
       Darstellung:word;
       case word of
         obKugel: ();
         obEbene: ();
         obTorus: (
           r1,r2:single);
         obSaule: ();
         obDose:  (
           n3:byte);
     end;

     PObjektParameterDialog=^TObjektParameterDialog;
     TObjektParameterDialog=object(TDialog)
       TexturName,MaterialName:PInputLine;
       InputZahl:array[0..4] of PInputLine;
       FarbRegler:array[0..2] of PFarbRegler;
       procedure HandleEvent(var Event: TEvent); virtual;
     end;

     Groupstr=string[15];
     
     T3DView = object(TView)
       Szene:PSzeneAbstract;
       OC_MC:TMatrix;
       Mesh:PMesh;
       Name:GroupStr;
       paramdata:TParamdata; {Paramdata mu die letzte Variable bleiben!}
       constructor Init(var pos: T3DRect;aszene:PSzeneAbstract;ax,ay:byte;Aname:GroupStr);
       destructor Done; virtual;
       {procedure HandleEvent(var Event: TEvent); virtual;}
       function CalcObjekt:boolean; virtual;
       function Calc:boolean; virtual;
       procedure Draw; virtual;
       procedure ReDraw(OldOC_MC,NewOC_MC:PMatrix;remove:boolean);
       procedure DrawPartMesh(x1,y1,x2,y2:byte;loschen:boolean);
       procedure maleSicht(Sicht:PSicht);
       procedure DrawView; virtual;
       function RegNr:word; virtual;
       procedure EckePressed(anr:byte); virtual;
       procedure MeshPressed(anr:integer); virtual;
       procedure sichern(var f:text); virtual;
       function sichereLicht(var f:text):boolean; virtual;
       procedure ChangeDarstellung(ADarstellung:word;enable:boolean);
       procedure SetParam(AData:TData); virtual;
       function ObjektDialog(pfad:pathstr;hohe:byte):PObjektParameterDialog; virtual;
       function ExecObjektDialog(HPara:PParamData):boolean; virtual;
       procedure setname(aname:groupstr); virtual;
       function Getname:Groupstr; virtual;
       function KopierDich(NeueSzene:PSzeneAbstract):P3DView; virtual;
       procedure MeshNeu;
       function MeshNeuErlaubt:boolean; virtual;
     end;

     T3DGroup = object(TGroup)
       szene:PSzeneAbstract;
       name:groupstr;
       MC_WC:TMatrix;
       pos:T3DRect;
       Darstellung:Word;
       constructor Init(Aname:groupstr;ASzene:PSzeneAbstract;AMC_WC:TMatrix);
       constructor Kopie(Original:P3DGroup;NeueSzene:PSzeneAbstract);
       procedure HandleEvent(var Event: TEvent); virtual;
       procedure SetState(astate:word;enable:boolean); virtual;
       procedure Focus3DGroup;
       procedure draw; virtual;
       procedure ReDraw(OldMC_WC,NewMC_WC:PMatrix;remove:boolean); virtual;
       procedure maleSicht(Sicht:PSicht);
       procedure sichern(var f:text); virtual;
       function sichereLicht(var f:text):boolean; virtual;
       procedure schreibesprung(var f:text); virtual;
       procedure ChangeDarstellung(ADarstellung:word;enable:boolean);
       procedure Getpfad(var s:objstr); virtual;
       procedure setname(aname:groupstr); virtual;
       function Getname:Groupstr; virtual;
       procedure NeueGruppe;
       function KopierDich(NeueSzene:PSzeneAbstract):P3DGroup; virtual;
       procedure EckePressed(anr:byte;gruppeErlaubt:Boolean);
       procedure Gruppieren;
       procedure EntGruppieren;
       function GetCurrentObjekt:P3dView;
       procedure CorrectMC_WC; virtual;
       function GetPfadGroup(path:string):P3DGroup;
       procedure GruppeE;
       procedure GruppeAufRev;
       function UnterGruppierung:boolean; virtual;
       procedure CorrectName;
       function NameExists(var Aname:GroupStr):boolean;
       function GetGroup(var Aname:GroupStr):P3DGroup;
       procedure PutMC_WC(AMC_WC:TMatrix);
     end;

     TRoot=object(T3DGroup)
       constructor init(ASzene:PSzeneAbstract;SubGroups:Boolean;var obj:P3DGroup);
       procedure Getpfad(var s:objstr); virtual;
       procedure draw; virtual;
       procedure CorrectMC_WC; virtual;
       function UnterGruppierung:boolean; virtual;
     end;

     TPosition=array[0..2] of PInputZahl;

     PBewege=^TBewege;
     TBewege = object(TDialog)
       XYZ:PCheckBoxes;
       grid:TPosition;
       u,dk:array[0..2] of single;
       ObGr,Ecke:PRadioButtons;
       AktPos:TPosition;
       constructor init(var Bounds:TRect;ATitle:TTitlestr);
       destructor done; virtual;
       procedure HandleEvent(var Event: TEvent); virtual;
       function Move(obj:PView;event:TEvent;eckenr:byte):boolean; virtual;
       function PosiVerandert(obj:PView):boolean; virtual;
       function CalcBewegung(var x,y,z:single;obj:PView;event:TEvent;eckenr:byte;quot:byte):boolean;
       procedure reset(obj:PView);
       function GruppeBewegen:Boolean;
       procedure CalcPosi(o:PView;var p:T3DPoint); virtual;{Holt das was in den Inputlines stehen soll aus den Objekten}
       procedure UpdatePosi(p:T3DPoint);
       procedure GetPosi(var p:T3DPoint);{Holt Position aus InputLines}
       procedure SelectPos(var r:T3DRect;var pos:T3DPoint); Virtual;
       procedure setpos(var pos:T3DRect;var p:T3DPoint); virtual;
       procedure setposi(o:PView;var p:T3DPoint); virtual;
     end;

     PVerschiebe=^TVerschiebe;
     TVerschiebe = object(TBewege)
       constructor init(var Bounds:TRect);
       function Move(obj:PView;event:TEvent;eckenr:byte):boolean; virtual;
       procedure CalcPosi(o:PView;var p:T3DPoint); virtual;
       procedure SelectPos(var r:T3DRect;var pos:T3DPoint); Virtual;
       procedure setpos(var pos:T3DRect;var p:T3DPoint); virtual;
       procedure setposi(o:PView;var p:T3DPoint); virtual;
     end;

     PDrehe=^TDrehe;
     TDrehe = object(TBewege)
       constructor init(var Bounds:TRect);
       function Move(obj:PView;event:TEvent;eckenr:byte):boolean; virtual;
       procedure CalcPosi(o:PView;var p:T3DPoint); virtual;
       procedure SelectPos(var r:T3DRect;var pos:T3DPoint); Virtual;
       procedure setpos(var pos:T3DRect;var p:T3DPoint); virtual;
       procedure setposi(o:PView;var p:T3DPoint); virtual;
     end;

     PDehne=^TDehne;
     TDehne = object(TBewege)
       constructor init(var Bounds:TRect);
       function Move(obj:PView;event:TEvent;eckenr:byte):boolean; virtual;
       procedure CalcPosi(o:PView;var p:T3DPoint); virtual;
       procedure SelectPos(var r:T3DRect;var pos:T3DPoint); Virtual;
       procedure setpos(var pos:T3DRect;var p:T3DPoint); virtual;
       procedure setposi(o:PView;var p:T3DPoint); virtual;
     end;

     PMeshObjMenu=^TMeshObjMenu;
     TMeshObjMenu = object(TDialog)
       breite:PInputZahl;
       constructor init(var Bounds:TRect);
       destructor done; virtual;
     end;

     T3DCursor=object(TView)
       Pos:T3DPoint;
       visible:boolean;
       constructor init;
       Procedure Handleevent(var Event:TEvent); virtual;
       procedure Draw; virtual;
       procedure EckePressed;
       procedure MoveTo(p:T3DPoint);
       procedure Malesicht(sicht:Psicht);
       procedure SetState(AState: Word; Enable: Boolean); virtual;
     end;

{procedure Register3DViews;}
function ExecDialog(P: PDialog; Data: Pointer): Word;
function getaktszene:pSzeneAbstract;
{procedure MakePos(Paramdata:TParamData;var pos:T3DRect);}
function no3DGroup(h:PView):boolean;

var ObjektCollection:PObjektCollection;
    SichereGosub:PStringCollection;
    CorNameCount:Char;
const Bewegung:PBewege=nil;
      MeshMenu:PMeshObjMenu=nil;
implementation
const Mitte:TPoint=(x:320;y:240);

{procedure MakePos(Paramdata:TParamData;var pos:T3DRect);
begin
  with paramdata do begin
    pos.T:=Translation;
    pos.r:=Rotation;
    pos.s:=Scalierung;
  end;
end;}

function getaktszene:pSzeneAbstract;

  function suchecurszene(item: PView):boolean;far;
  begin
    suchecurszene:=(TypeOf(Item^)=TypeOfTSzene) and (item^.getstate(sfSelected));
  end;

begin
  GetAktSzene:=PSzeneAbstract(desktop^.subviews^.firstthat(@suchecurszene));
end;


function getszene:pSzeneAbstract;

  function sucheszene(item: PView):boolean;far;
  begin
    sucheszene:=(TypeOf(Item^)=TypeOfTSzene);
  end;

begin
  GetSzene:=PSzeneAbstract(desktop^.subviews^.firstthat(@sucheszene));
end;

function no3DGroup(h:PView):boolean;
begin
  no3DGroup:=(Typeof(h^)<>Typeof(TRoot)) and (TypeOf(h^)<>TypeOf(T3DGroup));
end;

const CursorGrose:T3DPoint=(x:0.5;y:0.5;z:0.5);
      eMaterial:TMAterial=(ka:0.05;oa:(r:1;g:1;b:1);
                           kd:0.8;od:(r:1;g:1;b:1);
                           ks:0.05;os:(r:1;g:1;b:1);
                           alpha:0;oe:5);

{procedure Register3DViews;
const R3DView:TStreamRec = (
        ObjType:1001;
        VmtLink: Ofs(TypeOf(T3DView)^);
        Load: @T3DView.Load;
        Store: @T3DView.Store);
      RSzene:TStreamRec = (
        ObjType:1002;
        VmtLink: Ofs(TypeOf(TSzene)^);
        Load: @TSzene.Load;
        Store: @TSzene.Store);
      RSicht:TStreamRec = (
        ObjType:1003;
        VmtLink: Ofs(TypeOf(TSicht)^);
        Load: @TSicht.Load;
        Store: @TSicht.Store);
      RAnSicht:TStreamRec = (
        ObjType:1004;
        VmtLink: Ofs(TypeOf(TAnSicht)^);
        Load: @TAnSicht.Load;
        Store: @TAnSicht.Store);
begin
  RegisterType(R3DView);
  RegisterType(RSzeneAbstract);
  RegisterType(RSicht);
  RegisterType(RAnSicht);
end;}

function ExecDialog(P: PDialog; Data: Pointer): Word;
var
  Result: Word;
begin
  Result := cmCancel;
  P := PDialog(Application^.ValidView(P));
  if P <> nil then
  begin
    if Data <> nil then P^.SetData(Data^);
    Result := DeskTop^.ExecView(P);
    if (Result <> cmCancel) and (Data <> nil) then P^.GetData(Data^);
    Dispose(P, Done);
  end;
  ExecDialog := Result;
end;

{ TSicht }

procedure TSicht.Draw;
var r:TRect;
begin
  if state and sfvisible>0 then begin
    getextent(r);
    clearfeld(r.a.x,r.a.y,r.b.x,r.b.y,{false,}getcolor(1*256+2));
  end;
end;

constructor TSicht.init(Bounds:TRect;AWC_DC:TMatrix);
begin
  TGroup.Init(bounds);
  WC_DC:=AWC_DC;
  OriginalWC_DC:=AWC_DC;
  Art:=af3D;
  puffer:=nil;
end;

{constructor TSicht.load(var s:TStream);
begin
end;}

destructor TSicht.done;
begin
  if puffer<>nil then dispose(puffer,done);
  TGroup.done;
end;

procedure TSicht.setstate(Astate:word;enable:boolean);
begin
  TView.SetState(AState,enable);
end;

{procedure TSicht.store(var s:TStream);
begin
end;}

procedure TSicht.DrawPartMesh(Objekt:P3DView;x1,y1,x2,y2:byte;loschen:boolean);
var x,y:byte;
    color:word;
    p1,p2,p3:T3DPoint;
    HLine:P2DLine;
    Meshs:Pecken;
    changeMesh:boolean;
begin
  changeMesh:=false;
  if (objekt^.paramdata.darstellung and dsMeshecken>0) and (not loschen) then begin
    Meshs:=GetMeshs(Objekt);
    if Meshs=nil then begin
      AddMeshs(objekt^.Mesh^,objekt);
      Meshs:=GetMeshs(Objekt);
      changeMesh:=meshs<>nil;
    end else changeMesh:=true;
  end;
  setOC_MC(objekt^.OC_MC);
  setWC_DC(WC_DC);
  if correctviewport then with objekt^ do begin
    color:=8;{getcolor(3*256+4);}
    if WizOpt.AnzeigeModus=amNormal then begin
      if loschen then color:=0;
    end else setwritemode(xorput);
    setcolor(lo(color) and $f);
    HideMouse;
    new(HLine,init(mesh^.y));

    if HLine^.points=nil then begin
      for x:=x1 to pred(x2) do for y:=y1 to pred(y2) do begin
        calcpoint(mesh^.pointat(x,y)^,p1);if changeMesh then Meshs^.ChangePoint(x,y,Mesh^.y,@p1);
        calcpoint(mesh^.pointat(succ(x),y)^,p2);if changeMesh then Meshs^.ChangePoint(succ(x),y,Mesh^.y,@p2);
        calcpoint(mesh^.pointat(x,succ(y))^,p3);if changeMesh then Meshs^.ChangePoint(x,succ(y),Mesh^.y,@p3);
        graph.Line(round(p1.x),round(p1.y),round(p2.x),round(p2.y));
        graph.Line(round(p1.x),round(p1.y),round(p3.x),round(p3.y));
      end;
      for x:=x1 to pred(x2) do begin
        calcpoint(mesh^.pointat(x,y2)^,p1);
        calcpoint(mesh^.pointat(succ(x),y2)^,p2);
        graph.Line(round(p1.x),round(p1.y),round(p2.x),round(p2.y));
      end;
      for y:=y1 to pred(y2) do begin
        calcpoint(mesh^.pointat(x2,y)^,p1);
        calcpoint(mesh^.pointat(x2,succ(y))^,p3);
        graph.Line(round(p1.x),round(p1.y),round(p3.x),round(p3.y));
      end;
    end else begin
      for y:=y1 to y2 do begin
        calcpoint(mesh^.pointat(x1,y)^,p1);
        HLine^.Putin(y,p1);
      end;
      for x:=succ(x1) to x2 do begin
        for y:=y1 to pred(y2) do begin
          graph.Line(HLine^.pointat(y)^.x,HLine^.pointat(y)^.y,
                     HLine^.pointat(succ(y))^.x,HLine^.pointat(succ(y))^.y);
          calcpoint(mesh^.pointat(x,y)^,p1);if changeMesh then Meshs^.ChangePoint(x,y,Mesh^.y,@p1);
          graph.Line(HLine^.pointat(y)^.x,HLine^.pointat(y)^.y,
                     round(p1.x),round(p1.y));
          HLine^.putin(y,p1);
        end;
        calcpoint(mesh^.pointat(x,y2)^,p1);
        graph.Line(HLine^.pointat(y2)^.x,HLine^.pointat(y2)^.y,
                     round(p1.x),round(p1.y));
        HLine^.putin(y2,p1);
      end;
      for y:=y1 to pred(y2) do
        graph.Line(HLine^.pointat(y)^.x,HLine^.pointat(y)^.y,
                   HLine^.pointat(succ(y))^.x,HLine^.pointat(succ(y))^.y);
      dispose(HLine,done);
    end;

    setwritemode(normalput);
    showmouse;
  end;
end;

procedure TSicht.maleMesh(Mesh:PMesh;Buffer:PMesh;OldOC_MC,OC_MC:PMatrix;
  objekt:P3DView;var erste,imPuffer:boolean;remove:boolean);
{Diese Prozedur wird nur von der 3DView aufgerufen wenn sie bewegt, zum
 ersten oder letzten Mal dargestellt wird}
var Meshs:Pecken;
begin
  if objekt^.paramdata.darstellung and dsMeshecken>0 then Meshs:=GetMeshs(Objekt);
  if OldOC_MC<>nil then begin
    setOC_MC(OldOC_MC^);
    setWC_DC(WC_DC);
    DrawMesh(Mesh,Buffer,erste,imPuffer,true);
  end;
  if OC_MC<>nil then begin
    objekt^.OC_MC:=OC_MC^;
    setOC_MC(OC_MC^);
    setWC_DC(WC_DC);
    DrawMesh(Mesh,Buffer,erste,imPuffer,false);
    if objekt^.paramdata.darstellung and dsMeshecken>0 then begin
      if Meshs=nil then AddMeshs(Mesh^,objekt)
      else Meshs^.changeMeshs(Mesh^);
    end;
  end else if (objekt^.paramdata.darstellung and dsMeshecken>0) and
      (Meshs<>nil) and remove then RemoveMeshs(objekt);
end;

procedure TSicht.DrawMesh(Mesh:PMesh;Buffer:PMesh;var erste,imPuffer:boolean;loschen:boolean);
var x,y:byte;
    color:word;
    p1,p2,p3:T3DPoint;
    HLine:P2DLine;
begin
  if correctviewport then begin
    color:=8;{getcolor(3*256+4);}
    if WizOpt.AnzeigeModus=amNormal then begin
      if loschen then color:=0;
    end else setwritemode(xorput);
    setcolor(lo(color) and $f);
    HideMouse;
    new(HLine,init(mesh^.y));
    if HLine^.points=nil then begin
      for x:=0 to pred(mesh^.x) do for y:=0 to pred(mesh^.y) do begin
        calcpoint(mesh^.pointat(x,y)^,p1);
        calcpoint(mesh^.pointat(succ(x),y)^,p2);
        calcpoint(mesh^.pointat(x,succ(y))^,p3);
        graph.Line(round(p1.x),round(p1.y),round(p2.x),round(p2.y));
        graph.Line(round(p1.x),round(p1.y),round(p3.x),round(p3.y));
      end;
      for x:=0 to pred(mesh^.x) do begin
        calcpoint(mesh^.pointat(x,mesh^.y)^,p1);
        calcpoint(mesh^.pointat(succ(x),mesh^.y)^,p2);
        graph.Line(round(p1.x),round(p1.y),round(p2.x),round(p2.y));
      end;
      for y:=0 to pred(mesh^.y) do begin
        calcpoint(mesh^.pointat(mesh^.x,y)^,p1);
        calcpoint(mesh^.pointat(mesh^.x,succ(y))^,p3);
        graph.Line(round(p1.x),round(p1.y),round(p3.x),round(p3.y));
      end;
    end else begin
      for y:=0 to mesh^.y do begin
        calcpoint(mesh^.pointat(0,y)^,p1);
        HLine^.Putin(y,p1);
      end;
      for x:=1 to mesh^.x do begin
        for y:=0 to pred(mesh^.y) do begin
          graph.Line(HLine^.pointat(y)^.x,HLine^.pointat(y)^.y,
                     HLine^.pointat(succ(y))^.x,HLine^.pointat(succ(y))^.y);
          calcpoint(mesh^.pointat(x,y)^,p1);
          graph.Line(HLine^.pointat(y)^.x,HLine^.pointat(y)^.y,
                     round(p1.x),round(p1.y));
          HLine^.putin(y,p1);
        end;
        calcpoint(mesh^.pointat(x,mesh^.y)^,p1);
        graph.Line(HLine^.pointat(mesh^.y)^.x,HLine^.pointat(mesh^.y)^.y,
                     round(p1.x),round(p1.y));
        HLine^.putin(mesh^.y,p1);
      end;
      for y:=0 to pred(mesh^.y) do
        graph.Line(HLine^.pointat(y)^.x,HLine^.pointat(y)^.y,
                   HLine^.pointat(succ(y))^.x,HLine^.pointat(succ(y))^.y);
      dispose(HLine,done);
    end;
    setwritemode(normalput);
    showmouse;
  end;
end;

function TSicht.GetPositionctx:word;
var Mousev:PView;

  function MausInView(Item:PView):boolean;far;

    function MausOnEcke(Item:PView):boolean;far;
    begin
      MausOnEcke:=Item^.MouseInView(MouseWhere);
    end;

  begin
    if (TypeOf(Item^)=TypeOf(TEcken)) and (Pecken(Item)^.Subviews<>nil)
    then MausInView:=(PEcken(Item)^.Subviews^.LastThat(@MausOnEcke)<>nil)
    else MausInView:=False;
  end;

begin
  MouseV:=SubViews^.lastthat(@MausInView);
  if (MouseV<>nil)
  then getPositionctx:=MouseV^.getPositionctx
  else GetPositionCtx:=scKreuz;
end;

{ TEcke }

constructor Tecke.init(var r:TRect);
begin
  TView.init(r);
  state:=state and not sfVisible;
end;

procedure TEcke.Handleevent(var event:TEvent);
{Wenn der Mauscursor auf eine Ecke zeigt, wird diese Prozedur aufgerufen.
 Sobald die Maustaste gedrckt wird, wird die Methode EckePressed der
 zugehrigen 3DView, mit der Nummer der Ecke als Parameter, aufgerufen}
var h:PView;
begin
  if event.what and evmousedown>0 then
    if PEcken(owner)^.flag then begin
      if No3DGroup(PEcken(owner)^.objekt)
      then begin
        h:=PEcken(owner)^.objekt;
        if TypeOf(h^)=TypeOf(T3DCursor)
        then P3DCursor(h)^.EckePressed
        else P3DView(h)^.EckePressed(owner^.subviews^.IndexOf(@self))
      end else P3DGroup(PEcken(owner)^.objekt)^.EckePressed(owner^.subviews^.IndexOf(@self),true);
    end else P3DView(PEcken(owner)^.objekt)^.MeshPressed(owner^.subviews^.IndexOf(@self));
  clearevent(event);
end;

procedure TEcke.Draw;
begin
end;

{ TEcken }

constructor TEcken.initKoorSys(KoorSys:TKoorSys;Aobjekt:PView);
{Es werden gleichzeigig mit dem Verweis auf das Objekt die 7 Eckpunkte als
 TViews eingerichtet}
var r:TRect;
    n,x,y:byte;
    p:t3dPoint;
begin
  r.assign(0,0,0,0);
  TGroup.Init(r);
  Options:=options and (not ofselectable);
  state:=state and not sfVisible;
  flag:=true;
  objekt:=aobjekt;
  for n:=0 to 6 do begin
    r.assign(pred(round(Koorsys[n].x)),pred(round(Koorsys[n].y)),
             succ(round(Koorsys[n].x)),succ(round(Koorsys[n].y)));
    insert(new(Pecke,init(r)));
  end;
end;

constructor TEcken.initMeshs(Mesh:TMesh;Aobjekt:P3DView);
{Es werden gleichzeigig mit dem Verweis auf das Objekt die Ecken des Meshes
 als TViews eingerichtet}
var r:TRect;
    n,x,y:byte;
    p:t3dPoint;
begin
  r.assign(0,0,0,0);
  TGroup.Init(r);
  Options:=options and (not ofselectable);
  state:=state and not sfVisible;
  flag:=false;
  objekt:=aobjekt;
  for x:=0 to mesh.x do for y:=0 to mesh.y do begin
    calcpoint(mesh.pointat(x,y)^,p);
    r.assign(pred(round(p.x)),pred(round(p.y)),
             succ(round(p.x)),succ(round(p.y)));
    insert(new(Pecke,init(r)));
  end;
end;

function TEcken.GetPositionctx:word;
begin
  GetPositionCtx:=scRingKreuz;
end;

procedure TEcken.Changekoorsys(Koorsys:TKoorsys);
var n,x,y:byte;
    r:TRect;
    p:t3dPoint;
begin
  for n:=0 to 6 do begin
    r.assign(pred(round(Koorsys[n].x)),pred(round(Koorsys[n].y)),
             succ(round(Koorsys[n].x)),succ(round(Koorsys[n].y)));
    PView(Subviews^.at(n))^.setbounds(r);
  end;
end;

procedure TEcken.ChangePoint(x,y,my:byte;p:P3DPoint);
var r:TRect;
begin
  r.assign(pred(round(p^.x)),pred(round(p^.y)),
           succ(round(p^.x)),succ(round(p^.y)));
  PView(Subviews^.at(x*succ(my)+y))^.setbounds(r);
end;

procedure TEcken.ChangeMeshs(mesh:TMesh);
var x,y:byte;
    r:TRect;
    p:t3dPoint;
begin
  for x:=0 to mesh.x do for y:=0 to mesh.y do begin
    calcpoint(mesh.pointat(x,y)^,p);
    r.assign(pred(round(p.x)),pred(round(p.y)),
             succ(round(p.x)),succ(round(p.y)));
    PView(Subviews^.at(x*succ(mesh.y)+y))^.setbounds(r);
  end;
end;

{ TSicht }

procedure TSicht.Handleevent(var event:TEvent);
{Da mehrere Subviews sich berschneiden, aber nicht zu bestimmen ist, in
 welcher die angecklickte Ecke liegt, mssen alle TEcken abgesucht werden.
 Dazu mu der Handleevent Mechanismus abgendert werden}

  procedure handle(item:Pecken);far;
  begin
    if event.what<>evnothing then item^.handleevent(event);
  end;

begin
  if event.what and positionalevents>0 then subviews^.foreach(@handle)
  else TGroup.Handleevent(event);
end;

procedure TSicht.RemoveKoorSys(AObjekt:PView);
var ecken:PEcken;
begin
  ecken:=getkoorsys(aobjekt);
  if ecken<>nil then dispose(ecken,done);
end;

function TSicht.GetKoorSys(AObjekt:PView):PEcken;

  function obj(item:PEcken):boolean;far;
  begin
    obj:=(item^.objekt=AObjekt) and item^.flag;
  end;

begin
  GetKoorSys:=subviews^.firstthat(@obj);
end;

procedure TSicht.AddKoorSys(KoorSys:TKoorSys;AObjekt:PView);
{Jede Sicht speichert in ihren Subviews die 3DObjekte, die sie darstellt.
 Die 7 Subviews von TEcken speichern die Koordinaten der Eck- und Mittelpunkte
 der KoordiantenSysteme des 3DObjekts. Wenn sie angeklickt werden, aktivieren
 sie das Objekt}
begin
  insert(new(Pecken,initKoorsys(KoorSys,AObjekt)));
end;

procedure TSicht.RemoveMeshs(AObjekt:P3DView);
var ecken:PEcken;
begin
  ecken:=getMeshs(aobjekt);
  if ecken<>nil then dispose(ecken,done);
end;

function TSicht.GetMeshs(AObjekt:PView):PEcken;

  function obj(item:PEcken):boolean;far;
  begin
    obj:=(item^.objekt=AObjekt) and not item^.flag;
  end;

begin
  GetMeshs:=subviews^.firstthat(@obj);
end;

procedure TSicht.AddMeshs(Mesh:TMesh;AObjekt:P3DView);
{Jede Sicht speichert in ihren Subviews die 3DObjekte, die sie darstellt.
 Die 7 Subviews von TEcken speichern die Koordinaten der Eck- und Mittelpunkte
 der KoordiantenSysteme des 3DObjekts. Wenn sie angeklickt werden, aktivieren
 sie das Objekt}
begin
  insert(new(Pecken,initMeshs(Mesh,AObjekt)));
end;


procedure Tsicht.DrawKoorSys(var KoorSys:TKoorSys;loschen:boolean);
var color:word;
begin
  if correctviewport then begin
    color:=getcolor(3*256+4);
    if WizOpt.AnzeigeModus=amNormal then begin
      if loschen then color:=0;
    end else setwritemode(xorput);
    setcolor(hi(color) shr 4);
    HideMouse;
    graph.line(round(koorsys[1].x),round(koorsys[1].y),round(koorsys[2].x),round(koorsys[2].y));
    setcolor(hi(color) and $f);
    graph.line(round(koorsys[3].x),round(koorsys[3].y),round(koorsys[4].x),round(koorsys[4].y));
    setcolor(lo(color) shr 4);
    graph.line(round(koorsys[5].x),round(koorsys[5].y),round(koorsys[6].x),round(koorsys[6].y));
    ShowMouse;
    setwritemode(normalput);
  end;
end;

procedure TSicht.newWC_DC(var AWC_DC:TMatrix);
{Wenn WC_DC gendert werden soll, so mu dies ber diese Methode geschehen.
 Sie berechnet WC_DC neu und stellt dann die komplette Sicht neu dar.}
begin
  WC_DC:=AWC_DC;
  OriginalWC_DC:=AWC_DC;
  CalcWC_DC(WC_DC,(PAnSicht(Owner)^.XScroll^.Value)/qxy,
                    (PAnSicht(Owner)^.YScroll^.Value)/qxy,
                    exp(PAnSicht(Owner)^.ZoomScroll^.Value/qzoom),size.x,size.y);
  drawview;{Gibt den Hintergrund neu aus}
  PSzeneAbstract(Owner^.Owner)^.root^.malesicht(@self);{stellt die Objekte neu dar}
  PSzeneAbstract(Owner^.Owner)^.rev^.malesicht(@self);{stellt den Cursor neu dar}
end;

procedure TSicht.setbounds(bounds:TRect;xmin,ymin,zoom:single);
begin
  TGroup.setbounds(bounds);
  WC_DC:=OriginalWC_DC;
  CalcWC_DC(WC_DC,xmin,ymin,zoom,size.x,size.y);
end;

procedure TSicht.MaleKoor(OldOC_MC,OC_MC:PMAtrix;objekt:PView;remove:boolean);
{Diese Prozedur wird nur von der 3DView aufgerufen wenn sie bewegt, zum
 ersten oder letzten Mal dargestellt wird}
var KoorSys:TKoorSys;
    Koors:PEcken;
    KoorEcken:Boolean;
begin
  if No3DGroup(Objekt) then KoorEcken:=P3DView(objekt)^.paramdata.darstellung and dskoorecken>0
  else KoorEcken:=P3DGroup(objekt)^.darstellung and dskoorecken>0;
  if KoorEcken then Koors:=GetKoorsys(Objekt);
  if OldOC_MC<>nil then begin
    setOC_MC(OldOC_MC^);
    setWC_DC(WC_DC);
    CalcKoorSys(KoorSys);
    DrawKoorSys(KoorSys,true);
  end;
  if OC_MC<>nil then begin
    if No3DGroup(Objekt) then P3DView(objekt)^.OC_MC:=OC_MC^
    else P3DGroup(objekt)^.MC_WC:=OC_MC^;
    setOC_MC(OC_MC^);
    setWC_DC(WC_DC);
    CalcKoorSys(KoorSys);
    DrawKoorSys(KoorSys,false);
    if KoorEcken then begin
      if Koors=nil then AddKoorSys(KoorSys,objekt)
      else Koors^.changeKoorSys(KoorSys);
    end;
  end else if Koorecken and (Koors<>nil) and remove then RemoveKoorsys(objekt);
end;

procedure TSicht.Male3DCursor(Rev:P3DCursor;visible:boolean);
var KoorSys:TKoorSys;
    Koors:PEcken;
begin
  Koors:=GetKoorsys(Rev);
  PushOC_MC;
  PushTrafs;
    SetMC_WC(E);
    SetOC_MC(E);
    TransLate(Rev^.pos);
    Scale(CursorGrose);
    SetWC_DC(WC_DC);
    CalcKoorSys(KoorSys);
    if visible then begin
      if Koors=nil then AddKoorSys(KoorSys,Rev)
        else Koors^.changeKoorSys(KoorSys);
    end else if Koors<>nil then RemoveKoorsys(rev);
    if correctviewport then begin
      setwritemode(xorput);
      setcolor(2);
      HideMouse;
      graph.line(round(koorsys[1].x),round(koorsys[1].y),round(koorsys[2].x),round(koorsys[2].y));
      graph.line(round(koorsys[3].x),round(koorsys[3].y),round(koorsys[4].x),round(koorsys[4].y));
      graph.line(round(koorsys[5].x),round(koorsys[5].y),round(koorsys[6].x),round(koorsys[6].y));
      ShowMouse;
      setwritemode(normalput);
    end;
  PopTrafs;
  PopOC_MC;
end;

function TSicht.GetPalette: PPalette;
const
  CSicht = {#43}#38#42#79#80;
  PSicht: String[length(CSicht)] = CSicht;
begin
  getpalette:= @PSicht;
end;

{ TYZSicht }

constructor TYZSicht.init(Bounds:TRect);
begin
  TSicht.Init(bounds,YZMatrix);
  art:=afxyz;
end;

{procedure TYZSicht.DrawMesh(Mesh:PMesh;Buffer:PMesh;OldMC_WC,MC_WC:PMatrix;
   objekt:P3DView;var erste,imPuffer:boolean;loschen:boolean);
begin
end;}

{ TXZSicht }

constructor TXZSicht.init(Bounds:TRect);
begin
  TSicht.Init(bounds,XZMatrix);
  art:=afxyz;
end;

{procedure TXZSicht.DrawMesh(Mesh:PMesh;Buffer:PMesh;OldMC_WC,MC_WC:PMatrix;
  objekt:P3DView;var erste,imPuffer:boolean;loschen:boolean);
begin
end;}

{ TXYSicht }

constructor TXYSicht.init(Bounds:TRect);
begin
  TSicht.Init(bounds,xyMatrix);
  art:=afxyz;
end;

{procedure TXYSicht.DrawMesh(Mesh:PMesh;Buffer:PMesh;OldMC_WC,MC_WC:PMatrix;
  objekt:P3DView;var erste,imPuffer:boolean;loschen:boolean);
begin
end;}

{ TAnsicht }

constructor TAnsicht.init(var bounds:TRect;Atitel:TTitleStr;Asicht:Psicht);
var r:TRect;
begin
  TWindow.init(bounds,'',0);
  flags:=wfMove;

  getextent(r);
  r.a.x:=4;
  r.a.y:=15;
  dec(r.b.x,15);
  dec(r.b.y,15);
  sicht:=asicht;
  sicht^.setbounds(r,dx0/qxy,dy0/qxy,exp(zoom0/qzoom));
  insert(sicht);

  r.assign(15,4,31,13);
  insert(new(PStaticText,init(r,Atitel)));

  getextent(bounds);
  r.assign(bounds.b.x div 4,2,bounds.b.x-15,11);
  new(ZoomScroll,init(r));
  ZoomScroll^.setparams(zoom0,1,200,10,1);
  insert(ZoomScroll);

  r.assign(2,bounds.b.y-11,bounds.b.x-15,bounds.b.y-2);
  new(XScroll,init(r));
  xScroll^.setparams(dx0,-500,500,10,1);
  insert(XScroll);

  r.assign(bounds.b.x-11,15,bounds.b.x-2,bounds.b.y-15);
  new(Yscroll,init(r));
  yScroll^.setparams(dy0,-500,500,10,1);
  insert(YScroll);
end;

{constructor TAnsicht.load(var s:TStream);
begin
end;}

{destructor TAnsicht.done;
begin
  dispose(xscroll,done);
  dispose(yscroll,done);
  dispose(zoomscroll,done);
  TWindow.done;
end;}

{procedure TAnsicht.store(var s:TStream);
begin
end;}

procedure TAnsicht.Handleevent(var event:TEvent);
begin
  TWindow.Handleevent(event);
  if (event.what=evBroadCast) and (event.command=cmScrollBarChanged) then begin
    if (event.infoPtr=ZoomScroll) or (event.infoPtr=XScroll) or
       (event.infoPtr=YScroll) then begin
      clearevent(event);
      Sicht^.newWC_DC(Sicht^.OriginalWC_DC);
    end;
  end;
end;

function TAnsicht.getpalette:PPalette;
begin
  getpalette:=nil;
end;

procedure TAnsicht.InitFrame;
var b,r:TRect;
begin
  r.assign(0,0,size.x,size.y);
  b.assign(13,2,13,13);
  new(Frame,Init(r,b));
  insert(frame);
end;

procedure TAnsicht.draw;
var r:trect;
begin
  if state and sfvisible>0 then begin
    TWindow.Draw;
    if correctviewport then begin
      getextent(r);
      r.a.x:=3;
      r.a.y:=14;
      dec(r.b.x,14);
      dec(r.b.y,14);
      ramen(r.a.x,r.a.y,r.b.x,r.b.y,false,$3131);
    end;
  end;
end;

{ TLister

constructor TLister.init(var bounds:TRect;AObjekte:P3DGroup);
begin
  TDialog.init(bounds,'Objekt Lister');
  Objekte:=AObjekte;
end;

function TLister.getpalette:PPalette;
begin
  getpalette:=nil;
end;
}

{ TBewege }

constructor TBewege.init(var Bounds:TRect;Atitle:TTitleStr);
var R:TRect;
    b:PView;
    s:single;
    a:word;
    aktszen:PSzeneAbstract;
    p:T3DPoint;

  procedure Koords(str:string;x:word;var posi:TPosition;min:single);
  var a:byte;
  begin
    r.assign(20,x+10,bounds.b.x-8,x+23);
    for a:=0 to 2 do begin
      Posi[a]:=new(PInputZahl,init(r,TypSingle,6,3,min,1000));
      insert(Posi[a]);
      r.move(0,15);
      s:=0;
      Posi[a]^.setdata(s);
    end;
    r.assign(8,x,bounds.b.x-8,x+9);
    insert(new(PLabel,init(r,str,Posi[0])));
    r.assign(8,x+12,19,x+25);
    insert(new(PLabel,init(r,'~X~',Posi[0])));
    r.move(0,15);
    insert(new(PLabel,init(r,'~Y~',Posi[1])));
    r.move(0,15);
    insert(new(PLabel,init(r,'~Z~',Posi[2])));
  end;

begin
  aktszen:=getaktszene;
  if aktszen=nil then aktszen:=getszene;

  if bewegung<>nil then begin
    bewegung^.getbounds(bounds);
    dispose(bewegung,done);
  end;
  TDialog.Init(Bounds,Atitle);
  options:=(options or ofpreprocess) and (not ofbuffered);
  getextent(bounds);
  r.assign(8,bounds.b.y-25,bounds.b.x-8,bounds.b.y-8);
  b:=new(PButton,init(r,'Bewegen',cmBewege,bfdefault));
  insert(b);
  b^.options:=b^.options and (not ofselectable);

  r.assign(8,30,bounds.b.x-8,69);
  xyz:=new(PCheckBoxes,init(r,NewSItem('~X~',NewSItem('~Y~',NewSItem('~Z~',nil)))));
  insert(xyz);
  a:=1+2+4;
  xyz^.SetData(a);
  xyz^.options:=xyz^.options and (not ofselectable);
  r.assign(8,20,bounds.b.x-8,29);
  insert(new(PLabel,init(r,'~F~rei in:',xyz)));

  Koords('~G~itter',72,Grid,0);

  r.assign(8,140,bounds.b.x-8,169);
  ObGr:=new(PRadioButtons,init(r,NewSItem('~O~bjekt',NewSItem('~G~ruppe',nil))));
  ObGr^.options:=ObGr^.options or ofCenterX;
  insert(ObGr);
  a:=0;
  ObGr^.SetData(a);
  ObGr^.options:=ObGr^.options and (not ofselectable);
  r.assign(8,130,bounds.b.x-8,139);
  insert(new(PLabel,init(r,'~B~ewegt',ObGr)));

  r.assign(8,182,bounds.b.x-8,223);
  Ecke:=new(PRadioButtons,init(r,NewSItem('~A~lle',NewSItem('~C~lick',NewSItem('~A~ntiCl',nil)))));
  Ecke^.options:=Ecke^.options or ofCenterX;
  insert(Ecke);
  a:=0;
  Ecke^.SetData(a);
  Ecke^.options:=Ecke^.options and (not ofselectable);
  r.assign(8,172,bounds.b.x-8,181);
  insert(new(PLabel,init(r,'~R~ichtung',Ecke)));

  Koords('~P~osition',228,aktPos,-1000);

  bewegung:=@self;

  if (aktszen<>nil) and (aktszen^.aktobjekt<>nil) then begin
    calcposi(aktszen^.aktobjekt,p);
    Updateposi(p);
  end;

end;

procedure TBewege.Handleevent(var Event: TEvent);
var s:PSzeneAbstract;
begin
  TDialog.Handleevent(Event);
  if (event.what=evcommand) and (event.command=cmBewege) then begin
    clearevent(event);
    s:=getaktszene;
    if s=nil then begin
      s:=getszene;
      if s<>nil then s^.focus;
    end;
    if (s<>nil) then begin
      if (s^.aktObjekt<>nil) then begin
        if TypeOf(s^.AktObjekt^)=TypeOf(T3DGroup)
        then P3DGRoup(s^.AktObjekt)^.EckePressed(0,true)
        else if TypeOf(s^.AktObjekt^)<>TypeOf(TRoot)
        then P3DView(s^.AktObjekt)^.EckePressed(0);
      end;
    end;
  end;
end;

destructor TBewege.done;
var r:trect;
begin
  bewegung:=nil;
  if correctViewPort then begin
    getextent(r);
    clearfeld(r.a.x,r.a.y,r.b.x,r.b.y,$2222);
  end;
  setstate(sfvisible,false);
  TDialog.Done;
end;

procedure TBewege.UpdatePosi(p:T3DPoint);
begin
  AktPos[0]^.SetData(p.x);
  AktPos[1]^.SetData(p.y);
  AktPos[2]^.SetData(p.z);
end;

procedure TBewege.GetPosi(var p:T3DPoint);
begin
  AktPos[0]^.GetData(p.x);
  AktPos[1]^.GetData(p.y);
  AktPos[2]^.GetData(p.z);
end;

function TBewege.CalcBewegung(var x,y,z:single;obj:PView;event:TEvent;eckenr:byte;quot:byte):boolean;
var frei:word;
    eck:word;
    p:T3DPoint;

  procedure calckoord(var k:single;n:byte;adk:single);
  var g:single;
  begin
    grid[n]^.getdata(g);
    if g=0 then begin
      k:=k+adk/quot;
    end else begin
      dk[n]:=dk[n]+adk/quot;
      k:=round((u[n]+dk[n])/g)*g;
    end;
  end;

begin
  xyz^.getdata(frei);
  if eckenr<>0 then begin
    eckenr:=pred(eckenr) div 2;
    ecke^.getdata(eck);
    if eck=ekClick then begin
      frei:=frei and (1 shl eckenr);
    end else if eck=ekAntiClick then begin
      frei:=frei and not (1 shl eckenr);
    end;
  end;
  if frei and ffY>0 then calcKoord(y,1,Mitte.y-event.where.y);{ y:=y+(Mitte.y-event.where.y)/100;}
  if mouseButtons and 2>0 then begin
    if frei and ffZ>0 then calcKoord(z,2,Mitte.x-event.where.x);{z:=z+(Mitte.x-event.where.x)/100;}
  end else begin
      if frei and ffX>0 then calcKoord(x,0,event.where.x-Mitte.x);{x:=x-(Mitte.x-event.where.x)/100;}
  end;
  maussetpos(Mitte.x,Mitte.y);
  if frei and (ffy+ffx+ffz)>0 then begin
    if No3DGroup(obj)
    then CalcOC_MC(P3DView(obj)^.OC_MC,P3DView(obj)^.paramdata.pos)
    else CalcOC_MC(P3DGroup(obj)^.MC_WC,P3DGroup(obj)^.pos);
    CalcBewegung:=true;
    p.x:=x;p.y:=y;p.z:=z;
    UpdatePosi(p);
  end else CalcBewegung:=false;
end;


function TBewege.GruppeBewegen:Boolean;
var og:word;
begin
  ObGr^.GetData(og);
  GruppeBewegen:=og<>ogObjekt;
end;

procedure TBewege.CalcPosi(o:PView;var p:T3DPoint);
begin
  abstract;
end;

procedure TBewege.SelectPos(var r:T3DRect;var pos:T3DPoint);
begin
  abstract;
end;

constructor TVerschiebe.init(var Bounds:TRect);
begin
  TBewege.init(Bounds,'Schieben');
end;

procedure TBewege.Reset(obj:PView);
var p:T3DPoint;
    n:byte;
begin
  CalcPosi(obj,p);
  for n:=0 to 2 do dk[n]:=0;
  with p do begin
    u[0]:=x;
    u[1]:=y;
    u[2]:=z;
  end;
end;

function TBewege.Move(obj:PView;event:TEvent;eckenr:byte):boolean;
begin
  Move:=false;
end;

function TBewege.PosiVerandert(obj:PView):boolean;
var pos:T3DRect;
    zahlpos,position:T3DPoint;
begin
  GetPosi(ZahlPos);       {Holt Position aus InputLines}
  CalcPosi(obj,position); {Holt das was in den Inputlines stehen soll aus den Objekten}
  if punktegleich(0.001,zahlpos,position) then
    posiverandert:=false
  else begin
    posiverandert:=true;
    SetPosi(obj,ZahlPos);
    if No3DGroup(obj)
    then CalcOC_MC(P3DView(obj)^.OC_MC,P3DView(obj)^.paramdata.pos)
    else CalcOC_MC(P3DGroup(obj)^.MC_WC,P3DGroup(obj)^.pos);
  end;
end;

procedure TBewege.setpos(var pos:T3DRect;var p:T3DPoint);
begin
  abstract;
end;

procedure TBewege.setposi(o:PView;var p:T3DPoint);
begin
  abstract;
end;

function TVerschiebe.Move(obj:PView;event:TEvent;eckenr:byte):boolean;
begin
  if event.what and evmousemove>0 then begin
    if No3DGroup(obj) then with P3DView(obj)^.paramdata.pos.t do
      move:=CalcBewegung(x,y,z,obj,event,eckenr,100)
    else with P3DGroup(obj)^.pos.t do
      move:=CalcBewegung(x,y,z,obj,event,eckenr,100)
  end else Move:=false;
end;


procedure TVerschiebe.CalcPosi(o:PView;var p:T3DPoint);
begin
  if No3DGroup(o) then P:=P3dView(o)^.paramdata.pos.t else begin
    p:=P3DGroup(o)^.pos.t;
  end;
end;

procedure TVerschiebe.SelectPos(var r:T3DRect;var pos:T3DPoint);
begin
  Pos:=r.t;
end;

procedure TVerschiebe.setpos(var pos:T3DRect;var p:T3DPoint);
begin
  pos.t:=p;
end;

procedure TVerschiebe.setposi(o:PView;var p:T3DPoint);
begin
  if no3dGroup(o) then P3DView(o)^.paramdata.pos.t:=p
  else P3DGroup(o)^.pos.t:=p;
end;

constructor TDrehe.init(var Bounds:TRect);
begin
  TBewege.init(Bounds,'Drehen');
end;

function TDrehe.Move(obj:PView;event:TEvent;eckenr:byte):boolean;
begin
  if event.what and evmousemove>0 then begin
    if No3DGroup(obj) then with P3DView(obj)^.paramdata.pos.r do
      move:=CalcBewegung(x,y,z,obj,event,eckenr,10)
    else with P3DGroup(obj)^.pos.r do
      move:=CalcBewegung(x,y,z,obj,event,eckenr,10)
  end else Move:=false;
end;

procedure TDrehe.CalcPosi(o:PView;var p:T3DPoint);
begin
  if No3DGroup(o) then P:=P3dView(o)^.paramdata.pos.r
  else P:=P3DGroup(o)^.pos.r;
end;

procedure TDrehe.SelectPos(var r:T3DRect;var pos:T3DPoint);
begin
  Pos:=r.r;
end;

procedure TDrehe.setpos(var pos:T3DRect;var p:T3DPoint);
begin
  pos.r:=p;
end;

procedure TDrehe.setposi(o:PView;var p:T3DPoint);
begin
  if no3dGroup(o) then P3DView(o)^.paramdata.pos.r:=p
  else P3DGroup(o)^.pos.r:=p;
end;

constructor TDehne.init(var Bounds:TRect);
begin
  TBewege.init(Bounds,'Dehnen');
end;

function TDehne.Move(obj:PView;event:TEvent;eckenr:byte):boolean;
begin
  if event.what and evmousemove>0 then begin
    if No3DGroup(obj) then with P3DView(obj)^.paramdata.pos.s do
      move:=CalcBewegung(x,y,z,obj,event,eckenr,100)
    else with P3DGroup(obj)^.pos.s do
      move:=CalcBewegung(x,y,z,obj,event,eckenr,100)
  end else Move:=false;
end;

procedure TDehne.CalcPosi(o:PView;var p:T3DPoint);
begin
  if No3DGroup(o) then P:=P3dView(o)^.paramdata.pos.s
  else P:=P3DGroup(o)^.pos.s;
end;

procedure TDehne.SelectPos(var r:T3DRect;var pos:T3DPoint);
begin
  Pos:=r.s;
end;

procedure TDehne.setpos(var pos:T3DRect;var p:T3DPoint);
begin
  pos.s:=p;
end;

procedure TDehne.setposi(o:PView;var p:T3DPoint);
begin
  if no3dGroup(o) then P3DView(o)^.paramdata.pos.s:=p
  else P3DGroup(o)^.pos.s:=p;
end;

constructor TMeshObjMenu.init(var Bounds:TRect);
var R:TRect;
    a:byte;
begin
  if MeshMenu<>nil then begin
    MeshMenu^.getbounds(bounds);
    dispose(MeshMenu,done);
  end;
  TDialog.Init(Bounds,'Mesh');
  options:=(options or ofpreprocess) and (not ofbuffered);
  getextent(r);
  r.assign(8,35,r.b.x-8,50);
  breite:=new(PinputZahl,init(r,TypByte,3,0,1,51));
  insert(breite);
  a:=1;
  breite^.setdata(a);
  r.move(0,-15);
  insert(new(PLabel,init(r,'~B~reite',breite)));
  MeshMenu:=@self;
end;

destructor TMeshObjMenu.done;
var r:trect;
begin
  MeshMenu:=nil;
  if correctViewPort then begin
    getextent(r);
    clearfeld(r.a.x,r.a.y,r.b.x,r.b.y,$2222);
  end;
  setstate(sfvisible,false);
  TDialog.Done;
end;

{ TSzeneAbstract }

function TSzeneAbstract.GetName:Pathstr;
begin
  abstract;
end;

function TSzeneAbstract.error(s:string):word;
begin
  abstract;
end;

procedure TSzeneAbstract.SetObjekt(o:PView);
begin
  abstract;
end;

{ T3DView }

constructor T3DView.Init(var pos: T3DRect;aszene:PSzeneAbstract;ax,ay:byte;aname:GroupStr);
var r:TRect;
begin
  r.assign(0,0,0,0);
  TView.init(r);
  Name:=aname;
  options:=options or ofselectable;
  szene:=aszene;
  paramdata.pos:=pos;
  with ParamData do begin
    {Translation:=pos.T;
    Rotation:=pos.r;
    Scalierung:=pos.s;}
    x:=ax;
    y:=ay;
    darstellung:=dsKoorSys or dsKoorEcken;
    Textur:='';
    material:=eMaterial;
    materialname:='Papier';
  end;
  mesh:=nil;
  CalcOC_MC(OC_MC,paramdata.pos);
end;

function T3DView.KopierDich(NeueSzene:PSzeneAbstract):P3DView;
var h:p3DView;
begin
  getmem(h,sizeof(self));
  move(self,h^,sizeof(self));{Hiermit wird auch der Verweis auf die
  VMT kopiert.Das ist dasselbe, als wenn ein Constructor aufgerufen wrde.}
  with h^ do begin
    Szene:=NeueSzene;
    Owner:=nil;
    Next:=nil;
    if mesh<>nil then mesh^.IncNutzer;
  end;
  KopierDich:=h;
end;

destructor T3DView.Done;
begin
  if mesh<>nil then
    Objektcollection^.losche(mesh^.x,mesh^.y,RegNr); {Objekt existiert und wird geloscht, oder die Nutzerzahl dekrementiert}
  TView.Done;
end;

{procedure T3DView.Store(var S: TStream);
var obj:boolean;
begin
  TView.Store(s);
  s.write(ParamData,sizeof(ParamData));
  obj:=mesh<>nil;
  s.write(obj,sizeof(obj));
end;

constructor T3DView.Load(Var S: TStream);
var obj:boolean;
    pos:T3dRect;
    x,y:byte;
begin
  TView.load(s);
  s.read(ParamData,sizeof(ParamData));
  s.read(obj,sizeof(obj));
  if obj then calc else mesh:=nil;
  with paramdata do begin
    pos.t:=Translation;
    pos.s:=scalierung;
    pos.r:=rotation;
  end;
  CalcMC_WC(MC_WC,pos);
end;}

{procedure T3DView.HandleEvent(var Event: TEvent);
var myevent:boolean;
    hpara:TParamData;
begin
  TView.Handleevent(event);
  if event.what and evcommand>0 then begin
    myevent:=true;
    case event.command of
      cmLoeschen:dispose(P3DView(@self),done);
      cmObjektParameter:ExecObjektDialog(@hpara);
      else myevent:=false;
    end;
    if myevent then clearevent(event)
  end;
end;}

procedure T3DView.DrawView;
begin
  if exposed and Getstate({sfexposed+}sfvisible) then begin
    draw;
  end;
end;

procedure T3DView.Draw;
{Stellt die 3DView in allen Sichten dar.}
{ Und gibt die Daten im Lister und im ParamDiag neu aus
 wenn ntig}
begin
  if getstate(sfvisible) then redraw(nil,@OC_MC,true) else redraw(@OC_MC,nil,true);
{  if szene^.paramdiag<>nil then szene^.paramdiag^.setdata(paramdata);
  if szene^.lister<>nil then message(szene^.lister,evCommand,cmUpdateLister,@self);}
end;

procedure T3DView.ReDraw(OldOC_MC,NewOC_MC:PMatrix;remove:boolean);
{Stellt die 3DView in allen Sichten dar. Und lscht die alte Ansicht}
var erste,imPuffer:boolean;
    buffer:PMesh;

  procedure MaleKoorsys(item:PSicht);far;
  begin
    if paramdata.darstellung and dsKoorSys>0 then item^.malekoor(OldOC_MC,NewOC_MC,@self,remove);
    if paramdata.darstellung and dsObjekt>0 then item^.maleMesh(Mesh,buffer,OldOC_MC,NewOC_MC,@self,erste,imPuffer,remove);
  end;

begin
  erste:=true;
  imPuffer:=false;
  if mesh<>nil then new(buffer,init(mesh^.x,mesh^.y)) else buffer:=nil;
  {mu vermutlich anders geschrieben werden ^ }
  Szene^.sichten^.foreach(@Malekoorsys);
  if mesh<>nil then dispose(buffer,done);
end;

procedure T3DView.DrawPartMesh(x1,y1,x2,y2:byte;loschen:boolean);
{Stellt einen Teil des Meshs in allen Sichten dar.}

  procedure MalePartMesh(item:PSicht);far;
  begin
    if paramdata.darstellung and dsObjekt>0 then item^.DrawPartMesh(@self,x1,y1,x2,y2,loschen);
  end;

begin
  Szene^.sichten^.foreach(@MalePartMesh);
end;


procedure T3DView.Malesicht(sicht:Psicht);
{Stellt die 3DView in Sicht dar}
var erste,imPuffer:boolean;
    buffer:PMesh;
begin
  erste:=true;
  imPuffer:=false;
  if mesh<>nil then new(buffer,init(mesh^.x,mesh^.y)) else buffer:=nil;
  {mu vermutlich anders geschrieben werden ^ }
  if paramdata.darstellung and dsKoorSys>0 then sicht^.malekoor(nil,@OC_MC,@self,true);
  if paramdata.darstellung and dsObjekt>0 then sicht^.maleMesh(Mesh,buffer,nil,@OC_MC,@self,erste,imPuffer,true);
  if mesh<>nil then dispose(buffer,done);
end;


function T3DView.CalcObjekt:boolean;
begin
  abstract;
end;

function T3DView.Calc:boolean;
begin
  if paramdata.x<1 then paramdata.x:=1;
  if paramdata.y<1 then paramdata.y:=1;
  if mesh<>nil then begin
    if (mesh^.x=paramdata.x) and (mesh^.y=paramdata.y) then exit;
    {es wurde versucht, genau dasselbe Objekt nochmal zu berechnen}
    Objektcollection^.losche(mesh^.x,mesh^.y,RegNr);
    {Objekt existiert und wird geloscht, oder die Nutzerzahl dekrementiert}
  end;
  mesh:=Objektcollection^.vorhanden(paramdata.x,paramdata.y,RegNr);
  calc:=true;
  if mesh=nil then begin
    mesh:=objektcollection^.neu(paramdata.x,paramdata.y,RegNr);
    if mesh<>nil then begin
      if CalcObjekt then calc:=true else begin
        calc:=false;
        Objektcollection^.losche(mesh^.x,mesh^.y,RegNr);
      end;
    end else begin
      Application^.OutOfMemory;
      calc:=false;
    end;
  end;
end;

function T3DView.RegNr:word;
begin
  abstract;
end;

procedure T3DView.Eckepressed(anr:byte);
var event:TEvent;
    o:TPoint;
    OldOC_MC:TMatrix;
    los:boolean;
begin
  if Bewegung<>nil then begin
    if bewegung^.GruppeBewegen then begin
      if TypeOf(Owner^)<>TypeOf(Troot) then P3DGroup(owner)^.Eckepressed(0,false);
      Focus;
      Szene^.Setobjekt(@self);
    end else begin
      Focus;
      Hidemouse;
      if szene^.aktobjekt<>@self then Szene^.Setobjekt(@self)
      else begin
        OldOC_MC:=OC_MC;
        if Bewegung^.Posiverandert(@self) then Redraw(@OldOC_MC,@OC_MC,true);
      end;
      o:=MouseWhere;
      MausSetPos(Mitte.x,Mitte.y);
      repeat getMouseEvent(Event) until event.what=evNothing;
      Bewegung^.reset(@self);
      repeat
        repeat
          getmouseevent(event);
        until event.what<>evnothing;
        OldOC_MC:=OC_MC;
        if Bewegung^.Move(@self,event,anr) then Redraw(@OldOC_MC,@OC_MC,true);
        if los and (mousebuttons<>0) then los:=false;
      until not los and (Mousebuttons=0);
      MausSetPos(o.x,o.y);
      if MouseCursor <> nil then MouseCursor^.Update(GetShapeCtx,GetPositionCtx);
      ShowMouse;
      szene^.gesichert:=false;
    end;
  end else begin
    szene^.setObjekt(@self);
    focus;
  end;
end;

procedure T3DView.Meshpressed(anr:integer);
begin
  abstract;
end;

procedure T3DView.sichern(var f:text);

  function hexw(w:word):string;
  const tab:array[0..15] of char='0123456789ABCDEF';
  begin
    hexw:=tab[hi(w) shr 4]+tab[hi(w) and $F]+tab[lo(w) shr 4]+tab[lo(w) and $F];
  end;

  function hexb(w:word):string;
  const tab:array[0..15] of char='0123456789ABCDEF';
  begin
    hexb:=tab[lo(w) shr 4]+tab[lo(w) and $F];
  end;

  function notzahl(r:single;a:byte):boolean;
  begin
    notzahl:=round(r*100)<>a;
  end;

  function notzahlvct(v:T3dPoint;a:byte):boolean;
  begin
    notzahlvct:=notzahl(v.x,a) or notzahl(v.y,a) or notzahl(v.z,a);
  end;

begin
  with paramdata do begin
    writeln(f,'Push');
    {writeln(f,'  ;Wiz'+hexb(RegNr)+hexw(Darstellung));}
    with paramdata,paramdata.material do if WizOpt.speichermodus=smKurz then
    writeln(f,'  Param ',x:2,' ',y:2,' ',oa.r:3:2,' ',oa.g:3:2,' ',oa.b:3:2,' ', {TEXTUR}
                        ka:3:2,' ',kd:3:2,' ',ks:3:2,' ',os.r:3:2,' ',
              os.g:3:2,' ',os.b:3:2,' ',oe:2:0,' ',od.r:3:2,' ',od.g:3:2,' ',
              od.b:3:2,' ',alpha:3:2,' ', {OBERFLCHE}
              pos.t.x:3:2,' ',pos.t.y:3:2,' ',pos.t.z:3:2,' ', {VERSCHIEBEN}
              pos.r.x:3:2,' ',pos.r.y:3:2,' ',pos.r.z:3:2,' ',{ROTIEREN}
              pos.s.x:3:2,' ',pos.s.y:3:2,' ',pos.s.z:3:2,' ;',Materialname)    {VERGRERN}
    else begin
      if textur='' then writeln(f,'  Textur ',x:2,' ',y:2,' ',oa.r:3:2,' ',oa.g:3:2,' ',oa.b:3:2); {TEXTUR}
      writeln(f,'  Oberflche ',ka:3:2,' ',kd:3:2,' ',ks:3:2,' ',os.r:3:2,' ',
              os.g:3:2,' ',os.b:3:2,' ',oe:2:0,' ',od.r:3:2,' ',od.g:3:2,' ',
              od.b:3:2,' ',alpha:3:2,' ;',Materialname); {OBERFLCHE}
      if notzahlvct(pos.t,0)
      then writeln(f,'  Verschieben ',pos.t.x:3:2,' ',pos.t.y:3:2,' ',pos.t.z:3:2); {VERSCHIEBEN}
      if notzahl(pos.r.x,0) then writeln(f,'  Rotieren 1 ',pos.r.x:3:2);
      if notzahl(pos.r.y,0) then writeln(f,'  Rotieren 2 ',pos.r.y:3:2);
      if notzahl(pos.r.z,0) then writeln(f,'  Rotieren 3 ',pos.r.z:3:2); {ROTIEREN}
      if notzahlvct(pos.s,100)
      then writeln(f,'  Vergrern ',pos.s.x:3:2,' ',pos.s.y:3:2,' ',pos.s.z:3:2);    {VERGRERN}
    end;
    if (Textur<>'') and (Textur<>'MyOwn') then writeln(f,'  LadeObjekt 16 ',Textur);
  end;
end;

procedure T3DView.ChangeDarstellung(ADarstellung:word;enable:boolean);
var hdar:word;
begin
  hdar:=paramdata.darstellung;
  if (adarstellung and dsObjekt>0) and (((paramdata.darstellung and dsObjekt)>0)<>enable) then begin
    paramdata.darstellung:=dsObjekt or (paramdata.darstellung and ($F-3));
    {MeshEcken und Koorecken sollen behandelt werden wie zuvor}
    if {aDarstellung and dsObjekt>0} enable then begin
      if calc then draw else adarstellung:=adarstellung and not dsObjekt;
    end else redraw(@OC_MC,nil,true);
    paramdata.darstellung:=hdar;
  end;
  if (adarstellung and dsKoorSys>0) and (((paramdata.darstellung and dsKoorSys)>0)<>enable) then begin
    paramdata.darstellung:=dsKoorSys or (paramdata.darstellung and ($F-3));;
    if {adarstellung and dsKoorsys>0}enable then draw else redraw(@OC_MC,nil,true);
  end;
  if enable then paramdata.darstellung:=hdar or ADarstellung
  else paramdata.darstellung:=hdar and not ADarstellung;
end;

procedure T3DView.SetParam(AData:TData);
begin
  With paramdata do begin
    Material:=adata.M;
    MaterialName:=adata.Materialname;
    textur:=adata.textur;
    Darstellung:=adata.darstellung;
  end;
end;

function T3dView.ObjektDialog(pfad:pathstr;hohe:byte):PObjektParameterDialog;
var b:PView;
    r:TRect;
    h:PObjektParameterdialog;
    n,farbnr:byte;

  procedure zahl(s:pathstr;ho:word);
  begin
    with h^ do begin
      r.assign(80,ho,160,ho+14);
      Inputzahl[n]:=new(PInputZahl,init(r,typsingle,1,2,0,1));
      insert(Inputzahl[n]);
      r.assign(10,ho,80,ho+14);
      insert(new(PLabel,init(r,s,Inputzahl[n])));
      inc(n);
    end;
  end;

  procedure farbe(s:pathstr;ho:word);
  var r:TRect;
  begin
    zahl(s,ho);
    r.assign(80,ho+15,160,ho+50);
    h^.FarbRegler[farbnr]:=new(PFarbRegler,init(r));
    h^.insert(h^.FarbRegler[farbnr]);
    inc(farbnr);
{    zahl('Rot',h+15);
    zahl('Grn',h+30);
    zahl('Blau',h+45);}
  end;


  procedure posin(s:pathstr;ho:word);

    Function zahl(s:pathstr;x,y:word):PView;
    var b:Pview;
    begin
      with h^ do begin
        r.assign(x+10,y,x+80,y+14);
        b:=new(PInputZahl,init(r,typsingle,2,3,-10000,10000));
        insert(b);
        r.assign(x,y,x+10,y+14);
        insert(new(PLabel,init(r,s,b)));
      end;
      zahl:=b;
    end;

  begin
    b:=zahl('X',200,ho+15);
    r.assign(200,ho,400,ho+15);
    h^.insert(new(PLabel,init(r,s,b)));
    zahl('Y',290,ho+15);
    zahl('Z',380,ho+15);
  end;

begin
  r.assign(0,0,500,hohe*10);
  new(h,init(r,pfad));
  with h^ do begin
    options:=options or ofcentered;
    r.assign(80,25,160,40);
    Materialname:=new(PInputline,init(r,pred(sizeof(nameStr))));
    insert(Materialname);
    r.assign(10,25,90,40);
    insert(new(PLabel,init(r,'~M~aterial:',materialname)));
    r.assign(200,25,270,40);
    insert(new(PButton,init(r,'~L~aden',cmLadeMaterial,bfnormal)));
    r.assign(290,25,360,40);
    insert(new(PButton,init(r,'S~i~chern',cmSichereMaterial,bfnormal)));
    r.assign(80,45,160,60);
    texturname:=new(PInputline,init(r,pred(sizeof(nameStr))));
    insert(texturname);
    r.assign(10,45,90,60);
    insert(new(PLabel,init(r,'~T~extur:',texturname)));
    r.assign(200,45,270,60);
    insert(new(PButton,init(r,'Lad~e~n',cmLadeTextur,bfnormal)));
    n:=0;
    farbnr:=0;
    r.assign(165,65,175,185);
    insert(new(PMischFarbe,init(r)));
    farbe('~A~mbient',65);
    farbe('~D~iffus',125);
    farbe('~S~pekular',185);
    zahl('~T~ransparenz',245);
    with h^ do begin
      r.assign(80,260,160,260+14);
      Inputzahl[n]:=new(PInputZahl,init(r,typsingle,1,2,0,100));
      insert(Inputzahl[n]);
      r.assign(10,260,80,260+14);
      insert(new(PLabel,init(r,'Glan~z~',Inputzahl[n])));
      inc(n);
    end;

    r.assign(270,65,320,80);
    b:=new(PInputZahl,init(r,typbyte,2,0,2,50));
    insert(b);
    r.assign(200,65,270,80);
    insert(new(PLabel,init(r,'~B~reite:',b)));
    r.assign(400,65,450,80);
    b:=new(PInputZahl,init(r,typbyte,2,0,2,50));
    insert(b);
    r.assign(330,65,400,80);
    insert(new(PLabel,init(r,'~H~he:',b)));

    posin('Tra~n~slation',95);
    posin('Ska~l~ierung',140);
    posin('R~o~tation',185);

    r.assign(200,245,385,265);
    b:=New(PCheckBoxes,init(r,newsitem('Koors~y~s',newsItem('~G~itter',nil))));
    insert(b);
    r.assign(200,235,385,250);
    insert(new(PLabel,init(r,'Darstell~u~ng',b)));

    r.assign(200,280,280,300);
    Insert(new(PButton,init(r,'O~k~',cmOk,bfdefault)));
    r.assign(290,280,370,300);
    Insert(new(PButton,init(r,'~C~ancel',cmCancel,bfnormal)));
  end;
  ObjektDialog:=h;
end;

function T3dView.ExecObjektDialog(hpara:PParamData):boolean;{True falls MeshNeu aufgerufen wurde}
var ax,ay:byte;
    pos:T3DRect;
    h2darst,hdarst:word;
begin
  ax:=paramdata.x;
  ay:=paramdata.y;
  hdarst:=paramdata.darstellung;
  ChangeDarstellung(dsobjekt or dskoorsys,false);
  if meshneuerlaubt then begin
    if mesh<>nil then ObjektCollection^.losche(mesh^.x,mesh^.y,Regnr);
    mesh:=nil;
  end;
  hPara^:=Paramdata;
  h2darst:=paramdata.darstellung;
  hpara^.darstellung:=hdarst and (dsobjekt or dskoorsys);
  ExecDialog(Objektdialog('Parameter',32),hPara);
  Paramdata:=hPara^;
  pos:=paramdata.pos;
  CalcOC_MC(OC_MC,pos);
  P3DGroup(owner)^.CorrectMC_WC;
{  if (paramdata.x<>ax) or (paramdata.y<>ay) then begin
    meshneu;
    ExecObjektDialog:=true;
  end else begin}
    hdarst:=paramdata.darstellung;
    paramdata.darstellung:=h2darst;
    ExecObjektDialog:={false;}true;
    if not meshneuerlaubt then begin
      paramdata.x:=ax;
      paramdata.y:=ay;
    end;
    ChangeDarstellung(hdarst,true);
{  end;}
end;

function T3DView.MeshNeuErlaubt:boolean;
begin
  MeshNeuErlaubt:=true;
end;

procedure T3DView.setname(aname:groupstr);
begin
  name:=aname;
end;

function T3DView.Getname:Groupstr;
begin
  getname:=name;
end;

function T3DView.sichereLicht(var f:text):boolean;
begin
  SichereLicht:=false;
end;

procedure T3DView.MeshNeu;
var h:boolean;
begin
  h:=paramdata.darstellung and dsObjekt>0;
  if h then ChangeDarstellung(dsobjekt,false);
  if mesh<>nil then ObjektCollection^.losche(mesh^.x,mesh^.y,Regnr);
  mesh:=nil;
  if h then ChangeDarstellung(dsobjekt,true);
end;

{ TObjektParameterDialog }

procedure TObjektParameterDialog.HandleEvent(var Event: TEvent);
var myevent:boolean;

  procedure LadeTextur;
  var
    FileName: FNameStr;
    dir:dirstr;
    name:namestr;
    ext:extstr;
  begin
    FileName := '*.OBT';
    if ExecDialog(New(PFileDialog, Init('*.OBT', 'Suche die Textur aus',
      '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then begin
      fsplit(filename,dir,name,ext);
      texturname^.setdata(name);
    end;
  end;

  procedure LadeMaterial;
  var
    FileName: FNameStr;
    dir:dirstr;
    name:namestr;
    ext:extstr;
    s:string;
    si:single;
    n:byte;
    err:integer;
    

  procedure singlezahl(var s:single;var err:integer);
  begin
    while pos(' ',argumente)=1 do system.delete(argumente,1,1);
    argumente:=argumente+' ';
    system.val(copy(argumente,1,pred(pos(' ',argumente))),s,err);
    system.delete(argumente,1,pos(' ',argumente));
  end;

    procedure getfarbe(nr:byte);
    var farbe:TRgb;
    begin
      singlezahl(farbe.r,err);
      singlezahl(farbe.g,err);
      singlezahl(farbe.b,err);
      if err=0 then FarbRegler[nr]^.setdata(farbe);
    end;

  begin
    FileName := '*.MAT';
    if ExecDialog(New(PFileDialog, Init('*.MAT', 'Suche ein Material aus',
      '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then begin
      fsplit(filename,dir,name,ext);
      materialname^.setdata(name);
      assign(f,filename);
      reset(f);
      argumente:='';
      while not eof(f) do begin
        lesezeile;
        if id(befehl,'TEXTUR') then begin
          delarg(2);
          getfarbe(0);
        end else if id(befehl,'OBERFLCHE') then begin
          {OBERFLCHE ka kd ks osr osg osb oe odr odg odb alpha}
          for n:=0 to 2 do begin {ka,kd,ks}
            singlezahl(si,err);
            if err=0 then inputzahl[n]^.setdata(si);
          end;
          getfarbe(1); {os}
          singlezahl(si,err); {oe}
          if err=0 then inputzahl[4]^.setdata(si);
          getfarbe(2); {od}
          singlezahl(si,err); {alpha}
          if err=0 then inputzahl[3]^.setdata(si);
        end;
      end;
      system.close(f);
    end;
  end;

  procedure SichereMaterial;
  var aktszene:PSzeneAbstract;
      FileName: FNameStr;
      dir:dirstr;
      name:namestr;
      ext:extstr;
      s:string;
      n:byte;
      si:single;

    procedure Putfarbe(nr:byte);
    var farbe:TRGB;
    begin
      FarbRegler[nr]^.getdata(farbe);
      write(f,farbe.r:1:3,' ',farbe.g:1:3,' ',farbe.b:1:3);
    end;

  begin
    Materialname^.getdata(FileName);
    Filename:=Filename+'.MAT';
    if ExecDialog(New(PFileDialog, Init(filename, 'Material speichern unter',
      '~N~ame', fdOkButton, 101)), @FileName) <> cmCancel then begin
      fsplit(filename,dir,name,ext);
      materialname^.setdata(name);
      assign(f,filename);
      rewrite(f);
      write(f,'TEXTUR 50 50 ');
      putfarbe(0);
      writeln(f);
      write(f,'OBERFLCHE ');
      {OBERFLCHE ka kd ks osr osg osb oe odr odg odb alpha}
      for n:=0 to 2 do begin {ka,kd,ks}
        inputzahl[n]^.getdata(si);
        write(f,si:1:3,' ');
      end;
      putfarbe(1); {os}
      inputzahl[4]^.getdata(si);
      write(f,si:1:3,' ');
      putfarbe(2); {od}
      inputzahl[3]^.getdata(si);
      write(f,si:1:3,' ');
      system.close(f);
    end;
  end;


begin
  TDialog.Handleevent(event);
  if event.what and evcommand>0 then begin
    myevent:=true;
    case event.command of
      cmLadeMaterial:LadeMaterial;
      cmSichereMaterial:SichereMaterial;
      cmLadeTextur:LadeTextur;
      else myevent:=false;
    end;
    if myevent then clearevent(event)
  end;
end;


{ T3DGroup }

constructor T3DGroup.Init(AName:Groupstr;ASzene:PSzeneAbstract;AMC_WC:TMatrix);
var b:TRect;
begin
  b.assign(0,0,0,0);
  TGroup.Init(b);
  state:=state and not sfvisible;
  Szene:=ASzene;
  options:=options or ofselectable;
  helpCtx:=hcGruppe;
  name:=AName;
  MC_WC:=AMC_WC;
  CalcPos(MC_WC,pos);
  darstellung:=0;
end;

constructor T3DGroup.Kopie(Original:P3DGroup;NeueSzene:PSzeneAbstract);

  Procedure kopieren(Item:PView);far;
  var hview:PView;
  begin
    if no3DGroup(Item) then hview:=P3DView(Item)^.KopierDich(NeueSzene)
    else hview:=P3DGroup(Item)^.KopierDich(NeueSzene);
    hview^.state:=hview^.state and not sfvisible;
    hview^.options:=hview^.options and not ofselectable;
    Insert(hview);
    hview^.state:=hview^.state or sfvisible;
    hview^.options:=hview^.options or ofselectable;
  end;

begin
  T3DGroup.Init(original^.Name,NeueSzene,original^.MC_WC);
  state:=original^.state;
  options:=original^.options;
  darstellung:=original^.darstellung;
  Original^.Subviews^.foreach(@kopieren);
end;

function T3DGroup.KopierDich(NeueSzene:PSzeneAbstract):P3DGroup;
begin
  KopierDich:=New(P3DGroup,Kopie(@self,NeueSzene));
end;

procedure T3DGroup.HandleEvent(var Event: TEvent);
var h:PView;

  procedure NextScene;
  var aktszene:PView;
  begin
    aktszene:=owner^.next;
    while (TypeOf(AktSzene^)<>TypeOfTSzene) and (AktSzene<>PView(owner))
    do aktszene:=aktszene^.next;
    if aktszene<>PView(owner) then begin
      aktszene^.focus;
      PSzeneAbstract(aktszene)^.SetObjekt(PSzeneAbstract(aktszene)^.Root);
      if PSzeneAbstract(aktszene)^.Root<>nil
      then PSzeneAbstract(aktszene)^.Root^.focus;
    end;
  end;

  procedure PrevScene;
  var aktszene:PView;
  begin
    aktszene:=owner^.prev;
    while (TypeOf(AktSzene^)<>TypeOfTSzene) and (AktSzene<>PView(owner))
    do aktszene:=aktszene^.prev;
    if aktszene<>PView(owner) then begin
      aktszene^.focus;
      PSzeneAbstract(aktszene)^.SetObjekt(PSzeneAbstract(aktszene)^.Root);
      if PSzeneAbstract(aktszene)^.Root<>nil
      then PSzeneAbstract(aktszene)^.Root^.focus;
    end;
  end;

begin
  TGroup.Handleevent(event);
  if (event.what=evCommand) then begin
    if (event.command=cmTestIsMySubGroup) and (event.Infoptr=@self)
    then clearevent(event)
    else if (((current<>nil) and (current=Szene^.aktobjekt))
            or ((szene^.aktobjekt<>nil) and (Szene^.aktobjekt=@self)
                and (TypeOf(Self)=TypeOf(TRoot))))
            {^.state and sffocused>0)} then
    begin
      case Event.Command of
        cmNextObj: if (TypeOf(Self)=Typeof(Troot)) and (Szene^.aktobjekt=@self)
          then begin
            if PSzeneAbstract(owner)^.selectpfad then NextScene else exit;
          end else SelectNext(False);
        cmLastObj: if (TypeOf(Self)=Typeof(Troot)) and (Szene^.aktobjekt=@self)
          then begin
            if PSzeneAbstract(owner)^.selectpfad then PrevScene else exit;
          end else SelectNext(True);
        cmUpObj: begin Focus3DGroup;szene^.setobjekt(@self); end;
        cmDownObj: if (TypeOf(Self)=TypeOf(Troot)) and (Szene^.aktobjekt=@self) and
                      PSzeneAbstract(owner)^.selectpfad then begin
            if (current<>nil) then begin
              current^.focus; {cmDownObj kann nur ausgelst werden, wenn aktObj eine 3DGroup ist}
              szene^.setobjekt(current);
            end;
          end else begin
            if (current<>nil) and (P3DGroup(current)^.current<>nil) then begin
            P3DGroup(current)^.current^.focus; {cmDownObj kann nur ausgelst werden, wenn aktObj eine 3DGroup ist}
            szene^.setobjekt(P3DGroup(current)^.current);
          end;
        end;
      else
        Exit;
      end;
      case event.command of
        cmNextObj,cmLastObj:if (TypeOf(Self)<>TypeOf(Troot)) or (Szene^.aktobjekt<>@self) then szene^.setobjekt(current);
        cmUpObj,cmDownObj:if TypeOf(szene^.aktobjekt^)<>TypeOf(Troot)
          then P3DGroup(szene^.aktobjekt^.owner)^.CorrectMC_WC
          else SetMC_WC(E);
      end;
      ClearEvent(Event);
    end;
  end;
end;

procedure T3DGroup.SetState(astate:word;enable:boolean);
begin
  if astate and sffocused>0 then TView.Setstate(astate,enable)
  else TGroup.Setstate(astate,enable);
end;

procedure T3DGroup.Focus3DGroup;
begin
  TView.Focus;
end;

procedure T3DGroup.draw;
{sorgt dafr, da in jeder Ansicht der Inhalt der Sicht ausgegeben wird}

  procedure mal(item:PView);far;
  begin
    if Typeof(item^)=Typeof(T3dGroup) then P3dGroup(item)^.draw
    else P3dView(item)^.draw;
  end;

begin
  if darstellung and dsgruppiert>0 then begin
    if getstate(sfvisible) then redraw(nil,@mC_WC,true) else redraw(@MC_WC,nil,true);
  end else begin
    PushTrafs;
    Operation(MC_WC);
    if subviews<>nil then subviews^.foreach(@mal);
    PopTrafs;
  end;
end;

procedure T3DGroup.Redraw(OldMC_WC,NewMC_WC:PMatrix;remove:boolean);
{sorgt dafr, da in jeder Ansicht der Inhalt der Sicht ausgegeben wird}

  {procedure mal(item:PView);far;

    function NilOld(p:pMatrix):PMatrix;
    begin
      if OldMC_WC=nil then nilold:=nil else Nilold:=p;
    end;

    function NilNew(p:pMatrix):PMatrix;
    begin
      if NewMC_WC=nil then nilNew:=nil else NilNew:=p;
    end;

  begin
    if no3DGroup(Item)
    then P3dView(item)^.redraw(NilOld(@P3dView(item)^.OC_MC),NilNew(@P3dView(item)^.OC_MC),Remove)
    else P3dGroup(item)^.redraw(NilOld(@P3dGroup(item)^.MC_WC),NilNew(@P3dGroup(item)^.MC_WC),Remove);
  end;}

  procedure malabbau(item:PView);far;
  begin
    if no3DGroup(Item)
    then P3dView(item)^.redraw(@P3dView(item)^.OC_MC,Nil,Remove)
    else P3dGroup(item)^.redraw(@P3dGroup(item)^.MC_WC,Nil,Remove);
  end;

  procedure malaufbau(item:PView);far;
  begin
    if no3DGroup(Item)
    then P3dView(item)^.redraw(Nil,@P3dView(item)^.OC_MC,Remove)
    else P3dGroup(item)^.redraw(Nil,@P3dGroup(item)^.MC_WC,Remove);
  end;

  procedure MaleKoorsys(item:PSicht);far;
  begin
    if darstellung and dsKoorSys>0 then item^.malekoor(OldMC_WC,NewMC_WC,@self,true);
  end;

begin
  if darstellung and dsgruppiert>0 then begin
    Szene^.sichten^.foreach(@Malekoorsys);
  end else begin
    if OldMC_WC<>nil then begin
      PushTrafs;
      Operation(OldMC_WC^);
      if subviews<>nil then subviews^.foreach(@malabbau);
      PopTrafs;
    end;
    if NewMC_WC<>nil then begin
      PushTrafs;
      Operation(NewMC_WC^);
      if subviews<>nil then subviews^.foreach(@malaufbau);
      PopTrafs;
    end;
  end;
end;


procedure T3DGroup.maleSicht(Sicht:PSicht);
{Stellt alle Unterobjekte in einer Sicht dar}

  procedure mal(item:PView);far;
  begin
    if TypeOf(Item^)=TypeOf(T3dGroup) then
    P3dGroup(item)^.malesicht(sicht) else P3DView(item)^.malesicht(sicht);
  end;

begin
  if darstellung and dsgruppiert>0 then begin
    if darstellung and dsKoorSys>0 then sicht^.malekoor(nil,@MC_WC,@self,true);
  end else begin
    PushTrafs;
    Operation(MC_WC);
    if subviews<>nil then subviews^.foreach(@mal);
    PopTrafs;
  end;
end;

procedure T3DGroup.sichern(var f:text);
{Speichert alle noch nicht gespeicherten Subviews}
var hs:PString;
    dummy1:integer;

  procedure speicher3dViews(item:PView);far;
  begin
    if No3DGroup(Item) then P3DView(item)^.sichern(f);
  end;

  procedure speicher3dGroupsGosub(item:PView);far;
  begin
    if not No3DGroup(Item) then P3DGroup(Item)^.schreibeSprung(f);
  end;

  procedure speicher3dGroups(item:PView);far;
  begin
    if not No3DGroup(Item) then P3dGroup(item)^.sichern(f);
  end;

begin
  delspace(name);
  hs:=NewStr(upWordf(name));
  if not SichereGosub^.Search(hs,dummy1) then begin
    SichereGosub^.insert(hs);{Nun darf Disposestr nicht aufgerufen werden!}
    writeln(f);
    writeln(f,':',name);
    if subviews<>nil then subviews^.foreach(@speicher3dViews);
    if subviews<>nil then subviews^.foreach(@speicher3dGroupsGosub);
    writeln(f,'Return');
    if subviews<>nil then subviews^.foreach(@speicher3dGroups);
  end else disposestr(hs);
end;

function T3DGroup.sichereLicht(var f:text):boolean;
{Speichert Lichter aus allen Subviews
 Zurckgegeben wird, ob ein Licht gefunden wurde}
var h:boolean;

  procedure speicherLicht(item:PView);far;
  begin
    if No3DGroup(Item) then h:=P3DView(item)^.sichereLicht(f) or h
    else h:=P3DGroup(item)^.sichereLicht(f) or h;
  end;

begin
  h:=false;
  if subviews<>nil then subviews^.foreach(@speicherLicht);
  SichereLicht:=h;
end;

function T3DGroup.NameExists(var Aname:GroupStr):boolean;

  function nameFound(Item:PView):boolean;far;
  begin
    if No3DGroup(Item) then NameFound:=false
    else begin
      if gleich(P3DGroup(Item)^.name,aname) then nameFound:=true
      else NameFound:=P3DGroup(Item)^.NameExists(aname);
    end;
  end;

begin
  if subviews<>nil then nameexists:=subviews^.firstthat(@NameFound)<>nil
  else nameexists:=false;
end;

function T3DGroup.GetGroup(var Aname:GroupStr):P3DGroup;

  function nameFound(Item:PView):boolean;far;
  var hgroup:P3DGroup;
  begin
    if No3DGroup(Item) then begin
      NameFound:=false;
      getgroup:=nil;
    end else begin
      if gleich(P3DGroup(Item)^.name,aname) then begin
        nameFound:=true;
        getgroup:=P3DGroup(Item);
      end else begin
        hgroup:=P3DGroup(Item)^.GetGroup(aname);
        getgroup:=hgroup;
        NameFound:=hgroup<>nil;
      end;
    end;
  end;

begin
  if subviews<>nil then begin
    if subviews^.firstthat(@NameFound)=nil then getgroup:=nil;
  end else GetGroup:=nil;
end;

procedure T3DGroup.CorrectName;
begin
  if NameExists(name) then begin
    delSpace(name);
    name:=name+corNameCount;
    inc(corNameCount);
  end;
end;

procedure T3DGroup.schreibesprung(var f:text);
{Speichert die Transformationen und den GOSUB Befehl}
var transform:boolean;
begin
  transform:=Not MatrixGleich(e,MC_WC);
  if transform then begin
    writeln(f,'PushTrafs');
    with pos do begin
      if notzahlvct(T,0)
      then writeln(f,'  Verschieben ',T.x:3:2,' ',T.y:3:2,' ',T.z:3:2); {VERSCHIEBEN}
      if notzahl(R.x,0) then writeln(f,'  Rotieren 1 ',R.x:3:2);
      if notzahl(R.y,0) then writeln(f,'  Rotieren 2 ',R.y:3:2);
      if notzahl(R.z,0) then writeln(f,'  Rotieren 3 ',R.z:3:2); {ROTIEREN}
      if notzahlvct(S,100)
      then writeln(f,'  Vergrern ',S.x:3:2,' ',S.y:3:2,' ',S.z:3:2);    {VERGRERN}
    end;
    write(f,'  ');
  end;
  CorrectName;
  if darstellung and dsgruppiert>0 then writeln(f,'CLIPGOSUB ',name)
  else writeln(f,'GOSUB ',name);
  if transform then writeln(f,'PopTrafs');
end;

procedure T3DGroup.ChangeDarstellung(ADarstellung:word;enable:boolean);

  procedure setd(item:PView);far;
  begin
    if no3dGroup(item) then P3dView(item)^.ChangeDarstellung(adarstellung,enable)
    else P3dGroup(item)^.ChangeDarstellung(adarstellung,enable);
  end;

begin
  Pushtrafs;
  if (Darstellung and dsGruppiert>0) then begin
    P3DGroup(owner)^.CorrectMC_WC;
    ADarstellung:=ADarstellung and not dsObjekt;
    if (adarstellung and dsKoorSys>0) and (((darstellung and dsKoorSys)>0)<>enable) then begin
      if enable then begin
        if not P3DGroup(Owner)^.untergruppierung then begin
          darstellung:=darstellung or (ADarstellung and (dskoorsys or dskoorecken));
          draw;
        end;
      end else begin
        redraw(@MC_WC,nil,true);
        darstellung:=darstellung and not (ADarstellung and (dskoorsys or dskoorecken));
      end;
    end;
  end else begin
    CorrectMC_WC;
    if (subviews<>nil) and (ADarstellung<>0) then subviews^.foreach(@setd);
  end;
  PopTrafs;
end;

procedure T3DGroup.Getpfad(var s:objstr);
begin
  if owner<>nil then begin
    if TypeOf(Owner^)=TypeOf(T3DGroup) then P3DGroup(owner)^.getpfad(s)
    else if TypeOf(Owner^)=TypeOf(TRoot) then PRoot(owner)^.getpfad(s);
  end;
  delspace(name);
  s:=s+name+'\';
end;

procedure T3DGroup.Setname(Aname:GroupStr);
begin
  name:=aname;
end;

function T3DGroup.Getname:GroupStr;
begin
  getname:=name;
end;

procedure T3DGroup.NeueGruppe;
var h:P3DGroup;
begin
  h:=new(P3DGroup,init('NONAME',Szene,e));
  h^.state:=h^.state and not sfvisible;
  h^.options:=h^.options and not ofSelectable;
  insert(h);
  h^.state:=h^.state and sfvisible;
  h^.options:=h^.options or ofSelectable;
end;

procedure T3DGroup.eckepressed(anr:byte;gruppeerlaubt:boolean);
var event:TEvent;
    o:TPoint;
    OldMC_WC:TMatrix;
    los:boolean;
begin
  if Bewegung<>nil then begin
    if bewegung^.GruppeBewegen and Gruppeerlaubt then begin
      if TypeOf(Owner^)<>TypeOf(Troot) then P3DGroup(owner)^.Eckepressed(0,false);
      Focus;
      Szene^.Setobjekt(@self);
    end else begin
      Focus;
      Hidemouse;
      if szene^.aktobjekt<>@self then Szene^.setobjekt(@self) else begin
        OldMc_WC:=Mc_WC;
        if Bewegung^.posiverandert(@self) then Redraw(@OldMc_WC,@MC_WC,false);
      end;
      o:=MouseWhere;
      MausSetPos(Mitte.x,Mitte.y);
      repeat getMouseEvent(Event) until event.what=evNothing;
      if bewegung<>nil then Bewegung^.reset(@self);
      los:=mousebuttons=0;
      repeat
        repeat
          getmouseevent(event);
        until event.what<>evnothing;
        OldMc_WC:=Mc_WC;
        if Bewegung^.Move(@self,event,anr) then Redraw(@OldMc_WC,@MC_WC,false);
        if los and (mousebuttons<>0) then los:=false;
      until not los and (Mousebuttons=0);
      MausSetPos(o.x,o.y);
      if MouseCursor <> nil then MouseCursor^.Update(GetShapeCtx,GetPositionCtx);
      ShowMouse;
      szene^.gesichert:=false;
    end;
  end else begin
    szene^.setObjekt(@self);
    focus;
  end;
end;

function T3DGroup.UnterGruppierung:boolean;
begin
  if darstellung and dsgruppiert>0 then untergruppierung:=true
  else Untergruppierung:=P3DGroup(owner)^.UnterGruppierung;
end;

procedure T3DGroup.Gruppieren;
var sichtbar:boolean;
begin
  if Darstellung and dsgruppiert=0 then begin
    sichtbar:=not P3DGroup(Owner)^.UnterGruppierung;
    if sichtbar then begin
      changeDarstellung(dsObjekt+dsKoorSys,false);{Untergruppen werden unsichtbar}
      Darstellung:=dsGruppiert+dsKoorSys+dsKoorEcken;
    end else Darstellung:=dsGruppiert+dsKoorEcken;
    P3DGroup(owner)^.CorrectMC_WC;
    if sichtbar then draw;
    Szene^.setobjekt(@self);
  end;
end;

procedure T3DGroup.EntGruppieren;
var sichtbar:boolean;
begin
  if darstellung and dsgruppiert>0 then begin
    sichtbar:=(not P3DGroup(Owner)^.UnterGruppierung) and (darstellung and dskoorsys>0);
    if sichtbar then begin
      P3dGroup(owner)^.correctMC_WC;
      redraw(@MC_WC,nil,true);
    end;
    Darstellung:=0;
    CorrectMC_WC;
    if not P3DGroup(Owner)^.untergruppierung then changedarstellung(dsKoorSys,true);
  end;
end;

function T3DGroup.GetCurrentObjekt:P3dView;
begin
  if current<>nil then begin
    if No3DGroup(current) then GetCurrentObjekt:=P3DView(current)
    else Getcurrentobjekt:=P3dgroup(current)^.GetCurrentObjekt;
  end else GetCurrentObjekt:=nil;
end;

procedure T3DGroup.CorrectMC_WC;
begin
  if TypeOf(Owner^)=TypeOf(T3DGroup) then begin
    P3DGroup(owner)^.CorrectMC_WC;
    MulMC_WC(MC_WC);
  end else setMC_WC(MC_WC);
end;

function T3DGroup.GetPfadGroup(path:string):P3DGroup;
var MySub:Groupstr;
    Rest:String;
    hgroup:P3dgroup;

  function suche(item:PView):Boolean;far;
  begin
    if No3DGroup(Item) then suche:=false
    else suche:=gleich(P3DGroup(Item)^.name,mysub);
  end;

begin
  mySub:=copy(path,1,pred(system.pos('\',path)));
  Rest:=copy(path,succ(system.pos('\',path)),255);
  if subviews<>nil then begin
    hGroup:=subviews^.firstthat(@suche);
    if hgroup<>nil then getpfadgroup:=hgroup^.getpfadgroup(rest)
    else getpfadgroup:=@self;
  end else getpfadgroup:=@self;
end;

procedure T3DGroup.GruppeE;

  procedure MulMC_WC(Item:PView);far;
  var pos:T3DRect;
  begin
    if No3DGroup(Item) then begin
      mul(P3DView(item)^.OC_MC,MC_WC,P3DView(item)^.OC_MC);
      CalcPos(P3DView(item)^.OC_MC,P3DView(item)^.Paramdata.pos);
    end else begin
      mul(P3DGroup(item)^.MC_WC,MC_WC,P3DGroup(item)^.MC_WC);
      CalcPos(P3DGroup(item)^.MC_WC,P3DGroup(item)^.pos);
    end;
  end;

begin
  if not MatrixGleich(MC_WC,E) then begin
    if SubViews<>nil then SubViews^.ForEach(@MulMC_WC);
    if (darstellung and dsgruppiert)>0 then P3DGroup(owner)^.CorrectMC_WC
    else CorrectMC_WC;
    if (not P3DGroup(Owner)^.untergruppierung) then changedarstellung(dskoorsys or dsobjekt,false);
    MC_WC:=E;
    CorrectMC_WC;
    if (not P3DGroup(Owner)^.untergruppierung)then changedarstellung(dskoorsys,true);
    Szene^.SetObjekt(@self);
    Szene^.gesichert:=false;
  end;
end;

procedure T3DGroup.GruppeAufRev;
var gruppe:boolean;
    V,MyOldM,WC_MC:TMatrix;

  procedure MulMC_WC(Item:PView);far;
  var pos:T3DRect;
  begin
    if No3DGroup(Item) then begin
      mul(P3DView(item)^.OC_MC,MyOldM,P3DView(item)^.OC_MC);
      CalcPos(P3DView(item)^.OC_MC,P3DView(item)^.Paramdata.pos);
    end else begin
      mul(P3DGroup(item)^.MC_WC,MyOldM,P3DGroup(item)^.MC_WC);
      CalcPos(P3DGroup(item)^.MC_WC,P3DGroup(item)^.pos);
    end;
  end;

begin
  MyOldM:=MC_WC;
  gruppe:= (darstellung and dsgruppiert>0) and (not P3DGroup(Owner)^.Untergruppierung);
  if gruppe then P3DGroup(owner)^.CorrectMC_WC else CorrectMC_WC;
  changedarstellung(dskoorsys or dsobjekt,false);
  p3dGroup(owner)^.CorrectMC_WC;
  invmat(GetMC_WC^,WC_MC);
  with Szene^.rev^.pos do begin
    V:=E;
    V[0][1]:=x; V[0][2]:=y; V[0][3]:=z;
  end;
  mul(V,WC_MC,MC_WC);
  invmat(MC_WC,WC_MC);
  Mul(MyOldM,WC_MC,MyOldM);
  if SubViews<>nil then SubViews^.ForEach(@MulMC_WC);
  CalcPos(MC_WC,pos);
  if gruppe then P3DGroup(owner)^.CorrectMC_WC else CorrectMC_WC;
  changedarstellung(dskoorsys,true);
end;

procedure T3DGroup.PutMC_WC(AMC_WC:TMatrix);
begin
  MC_WC:=AMC_WC;
  CalcPos(MC_WC,pos);
end;

{ T2DMesh }

constructor T2dMesh.init(ax,ay:byte;Aobjekt:P3DView);
{initialisiert mesh mit Punkten von x=0..ax und y=0..ay zum
 zwischenspeichern der angezeigten Meshs. Nur die focussierte 3DView wird
 zwischengespeichert, die anderen immer neu berechnet}
begin
  x:=ax;
  y:=ay;
  objekt:=AObjekt;
  if maxavail>succ(x)*succ(y)*sizeof(TPoint) then begin
    getmem(points,succ(x)*succ(y)*sizeof(TPoint));
    fillchar(points^,succ(x)*succ(y)*sizeof(TPoint),#0);
  end else points:=nil;
end;

destructor T2dMesh.done;
begin
  if points<>nil then freemem(points,succ(x)*succ(y)*sizeof(TPoint));
end;

function T2dMesh.PointAt(ax,ay:byte):PPoint;
begin
  PointAt:=PPoint(@meml[seg(points^):
                          ofs(points^)+(ay*succ(x)+ax)*sizeof(TPoint)]);
end;

procedure T2DMesh.putin(ax,ay:byte;var p:TPoint);
begin
  if (ax<=x) and (ay<=y) then begin
    pointat(ax,ay)^:=p;
  end;
end;

{ TObjektCollection }

function TObjektCollection.vorhanden(x,y:byte;p:word):PMesh;

  function gleich(item:Pointer):boolean;far;
  begin
    gleich:=(PMesh(Item)^.x=x) and (PMesh(Item)^.y=y) and (PMesh(Item)^.erzeuger=p);
  end;

begin
  vorhanden:=firstthat(@gleich);
end;

procedure TObjektCollection.losche(x,y:byte;p:word);
var objekt:PMesh;
begin
  objekt:=vorhanden(x,y,p);
  if (objekt<>nil) then begin
    if (objekt^.nutzer>0) then dec(objekt^.nutzer);
    if (objekt^.nutzer=0) then AtDelete(IndexOf(objekt));
  end;
end;

function TObjektCollection.neu(x,y:byte;p:word):PMesh;
var h:PMesh;
begin
  new(h,init(x,y));
  if (h<>nil) then begin
    if (h^.points<>nil) then insert(h) else begin
      dispose(h,done);
      h:=nil;
    end;
  end;
  neu:=h;
end;

function TObjektCollection.kopiere(x,y:byte;p,neup:word):PMesh;
var h,objekt:PMesh;
begin
  objekt:=vorhanden(x,y,p);
  if (objekt<>nil) then begin
    h:=neu(x,y,neup);
    if h<>nil then begin
      h^.kopiere(objekt);
      kopiere:=h;
    end else kopiere:=nil;
  end else kopiere:=nil;
end;

{ TRoot }

constructor TRoot.init(ASzene:PSzeneAbstract;SubGroups:boolean; var obj:P3DGroup);
begin
  T3DGroup.Init(Aszene^.getname,ASzene,e);
  helpctx:=hcWurzel;
  if SubGroups then begin
    new(obj,init('Objekte',ASzene,e));
    insert(obj);
  end;
end;

procedure TRoot.Getpfad(var s:objstr);
begin
  delspace(name);
  s:=name+':\';
end;

procedure TRoot.draw;
begin
  SetMC_WC(E);
  T3DGroup.Draw;
end;

procedure TRoot.CorrectMC_WC;
begin
  SetMC_WC(E);
end;

function TRoot.UnterGruppierung:boolean;
begin
  untergruppierung:=false;
end;

constructor T3DCursor.init;
var r:trect;
begin
  r.assign(0,0,0,0);
  TView.init(r);
  state:=state and not sfvisible;
  visible:=false;
  options:=options and not ofselectable;
end;

procedure T3DCursor.Draw;

  procedure MaleCursor(item:PSicht);far;
  begin
    item^.male3DCursor(@self,visible);
  end;

begin
  PSzeneAbstract(owner)^.sichten^.foreach(@MaleCursor);
end;

procedure T3DCursor.Malesicht(sicht:Psicht);
{Stellt den Cursor in Sicht dar}
begin
  if visible then sicht^.male3DCursor(@self,visible);
end;


Procedure T3DCursor.Handleevent(var Event:TEvent);
var myevent:boolean;
begin
  TView.HandleEvent(event);
  if event.what=evcommand then begin
    myevent:=true;
    case event.command of
      cmRevAn:if not visible then begin
        visible:=true;
        draw;
      end;
      cmRevAus:if visible then begin
        visible:=false;
        draw;
      end;
      else myevent:=false;
    end;
    if myevent then clearevent(event);
  end;
{  if event.what=evJoyString then with PJoyInfo(event.InfoPtr)^ do begin
    if what and evJoyAn>0 then begin
      if abs(pos.x)>10 then pos.x:=0;
      if abs(pos.y)>10 then pos.y:=0;
      if abs(pos.z)>10 then pos.z:=0;
      state:=state or sfvisible;
      draw;
    end;
    if what and evJoyAus>0 then begin
      state:=state and not sfvisible;
      draw;
    end;
    if what and evJoyUp>0 then begin

    end;
    if what and evJoyDown>0 then begin

    end;
    if (what and evJoyMove>0) and (state and sfvisible>0) then begin
      draw;
      Pos.x:=pos.x+x/300;
      Pos.y:=pos.y+y/300;
      Pos.z:=pos.z+z/300;
      (Pos.x:=x/100;
      Pos.y:=y/100;
      Pos.z:=z/100;)
      draw;
    end;
    clearevent(event);
  end;}
end;

procedure t3dCursor.EckePressed;
var event:TEvent;
    o:TPoint;
    hpos:t3dpoint;
begin
  Hidemouse;
  o:=MouseWhere;
  MausSetPos(Mitte.x,Mitte.y);
  repeat
    repeat
      getmouseevent(event);
    until (event.what<>evnothing) and (event.what<>evmouseAuto);
    hpos:=pos;
    hpos.y:=hpos.y+(Mitte.y-event.where.y)/100;
    if mouseButtons and 2>0 then begin
      hpos.z:=hpos.z+(Mitte.x-event.where.x)/100;
    end else begin
      hpos.x:=hpos.x-(Mitte.x-event.where.x)/100;
    end;
    maussetpos(Mitte.x,Mitte.y);
    if (hpos.x<>pos.x) or (hpos.y<>pos.y) or (hpos.z<>pos.z) then begin
      draw;
      pos:=hpos;
      draw;
    end;
  until Mousebuttons=0;
  MausSetPos(o.x,o.y);
  if MouseCursor <> nil then MouseCursor^.Update(GetShapeCtx,GetPositionCtx);
  ShowMouse;
end;

procedure t3dcursor.MoveTo(p:T3DPoint);
begin
  if state and sfvisible>0 then draw;
  pos:=p;
  if state and sfvisible>0 then draw;
end;

procedure T3DCursor.SetState(AState: Word; Enable: Boolean);
begin
  if (AState<>sfvisible) or (visible=enable) then TView.SetState(AState,Enable);
end;

const KreuzShape:TShape = (relx:7;rely:7;
      shape : (screen : ($FFFF,$FEFF,$FEFF,$FEFF,
                         $FC7F,$FEFF,$F7DF,$8383,
                         $F7DF,$FEFF,$FC7F,$FEFF,
                         $FEFF,$FEFF,$FFFF,$FFFF);
               mask   : ($0000,$0100,$0100,$0100,
                         $0380,$0100,$0820,$7C7C,
                         $0820,$0100,$0380,$0100,
                         $0100,$0100,$0000,$0000));
          number:scKreuz);

      RingKreuzShape:TShape = (relx:7;rely:7;
      shape : (screen : ($FFFF,$FEFF,$F29F,$EEEF,
                         $DEF7,$DEF7,$FFFF,$8383,
                         $FFFF,$DEF7,$DEF7,$EEEF,
                         $F29F,$FEFF,$FFFF,$FFFF);
               mask   : ($0000,$0100,$0D60,$1110,
                         $2108,$2108,$0000,$7C7C,
                         $0000,$2108,$2108,$1110,
                         $0D60,$0100,$0000,$0000));
          number:scRingKreuz);
      UhrShape:TShape = (relx:7;rely:7;
      shape : (screen : ($0001,$BFFB,$9FF3,$AFEB,
                         $AFEB,$B7DB,$BBBB,$BD7B,
                         $BD7B,$BBBB,$B7DB,$AFEB,
                         $AFEB,$9FF3,$BFFB,$0001);
               mask   : ($FFFE,$4004,$600C,$5014,
                         $5014,$4C64,$47C4,$4384,
                         $4384,$4544,$4924,$5114,
                         $57D4,$7FFC,$7FFC,$FFFE));
          number:scUhr);
begin
  MouseCursor^.RegisterShape(@KreuzShape);
  MouseCursor^.RegisterShape(@RingKreuzShape);
  MouseCursor^.RegisterShape(@UhrShape);
  new(ObjektCollection,init(50,500));
end.