unit USzene;
interface
uses crt,graph,dos,Maus,Objects,TGDriver,TGViews,TGDialog,Matrizen,TGApp,
     TGMouse,TGstdDlg,TGMsgBox,WizView,UObjList,U3DViews,UUtils,UObjekte,
     {UWizJoy,}UObtFast;
const cmGruppeE=3100;
      cmSaveAll=3101;
      cmGruppeAufRev=3102;
      cmRevAufObj=3103;
      cmSave=3104;
      cmSaveAs=3105;
type PSzene=^TSzene;
     TSzene=object(TSzeneAbstract)
       constructor init(SubGroups:Boolean);
       constructor lade(Aname:pathstr);
       {constructor load(var s:TStream);}
       destructor done; virtual;
       {procedure Store(var s:TStream); virtual;}
       procedure draw; virtual;
       procedure handleevent(var event:TEvent); virtual;
       procedure Male;
       procedure MaleSicht(sicht:PSicht);
       Procedure sichern;
       procedure LadeLicht(var f:text);
       function getpalette:PPalette; virtual;
       procedure SetName(Aname:Pathstr);
       function GetName:Pathstr; virtual;
       function Valid(Command: Word): Boolean; virtual;
       function error(s:string):word; virtual;
       function zeilenerror(s:string):word;
       procedure interpretiere(var f:text;start:word);
       procedure transdaten(var f:text);
       function GetHlpCtx:Word; virtual;
       procedure InsertObjekt(objekt:PView);
       function GetInsertGroup:p3dgroup;
       function getaktGruppe:P3DGroup;
       function getcurrentObjekt:P3DView;
       procedure SetObjekt(o:PView); virtual;
     end;

     PSzeneParamDialog=^TSzeneParamDialog;
     TSzeneParamDialog=object(TDialog)
       procedure Handleevent(var event:TEvent); virtual;
     end;

implementation
const pd1:T3DPoint=(x:1;y:0;z:0);
      pd2:T3DPoint=(x:0;y:1;z:0);
      pd3:T3DPoint=(x:0;y:0;z:1);
      pv1:T3DPoint=(x:0;y:0;z:1);
      pv2:T3DPoint=(x:0;y:1;z:1);
      pv3:T3DPoint=(x:1;y:1;z:0);
      pv4:T3DPoint=(x:1;y:0;z:0);

      cmLadePosition=3000;

{ TSzene }

constructor TSzene.init(SubGroups:boolean);
var HAnsicht:PAnsicht;
    r:TRect;
    y0,y1,y2,y3,x0,x1,x2:word;
    b:PView;
    objekte:P3DGroup;
begin
  r.assign(100,1,pred(screenwidth),screenheight-28);
  TWindow.init(r,'NONAME.WIZ',0);
  flags:=wfmove+wfclose;

  gesichert:=true;
  val:=true;
  eventmask:=eventmask or evcommand or evbroadcast;
  options:=options or ofpreProcess;

  y0:=15;
  {y1:=(screenheight-101) div 2 +15;
  y2:=screenheight-86;}
  y1:=(screenheight-47) div 2 +15;
  y2:=screenheight-32;
  y3:=screenheight-21;
  x0:=4;
  x1:=(screenwidth-119) div 2 +9;
  x2:=screenwidth-106;

  New(Sichten,init(4,16));

  r.assign(x0,y0,pred(x1),pred(y1));
  HAnsicht:=PAnSicht(Application^.ValidView(new(PAnsicht,init(r,'YZ',new(PYZSicht,init(r))))));
  if HAnsicht<>nil then begin
    Sichten^.insert(HAnsicht^.Sicht);
    Insert(HAnsicht);
  end else begin val:=false; exit; end;

  r.assign(x1,y0,x2,pred(y1));
  HAnsicht:=PAnSicht(Application^.ValidView(new(PAnsicht,init(r,'YX',new(PXYSicht,init(r))))));
  if HAnsicht<>nil then begin
    Sichten^.insert(HAnsicht^.Sicht);
    Insert(HAnsicht);
  end else begin val:=false; exit; end;

  r.assign(x0,y1,pred(x1),pred(y2));
  HAnsicht:=PAnSicht(Application^.ValidView(new(PAnsicht,init(r,'3D',new(PSicht,init(r,Matrix3d))))));
  if HAnsicht<>nil then begin
    Sichten^.insert(HAnsicht^.Sicht);
    Insert(HAnsicht);
  end else begin val:=false; exit; end;

  r.assign(x1,y1,x2,pred(y2));
  HAnsicht:=PAnSicht(Application^.ValidView(new(PAnsicht,init(r,'XZ',new(PXZSicht,init(r))))));
  if HAnsicht<>nil then begin
    Sichten^.insert(HAnsicht^.Sicht);
    Insert(HAnsicht);
  end else begin val:=false; exit; end;

  name:=WizOpt.Verzeichnis+'NONAME.WIZ';
  daten:=edaten;

  Root:=new(PRoot,init(@self,SubGroups,objekte));
  if root<>nil then insert(root) else begin val:=false; exit; end;
  if SubGroups then SetObjekt(Objekte)
  else SetObjekt(root);

  Rev:=New(P3DCursor,init);
  Insert(Rev);

{  r.assign(x0,y2,pred(x1),y3);
  new(Lister,init(r,objekte));}
end;

function TSzene.Valid(Command: Word): Boolean;
begin
  if command=cmCancel then valid:=true else valid:=val;
end;

{procedure MakePos(Paramdata:TParamData;var pos:T3DRect);
begin
  with paramdata do begin
    pos.T:=Translation;
    pos.r:=Rotation;
    pos.s:=Scalierung;
  end;
end;}

function TSzene.error(s:string):word;
begin
  error:=MessageBox(s,nil, mfError + mfOkButton+mfCancelButton);
end;

function TSzene.zeilenerror(s:string):word;
var buf:string[4];
begin
  str(zeile,buf);
  zeilenerror:=error(s+#13'in Zeile '+buf);
end;

const AktData:TData=(x:10;y:10;M:(ka:0.3;oa:(r:0.5;g:1;b:1);
                                  kd:0.3;od:(r:0.5;g:1;b:0.5);
                                  ks:0.3;os:(r:1;g:1;b:1);
                                  alpha:0;oe:30);
                     materialname:'Papier';
                     textur:'';darstellung:dsKoorSys or dskoorecken);

procedure TSzene.interpretiere(var f:text;start:word);
const koordinaten:boolean=false;
      xz:boolean=false;
      YZ:boolean=false;
      XY:boolean=false;
      gesamt:boolean=false;
      lampe:boolean=false;
      mass:single=3;
var cliplevel:byte;
    ende:boolean;
    n,hilfzeile:word;
    h,v,obtzahl:byte;
    hilf:string[6];
    a,p1,p2,p3,p4:T3DPoint;
    x,y:byte;
    AktOC_MC:TMatrix;
    AktPos:T3DRect;
    riss,obtname:namestr;
    hgruppe:P3DGroup;
    GroupName:GroupStr;
    haktobj:PView;
    hObjekt:P3DView;
    clipgosub:boolean;
    olddarst:word;
    nochnichda:boolean;

  function calculate(s:string;var error:Integer):single;
  var buf,hilf:string;
      intzahl:boolean;
      n:byte;
      funk:shortint;

    procedure datevar(nr:byte);
    var date:array[0..3] of word;
    begin
      funk:=-1;
      getdate(date[0],date[1],date[2],date[3]);
      str(date[nr]:4,buf);
      while pos(' ',buf)=1 do system.delete(buf,1,1);
      hilf:=hilf+buf;
    end;

    procedure timevar(nr:byte);
    var time:array[0..3] of word;
    begin
      funk:=-1;
      gettime(time[0],time[1],time[2],time[3]);
      str(time[nr]:2,buf);
      while pos(' ',buf)=1 do system.delete(buf,1,1);
      hilf:=hilf+buf;
    end;

    procedure setvar(v:integer);
    begin
      str(v:10,buf);
      while pos(' ',buf)=1 do system.delete(buf,1,1);
      hilf:=hilf+buf;
    end;

  begin
    hilf:='';
    if pos(' ',s)<>0 then s:=copy(s,1,pred(pos(' ',s)));
    intzahl:=false;
    for n:=1 to length(s) do begin
      if (s[n]<>'$') and ((upcase(s[n])<'A') or (upcase(s[n])>'Z')) then hilf:=hilf+s[n] else begin
        if s[n]='$' then intzahl:=true else begin
          if intzahl then setvar(varint[byte(upcase(s[n]))])
          else begin
            funk:=0;
            if pos('(',copy(s,n,succ(length(s)-n)))<>0 then begin
              buf:=copy(s,n,pred(pos('(',copy(s,n,succ(length(s)-n)))));
              if ((length(buf)=2) and gleich(buf,'LN')) or
                 ((length(buf)=3) and ((gleich(buf,'EXP') or
                 gleich(buf,'SIN') or gleich(buf,'COS') or
                 gleich(buf,'TAN') or gleich(buf,'COT') or
                 gleich(buf,'ABS') or gleich(buf,'SGN') or
                 gleich(buf,'SQR'))) or
                 ((length(buf)=4) and (gleich(buf,'SQRT') or
                 gleich(buf,'FRAC'))) or
                 ((length(buf)=5) and (gleich(buf,'TRUNC') or gleich(buf,'ROUND'))) or
                 ((length(buf)=6) and gleich(buf,'ARCTAN'))) then funk:=length(buf);
            end else if gleich(copy(s,n,2),'PI') then funk:=2 else
            if gleich(copy(s,n,3),'RND') then funk:=3 else
            if gleich(copy(s,n,3),'TAG') then begin datevar(0); inc(n,2); end else
            if gleich(copy(s,n,5),'MONAT') then begin datevar(1); inc(n,4); end else
            if gleich(copy(s,n,4),'JAHR') then begin datevar(2); inc(n,3); end else
            if gleich(copy(s,n,6),'STUNDE') then begin timevar(0); inc(n,5); end else
            if gleich(copy(s,n,6),'MINUTE') then begin timevar(1); inc(n,5); end else
            if gleich(copy(s,n,7),'SEKUNDE') then begin timevar(2); inc(n,6); end else
            if gleich(copy(s,n,5),'MESHX') then begin setvar(Aktdata.x); inc(n,4); end else
            if gleich(copy(s,n,5),'MESHY') then begin setvar(AktData.y); inc(n,4); end;
            if funk>=0 then begin
              if funk=0 then begin
                str(varsingle[byte(upcase(s[n]))]:10:8,buf);
                while pos(' ',buf)=1 do system.delete(buf,1,1);
                hilf:=hilf+buf;
              end else begin
                hilf:=hilf+copy(s,n,funk);
                inc(n,pred(funk));
              end;
            end;
          end;
          intzahl:=false;
        end;
      end
    end;
    calculate:=berechne(hilf,0,0,error);
  end;

  procedure rechenfehler(argumente:string;err:integer);
  begin
    ende:=error(copy(argumente,1,err)+'_'+
                copy(argumente,succ(err),length(argumente)-err))=cmcancel;
  end;


  function zahl:integer;
  var h,err:integer;
      hilf:string[6];
  begin
    while pos(' ',argumente)=1 do system.delete(argumente,1,1);
    argumente:=argumente+' ';
    system.val(copy(argumente,1,pred(pos(' ',argumente))),h,err);
    if err<>0 then begin
      zahl:=round(calculate(argumente,err));
      if err<>0 then rechenfehler(argumente,err);
    end else zahl:=h;
    system.delete(argumente,1,pos(' ',argumente));
  end;

  function singlezahl:single;
  var h:single;
      err:integer;
  begin
    while pos(' ',argumente)=1 do system.delete(argumente,1,1);
    argumente:=argumente+' ';
    system.val(copy(argumente,1,pred(pos(' ',argumente))),h,err);
    if err<>0 then begin
      singlezahl:=calculate(argumente,err);
      if err<>0 then rechenfehler(argumente,err);
    end else singlezahl:=h;
    system.delete(argumente,1,pos(' ',argumente));
  end;

  function findesprung:word;
  var n:word;
  begin
    n:=pos(' ',argumente);
    if n<>0 then argumente:=copy(argumente,1,n);
    upword(argumente);
    argumente:=':'+argumente;
    reset(f);
    n:=0;
    repeat
      readln(f,befehl);
      inc(n);
      while pos(' ',befehl)=1 do system.delete(befehl,1,1);
      if pos(' ',befehl)<>0 then
       befehl:=copy(befehl,1,pred(pos(' ',befehl)));
    until eof(f) or gleich(befehl,argumente);
    if eof(f) then ende:=error('Label '+argumente+#13'nicht gefunden (Interpretiere)')=cmcancel;
    argumente:='';
    findesprung:=n;
  end;

  procedure ifinter;
  var entsch:boolean;
      a,b:single;
      l,art,elsepos:byte;
      tex:string;
      err:Integer;
  begin
    l:=1;
    while (not (argumente[l] in ['=','>','<'])) and (l<length(argumente)) do inc(l);
    if l=length(argumente) then begin
      str(zeile,hilf);
      ende:=zeilenerror('< > = <> >= <= erwartet')=cmcancel;
    end;
    tex:=copy(argumente,1,pred(l));
    a:=calculate(tex,err);
    if err<>0 then rechenfehler(tex,err);
    system.delete(argumente,1,pred(l));
    if argumente[1]='>' then art:=1 else
    if argumente[1]='<' then art:=2 else
    if argumente[1]='=' then art:=3;
    if argumente[2]='>' then art:=4 else
    if argumente[2]='=' then inc(art,4);
    system.delete(argumente,1,1);
    if art>=4 then system.delete(argumente,1,1);
    while pos(' ',argumente)=1 do system.delete(argumente,1,1);
    tex:=copy(argumente,1,pos(' ',argumente));
    b:=calculate(tex,err);
    if err<>0 then rechenfehler(tex,err);
    system.delete(argumente,1,pos(' ',argumente));
    while pos(' ',argumente)=1 do system.delete(argumente,1,1);
    case art of
      1:entsch:=a>b;
      2:entsch:=a<b;
      4:entsch:=a<>b;
      5:entsch:=a>=b;
      6:entsch:=a<=b;
      else entsch:=a=b;
    end;
    upword(argumente);
    elsepos:=pos('ELSE',argumente);
    if elsepos<>0 then begin
      if entsch then argumente:=copy(argumente,1,pred(elsepos))
      else argumente:=copy(argumente,elsepos+4,length(argumente)-elsepos-3);
    end else begin
      readln(f,tex);
      inc(zeile);
      elsepos:=pos('ELSE',tex);
      if elsepos=0 then begin
        if not entsch then argumente:=tex else argumente:=argumente+' '+tex;
      end else begin
        if entsch then begin
          if elsepos>1 then argumente:=argumente+copy(tex,1,pred(elsepos));
        end else argumente:=copy(tex,elsepos+4,length(tex)-elsepos-3);
      end;
    end;
  end;

  procedure letinter;
  var intzahl:boolean;
      nummer:byte;
      err:Integer;
  begin
    intzahl:=argumente[1]='$';
    if intzahl then system.delete(argumente,1,1);
    nummer:=byte(upcase(argumente[1]));
    if (nummer>byte('Z')) or (nummer<byte('A')) then begin
      str(zeile,hilf);
      ende:=zeilenerror('Fehlerhafte Variable')=cmcancel;
    end;
    system.delete(argumente,1,pos('=',argumente));
    while pos(' ',argumente)=1 do system.delete(argumente,1,1);
    if intzahl then begin
      varint[nummer]:=round(calculate(copy(argumente,1,pos(' ',argumente)),err));
      if err<>0 then rechenfehler(copy(argumente,1,pos(' ',argumente)),err);
    end else begin
      varsingle[nummer]:=calculate(copy(argumente,1,pos(' ',argumente)),err);
      if err<>0 then rechenfehler(copy(argumente,1,pos(' ',argumente)),err);
    end;
    system.delete(argumente,1,pos(' ',argumente));
  end;

  procedure schreibeinter;
  var tex,tex2:string;
      buf:string[10];
      mark1,mark2:byte;
      err:Integer;
  begin
    system.delete(argumente,1,pos('"',argumente));
    tex:=copy(argumente,1,pred(pos('"',argumente)));
    system.delete(argumente,1,pos('"',argumente));
    mark1:=pos('+''',tex);
    tex2:='';
    n:=1;
    while (n<length(tex)) and (mark1<>0) do begin
      tex[mark1]:=' ';
      if mark1-n>0 then tex2:=tex2+copy(tex,n,mark1-n);
      mark2:=pos('''+',tex);
      tex[mark2]:=' ';
      str(calculate(copy(tex,mark1+2,mark2-mark1-2),err):10:0,buf);
      if err<>0 then rechenfehler(copy(tex,mark1+2,mark2-mark1-2),err);
      while pos(' ',buf)<>0 do system.delete(buf,pos(' ',buf),1);
      tex2:=tex2+buf;
      n:=mark2+2;
      mark1:=pos('+''',tex);
    end;
    if n<length(tex) then tex2:=tex2+copy(tex,n,succ(length(tex)-n));
    {schreibe3d(tex2,singlezahl,singlezahl,singlezahl,singlezahl,singlezahl,singlezahl);}
  end;

  procedure ladeobtinter;
  var newobtzahl:byte;
  begin
    newobtzahl:=zahl;
    obtzahl:=(obtzahl and 16) or newobtzahl;
    obtname:=getstring(8);
    if (newobtzahl and 16)<>0 then aktdata.textur:=obtname;
  end;

  procedure matname;
  var h:byte;
  begin
    h:=pos(';',argumente);
    if h<>0 then aktdata.materialname:=copy(argumente,succ(h),h+9);
  end;

  procedure meshinter;
  var dir:dirstr;
      nam:namestr;
      ext:extstr;
  begin
    if pos(';',argumente)<>0 then begin
      GetOC_MC(aktOC_MC);
      CalcPos(aktOC_MC,aktpos);
      argumente:=copy(argumente,succ(pos(';',argumente)),255);
      if gleich(copy(argumente,1,pred(pos(' ',argumente))),'FREI') then begin
        system.delete(argumente,1,pos(' ',argumente));
        hobjekt:=new(PMeshObj,init(aktpos,@self,argumente));
        PMeshObj(hobjekt)^.lademesh(argumente);
      end else begin
        if gleich(copy(argumente,1,pred(pos(' ',argumente))),'STARR') then
        system.delete(argumente,1,pos(' ',argumente));
        hobjekt:=new(PObjekt,init(aktpos,@self,argumente,obtzahl));
        fsplit(PObjekt(HObjekt)^.pfad,dir,nam,ext);
        if gleich(aktdata.textur,nam) then aktdata.textur:='MyOwn';
      end;
      argumente:='';
      insertobjekt(hobjekt);
      P3DView(aktobjekt)^.setparam(aktdata);
    end;
  end;

begin
  argumente:='';
  if start=0 then begin
    fillchar(varint,sizeof(varint),#0);
    fillchar(varsingle,sizeof(varsingle),#0);
    AktOC_MC:=E;
    setOC_MC(AktOC_MC);
  end;
  reset(f);
  zeile:=0;
  while start<>zeile do begin
    inc(zeile);
    readln(f,befehl);
  end;
  ende:=false;
  while (not (eof(f) or ende)) or (notleer(argumente)) do begin
    lesezeile;
    if id(befehl,'{') then begin
      repeat
        lesezeile;
      until (pos('}',befehl)<>0) or (pos('}',argumente)<>0) or eof(f);
      if eof(f) then ende:=error('Bemerkungsklammer { nicht geschlossen !')=cmcancel;
      argumente:='';
    end else if id(befehl,'RAM') or id(befehl,'INTERAKTIV') or
       id(befehl,'TRUECOLOR') or id(befehl,'MAGICPICTURE') then delarg(2)
    else if not (id(befehl,':') or (befehl=' ') or
       id(befehl,'KOORDINATEN') or id(befehl,'FARBIG') or
       id(befehl,'SW256') or
       id(befehl,'RCKFLCHEN') or id(befehl,'RAHMEN') or
       id(befehl,'CLIPWRFEL') or id(befehl,'SCQ') or id(befehl,'IBM') or
       id(befehl,'DRAHTGITTER'))
    then if (id(befehl,'XY') or id(befehl,'ZX') or id(befehl,'YZ') or
        id(befehl,'XSIZE') or id(befehl,'XMIN') or id(befehl,'YMIN') or
        id(befehl,'ABSTAND') or id(befehl,'FPD') or id(befehl,'BPD')  or
        id(befehl,'BILDDATEI') or
        id(befehl,'GESAMTPLAN') or id(befehl,'COLOR') or
        id(befehl,'PAL') or id(befehl,'3D-BRILLE')) then delarg(1)
    else if (id(befehl,'STANDPUNKT') or id(befehl,'BLICKPUNKT') or
       id(befehl,'ACHSENRICHTUNG') or id(befehl,'HINTERGRUND'))
       then delarg(3)
    else if id(befehl,'NEBEL') then delarg(4)
    else if id(befehl,'LAMPEN') then delarg(5)
    else if (id(befehl,'SCHWARZWEI')) then delarg(12)
    else if pos(';',befehl)<>0 then
      argumente:=''
    else if id(befehl,'UMGEBUNGSLICHT') then delarg(3)
      {addambls(succ(maxls),true,singlezahl,singlezahl,singlezahl)}
    else if id(befehl,'ANFANGCLIPBOX') then begin
      delarg(3);
      {defineclipvolume(singlezahl,singlezahl,singlezahl,r,g,b);
      cliplevel:=1;
      if clipmode=outside then begin
        repeat
          readln(f,befehl);
          inc(zeile);
          if id(befehl,'ENDCLIPBOX') then dec(cliplevel) else
           if id(befehl,'ANFANGCLIPBOX') then inc(cliplevel);
        until (cliplevel=0) or eof(f);
        if eof(f) then ende:=error('Mehr ClipBoxen geffnet als geschlossen !')=cmcancel;
      end;}
    end else if id(befehl,'ENDCLIPBOX') then {undefclipvolume}
    else if id(befehl,'LICHT') then {setzelichter}
    else if id(befehl,'SONNENLICHT') then delarg(6)
      {addinfls(succ(maxls),true,singlezahl,singlezahl,singlezahl,singlezahl,singlezahl,singlezahl)}
    else if id(befehl,'GLHLAMPE') then delarg(8)
      {addposls(succ(maxls),true,singlezahl,singlezahl,singlezahl,singlezahl,singlezahl,singlezahl,singlezahl,singlezahl)}
    else if id(befehl,'SPOT') then delarg(13)
      {addsptls(succ(maxls),true,singlezahl,singlezahl,singlezahl,singlezahl,singlezahl,singlezahl,singlezahl,singlezahl,
      singlezahl,singlezahl,
               singlezahl,singlezahl,singlezahl)}
    else if id(befehl,'GESCHWINDIGKEIT') then delarg(4)
      {changespeed(singlezahl,singlezahl,singlezahl,singlezahl)}
    else if id(befehl,'PUSHTRAFS') then pushOC_MC
    else if id(befehl,'POPTRAFS') then popOC_MC
    else if id(befehl,'VERGRERN') then begin
      a.x:=singlezahl;
      a.y:=singlezahl;
      a.z:=singlezahl;
      scale(a)
    end else if id(befehl,'VERSCHIEBEN') then begin
      a.x:=singlezahl;
      a.y:=singlezahl;
      a.z:=singlezahl;
      translate(a);
    end else if id(befehl,'ROTIEREN') then
      rotate(zahl,singlezahl)
    else if id(befehl,'GESCHWINDIGKEIT') then delarg(4)
      {changespeed(singlezahl,singlezahl,singlezahl,singlezahl) }
    else if id(befehl,'WRFEL') then
      {wuerfel(r,g,b)}
    else if id(befehl,'KUGEL') then begin
      GetOC_MC(aktOC_MC);
      CalcPos(aktOC_MC,aktpos);
      aktdata.x:=zahl;
      aktdata.y:=zahl;
      hObjekt:=new(PKugel,init(aktpos,@self,aktdata.x,aktdata.y));
      insertobjekt(hobjekt);
      P3DView(aktobjekt)^.setparam(aktdata);
    end else if id(befehl,'EBENE') then begin
      GetOC_MC(aktOC_MC);
      CalcPos(aktOC_MC,aktpos);
      aktdata.x:=zahl;
      aktdata.y:=zahl;
      hobjekt:=new(PEbene,init(aktpos,@self,aktdata.x,aktdata.y));
      insertobjekt(hobjekt);
      P3DView(aktobjekt)^.setparam(aktdata);
    end else if id(befehl,'TORUS') then begin
      GetOC_MC(aktOC_MC);
      CalcPos(aktOC_MC,aktpos);
      aktdata.r1:=singlezahl;
      aktdata.r2:=singlezahl;
      aktdata.x:=zahl;
      aktdata.y:=zahl;
      hobjekt:=new(PTorus,init(aktpos,@self,aktdata.r1,aktdata.r2,aktdata.x,aktdata.y));
      insertobjekt(hobjekt);
      P3DView(aktobjekt)^.setparam(aktdata);
    end else if id(befehl,'PUTINMESH') then begin
      {x:=zahl;y:=zahl;
      p.crd.x:=singlezahl;p.crd.y:=singlezahl;p.crd.z:=singlezahl;
      p.nrm.x:=singlezahl;p.nrm.y:=singlezahl;p.nrm.z:=singlezahl;
      putinmesh(x,y,p.crd,p.nrm)}
      delarg(8)
    end else if id(befehl,'NOTUSED') then
      {putnotused(zahl,zahl)} delarg(2)
    else if id(befehl,'EXTENSIONS') then
      {meshextensions(zahl,zahl)}delarg(2)
    else if id(befehl,'MESH') then meshinter else if id(befehl,'NORMIEREN') then begin
      {norm(id(getstring(6),'FLCHE'))}delarg(1)
    end else if id(befehl,'SHIFTL') then begin
      x:=zahl;
      for y:=x to 25 do varsingle[y+byte('A')]:=varsingle[y-x+byte('A')];
    end else if id(befehl,'SHIFTR') then begin
      x:=zahl;
      for y:=25-x downto 0 do varsingle[y+x+byte('A')]:=varsingle[y+byte('A')];
      for y:=0 to pred(x) do varsingle[y+byte('A')]:=0;
    end else if id(befehl,'$SHIFTL') then begin
      x:=zahl;
      for y:=x to 25 do varint[y+byte('A')]:=varint[y-x+byte('A')];
    end else if id(befehl,'$SHIFTR') then begin
      x:=zahl;
      for y:=25-x downto 0 do varint[y+x+byte('A')]:=varint[y+byte('A')];
      for y:=0 to pred(x) do varint[y+byte('A')]:=0;
    end else if id(befehl,'SULE') then begin
      GetOC_MC(aktOC_MC);
      CalcPos(aktOC_MC,aktpos);
      aktdata.x:=zahl;
      aktdata.y:=zahl;
      hobjekt:=new(PSaule,init(aktpos,@self,aktdata.x,aktdata.y));
      insertobjekt(hobjekt);
      P3DView(aktobjekt)^.setparam(aktdata);
    end else if id(befehl,'ZYLINDER') then begin
      GetOC_MC(aktOC_MC);
      CalcPos(aktOC_MC,aktpos);
      aktdata.x:=zahl;
      aktdata.y:=zahl;
      aktdata.n3:=zahl;
      hobjekt:=new(PDose,init(aktpos,@self,aktdata.x,aktdata.y,aktdata.n3));
      insertobjekt(hobjekt);
      P3DView(aktobjekt)^.setparam(aktdata);
    end else if id(befehl,'LINIE') then begin
      delarg(6);
      {a.x:=singlezahl;a.y:=singlezahl;a.z:=singlezahl;
      e.x:=singlezahl;e.y:=singlezahl;e.z:=singlezahl;
      linie3d(a,e);}
    end
    else if id(befehl,'SCHACHBRETT') then delarg(8)
      {schachbrett(zahl,zahl,singlezahl,singlezahl,singlezahl,singlezahl,singlezahl,singlezahl)}
    else if id(befehl,'DREIECK') then begin
      p1.x:=singlezahl;p1.y:=singlezahl;p1.z:=singlezahl;
      p2.x:=singlezahl;p2.y:=singlezahl;p2.z:=singlezahl;
      p3.x:=singlezahl;p3.y:=singlezahl;p3.z:=singlezahl;
      GetOC_MC(aktOC_MC);
      CalcPos(aktOC_MC,aktpos);
      hobjekt:=new(PDreieck,init(aktpos,@self,p1,p2,p3));
      insertobjekt(hobjekt);
      aktdata.x:=2;aktdata.y:=2;
{!}        aktdata.darstellung:=dsObjekt or dsMeshEcken;
      P3DView(aktobjekt)^.setparam(aktdata);
{!}        aktdata.darstellung:=dsKoorSys or dskoorecken;
    end else if id(befehl,'VIERECK') then begin
      p1.x:=singlezahl;p1.y:=singlezahl;p1.z:=singlezahl;
      p2.x:=singlezahl;p2.y:=singlezahl;p2.z:=singlezahl;
      p3.x:=singlezahl;p3.y:=singlezahl;p3.z:=singlezahl;
      p4.x:=singlezahl;p4.y:=singlezahl;p4.z:=singlezahl;
      GetOC_MC(aktOC_MC);
      CalcPos(aktOC_MC,aktpos);
      aktdata.x:=2;aktdata.y:=2;
      hobjekt:=new(PViereck,init(aktpos,@self,p1,p2,p3,p4));
      insertobjekt(hobjekt);
{!}        aktdata.darstellung:=dsObjekt or dsMeshEcken;
      P3DView(aktobjekt)^.setparam(aktdata);
{!}        aktdata.darstellung:=dsKoorSys or dskoorecken;
    end else if id(befehl,'MESH') then {mesh}
    else if id(befehl,'SCHREIBE') then schreibeinter
    else if id(befehl,'LADESCHRIFT') then
      {ladeschrift(getstring(8))}delarg(1)
    else if id(befehl,'ROTATIONSKRPER') then begin
      GetOC_MC(aktOC_MC);
      CalcPos(aktOC_MC,aktpos);
      aktdata.y:=zahl;
      hobjekt:=new(PRotationskoerper,init(aktpos,@self,riss,aktdata.y,zahl));
      insertobjekt(hobjekt);
      P3DView(aktobjekt)^.setparam(aktdata);
    end else if id(befehl,'ZIEHKRPER') then begin
      GetOC_MC(aktOC_MC);
      CalcPos(aktOC_MC,aktpos);
      aktdata.y:=zahl;
      hobjekt:=new(PZiehkoerper,init(aktpos,@self,riss,aktdata.y));
      insertobjekt(hobjekt);
      P3DView(aktobjekt)^.setparam(aktdata);
    end else if id(befehl,'LADEROTATIONSKRPER') then
      riss:=getstring(8)
    else if id(befehl,'LADEOBJEKT') then ladeobtinter
    else if id(befehl,'TEXTUR') then begin
      aktdata.x:=zahl;aktdata.y:=zahl;
      aktdata.m.oa.r:=singlezahl;
      aktdata.m.oa.g:=singlezahl;
      aktdata.m.oa.b:=singlezahl;
      aktdata.textur:='';
    end else if id(befehl,'TON') then begin
      sound(zahl);delay(zahl);nosound;
    end else if id(befehl,'OBERFLCHE') then with aktdata.m do begin
     ka:=singlezahl;
     kd:=singlezahl;
     ks:=singlezahl;
     os.r:=singlezahl;
     os.g:=singlezahl;
     os.b:=singlezahl;
     oe:=singlezahl;
     od.r:=singlezahl;
     od.g:=singlezahl;
     od.b:=singlezahl;
     alpha:=singlezahl;
     matname;
    end else if id(befehl,'PARAM') then with aktdata.m do begin
      aktdata.x:=zahl;aktdata.x:=zahl;
      aktdata.m.oa.r:=singlezahl;
      aktdata.m.oa.g:=singlezahl;
      aktdata.m.oa.b:=singlezahl;
      ka:=singlezahl;kd:=singlezahl;ks:=singlezahl;oe:=singlezahl;
      os.r:=singlezahl;
      os.g:=singlezahl;
      os.b:=singlezahl;
      od.r:=singlezahl;
      od.g:=singlezahl;
      od.b:=singlezahl;
      alpha:=singlezahl;
      a.x:=singlezahl;
      a.y:=singlezahl;
      a.z:=singlezahl;
      translate(a);
      rotate(1,singlezahl);
      rotate(2,singlezahl);
      rotate(3,singlezahl);
      a.x:=singlezahl;
      a.y:=singlezahl;
      a.z:=singlezahl;
      scale(a);
      matname;
    end else if id(befehl,'LET') then letinter
    else if id(befehl,'IF') then ifinter
    else if id(befehl,'GOTO') then
      zeile:=findesprung
    else if (id(befehl,'GOSUB') or id(befehl,'CLIPGOSUB')) then begin
      clipgosub:=id(befehl,'CLIPGOSUB');
      argumente:=argumente+' ';
      Groupname:=copy(argumente,1,pos(' ',argumente));
      nochnichda:=true;
      if (root<>nil) {and (wizopt.lademodus=lmschnell)} then begin
        hgruppe:=root^.getgroup(groupname);
        if hgruppe<>nil then begin
          if (hgruppe<>getInsertGroup) and (not hgruppe^.nameexists(name)) then begin
            GetOC_MC(aktOC_MC);
            hgruppe:=hgruppe^.KopierDich(@self);
            haktObj:=aktobjekt;
            insertobjekt(hgruppe);
            SetObjekt(haktobj);
            hgruppe^.putMC_WC(aktOC_MC);
            nochnichda:=false;
            argumente:='';
          end;
        end;
      end;
      if nochnichda then begin
        n:=findesprung;
        hilfzeile:=zeile;
        if start<>0 then begin
          GetOC_MC(aktOC_MC);
          hgruppe:=new(P3DGroup,init(GroupName,@self,aktOC_MC));
          if CLIPGOSUB
          then hgruppe^.darstellung:=hgruppe^.darstellung or
                 dsgruppiert or  dskoorecken or
                 (dskoorsys and aktdata.darstellung);
          haktObj:=aktobjekt;
          insertobjekt(hgruppe);
          aktOC_MC:=e;
          SetOC_MC(aktOC_MC);
        end else if CLIPGOSUB and (not no3dGroup(aktobjekt))
        then p3dgroup(aktobjekt)^.darstellung:=
             P3dgroup(aktobjekt)^.darstellung or dsgruppiert or
               dskoorecken or (dskoorsys and aktdata.darstellung);
        if clipgosub then begin
          olddarst:=aktdata.darstellung;
          aktdata.darstellung:=dskoorecken;
        end;
        interpretiere(f,n);
        if clipgosub then aktdata.darstellung:=olddarst;
        if start<>0 then begin
          aktOC_MC:=hgruppe^.MC_WC;
          SetOC_MC(aktOC_MC);
          SetObjekt(haktobj);
        end;
        zeile:=hilfzeile;
        reset(f);
        start:=0;
        while start<>zeile do begin
          inc(start);
          readln(f,befehl);
        end;
      end;
    end else if id(befehl,'ENDE') or id(befehl,'RETURN') then ende:=true
    else begin
      str(zeile,hilf);
      ende:=error('Unbekannter Befehl in Zeile '+hilf+#13':'+befehl+':'#13'(Interpretiere)')=cmcancel;
    end;
  end;
end;

procedure TSzene.transdaten(var f:text);
const koordinaten:boolean=false;
var cliplevel:byte;
    ende:boolean;
    r:single;
    hilf:string[6];
    n:byte;

  procedure rechenfehler(argumente:string;err:integer);
  begin
    ende:=error(copy(argumente,1,err)+'_'+
                copy(argumente,succ(err),length(argumente)-err))=cmcancel;
  end;


  function zahl:integer;
  var h,err:integer;
      hilf:string[6];
  begin
    while pos(' ',argumente)=1 do system.delete(argumente,1,1);
    argumente:=argumente+' ';
    system.val(copy(argumente,1,pred(pos(' ',argumente))),h,err);
    if err<>0 then begin
      zahl:=round(berechne(argumente,0,0,err));
      if err<>0 then rechenfehler(argumente,err);
    end else zahl:=h;
    system.delete(argumente,1,pos(' ',argumente));
  end;

  function singlezahl:single;
  var h:single;
      err:integer;
  begin
    while pos(' ',argumente)=1 do system.delete(argumente,1,1);
    argumente:=argumente+' ';
    system.val(copy(argumente,1,pred(pos(' ',argumente))),h,err);
    if err<>0 then begin
      singlezahl:=berechne(argumente,0,0,err);
      if err<>0 then rechenfehler(argumente,err);
    end else singlezahl:=h;
    system.delete(argumente,1,pos(' ',argumente));
  end;


begin
  daten.flag:=sffarbig;
  daten.darstellung:=0;
  argumente:='';
  zeile:=0;
  ende:=false;
  while not (eof(f) or ende) do begin
    lesezeile;
    if id(befehl,'{') then begin
      repeat
        lesezeile;
      until (pos('}',befehl)<>0) or (pos('}',argumente)<>0) or eof(f);
      if eof(f) then ende:=error('Bemerkungsklammer { nicht geschlossen !')=cmcancel;
      argumente:='';
    end else if not (
       id(befehl,':')  or
       id(befehl,'WRFEL') or (befehl=' ') or id(befehl,'POPTRAFS') or
       id(befehl,'PUSHTRAFS') or id(befehl,'RETURN') or id(befehl,'MESH') or
       id(befehl,'ENDCLIPBOX') or id(befehl,'LICHT') or
       id(befehl,'LINIE') or id(befehl,'ANFANGCLIPBOX') or id(befehl,'MESH'))
    then if (id(befehl,'COLOR') or id(befehl,'PAL') or
             id(befehl,'LADEROTATIONSKRPER') or
             id(befehl,'ZIEHKRPER') or id(befehl,'LADESCHRIFT') or
             id(befehl,'NORMIEREN') or id(befehl,'LET') or id(befehl,'SHIFTL') or
             id(befehl,'SHIFTR') or id(befehl,'$SHIFTL') or id(befehl,'$SHIFTR'))
         then delarg(1)
    else if (id(befehl,'LADEOBJEKT') or id(befehl,'ROTIEREN') or
             id(befehl,'KUGEL') or id(befehl,'SULE') or id(befehl,'EBENE') or
             id(befehl,'NOTUSED') or id(befehl,'EXTENSIONS') or id(befehl,'TON') or
             id(befehl,'SULE') or id(befehl,'ROTATIONSKRPER'))
         then delarg(2)
    else if (id(befehl,'UMGEBUNGSLICHT') or id(befehl,'VERGRERN') or
             id(befehl,'VERSCHIEBEN') or id(befehl,'ZYLINDER'))
         then delarg(3)
    else if (id(befehl,'TORUS') or id(befehl,'GESCHWINDIGKEIT'))
         then delarg(4)
    else if (id(befehl,'TEXTUR')) then delarg(5)
    else if (id(befehl,'SONNENLICHT')) then delarg(6)
    else if (id(befehl,'SCHREIBE')) then begin
      deltext;
      delarg(6);
    end else if (id(befehl,'GLHLAMPE') or id(befehl,'SCHACHBRETT') or
             id(befehl,'PUTINMESH')) then delarg(8)
    else if (id(befehl,'DREIECK')) then delarg(9)
    else if (id(befehl,'OBERFLCHE')) then delarg(11)
    else if (id(befehl,'VIERECK')) then delarg(12)
    else if (id(befehl,'SPOT')) then delarg(13)
    else if (id(befehl,'PARAM')) then delarg(25)
    else if (id(befehl,'GOSUB') or id(befehl,'CLIPGOSUB') or
             id(befehl,'GOTO')) then argumente:=''
    else if id(befehl,'IF') then argumente:=''
    else if id(befehl,'KOORDINATEN') then
      Daten.Darstellung:=dfKoordinaten
    else if pos(';',befehl)<>0 then
      argumente:=''
    else if id(befehl,'ZX') then begin
      Daten.Darstellung:=(Daten.Darstellung and not (dfYZ or dfXY or dfGesamt)) or dfXZ;
      daten.mass:=singlezahl;
    end else if id(befehl,'YZ') then begin
      daten.mass:=singlezahl;
      Daten.Darstellung:=(Daten.Darstellung and not (dfXZ or dfXY or dfGesamt)) or dfYZ;
    end else if id(befehl,'XY') then begin
      daten.mass:=singlezahl;
      Daten.Darstellung:=(Daten.Darstellung and not (dfXZ or dfYZ or dfGesamt)) or dfXY;
    end else if id(befehl,'GESAMTPLAN') then begin
      daten.mass:=singlezahl;
      Daten.Darstellung:=(Daten.Darstellung and not (dfXZ or dfYZ or dfXY)) or dfGesamt;
    end else if id(befehl,'SCHWARZWEI') then with daten do begin
      flag:=flag and (not (sfFarbig or sfsw256));
      for n:=0 to 3 do begin
        greytab[n].r:=singlezahl;greytab[n].g:=singlezahl;greytab[n].b:=singlezahl;
      end;
    end else if id(befehl,'FARBIG') then Daten.flag:=Daten.flag or sfFarbig
    else if id(befehl,'SW256') then Daten.flag:=(Daten.flag or sfSW256) and (not sffarbig)
    else if id(befehl,'INTERAKTIV') then begin
      hilf:=getstring(4);
      if id(hilf,'MAUS') or id(hilf,'JOYMAUS')
      then daten.flag:=daten.flag or sfInteraktivMaus;
      if id(hilf,'JOYSTICK') or id(hilf,'JOYMAUS')
      then daten.flag:=daten.flag or sfInteraktivJoystick;
      if id(getstring(5),'DATEN') then daten.flag:=daten.flag or sfvariablenanzeigen;
    end else if id(befehl,'XSIZE') then
      daten.xsize:=singlezahl
    else if id(befehl,'XMIN') then
      daten.xmin:=singlezahl
    else if id(befehl,'YMIN') then
      daten.ymin:=singlezahl
    else if id(befehl,'STANDPUNKT') then begin
      daten.NRP.X:=singlezahl;daten.NRP.Y:=singlezahl;daten.NRP.Z:=singlezahl;
    end else if id(befehl,'BLICKPUNKT') then with daten do begin
      VRP.X:=singlezahl;VRP.y:=singlezahl;VRP.z:=singlezahl;
    end else if id(befehl,'ACHSENRICHTUNG') then with daten do begin
      VUP.X:=singlezahl;VUP.y:=singlezahl;VUP.z:=singlezahl;
    end else if id(befehl,'BILDDATEI') then begin
      delarg(1);
      daten.flag:=daten.flag or sfAutoSave;
    end else if id(befehl,'ABSTAND') then
      daten.vpd:=singlezahl
    else if id(befehl,'FPD') then
      daten.FPD:=singlezahl
    else if id(befehl,'BPD') then
      daten.bpd:=singlezahl
    else if id(befehl,'RCKFLCHEN') then
      daten.flag:=daten.flag or sfflipareaenabled
    else if id(befehl,'3D-BRILLE') then begin
      daten.flag:=daten.flag or sfbrille;
      daten.augendist:=singlezahl;
    end else if id(befehl,'RAHMEN') then
      daten.flag:=daten.flag or sfframe
    else if id(befehl,'LAMPEN') then begin
      daten.flag:=daten.flag or sflampe;
      daten.lampen1:=zahl;daten.lampen2:=zahl;
      with daten do begin
        LampeSkalierung:=singlezahl;LampeSkalierung:=singlezahl;LampeSkalierung:=singlezahl;
      end;
    end else if id(befehl,'HINTERGRUND') then with daten do begin
      with bkcolor do begin r:=singlezahl;g:=singlezahl;b:=singlezahl; end;
    end else if id(befehl,'NEBEL') then begin
      daten.flag:=daten.flag or sfNebel;
      daten.nebel:=singlezahl;
      with daten.nebelcolor do begin r:=singlezahl;g:=singlezahl;b:=singlezahl; end;
    end else if id(befehl,'CLIPWRFEL') then
      daten.flag:=daten.flag or sfclipcube
    else if id(befehl,'SCQ') then daten.darstellung:=daten.darstellung or dfHigh
    else if id(befehl,'IBM') then daten.darstellung:=daten.darstellung or dfLow
    else if id(befehl,'RAM') then begin
      daten.darstellung:=daten.darstellung or dfRAM;
      daten.xmax:=zahl;
      daten.ymax:=zahl;
    end else if id(befehl,'MAGICPICTURE') then begin
      daten.darstellung:=daten.darstellung or dfMagicPic;
      daten.xmax:=zahl;
      daten.ymax:=zahl;
    end else if id(befehl,'TRUECOLOR') then begin
      daten.darstellung:=daten.darstellung or dfTrueColor;
      daten.xmax:=zahl;
      daten.ymax:=zahl;
    end else if id(befehl,'DRAHTGITTER') then daten.flag:=daten.flag or sfWireFrame
    else if id(befehl,'ENDE') then ende:=true
    else begin
      str(zeile,hilf);
      ende:=error('Unbekannter Befehl in Zeile '+hilf+#13':'+befehl+':'#13'(Transdaten)')=cmcancel;
    end;
  end;
end;

procedure TSzene.LadeLicht(var f:text);
var posi:T3DRect;
    nam:groupstr;
    Farbe:TRGB;
    ende:boolean;

  procedure rechenfehler(argumente:string;err:integer);
  begin
    ende:=error(copy(argumente,1,err)+'_'+
                           copy(argumente,succ(err),length(argumente)-err))=cmcancel;
  end;

  function singlezahl:single;
  var h:single;
      err:integer;
  begin
    while pos(' ',argumente)=1 do system.delete(argumente,1,1);
    argumente:=argumente+' ';
    system.val(copy(argumente,1,pred(pos(' ',argumente))),h,err);
    if err<>0 then begin
      singlezahl:=berechne(argumente,0,0,err);
      if err<>0 then rechenfehler(argumente,err);
    end else singlezahl:=h;
    system.delete(argumente,1,pos(' ',argumente));
  end;


  procedure setzteGroupGetPos(var posi:T3DRect;var nam:groupstr;var Farbe:TRGB);
  var posii,path:string;
      HGroup:P3dGroup;
  begin
    farbe.r:=singlezahl;
    farbe.g:=singlezahl;
    farbe.b:=singlezahl;
    if pos(';',argumente)<>0 then begin
      path:=copy(argumente,2+(pos(':\',argumente)),255);
      posii:=copy(path,succ(pos(' ',path)),255);
      path:=copy(path,1,pred(pos(' ',path)));
      HGroup:=Root^.GetPfadGroup(path);
      if HGroup<>nil then SetObjekt(HGroup) else SetObjekt(Root);
      while pos('\',path)<>0 do system.delete(path,1,pos('\',path));
      nam:=path;
      path:=argumente;
      argumente:=posii;
      posi.t.x:=singlezahl;
      posi.t.y:=singlezahl;
      posi.t.z:=singlezahl;
      posi.r.x:=singlezahl;
      posi.r.y:=singlezahl;
      posi.r.z:=singlezahl;
      posi.s.x:=1;posi.s.y:=1;posi.s.z:=1;
      argumente:=path;
    end else begin
      SetObjekt(Root);
      posi:=E3DRect;{Hier sollten noch die Rumlichen Koordinaten der Lampenrichtung in Polarkooordinaten umgerechnet werden}
    end;
  end;

begin
  argumente:='';
  reset(f);
  zeile:=0;
  ende:=false;
  while not (eof(f) or ende) do begin
    lesezeile;
    if id(befehl,'UMGEBUNGSLICHT') then begin
      with daten.umgebungslicht do begin
        r:=singlezahl;
        g:=singlezahl;
        b:=singlezahl;
      end;
    end else if id(befehl,'SONNENLICHT') then begin
      setzteGroupGetPos(posi,nam,farbe);
      insertobjekt(new(PLicht,init(posi,@self,Sonne,farbe,1,0,15,90)));
    end else if id(befehl,'GLHLAMPE') then begin
      setzteGroupGetPos(posi,nam,farbe);
      delarg(3);
      insertobjekt(new(PLicht,init(posi,@self,Lampe,farbe,singlezahl,singlezahl,15,90)));
    end else if id(befehl,'SPOT') then begin
      setzteGroupGetpos(posi,nam,farbe);
      delarg(6);
      insertobjekt(new(PLicht,init(posi,@self,Spot,farbe,singlezahl,singlezahl,singlezahl,singlezahl)));
    end;
  end;
end;


constructor TSzene.lade(Aname:pathstr);
var suche:searchrec;
    buf:pointer;
    grose:word;
    dir:dirstr;
    nam:namestr;
    ext:extstr;
begin
  TSzene.Init(NoSubGroups);
  MouseCursor^.Update(scuhr,scnormalshape);
  fsplit(aname,dir,nam,ext);
  aname:=dir+nam+'.WIZ';
  Setname(aname);
  findfirst(aname,$3f,suche);
  if doserror=0 then begin
    assign(f,aname);
    if (memavail>suche.size*10+16000) then begin
      if suche.size<=$FFFF then grose:=suche.size else grose:=$FFFF;
      getmem(buf,grose);
      settextbuf(f,buf^,grose);
    end else buf:=nil;
    reset(f);
    Transdaten(f);
    Interpretiere(f,0);
    LadeLicht(f);
    system.close(f);
    if buf<>nil then freemem(buf,grose);
    if root^.current<>nil then setObjekt(root^.current);
  end else error('Ich konnte'#13+aname+#13'nicht laden !');
end;

{constructor TSzene.load(var s:TStream);
begin
end;}

destructor TSzene.done;
begin
  root^.putState(sfvisible,false);
  TWindow.Done; {Braucht noch die korrekte eintragung der Sichten}
{  if root<>nil then begin
    root^.state:=state and not sfvisible;
    (dispose(root,done);)
  end;}
  while Sichten^.count>0 do Sichten^.atdelete(0); {Die Eintrge werden erst durch Twindow richtig freigegeben}
  Dispose(Sichten,Done);
end;

{procedure TSzene.Store(var s:TStream);
begin
end;}

Procedure TSzene.sichern;
var f:text;
    n:byte;
    dir:dirstr;
    nam:namestr;
    ext:extstr;
    FileName: FNameStr;

  function notschwarz(f:trgb):boolean;
  begin
    notschwarz:=(f.r<>0) or (f.g<>0) or (f.b<>0);
  end;

begin
  if getname='NONAME' then begin
    FileName := '';
    if ExecDialog(New(PFileDialog, Init('*.WIZ', 'Speichern unter',
      '~N~ame', fdOkButton, 101)), @FileName) <> cmCancel then setname(FileName);
  end;
  MouseCursor^.Update(scuhr,scnormalshape);
  fsplit(name,dir,nam,ext);
  assign(f,dir+nam+'.WIZ');
  rewrite(f);
  with daten do begin
    if (flag and sfAutoSave)>0 then writeln(f,'BildDatei ',Nam)
    else writeln(f,';Bild ',nam);
    writeln(f,'XMin ',xmin:5:3,' YMin ',ymin:5:3,' XSize ',xsize:5:3);
    writeln(f,'Abstand ',vpd:5:3,' FPD ',fpd:5:3,' BPD ',bpd:5:3);
    writeln(f,'Blickpunkt ',VRP.x:5:3,' ',VRP.y:5:3,' ',VRP.z:5:3);
    writeln(f,'Standpunkt ',NRP.x:5:3,' ',NRP.y:5:3,' ',NRP.z:5:3);
    writeln(f,'Achsenrichtung ',vup.x:5:3,' ',vup.y:5:3,' ',vup.z:5:3);
    if (flag and sfFlipAreaEnabled)>0 then writeln(f,'Rckflchen');
    if (flag and sfWireFrame)>0 then writeln(f,'DrahtGitter');
    if (flag and sfTrifillenabled)>0 then {writeln(f,'')};
    if (flag and sfshadingmethod)>0 then {writeln(f,'')};
    if (flag and sfLampe)>0 then writeln(f,'Lampen ',lampen1:2,' ',lampen2:2,
      ' ',lampeskalierung:5:3,' ',lampeskalierung:5:3,' ',lampeskalierung:5:3);
    if (flag and sfclipcube)>0 then writeln(f,'ClipWrfel');
    if (flag and sfNebel)>0 then writeln(f,'Nebel ',Nebel:5:3,' ',
             nebelcolor.r:5:3,' ',nebelcolor.g:5:3,' ',nebelcolor.b:5:3);
    if (flag and sfbrille)>0 then writeln(f,'3D-Brille ',augendist:5:3);
    if (flag and sfframe)>0 then writeln(f,'Rahmen');
    if (flag and sffarbig)=0 then
    if (flag and sfsw256)<>0 then writeln(f,'SW256') else begin
      write(f,'SchwarzWei ');
      for n:=0 to 3 do write(f,GreyTab[n].r:5:3,' ',GreyTab[n].g:5:3,' ',GreyTab[n].b:5:3,' ');
      writeln(f);
    end;
    if notSchwarz(bkcolor) then writeln(f,'Hintergrund ',bkcolor.r:5:3,' ',bkcolor.g:5:3,' ',bkcolor.b:5:3);
    if (flag and (sfInteraktivMaus or sfInteraktivJoystick))>0 then begin
      write(f,'Interaktiv ');
      if (flag and (sfInteraktivMaus or sfInteraktivJoystick)=(sfInteraktivMaus or sfInteraktivJoystick))
      then write(f,'JoyMaus ')
      else if (flag and sfInteraktivMaus)>0
      then write(f,'Maus ')
      else if (flag and sfInteraktivJoystick)>0
      then write(f,'Joystick ');
      if (flag and sfVariablenAnzeigen)>0 then write(f,'Daten') else write(f,'Nichts');
      writeln(f,'');
    end;
    if (Darstellung and dfHigh)>0 then writeln(f,'SCQ')
    else if (Darstellung and dfLow)>0 then writeln(f,'IBM');
    if (Darstellung and dfRam)>0 then writeln(f,'RAM ',xmax:3,' ',ymax:3)
    else if (Darstellung and dfMagicPic)>0 then writeln(f,'MagicPicture ',xmax:3,' ',ymax:3)
    else if (Darstellung and dfTrueColor)>0 then writeln(f,'TrueColor ',xmax:3,' ',ymax:3);
    if (Darstellung and dfkoordinaten)>0 then writeln(f,'Koordinaten')
    else if (Darstellung and dfxz)>0 then write(f,'ZX')
    else if (Darstellung and dfyz)>0 then write(f,'YZ')
    else if (Darstellung and dfxy)>0 then write(f,'XY')
    else if (Darstellung and dfgesamt)>0 then write(f,'Gesamtplan');
    if ((Darstellung and (dfxz or dfYZ or dfXY or dfgesamt))>0) and
       (Darstellung and dfkoordinaten=0)
    then writeln(f,' ',mass:5:3);
    with umgebungslicht do if (r<>0) or (g<>0) or (b<>0) then writeln(f,'Umgebungslicht ',r:5:3,' ',g:5:3,' ',b:5:3);
  end;
  if not Root^.SichereLicht(f) then writeln(f,'Licht');
  CorNameCount:='A';
  Root^.CorrectName;
  writeln(f,'GoSub '+Root^.getname);
  writeln(f,'Ende');
  New(sichereGosub,init(10,10));
  Root^.sichern(f);
  dispose(sichereGosub,done);
  system.close(f);
  gesichert:=true;
end;

procedure TSzene.SetName(Aname:Pathstr);
var Dir:DirStr;
    Ext: ExtStr;
begin
  Name:=AName;
  FSplit(AName,Dir,AName,Ext);
  if length(ext)<4 then ext:='.WIZ';
  SetTitle(AName+Ext);
  root^.setname(aname);
end;

function Tszene.GetName:Pathstr;
var Dir:DirStr;
    Ext: ExtStr;
    aname:namestr;
begin
  FSplit(Name,Dir,AName,Ext);
  getname:=aname;
end;

function TSzene.getpalette:PPalette;
const PSzene: String[length(CDialog)] = CDialog;
begin
  getpalette:=@PSzene;
end;

procedure TSzene.handleevent(var event:TEvent);
var myevent:boolean;
    hcurrentobjekt:P3DView;
    hobjekt:Pview;
    hpara:TParamData;

  procedure LadeRotationskoerper;
  var
    FileName: FNameStr;
  begin
    FileName := '*.RIS';
    if ExecDialog(New(PFileDialog, Init('*.RIS', 'Suche den Rotationskrper aus',
      '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then begin
      hcurrentobjekt:=new(PRotationskoerper,init(e3DRect,@self,FileName,10,360));
    end else hcurrentobjekt:=nil;
  end;

  procedure LadeZiehkoerper;
  var
    FileName: FNameStr;
  begin
    FileName := '*.RIS';
    if ExecDialog(New(PFileDialog, Init('*.RIS', 'Suche den Ziehkrper aus',
      '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then begin
      hcurrentobjekt:=new(PZiehKoerper,init(e3DRect,@self,FileName,10));
    end else hcurrentobjekt:=nil;
  end;

  procedure LadeObjekt;
  var
    FileName: FNameStr;
  begin
    FileName := '*.OBT';
    if ExecDialog(New(PFileDialog, Init('*.OBT', 'Suche das Objekt aus',
      '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then begin
      hcurrentobjekt:=new(PObjekt,init(e3DRect,@self,FileName,xdat+ydat+zdat+texturdat+materialdat+sichtdat));
    end else hcurrentobjekt:=nil;
  end;

  procedure LadeMesh;
  var
    FileName: FNameStr;
  begin
    FileName := '*.OBT';
    if ExecDialog(New(PFileDialog, Init('*.OBT', 'Suche ein Ausgangsobjekt aus',
      '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then begin
      hcurrentobjekt:=new(PMeshObj,init(e3DRect,@self,FileName));
      PMeshObj(hcurrentobjekt)^.ladeMesh(FileName);
    end else hcurrentobjekt:=nil;
  end;

  procedure change(w:word;enable:boolean);
  begin
    if aktobjekt<>nil then begin
      gesichert:=false;
      if No3DGroup(aktobjekt)
      then P3DView(aktobjekt)^.ChangeDarstellung(w,enable)
      else P3DGroup(aktobjekt)^.ChangeDarstellung(w,enable)
    end;
  end;

  procedure Gruppieren;
  begin
    if (aktobjekt<>nil) then begin
      gesichert:=false;
      if No3DGroup(aktobjekt) then P3DGroup(P3DView(aktobjekt)^.owner)^.Gruppieren
      else P3DGroup(aktobjekt)^.Gruppieren;
    end;
  end;

  procedure EntGruppieren;
  begin
    if (aktobjekt<>nil) and not No3DGroup(aktobjekt)
    then begin
      P3DGroup(aktobjekt)^.EntGruppieren;
      gesichert:=false;
    end;
  end;

{     
   Type TGreyTab=array[0..3] of Trgb;
     PDaten=^TDaten;
     TDaten=record
       Flag:Word;
       Darstellung:Word;
       XMIN:single;
       YMIN:single;
       XSIZE:single;
       VPD:single;
       FPD:single;
       BPD:single;
       mass:single;
       augendist:single;
       Nebel:single;
       Lampen1,Lampen2:byte;
       LampeSkalierung:Single;
       xmax,ymax:word;
       VRP,NRP,VUP:T3DPoint;
       bkcolor,nebelcolor,umgebungslicht:Trgb;
       GreyTab:TGreyTab;
     end;

      dfkoordinaten=0;
      dfxz=1;
      dfYZ=2;
      dfXY=3;
      dfgesamt=4;
      dfHigh=8;
      dfLow=16;

     }

  procedure SzeneParamDlg;
  var h:PSzeneParamDialog;
      r:TRect;
      V:PView;

    procedure farbe(s:string;x,y:word);
    begin
      with h^ do begin
        r.assign(x,y+10,x+100,y+40);
        v:=new(PFarbRegler,init(r));
        insert(v);
        r.assign(x,y,x+130,y+10);
        insert(new(Plabel,init(r,s,v)));
      end;
    end;

    procedure posin(s:pathstr;x,ho:word);
    var b:PView;
    begin
      b:=zahl(h,'X',x,ho+10,5,2,-1000,1000,TypSingle);
      r.assign(x,ho,x+100,ho+10);
      h^.insert(new(PLabel,init(r,s,b)));
      zahl(h,'Y',x,ho+25,5,2,-1000,1000,TypSingle);
      zahl(h,'Z',x,ho+40,5,2,-1000,1000,TypSingle);
    end;

  begin
    r.assign(0,0,400,400);
    new(h,init(r,'Szenen Parameter'));
    h^.options:=h^.options or ofCentered;
    with h^ do begin
      r.assign(20,30,380,82);
      V:=New(PCheckBoxes,init(r,NewSItem('~F~lip',NewSItem('~D~rahtgitter',
        {NewSItem('F~~llen',NewSItem('~G~ouraud',}NewSItem('~L~ampe',
        NewSItem('~C~lip',NewSItem('~3~D-Brille',
        NewSItem('~R~ahmen',NewSItem('F~a~rbig',NewSItem('~S~W256',
        NewSItem('~N~ebel',NewSItem('S~i~chern',nil{))}))))))))))));
      insert(v);
      r.assign(20,20,380,30);
      insert(new(PLabel,init(r,'~V~erschiedenes',v)));

      r.assign(20,94,380,136);
      V:=New(PCheckBoxes,init(r,NewSItem('~K~oordinaten',NewSItem('~X~Z',
        NewSItem('Y~Z~',NewSItem('X~Y~',NewSItem('~G~esamt',
        NewSItem('~H~och',NewSItem('~N~iedrig',
        NewSItem('~R~AM',NewSItem('~T~rueColor',NewSItem('~M~agic',nil))))))))))));
      insert(v);
      r.assign(20,84,380,94);
      insert(new(PLabel,init(r,'~D~arstellung',v)));

      zahl(h,'~X~Min   ',20,141,5,2,-1000,1000,TypSingle);
      zahl(h,'~Y~Min   ',20,156,5,2,-1000,1000,TypSingle);
      zahl(h,'X~S~ize  ',20,171,5,2,-1000,1000,TypSingle);

      zahl(h,'V~P~D    ',160,141,5,2,-1000,1000,TypSingle);
      zahl(h,'~F~PD    ',160,156,5,2,-1000,1000,TypSingle);
      zahl(h,'~B~PD    ',160,171,5,2,-1000,1000,TypSingle);

      zahl(h,'A~b~stand',20,186,5,2,-1000,1000,TypSingle);
      zahl(h,'A~u~gen  ',20,201,5,2,-1000,1000,TypSingle);
      zahl(h,'~N~ebel  ',20,216,5,2,-1000,1000,TypSingle);

      zahl(h,'LampeN~1~',160,186,5,2,-1000,1000,TypByte);
      zahl(h,'LampeN~2~',160,201,5,2,-1000,1000,TypByte);
      zahl(h,'~L~ampeS ',160,216,5,2,-1000,1000,TypSingle);

      zahl(h,'X~M~ax   ',20,231,4,0,0,4096,TypWord);
      zahl(h,'YM~a~x   ',160,231,4,0,0,4096,TypWord);

      Posin('B~l~ickpunkt',20,250);
      Posin('S~t~andpunkt',120,250);
      Posin('~O~ben',220,250);

      r.assign(20,310,380,320);
      insert(new(PMischFarbe,init(r)));

      farbe('~H~intergrund',20,325);
      farbe('N~e~bel',140,325);
      farbe('~U~mgebungslicht',260,325);

      r.assign(20,370,100,390);
      Insert(new(PButton,init(r,'~O~k',cmOk,bfdefault)));
      r.assign(120,370,200,390);
      Insert(new(PButton,init(r,'~C~ancel',cmCancel,bfnormal)));

      r.assign(220,370,300,390);
      Insert(new(PButton,init(r,'L~a~den',cmLadePosition,bfnormal)));

    end;
    if ExecDialog(h,@Daten)=cmOk then gesichert:=false;
  end;

  procedure RevAufObj;
  var Ort,Richtung:T3DPoint;
  begin
    If (aktobjekt<>nil) then begin
      PushTrafs;
      PushOC_MC;
      if No3DGroup(aktobjekt) then begin
        P3DGroup(aktobjekt^.owner)^.CorrectMC_WC;
        MulMC_WC(P3DView(aktobjekt)^.OC_MC);
        CalcOrtRichtung(Ort,Richtung);
        Rev^.MoveTo(Ort);
      end else if TypeOf(AktObjekt^)=TypeOf(TRoot)
      then Rev^.MoveTo(e3drect.t)
      else begin
        P3DGroup(AktObjekt)^.CorrectMC_WC;
        CalcOrtRichtung(Ort,Richtung);
        Rev^.MoveTo(Ort);
      end;
      PopOC_MC;
      PopTrafs;
    end;
  end;

  procedure SichernAls;
  var FileName: FNameStr;
  begin
    FileName := '';
    if ExecDialog(New(PFileDialog, Init('*.WIZ', 'Speichern unter',
      '~N~ame', fdOkButton, 101)), @FileName) <> cmCancel then begin
      setname(FileName);
      sichern;
    end;
  end;

  procedure Sichere;
  var aktszene:PSzene;
  begin
    if getname='NONAME' then SichernAls else sichern;
  end;

begin
  if (event.what and evcommand>0) and
     ((event.command=cmcancel) or (event.command=cmclose)) then begin
    clearevent(event);
    if not gesichert then begin
      if (wizopt.autosave and asSzene>0) then sichern else begin
        case MessageBox(name+#13'ist gendert worden. Sichern?',
        nil, mfInformation + mfYesNoCancel ) of
          cmYes:sichern;
          cmCancel:exit;
        end;
      end;
      gesichert:=true;
    end;
    if getstate(sfmodal) then endmodal(cmcancel)
    else dispose(PSzene(@self),done);
    exit;
  end;
  Rev^.handleevent(event);
  TWindow.handleevent(event);
  if event.what and evcommand>0 then begin
    myevent:=true;
    case event.command of
      cmSave:Sichere;
      cmSaveAs:SichernAls;
      cmGetSzene:;
      cmSzenenParameter:SzeneParamDlg;
      cms3Dan:change(dsobjekt,true);
      cms3Daus:change(dsobjekt,false);
      cmsXYZan:change(dsKoorsys,true);
      cmsXYZaus:change(dsKoorsys,false);
      cmGruppieren:gruppieren;
      cmEntGruppieren:EntGruppieren;
      cmSichern:sichern;
      cmGruppeE:If (aktobjekt<>nil) and (TypeOf(AktObjekt^)=TypeOf(T3DGroup))
                then P3DGroup(aktobjekt)^.GruppeE;
      cmGruppeAufRev:If (aktobjekt<>nil) and (TypeOf(AktObjekt^)=TypeOf(T3DGroup))
                then P3DGroup(aktobjekt)^.GruppeAufRev;
      cmRevAufObj:RevAufObj;
      cmLoeschen:if (aktobjekt<>nil) and (TypeOf(aktobjekt^)<>TypeOf(Troot)) then begin
                   gesichert:=false;
                   hobjekt:=aktobjekt^.next;
                   if hobjekt=aktobjekt then hobjekt:=aktobjekt^.owner;
                   if not No3DGroup(aktobjekt)
                   then P3DGroup(aktobjekt)^.ChangeDarstellung(dskoorsys+dsobjekt,false);
                   dispose(aktobjekt,done);
                   setObjekt(hObjekt);
                   HObjekt^.Focus;
                 end;
      cmObjektParameter:if (aktobjekt<>nil) and No3DGroup(aktObjekt)
        then begin
          P3DView(aktobjekt)^.ExecObjektDialog(@hpara);
          gesichert:=false;
        end;
      else myevent:=false;
    end;
    if myevent then clearevent(event)
    else begin
      myevent:=true;
      case event.command of
        cmkugel:hcurrentobjekt:=new(PKugel,init(e3DRect,@self,10,10));
        cmEbene:hcurrentobjekt:=new(PEbene,init(e3DRect,@self,10,10));
        cmSaule:hcurrentobjekt:=new(PSaule,init(e3DRect,@self,10,10));
        cmDose:hcurrentobjekt:=new(PDose,init(e3DRect,@self,10,10,2));
        cmTorus:hcurrentobjekt:=new(PTorus,init(e3DRect,@self,1,0.2,10,6));
        cmDreieck:hcurrentobjekt:=new(PDreieck,init(e3DRect,@self,pd1,pd2,pd3));
        cmViereck:hcurrentobjekt:=new(PViereck,init(e3DRect,@self,pv1,pv2,pv3,pv4));
        cmRotationskoerper:ladeRotationskoerper;
        cmZiehKoerper:ladeZiehKoerper;
        cmObjekt:ladeObjekt;
        cmMesh:ladeMesh;
        cmLicht:hcurrentobjekt:=new(PLicht,Init(e3DRect,@self,Lampe,Weiss,1,0,15,90));
        else myevent:=false;
      end;
      if myevent then begin {Neues Objekt einfgen}
        clearevent(event);
        if Application^.Validview(hcurrentobjekt)<>nil then begin
          gesichert:=false;
          if aktobjekt<>nil then begin
            if No3DGroup(aktobjekt) then P3DGroup(aktobjekt^.owner)^.CorrectMC_WC
            else P3DGroup(aktobjekt)^.CorrectMC_WC;
          end else SetMC_WC(E);{Root}
          insertobjekt(hcurrentobjekt);
          {hcurrentobjekt^.drawview;}
          gesichert:=false;
        end;
      end
    end;
  end else if (event.what and evbroadcast>0) and (event.command=cmsaveall) then begin
    if not gesichert then begin
      if (wizopt.autosave and asSzene>0) then sichern else begin
        case MessageBox(name+#13'ist gendert worden. Sichern?',
        nil, mfInformation + mfYesNoCancel ) of
          cmYes:sichern;
          cmCancel:clearevent(event);
        end;
      end;
    end;
  end;
{  if (event.what<>evnothing) and (aktobjekt<>nil) then aktobjekt^.handleevent(event);}
end;

procedure TSzeneParamDialog.Handleevent(var event:TEvent);

  procedure LadePosition;
  var
    NeuDaten:TDaten;
    FileName: FNameStr;
    dir:dirstr;
    name:namestr;
    ext:extstr;
    error:boolean;


    {Standpunkt   0.002  3.464  3.027
Blickpunkt   0.000  0.000  0.000
Achsenrichtung   0.000  0.000  1.000
Abstand   4.600
XSize   3.600
XMin  -1.400
YMin  -1.200
BPD  -5.000
FPD   5.000
}

  function singlezahl:single;
  var err:integer;
      s:single;
  begin
    while pos(' ',argumente)=1 do system.delete(argumente,1,1);
    argumente:=argumente+' ';
    system.val(copy(argumente,1,pred(pos(' ',argumente))),s,err);
    system.delete(argumente,1,pos(' ',argumente));
    if err=0 then singlezahl:=s else begin
      singlezahl:=1;
      error:=true;
    end;
  end;

  begin
    error:=false;
    FileName := '*.POS';
    if ExecDialog(New(PFileDialog, Init('*.POS', 'Suche eine Position aus',
      '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then begin
      fsplit(filename,dir,name,ext);
      assign(f,filename);
      reset(f);
      argumente:='';
      GetData(NeuDaten);
      while not eof(f) do begin
        lesezeile;
        if id(befehl,'STANDPUNKT') then begin
          neuDaten.NRP.x:=singlezahl;
          neuDaten.NRP.y:=singlezahl;
          neuDaten.NRP.z:=singlezahl;
        end else
        if id(befehl,'BLICKPUNKT') then begin
          neuDaten.VRP.x:=singlezahl;
          neuDaten.VRP.y:=singlezahl;
          neuDaten.VRP.z:=singlezahl;
        end else
        if id(befehl,'ACHSENRICHTUNG') then begin
          neuDaten.VUP.x:=singlezahl;
          neuDaten.VUP.y:=singlezahl;
          neuDaten.VUP.z:=singlezahl;
        end else
        if id(befehl,'ABSTAND') then begin
          neuDaten.VPD:=singlezahl;
        end else
        if id(befehl,'XSIZE') then begin
          neuDaten.XSIZE:=singlezahl;
        end else
        if id(befehl,'XMIN') then begin
          neuDaten.XMIN:=singlezahl;
        end else
        if id(befehl,'YMIN') then begin
          neuDaten.YMIN:=singlezahl;
        end else
        if id(befehl,'BPD') then begin
          neuDaten.BPD:=singlezahl;
        end else
        if id(befehl,'FPD') then begin
          neuDaten.FPD:=singlezahl;
        end;
      end;
      system.close(f);
      if not error then SetData(NeuDaten);
    end;
  end;

begin
  TDialog.Handleevent(event);
  if (event.what=evcommand) and (event.command=cmLadePosition) then begin
    clearevent(event);
    LadePosition;
  end;
end;

procedure TSzene.draw;
begin
  if state and sfvisible>0 then begin
    if root<>nil then root^.state:=root^.state and not sfvisible;
    if rev<>nil then rev^.state:=rev^.state and not sfvisible;
    TWindow.Draw;
    Male;
  end;
end;

procedure Tszene.Male;
begin
  if root<>nil then root^.draw;
  if (rev<>nil) and rev^.visible then rev^.draw;
end;

procedure TSzene.MaleSicht(sicht:PSicht);
begin
  if root<>nil then root^.MaleSicht(sicht);
end;

function TSzene.GetHlpCtx:Word;
begin
  if aktObjekt<>nil then gethlpctx:=aktObjekt^.HelpCtx
  else Gethlpctx:=helpctx;
end;

function TSzene.GetInsertGroup:p3dgroup;
begin
  if aktobjekt<>nil then begin
    if No3DGroup(aktobjekt) then GetInsertGroup:=p3dgroup(aktobjekt^.owner)
    else GetInsertGroup:=P3DGroup(aktobjekt);
  end else GetInsertGroup:=root;
end;

procedure TSzene.InsertObjekt(objekt:PView);
begin
{  if aktobjekt<>nil then begin
    if No3DGroup(aktobjekt) then aktobjekt^.owner^.insert(objekt)
    else P3DGroup(aktobjekt)^.insert(objekt);
  end else root^.insert(objekt);}
  getinsertGroup^.insert(objekt);
  SetObjekt(objekt);
end;

function TSzene.getaktGruppe:P3DGroup;
begin
  if aktobjekt=nil then getAktGruppe:=nil
  else if No3dGroup(aktobjekt) then GetAktGruppe:=P3DGroup(aktobjekt^.owner)
  else GetAktGruppe:=P3DGroup(AktObjekt);
end;

function TSzene.getcurrentObjekt:P3DView;
begin
  if aktobjekt=nil then GetCurrentObjekt:=nil
  else if no3dGroup(aktObjekt) then GetCurrentObjekt:=P3DView(aktObjekt)
  else GetCurrentObjekt:=P3DGroup(aktobjekt)^.getcurrentObjekt;
end;

procedure TSzene.SetObjekt(o:PView);
var p:T3DPoint;
begin
  aktobjekt:=o;
  if o<>nil then begin
    if TypeOf(o^)=TypeOf(T3DGroup) then begin
      disposestr(GruppeText^);
      GruppeText^:=NewStr(P3DGroup(o)^.getname);
      P3DGroup(o^.owner)^.CorrectMC_WC;
    end else if TypeOf(o^)=TypeOf(TRoot) then begin
      disposestr(WurzelText^);
      WurzelText^:=NewStr(PRoot(o)^.getname);
      PRoot(o)^.correctMC_WC;
    end else begin
      disposestr(ObjektText^);
      ObjektText^:=NewStr(P3DView(o)^.getname);
      P3DGroup(o^.owner)^.CorrectMC_WC;
    end;
    StatusLine^.DrawView;
    if Bewegung<>nil then begin
      Bewegung^.calcposi(o,p);
      Bewegung^.UpdatePosi(p);
    end;
  end;
end;

end.