unit joystick;
interface
uses crt;

function paddle(Nr:integer):integer; {0..3}
function switch(nr:integer):boolean; {0..3}
function buttonpressed:boolean;
function initjoystick(nr:byte;pos:byte):boolean;
function initjoysticktext(nr:byte):boolean;
{procedure getpos(x,y:integer;tasten:byte);
procedure setxy(nr:byte;x,y:integer);}
function joystickvorhanden(nr:byte):boolean; {0..1}

var maxpos:array[0..1,0..1,0..1] of integer;
                {        0=Oben/Links 1=Unten/Rechts}
                {     0=Links/Rechts 1=Hoch/Runter   }
                {Joystick Nr.0/1                      }
implementation

function paddle(Nr:integer):integer;
var h:integer;

function timetoresetbit(nr:integer):integer;
begin
  nr:=(1 shl nr);
  inline($b9/$00/$00/
         $ba/$01/$02/
         $8B/$9E/NR/
         $EC/
         $85/$C3/
         $74/$07/
         $41/
         $81/$F9/$FF/$7F/
         $75/$F4/
         $89/$8E/NR);
  TIMETORESETBIT:=NR;
end;

begin
  h:=timetoresetbit(nr);
  inline($FA/
         $EE);
  paddle:=timetoresetbit(Nr);
  inline($FB);
end;

function switch(nr:integer):boolean;
begin
  switch:=(port[$201] and (16 shl NR))=0;
end;

function buttonpressed:boolean;
begin
  buttonpressed:=switch(0) or switch(1) or switch(2) or switch(3);
end;

function initjoystick(nr:byte;pos:byte):boolean;
var timeout:word;
begin
  timeout:=6000;
  repeat
    dec(timeout);
    delay(1);
  until ((timeout=0) or buttonpressed);
  if (Timeout=0) then initjoystick:=false else initjoystick:=true;
  maxpos[nr,0,pos]:=paddle(nr*2);
  maxpos[nr,1,pos]:=paddle(succ(nr*2));
end;

function initjoysticktext(nr:byte):boolean;
begin
  writeln;
  initjoysticktext:=true;
  writeln('Halten Sie den ',succ(nr),'. Joystick nach links oben und drcken Sie einen Feuerknopf !');
  if not initjoystick(nr,0) then begin
    initjoysticktext:=false;
    writeln('Timeout: Sie haben keine Taste gedrckt !',^G);
  end;
  delay(500);
  writeln('Halten Sie den ',succ(nr),'. Joystick nach rechts unten und drcken Sie einen Feuerknopf !');
  if not initjoystick(nr,1) then begin
    writeln('Timeout: Sie haben keine Taste gedrckt !',^G);
    initjoysticktext:=false;
  end;
end;

function joystickvorhanden(nr:byte):boolean;
var zahler:byte;
begin
  zahler:=100;
  port[$201]:=0;
  repeat
    dec(zahler);
    delay(1);
  until ((zahler=0) or ((port[$201] and (3 shl (2*nr)))=0));
  joystickvorhanden:=(zahler<>0);
end;

end.