program Anti_Aliasing;
uses vga,dos,crt,UPic,wizinfo;
var aktpal,pnormal,prgb,psw256,p3d:ppalette;
const headlength=15;
Type THeader=array[0..headlength] of char;
const TrueColor=0;
      NormalPal=1;
      RGBPal=2;
      SW256Pal=3;
      Pal3D=4;
      SCQSave=8;
      header:THeader=('W','i','z','A','r','t',' ','P','i','c','t','u','r','e',#$00,#$1A);
var palnr:byte;
    ein:char;
    datname:pathstr;

procedure bildname;
var dir:dirstr;
    name:namestr;
    ext:extstr;
    suche:searchrec;
begin
  if paramcount<>0 then datname:=paramstr(1) else
  if getinfo<>'' then begin
    fsplit(getinfo,dir,name,ext);
    datname:=dir+name;
  end else begin
    textbackground(blue);
    textcolor(yellow);
    clrscr;
    writeln('***  Anti Aliasing  ***');
    writeln;
    writeln('320*200 TrueColor Bilder werden in 320*200 8bit Bilder verwandelt.');
    writeln('640*400 TrueColor Bilder werden in 320*200 8bit Anti Aliasing Bilder verwandelt.');
    writeln('640*400 SW256 Bilder werden in 320*200 SW256 Anti Aliasing Bilder verwandelt.');
    writeln;
    writeln('Folgende Bilder knnen Sie laden:');
    writeln;
    suche.name:='*.PIC';
    findfirst('*.PIC',$3f,suche);
    if (Doserror<>0) then writeln('keine':10);
    while (doserror=0) do begin
      write(suche.name:20);
      findnext(suche);
    end;
    writeln;
    write('Geben Sie den Bildnamen ein (ohne Extension) : ');
    readln(datname);
  end;
  suche.name:='*.PIC';
  findfirst(datname+'.PIC',$3f,suche);
  if doserror<>0 then begin
    writeln(datname+'.PIC nicht gefunden !');
    halt(1);
  end
  else setinfo(datname+'.PIC');
end;


procedure coldotrgb(x,y:integer; r,g,b:integer);
var cmp,
    ri,gi,bi,
    rr,gr,br:integer;
    hilf:byte;
const dm:array[0..3,0..3] of byte =
         ((0,8,2,10),(12,4,14,6),
          (3,11,1,9),(15,7,13,5));
begin
  cmp:=dm[x and 3,y and 3];
  if r<0 then ri:=0 else if r>63 then ri:=7 else begin
    ri:=r shr 3-1;
    rr:=(r and 7) shl 1;
    if rr>cmp then inc(ri)
    else if ri<0 then ri:=0;
  end;
  if g<0 then gi:=0 else if g>63 then gi:=7 else begin
    gi:=g shr 3-1;
    gr:=(g and 7) shl 1;
    if gr>cmp then inc(gi)
    else if gi<0 then gi:=0;
  end;
  if b<0 then bi:=0 else if b>63 then bi:=7 else begin
    bi:=b shr 4-1;
    br:=b and 15;
    if br>cmp then inc(bi)
    else if bi<0 then bi:=0;
  end;
  mem[$A000:320*y+x]:=ri*32+gi*4+bi;
end;

function LoadBild(name:pathstr;var palnr:byte):boolean;
type PRGBARRAY=^TRGBArray;
     TRGBArray=array[0..49,0..319,0..2] of byte;
     PRGBARRAY2=^TRGBArray2;
     TRGBArray2=array[0..19,0..639,0..2] of byte;
     PRGBARRAY3=^TRGBArray3;
     TRGBArray3=array[0..19,0..639] of byte;
     PRGBARRAY4=^TRGBArray4;
     TRGBArray4=array[0..79,0..639] of byte;
var f:file;
    r,y,n:byte;
    dir:dirstr;
    nam:namestr;
    ext:extstr;
    x,xmax,ymax:word;
    wizpic:boolean;
    buf:PRGBArray;
    buf2:PRGBArray2;
    buf3:PRGBArray3;
    buf4:PRGBArray4;
    head:THeader;
    c:array[0..2] of byte;
    gd,gm:integer;
begin
  fsplit(name,dir,nam,ext);
  assign(f,dir+nam+'.PIC');
  reset(f,1);
  blockread(f,head,sizeof(head));
  wizpic:=true;
  for n:=0 to headlength do wizpic:=wizpic and (head[n]=header[n]);
  if wizpic then begin
    blockread(f,palnr,sizeof(palnr));
    blockread(f,xmax,sizeof(xmax));
    blockread(f,ymax,sizeof(ymax));
    LoadBild:=true;
    if (xmax=320) and (ymax=200) and (palnr=TrueColor) then begin
      new(buf);
      videomodus($13);
      shadein(0,prgb);
      for n:=0 to 3 do begin
        blockread(f,buf^,sizeof(buf^));
        for y:=0 to 49 do for x:=0 to 319 do coldotrgb(x,y+50*n,buf^[y,x,0] shr 2,buf^[y,x,1] shr 2,buf^[y,x,2] shr 2);
      end;
      dispose(buf);
    end else
    if (xmax=640) and (ymax=400) then begin
      if (palnr=TrueColor) then begin
        new(buf2);
        videomodus($13);
        shadein(0,prgb);
        for n:=0 to 19 do begin
          blockread(f,buf2^,sizeof(buf2^));
          for y:=0 to 9 do for x:=0 to 319 do begin
            for r:=0 to 2 do c[r]:=(word(buf2^[y*2,x*2,r])+word(buf2^[succ(y*2),x*2,r])+
                word(buf2^[succ(y*2),succ(x*2),r])+word(buf2^[y*2,succ(x*2),r])) div 16;
            coldotrgb(x,y+10*n,c[0],c[1],c[2]);
          end;
        end;
        dispose(buf2);
      end else if palnr=sw256pal then begin
        new(buf3);
        videomodus($13);
        shadein(0,psw256);
        for n:=0 to 19 do begin
          blockread(f,buf3^,sizeof(buf3^));
          for y:=0 to 9 do for x:=0 to 319 do
            mem[$A000:320*(y+10*n)+x]:=(word(buf3^[y*2,x*2])+word(buf3^[succ(y*2),x*2])+
                word(buf3^[succ(y*2),succ(x*2)])+word(buf3^[y*2,succ(x*2)])) div 4;
        end;
        dispose(buf3);
      end;
    end else LoadBild:=false;
    close(f);
    palnr:=palnr and not SCQSave;
  end else LoadBild:=false;
end;

procedure setfarbe(var p:ppalette;register:word;rot,gruen,blau:byte);
begin
  p^[register,0]:=rot;p^[register,1]:=gruen;p^[register,2]:=blau;
end;

procedure calcclutrgb;
var r,b,g,redi,greeni,bluei,colorindex:integer;
begin
  new(prgb);
  for r:=0 to 7 do begin
    redi:=r*9;
    for g:=0 to 7 do begin
      greeni:=g*9;
      for b:=0 to 3 do begin
        bluei:=b*21;
        colorindex:=(r shl 3 or g) shl 2 or b;
        setfarbe(prgb,colorindex,redi,greeni,bluei);
      end;
    end;
  end;
end;

procedure calcclutnormal;
var f:byte;
begin
  new(pnormal);
  for f:=0 to 63 do setfarbe(pnormal,f,f,0,0);
  for f:=0 to 63 do setfarbe(pnormal,f+64,0,f,0);
  for f:=0 to 63 do setfarbe(pnormal,f+128,0,0,f);
  for f:=0 to 63 do setfarbe(pnormal,f+192,f,f,f);
end;

procedure calcclutsw256;
var n,f,m:byte;
begin
  new(psw256);
  for n:=0 to 62 do begin
    f:=n*4;
    setfarbe(psw256,f,n,n,n);
    setfarbe(psw256,succ(f),succ(n),n,n);
    if n<62 then setfarbe(psw256,f+2,succ(n),n,n+2) else setfarbe(psw256,f+2,succ(n),n,n+1);
    setfarbe(psw256,f+3,n,succ(n),succ(n));
  end;
  for m:=0 to 3 do setfarbe(psw256,63*4+m,n,n,n);
end;

procedure calcclut3d;
var n,m:byte;
begin
  new(p3d);
  for m:=0 to 15 do for n:=0 to 15 do setfarbe(p3d,m*16+n,
       round(m*63/15),
       round(n*63/15),
       0);
end;


begin
  if paramcount>0 then begin
    aktpal:=nil;
    calcclutrgb;
    calcclutnormal;
    calcclutsw256;
    calcclut3d;
    bildname;
    loadbild(datname,palnr);
    case palnr of
      1:aktpal:=pnormal;
      2:aktpal:=prgb;
      3:aktpal:=psw256;
      4:aktpal:=p3d;
    end;
    savebild(paramstr(1)+'S',-1,false,1);
  end;
end.