unit dreid;
interface
uses crt,dos,graph,vga,ems,UPic;
const bgipath='';
      epsilon=1E-30;
      maxpnts=50;
      pysscrsizex=24.0;
      pysscrsizey=17.0;
      colrange:byte = 64;
      xdat=1;
      ydat=2;
      zdat=4;
      nrmdat=8;
      texturdat=16;
      materialdat=32;
      realdat=64;
      sichtdat=128;
      maxxdef=4096;
      maxydef=4096;
{      kartemaxx:word=359;
      kartemaxy:word=479;}
      flaeche=true;
      koerper=false;
      normal=0;
      isvis=1;
      isinnpc=2;
      isinwc=4;
      isindc=8;
      notused=16;
      gouraud=true;
      flat=false;
      freierSpeicher=$FFFF;

{ifopt n+} type real=single; {endif}
type fix = record case boolean of
             true:(fix:longint);
             false:(f:word;i:integer);
           end;
     RGB  = record r,g,b:real; end;
     RGBb = record r,g,b:byte; end;
     RGBi = record r,g,b:integer; end;
     RGBf = record r,g,b:fix; end;
     mat4=array[0..3,0..3] of real;
     vct3=record x,y,z:real; end;
     vct4=record w,x,y,z:real; end;
     vertex=record
       crd,nrm:vct3;
       c:RGB;
     end;
     polyobjtyp=array[0..maxpnts] of vertex;
     trafstackptr=^trafstacktyp;
     trafstacktyp = record
                      mc_wc,mc_npc,mc_dc,
                      wc_mc,wc_dc,wc_npc,
                      npc_mc,npc_dc:mat4;
                      vor,nach:trafstackptr;
                    end;
     shd_vtx= record x,y,z:integer; c:RGBb; end;
     polyscrtyp=array[0..maxpnts] of shd_vtx;
     zbufferspan=array[0..maxxdef] of integer;
     spanptr=^zbufferspan;
     lstype=(ambient,infinite,positional,spot);
     surfacepropertytyp=record
                          ka,kd,ks,oe:real;os,od:rgb;
                          alpha:real;
                        end;
     plsentry = ^lsentry;
     lsentry= record
                nr:integer; typ:lstype; active:boolean;
                lc,kalc,kdlc,ksoslc:rgb;
                c1,c2,le,cosash:real;
                ld,lp:vct3;
                next,pred,
                nextactthistyp,
                predactthistyp: plsentry;
              end;
     meshpnttyp = record
                     flags:byte;
                     a:vertex;
                     h:vct4;
                     l:shd_vtx;
                   end;
     meshlinetyp=array[0..maxpnts] of meshpnttyp;
     meshtyp=record
               m:array[0..maxpnts] of ^meshlinetyp;
               xmax,ymax:byte;
               volume:vct3;
             end;
     intptr=^integer;

const e:mat4=((1.0,0.0,0.0,0.0), (0.0,1.0,0.0,0.0),
              (0.0,0.0,1.0,0.0), (0.0,0.0,0.0,1.0));
      greytab:array[0..3] of rgb=((r:1;g:1;b:1),(r:1;g:0;b:0),(r:0;g:1;b:0),(r:0;g:0;b:1));
      aktgrey:byte=0;
      e_z: vct3=(x:0.0;y:0.0;z:1.0);
      me_z:vct3=(x:0.0;y:0.0;z:-1.0);
      flipareaenabled:boolean=false;
      wireframe:boolean=false;
      trifillenable : boolean=true;
      shadingmethod : boolean = gouraud;
      surfaceproperty: surfacepropertytyp= (ka:1/3; kd:1/3; ks:1/3;
                                            oe:10; os:(r:1;g:1;b:1);
                                                   od:(r:1;g:1;b:1);
                                                   alpha:0.5);
      clipmode:(inside,outside,toclip)=toclip;
      volclipcode:integer=$FF;
      clipcube:boolean=false;
      bkcolor:rgbb=(r:0;g:0;b:0);
      bkcolorr:rgb=(r:0.0;g:0.0;b:0.0);
      nebelcolorr:rgb=(r:0.0;g:0.0;b:0.0);
      nebel:boolean=false;
      ende:integer=0;
      ender:real=0;
      VRP:vct3=(x:0;y:0;z:0);
      NRP:vct3=(x:1;y:1;z:1);
      VUP:vct3=(x:0;y:0;z:1);
      XMIN:real=-1.5;
      YMIN:real=-1.1;
      XSIZE:real=3;
      VPD:real=6;
      FPD:real=5;
      BPD:real=-5;
      speicherplatz:word=$8000;
      lichtgesch:boolean=false;
      durchsichtig:boolean=false;
      p:real=0.99;
      v:vct3=(x:1;y:1;z:1);
      lichtberechnet:boolean=false;
      name:pathstr='';
      brille:boolean=false;
      mapcolor:byte=15;
      augendist:real=0.5;
      frame:boolean=false;
      farbergb=1;
      farbebw64=0;
      farbebw256=2;
      farbig:byte=farbergb;
      ram:boolean=false;
      TrueColor:boolean=false;
      Magic:boolean=false;
      zsave:boolean=false;
      amblsdefined:boolean=false;
      overwriteflags:boolean=true;
      _xmaxglobal:integer=640;
      _ymaxglobal:integer=480;

var MC_WC,WC_NPC,MC_NPC,MC_DC,
    WC_MC,WC_DC,NPC_MC,NPC_DC:mat4;
    xwinsize,ywinsize:real;
    xwinofs,ywinofs:integer;
    MatsChanged:boolean;
    eyepoint:vct3;
    trafstack:trafstackptr;
    zbuffer:array[0..maxydef] of spanptr;
    _pixelhochzubreit:real;
    grafmode:integer;
    amblsc:rgb;
    lslistroot,lslistend,
    firstinf,lastinf,
    firstpos,lastpos,
    firstspt,lastspt:plsentry;
    _VRP,_NRP,_VUP: vct3;
    _VPD,_FPD,_BPD,_xMin,
    _ymin,_xsize,_ysize:real;
    _lux,_luy,_rox,_roy:real;
    _ysubu,_ysubo,
    _spanmemsize:integer;
    _wrkarr:meshtyp;
    datei : file;
    gezeichnet:boolean;
    augenvector,hilfnrp:vct3;
    _ZRM:real;
    emshandle:word;
    totalpages,pages:word;
    _useems:boolean;
    emsbufbegin:longint;
    zbuffile:file;
    zbufmin,zbufmax:integer;

procedure savebild;
procedure Rotate(achse:integer;w:real); {x=1;y=2;z=3; w in Grad gegen Uhrzeigersinn}
procedure translate(xv,yv,zv:real);
procedure Scale(scx,scy,scz:real);
procedure pushtrafs;
procedure poptrafs;
procedure copytrafs;
procedure changesurfaceproperty(newka,newkd,newks,
                                newosr,newosg,newosb,
                                newoe,
                                newodr,newodg,newodb,
                                newalpha:real);
procedure changesurfacepropertybyte(newka,newkd,newks,
                                newosr,newosg,newosb,
                                newoe,
                                newodr,newodg,newodb,
                                newalpha:byte);
procedure changespeed(newp,newvx,newvy,newvz:real);
procedure norm(ebene:boolean);
procedure textur(x1,y1:byte;cr,cg,cb:real);
procedure setzelichter;
procedure addambls(nr:integer; active: boolean; lcr,lcg,lcb:real);
procedure addinfls(nr:integer; active:boolean; lcr,lcg,lcb:real; ldx,ldy,ldz:real);
procedure addposls(nr:integer; active:boolean; lcr,lcg,lcb:real; lpx,lpy,lpz,
                   c1,c2:real);
procedure addsptls(nr:integer; active:boolean; lcr,lcg,lcb:real; ldx,ldy,ldz,
                   lpx,lpy,lpz,c1,c2,le,as:real);
procedure switchls(nr:integer; on:boolean);
procedure clearls(nr:integer);
function lsnrexists(nr:integer; var lsp:plsentry):boolean;
function maxls:integer;
procedure backgroundcolor(r,g,b:real);
procedure setnebel(unsichtbar,r,g,b:real);
procedure defineclipvolume(xm,ym,zm,r,g,b:real);
procedure undefclipvolume;
procedure initmesh;
procedure putinmesh(x,y:integer; var crd,nrm:vct3);
procedure putnotused(x,y:integer);
procedure mesh;
procedure meshextensions(x,y:byte);
procedure setviewing(VRP,NRP,VUP:vct3;
                     xmin,ymin,xmax,ymax,vpd,fpd,bpd:real);
function dolocalinit:boolean;
procedure grafikende;
procedure grafikbegin;
procedure MCtoDCi(a:vct3; var x,y:integer);
procedure MCtoDC(a:vct3; var x,y:real);
procedure MCtoWC(var a:vct3);
procedure updatemats;
function VGAvorhanden:boolean;
function donorm(var v:vct3):boolean;
procedure linie3d(b,e:vct3);
procedure init;
procedure SetScreenGlobal(lux,luy,rox,roy:real);
procedure SetViewGlobal(VRP,NRP,VUP:vct3;xmin,ymin,xSize,VPD, FPD, BPD: real);
var error:procedure(s:string);

implementation

var _a,_b,_c,_t:real;
    _flip:boolean;
{    min,max:integer;}
    coldot:procedure(x,y:integer; r,g,b:integer);
    
procedure line2d(x1r,y1r,x2r,y2r:real);
begin
  map(mapcolor);
  line(round(x1r),round(y1r),round(x2r),round(y2r));
end;

procedure standarterror(s:string);far;
var c:char;
begin
  if grafmode<0 then vgaende else closegraph;
  if ram or Truecolor then CloseEMSVideo;
  if s<>'' then begin
    textcolor(yellow);
    textbackground(blue);
    write(#7,s);
    c:=readkey;
  end else write(#7);
  halt;
end;

procedure coldot3dgruen(x,y:integer; r,g,b:integer);far;forward;
procedure coldot3dgruenRAM(x,y:integer; r,g,b:integer);far;forward;
procedure coldot3dgruenTrueColor(x,y:integer; r,g,b:integer);far;forward;

(*$I VIEWING.INC  *)
(*$I CLIPPING.INC *)
(*$I SHADING.INC  *)
(*$I LIGHTING.INC *)
(*$I MESH.INC     *)

function VGAvorhanden:boolean;
var mode,driver:integer;
begin
  detectgraph(mode,driver);
  VGAvorhanden:=mode=9;
end;

procedure setclutbw64;
var n,m:byte;
begin
  for m:=0 to 3 do for n:=0 to 63 do farbe(m*64+n,
       round((n and $3F)*greytab[m].r),
       round((n and $3F)*greytab[m].g),
       round((n and $3F)*greytab[m].b));
end;

procedure setclut3d;
var n,m:byte;
begin
  for m:=0 to 15 do for n:=0 to 15 do farbe(m*16+n,
       round(m*63/15),
       round(n*63/15),
       0);
end;

procedure setclutbw256;
var n,f,m:byte;
begin
  for n:=0 to 62 do begin
    f:=n*4;
    farbe(f,n,n,n);
    farbe(succ(f),succ(n),n,n);
    if n<62 then farbe(f+2,succ(n),n,n+2) else farbe(f+2,succ(n),n,n+1);
    farbe(f+3,n,succ(n),succ(n));
  end;
  for m:=0 to 3 do farbe(63*4+m,n,n,n);
end;


procedure setpal;
begin
  if brille then setclut3d else
  case farbig of
    farbebw64:setclutbw64;
    farbebw256:setclutbw256;
    else setclutrgb;
  end;
end;

PROCEDURE INIT;
VAR zahler:byte;
    graphdriver,graphmode,grapherror: integer;
begin
  if ram and (grafmode<0) then begin
    if magic then coldot:=NopColDot
    else if brille then begin
      coldot:=coldot3drotRAM;
      colrange:=16;
    end else case farbig of
      farbebw64:begin
          coldot:=coldotbw64RAM;
          colrange:=64;
        end;
      farbebw256:begin
          coldot:=coldotbw256RAM;
          colrange:=255;
        end;
      else begin
        coldot:=coldotrgb;
        colrange:=64;
      end;
    end;
    correctbkcolor;
    zahler:=((bkcolor.r shl 2) and $e0) or ((bkcolor.g shr 1) and $1C) or (bkcolor.b shr 4);
    if not magic then begin
      if not GetEMSVideoRAM(_xmaxGlobal,_ymaxglobal,zahler)
      then error('EMS Fehler');
    end;
  end else if truecolor and (grafmode<0) then begin
    if brille then begin
      coldot:=coldot3drotTRUECOLOR;
      colrange:=255;
    end else case farbig of
      farbebw64,farbebw256:begin
          coldot:=coldotbwTRUECOLOR;
          colrange:=255;
        end;
      else begin
        coldot:=coldotrgbTrueColor;
        colrange:=255;
      end;
    end;
    correctbkcolor;
    if not GetEMSVideoTrueColor(_xmaxGlobal,_ymaxglobal,TRGB(bkcolor))
    then error('EMS Fehler');
  end else begin
    if brille then begin
      coldot:=coldot3drot;
      colrange:=16;
    end else case farbig of
      farbebw64:begin
          coldot:=coldotbw64;
          colrange:=64;
        end;
      farbebw256:begin
          coldot:=coldotbw256;
          colrange:=255;
        end;
      else begin
        coldot:=coldotrgb;
        colrange:=64;
      end;
    end;
    case grafmode of
      -1:begin
           videomodus($13);
           _xmaxglobal:=319; _ymaxglobal:=199;
           setpal;
         end;
      -2:begin
           scqmode;
           _xmaxglobal:=359; _ymaxglobal:=479;
           {SetMode(R640x400);
           _xmaxglobal:=max_x; _ymaxglobal:=max_Y;}
           setpal;
         end;
      else begin
        detectgraph(graphdriver,graphmode);
        if (grafmode=1) and (graphdriver=graph.VGA) then begin
          graphdriver:=ega;
          graphmode:=egahi;
        end;
        if (grafmode=1) and (graphdriver<>EGA) then error('Kein EGA 2 Seiten Modus gefunden');
        initgraph(graphdriver,graphmode,bgipath);
        grapherror:=graphresult;
        if (grapherror<>GrOK) then begin
          clrscr;
          textcolor(red);
          writeln('Grafik Fehler:');
          writeln(GraphErrorMsg(grapherror));
          repeat until keypressed;
          halt(1);
        end;
        _xmaxglobal:=getmaxx; _ymaxglobal:=getmaxy;
        if brille then begin
          for zahler:=0 to 15 do
           farbe(zahler+14*byte(zahler=6)+48*byte(zahler>7),(zahler mod 4)*21,(zahler div 4)*21,0);
        end;
      end;
    end;
    if (grafmode<0) then begin
      correctbkcolor;
      zahler:=((bkcolor.r shl 2) and $e0) or ((bkcolor.g shr 1) and $1C) or (bkcolor.b shr 4);
      map($F);
      fillchar(mem[$A000:0],$FFFF,zahler);
    end;
  end;
  _pixelhochzubreit:=((pysscrsizey/succ(_ymaxglobal)) /
                      (pysscrsizex/succ(_xmaxglobal)));
  MC_WC:=E;
  trafstack:=nil;
  lslistroot:=nil;
end;

procedure savebild;
begin
  if not((grafmode=-1) and ram and magic) then
  UPic.savebild(name,grafmode,brille,farbig);
end;

{procedure savebild;
var n,m:byte;
(    t:text;)
    palnr:byte;
begin
  if brille then palnr:=3 else palnr:=farbig;
  if grafmode=-1 then begin
    assign(datei,name+'.PIC');
    rewrite(datei,1);
    blockwrite(datei,mem[$A000:0],64000);
    blockwrite(datei,palnr,1);
    close(datei);
(    assign(t,name+'.PIC');
    rewrite(t);
    write(t,'(');
    for m:=0 to 15*2 do begin
      write(t,'(');
      for n:=0 to 18*2 do begin
        write(t,getpixel(n,m));
        if n<>18*2 then write(t,',');
      end;
      writeln(t,'),');
    end;
    write(t,');');
    close(t);
    plot(0,0,9);
    plot(18*2,15*2,9);)
  end;
  if grafmode=-2 then begin
    assign(datei,name+'.PIC');
    rewrite(datei,1);
    for n:=0 to 3 do begin
      readmap(n);
      blockwrite(datei,mem[$A000:0],43200);
    end;
    blockwrite(datei,palnr,1);
    close(datei);
  end;
end;
}

procedure setzelichter;
begin
  addambls(succ(maxls),true,1,1,1);
  addinfls(succ(maxls),true,1,1,1,-1,-1,-1);
  addinfls(succ(maxls),true,1,1,1,1,-1,-1);
  addposls(succ(maxls),true,1,1,1,        -0.9,0,0.7,1,0);
end;

procedure grafikende;
begin
  if ram or truecolor then begin
    if not magic then closeemsvideo;
  end else if grafmode<0 then vgaende else closegraph;
end;

procedure grafikbegin;
begin
  if (grafmode=-1) and ram and magic then preparesavezbuf;
  while keypressed do readkey;
  init;
  gezeichnet:=false;
  if brille then begin
    calcaugenvector(nrp,vrp,vup,augendist,augenvector);
    hilfnrp:=nrp;
    nrp.x:=nrp.x+augenvector.x;
    nrp.y:=nrp.y+augenvector.y;
    nrp.z:=nrp.z+augenvector.z;
    mapcolor:=3;
  end;
  setviewglobal(VRP,NRP,VUP,xMin,yMin,xSize,vpd,FPd,bpd);
  setscreenglobal(0,_ymaxglobal,_xmaxglobal,0);
  if frame and (grafmode<0) then overscan(255);
end;

{$L EGAVGA}
procedure EGAVGAdriver;external;

begin
  if (registerbgidriver(@EGAVGAdriver)<0) then error('Fehler beim Anmelden der Grafiktreiber!');
  wireframe:=not VGAvorhanden;
  if wireframe then grafmode:=0 else grafmode:=-1;
  initmesh;
  textur(_wrkarr.xmax,_wrkarr.ymax,1,1,1);
  clipcube:=false;
  _useems:=false;
  coldot:=coldotrgb;
  error:=standarterror;
end.