unit errorhdl;
{Nur Zusammen mit EXITS zu gebrauchen!
Im Hauptprogramm:
  seterrorcodes([200,205,207]);
  errcode:=setexit(cpupointer);
  case errcode of
    200:writeln('Division durch 0');
    205:writeln('Fliekommaberlauf');
    207:writeln('Unzulssige Werte');
  end;
}
{$F+}
interface
uses exits;
const cpupointer:exitbuf=(bp:0;cs:0;ip:0);
type TErrorCodes=set of byte;

procedure seterrorcodes(err:TErrorCodes);
procedure enableerrorcodes(err:TErrorCodes);
procedure disableerrorcodes(err:TErrorCodes);

implementation
var exitsave:pointer;
const errcode:word=0;
      errorcodes:set of byte=[];

procedure myexit;far;
begin
  exitproc:=exitsave;
  if (cpupointer.cs<>0) and (exitcode in errorcodes) then begin
    errcode:=exitcode;
    exitcode:=0;
    erroraddr:=nil;
    exitproc:=@myexit;
    longexit(cpupointer,errcode);
  end;
end;

procedure seterrorcodes(err:TErrorCodes);
begin
  errorcodes:=err;
end;

procedure enableerrorcodes(err:TErrorCodes);
begin
  errorcodes:=errorcodes+err;
end;

procedure disableerrorcodes(err:TErrorCodes);
begin
  errorcodes:=errorcodes-err;
end;

begin
  exitsave:=exitproc;
  exitproc:=@myexit;
end.