unit farbreg;
interface
uses crt,dos,vga;
procedure farberegeln;

implementation
const modus:char='H';
      offset:integer=0;
      c:real=1;
      l:real=1;
type palettentyp=array[0..255] of record r,g,b:byte; end;
var palette,palneu,palakt:palettentyp;
    y:array[0..255] of byte;
    regs:registers;
    farbz,z:byte;
    hilf:integer;
    ein:char;

procedure init;
begin
  offset:=0;
  c:=1;
  l:=1;
  with regs do begin
    bx:=0;cx:=256;es:=seg(palette);dx:=ofs(palette);
    ax:=$1017;intr($10,regs);
  end;
end;

procedure farberegeln;
begin
  init;
  sound(440);delay(100);sound(550);delay(100);sound(660);delay(100);nosound;
  move(palette,palneu,sizeof(palneu));
  move(palette,palakt,sizeof(palakt));
  repeat
    repeat until keypressed;
    repeat ein:=upcase(readkey) until not keypressed;
    case ein of
      'H':begin
            modus:=ein;
            sound(byte(ein)*10);delay(100);nosound;
            for z:=0 to 255 do begin
              y[z]:=round(palette[z].r*0.3+palette[z].g*0.59+palette[z].b*0.11);
              hilf:=round(l*palette[z].r+(1-l)*y[z]);
              if hilf<0 then palneu[z].r:=0
              else if hilf >63 then palneu[z].r:=63 else palneu[z].r:=hilf;
              hilf:=round(l*palette[z].g+(1-l)*y[z]);
              if hilf<0 then palneu[z].g:=0
              else if hilf >63 then palneu[z].g:=63 else palneu[z].g:=hilf;
              hilf:=round(l*palette[z].b+(1-l)*y[z]);
              if hilf<0 then palneu[z].b:=0
              else if hilf >63 then palneu[z].b:=63 else palneu[z].b:=hilf;
              hilf:=round((palneu[z].r-32)*c+32);
              if hilf<0 then palneu[z].r:=0
              else if hilf >63 then palneu[z].r:=63 else palneu[z].r:=hilf;
              hilf:=round((palneu[z].g-32)*c+32);
              if hilf<0 then palneu[z].g:=0
              else if hilf >63 then palneu[z].g:=63 else palneu[z].g:=hilf;
              hilf:=round((palneu[z].b-32)*c+32);
              if hilf<0 then palneu[z].b:=0
              else if hilf >63 then palneu[z].b:=63 else palneu[z].b:=hilf;
            end;
          end;
      'K':begin
            modus:=ein;
            sound(byte(ein)*10);delay(100);nosound;
            for z:=0 to 255 do begin
              hilf:=palette[z].r+offset;if hilf<0 then palneu[z].r:=0
              else if hilf >63 then palneu[z].r:=63 else palneu[z].r:=hilf;
              hilf:=palette[z].g+offset;if hilf<0 then palneu[z].g:=0
              else if hilf >63 then palneu[z].g:=63 else palneu[z].g:=hilf;
              hilf:=palette[z].b+offset;if hilf<0 then palneu[z].b:=0
              else if hilf >63 then palneu[z].b:=63 else palneu[z].b:=hilf;
              y[z]:=round(palneu[z].r*0.3+palneu[z].g*0.59+palneu[z].b*0.11);
              hilf:=round(l*palneu[z].r+(1-l)*y[z]);
              if hilf<0 then palneu[z].r:=0
              else if hilf >63 then palneu[z].r:=63 else palneu[z].r:=hilf;
              hilf:=round(l*palneu[z].g+(1-l)*y[z]);
              if hilf<0 then palneu[z].g:=0
              else if hilf >63 then palneu[z].g:=63 else palneu[z].g:=hilf;
              hilf:=round(l*palneu[z].b+(1-l)*y[z]);
              if hilf<0 then palneu[z].b:=0
              else if hilf >63 then palneu[z].b:=63 else palneu[z].b:=hilf;
            end;
          end;
      'L':begin
            modus:=ein;
            sound(byte(ein)*10);delay(100);nosound;
            for z:=0 to 255 do begin
              hilf:=palette[z].r+offset;if hilf<0 then palneu[z].r:=0
              else if hilf >63 then palneu[z].r:=63 else palneu[z].r:=hilf;
              hilf:=palette[z].g+offset;if hilf<0 then palneu[z].g:=0
              else if hilf >63 then palneu[z].g:=63 else palneu[z].g:=hilf;
              hilf:=palette[z].b+offset;if hilf<0 then palneu[z].b:=0
              else if hilf >63 then palneu[z].b:=63 else palneu[z].b:=hilf;
              hilf:=round((palneu[z].r-32)*c+32);
              if hilf<0 then palneu[z].r:=0
              else if hilf >63 then palneu[z].r:=63 else palneu[z].r:=hilf;
              hilf:=round((palneu[z].g-32)*c+32);
              if hilf<0 then palneu[z].g:=0
              else if hilf >63 then palneu[z].g:=63 else palneu[z].g:=hilf;
              hilf:=round((palneu[z].b-32)*c+32);
              if hilf<0 then palneu[z].b:=0
              else if hilf >63 then palneu[z].b:=63 else palneu[z].b:=hilf;
            end;
          end;
      'R':begin init; sound(440);DELAY(30);nosound; END;
      '+':begin
            sound(440);delay(10);nosound;
            case modus of
              'H':inc(offset);
              'K':c:=c+0.05;
              'L':l:=l+0.05;
            end;
          end;
      '-':begin
            sound(220);delay(10);nosound;
            case modus of
              'H':dec(offset);
              'K':c:=c-0.05;
              'L':l:=l-0.05;
            end;
          end;
      '=':begin
            sound(660);delay(10);nosound;
            case modus of
              'H':offset:=0;
              'K':c:=1;
              'L':l:=1;
            end;
          end;
    end;
    case modus of
      'H':begin
            for z:=0 to 255 do begin
              hilf:=palneu[z].r+offset;if hilf<0 then palakt[z].r:=0
              else if hilf >63 then palakt[z].r:=63 else palakt[z].r:=hilf;
              hilf:=palneu[z].g+offset;if hilf<0 then palakt[z].g:=0
              else if hilf >63 then palakt[z].g:=63 else palakt[z].g:=hilf;
              hilf:=palneu[z].b+offset;if hilf<0 then palakt[z].b:=0
              else if hilf >63 then palakt[z].b:=63 else palakt[z].b:=hilf;
            end;
          end;
      'K':begin
            for z:=0 to 255 do begin
              hilf:=round((palneu[z].r-32)*c+32);
              if hilf<0 then palakt[z].r:=0
              else if hilf >63 then palakt[z].r:=63 else palakt[z].r:=hilf;
              hilf:=round((palneu[z].g-32)*c+32);
              if hilf<0 then palakt[z].g:=0
              else if hilf >63 then palakt[z].g:=63 else palakt[z].g:=hilf;
              hilf:=round((palneu[z].b-32)*c+32);
              if hilf<0 then palakt[z].b:=0
              else if hilf >63 then palakt[z].b:=63 else palakt[z].b:=hilf;
            end;
          end;
      'L':begin
            for z:=0 to 255 do begin
              y[z]:=round(palneu[z].r*0.3+palneu[z].g*0.59+palneu[z].b*0.11);
              hilf:=round(l*palneu[z].r+(1-l)*y[z]);
              if hilf<0 then palakt[z].r:=0
              else if hilf >63 then palakt[z].r:=63 else palakt[z].r:=hilf;
              hilf:=round(l*palneu[z].g+(1-l)*y[z]);
              if hilf<0 then palakt[z].g:=0
              else if hilf >63 then palakt[z].g:=63 else palakt[z].g:=hilf;
              hilf:=round(l*palneu[z].b+(1-l)*y[z]);
              if hilf<0 then palakt[z].b:=0
              else if hilf >63 then palakt[z].b:=63 else palakt[z].b:=hilf;
            end;
          end;
    end;
    setpalette(ppalette(@palakt));
{    with regs do begin
      bx:=0;cx:=256;es:=seg(palakt);dx:=ofs(palakt);
      ax:=$1012;intr($10,regs);
    end;}
  until ein=#27;
  sound(660);delay(100);sound(550);delay(100);sound(440);delay(100);nosound;
end;

end.
