program funktion2;
uses app,Objects, Drivers, Memory, Views, Menus, Dialogs, StdDlg, MsgBox,
     crt,dos{$IFopt D-},graph,dreid,vga,koords,materie,maus{$ENDIF},exits,
     errorhdl,obtfast;
const cmfun     = 100;
      cmsichern = 101;
      cmladen   = 102;
      cmposition= 103;
      cmrender  = 104;
      cmmaterial= 105;
      cmfunda   = 106;
      cmsichernals= 107;
      cmrechenda   = 109;
      cmneufun =110;
      cmzeichnen=111;
      cmobtsichern=112;
type Pfundialog=^Tfundialog;
     Tfundialog=object(TDialog)
                  procedure handleevent(var event:tevent); virtual;
                end;
     Prechnedialog=^Trechnedialog;
     Trechnedialog=object(TDialog)
                  procedure handleevent(var event:tevent); virtual;
                end;
     Pfun=^Tfun;
     Tfun=object(TApplication)
                constructor init;
                procedure initmenubar; virtual;
                procedure InitStatusLine; virtual;
                procedure handleevent(var event:tevent); virtual;
                procedure fundialog;
                procedure neufundialog;
                procedure sichern;
                procedure sichernals;
                procedure laden;
              end;
     Tfundata=record
                name:namestr;
                bemerkung:array[1..5] of string[76];
                funktion:array[1..4] of string[255];
                grenzen:array[5..10] of string[8];
                ansicht:word;
              end;
{$IFopt D+}
const maxpnts=50;
      normal=0;
      isvis=1;
      isinnpc=2;
      isinwc=4;
      isindc=8;
      notused=16;
      pysscrsizex=24.0;
      pysscrsizey=17.0;

var error:procedure(s:string);
type vct3=record x,y,z:single; end;
     RGB  = record r,g,b:real; end;
     RGBb = record r,g,b:byte; end;
     vertex=record
       crd,nrm:vct3;
       c:RGB;
     end;
     vct4=record w,x,y,z:real; end;
     shd_vtx= record x,y,z:integer; c:RGBb; end;

     meshpnttyp = record
                     flags:byte;
                     a:vertex;
                     h:vct4;
                     l:shd_vtx;
                   end;

     meshlinetyp=array[0..maxpnts] of meshpnttyp;
     meshtyp=record
               m:array[0..maxpnts] of ^meshlinetyp;
               xmax,ymax:byte;
               volume:vct3;
             end;

const VRP:vct3=(x:0;y:0;z:0);
      NRP:vct3=(x:1;y:1;z:1);
      VUP:vct3=(x:0;y:0;z:1);
      XMIN:single=-1.5;
      YMIN:single=-1.1;
      XSIZE:single=3;
      VPD:single=6;
      FPD:single=5;
      BPD:single=-5;
      flipareaenabled:boolean=false;
      wireframe:boolean=false;
      frame:boolean=false;
var grafmode:integer;
    _wrkarr:meshtyp;


type mattyp=record
       ambc,difc,spec:rgbb;
       ka,kd,ks:byte;
       oe,alpha,facetten:byte;
     end;

procedure initmesh;
var x:integer;
begin
  if memavail>((sizeof(meshlinetyp)+4)*succ(maxpnts)+$8000+20)
    then begin
    for x:=0 to maxpnts do new(_wrkarr.m[x]);
    _wrkarr.xmax:=maxpnts;
    _wrkarr.ymax:=maxpnts;
  end else error('Zu wenig Speicherplatz (InitMesh)');
end;

procedure putinmesh(x,y:integer; var crd,nrm:vct3);
begin
  with _wrkarr.m[x]^[y] do begin
    a.crd:=crd;
    a.nrm:=nrm;
    flags:=isvis;
  end;
end;


{$ENDIF}

const ingraphicmode:boolean=false;
var fundata:Tfundata;
    D: PFunDialog;
    rechne:prechnedialog;
    nrph,vrph,vuph:vct3;
    VPDh,FPDh,BPDh,xminh,yminh,xsizeh:single;
    wireframeh,flipareaenabledh:boolean;
    grafmodeh:integer;


{Hier beginnt BERECHNE.INC}

Function berechne(f:string;x,y:real):real;
const klammer=true;
      glied=false;
      maxreal=1.7e38;
      plus=0;
      minus=1;
      geteilt=2;
      mal=3;
      nichts=4;
var hilfb,aktpos:byte;
    err2,err:integer;
    hilf:real;
    funkt:string[6];
    modus:boolean;

  Function rechne(sinn:boolean):real;
  var z,stapel:real;
      vorprodukt,vorganger:byte;

  procedure fehler;
  begin
    error(copy(f,1,aktpos)+'_'+copy(f,succ(aktpos),length(f)-aktpos));
  end;

  begin
    while (pos(' ',f)=aktpos) and (aktpos<=length(f)) do inc(aktpos);
    if aktpos>length(f) then fehler;
    if ((f[aktpos]='[') or (f[aktpos]='{') or (f[aktpos]='(')) then begin
      inc(aktpos);
      z:=rechne(klammer)
    end else begin
      funkt:='';
      while (f[aktpos]>='A') and (f[aktpos]<='Z') do begin
        funkt:=funkt+f[aktpos];
        inc(aktpos);
      end;
      if length(funkt)<>0 then begin
        if funkt='Y' then z:=y else
        if funkt='X' then z:=x else
        if funkt='E' then z:=2.718281829 else
        if funkt='PI' then z:=pi else
        if funkt='RND' then z:=random else
        if funkt='LN' then begin
          inc(aktpos);
          hilf:=rechne(klammer);
          if hilf<=0 then error('ln mit negativem Argument');
          z:=ln(hilf);
        end else if funkt='EXP' then begin
          inc(aktpos);
          z:=exp(rechne(klammer));
        end else if funkt='SIN' then begin
          inc(aktpos);
          z:=sin(rechne(klammer));
        end else if funkt='COS' then begin
          inc(aktpos);
          z:=cos(rechne(klammer));
        end else if funkt='TAN' then begin
          inc(aktpos);
          hilf:=rechne(klammer);
          z:=sin(hilf);
          hilf:=cos(hilf);
          if hilf<>0 then z:=z/hilf else z:=maxreal;
        end else if funkt='COT' then begin
          inc(aktpos);
          hilf:=rechne(klammer);
          z:=cos(hilf);
          hilf:=sin(hilf);
          if hilf<>0 then z:=z/hilf else z:=maxreal;
        end else if funkt='ABS' then begin
          inc(aktpos);
          z:=abs(rechne(klammer));
        end else if funkt='SGN' then begin
          inc(aktpos);
          hilf:=rechne(klammer);
          if hilf<0 then z:=-1 else if z>0 then z:=1 else z:=0;
        end else if funkt='SQR' then begin
          inc(aktpos);
          z:=sqr(rechne(klammer));
        end else if funkt='SQRT' then begin
          inc(aktpos);
          hilf:=rechne(klammer);
          if hilf<0 then error('sqrt mit negativem Argument');
          z:=sqrt(hilf);
        end else if funkt='FRAC' then begin
          inc(aktpos);
          z:=frac(rechne(klammer));
        end else if funkt='TRUNC' then begin
          inc(aktpos);
          z:=trunc(rechne(klammer));
        end else if funkt='ROUND' then begin
          inc(aktpos);
          z:=round(rechne(klammer));
        end else if funkt='ARCTAN' then begin
          inc(aktpos);
          z:=arctan(rechne(klammer));
        end else fehler;
      end else begin
        val(copy(f,aktpos,length(f)-pred(aktpos)),z,err);
        if err=1 then fehler;
        if err=0 then aktpos:=length(f) else begin
          val(copy(f,aktpos,pred(err)),z,err2);
          aktpos:=aktpos+pred(err);
        end;
      end;
    end;
    if sinn=klammer then begin
      vorganger:=nichts; stapel:=0;
      while ((f[aktpos]<>']') and (f[aktpos]<>'}') and
             (f[aktpos]<>')') and (aktpos<length(f))) do begin
        hilfb:=aktpos;
        inc(aktpos);
        if ((f[aktpos]='[') or (f[aktpos]='{') or (f[aktpos]='(')) then begin
          inc(aktpos);
          modus:=klammer;
        end else modus:=glied;
        case f[hilfb] of
          '+':begin
                case vorganger of
                  plus,nichts: begin z:=z+stapel; stapel:=rechne(modus); end;
                  minus: begin z:=z-stapel; stapel:=rechne(modus); end;
                  mal,geteilt:
                  case vorprodukt of
                    plus: begin z:=z+stapel; stapel:=rechne(modus); end;
                    minus: begin z:=z-stapel; stapel:=rechne(modus); end;
                    nichts: begin z:=stapel; stapel:=rechne(modus); end;
                  end;
                end;
                vorganger:=plus;
              end;
          '-':begin
                case vorganger of
                  plus,nichts: begin z:=z+stapel; stapel:=rechne(modus); end;
                  minus: begin z:=z-stapel; stapel:=rechne(modus); end;
                  mal,geteilt: case vorprodukt of
                    plus: begin z:=z+stapel; stapel:=rechne(modus); end;
                    minus: begin z:=z-stapel; stapel:=rechne(modus); end;
                    nichts: begin z:=stapel; stapel:=rechne(modus); end;
                  end;
                end;
                vorganger:=minus;
              end;
          '/':begin
                hilf:=rechne(modus);
                if vorganger=nichts then stapel:=z;
                if (vorganger=minus) or (vorganger=plus) or
                   (vorganger=nichts) then vorprodukt:=vorganger;
                if hilf<>0 then stapel:=stapel/hilf else stapel:=maxreal;
                vorganger:=geteilt;
              end;
          '*':begin
                if vorganger=nichts then stapel:=z;
                if (vorganger=minus) or (vorganger=plus) or
                   (vorganger=nichts) then vorprodukt:=vorganger;
                stapel:=stapel*rechne(modus);
                vorganger:=mal;
              end;
          else fehler;
        end;
      end;
      case vorganger of
        plus:   z:=z+stapel;
        minus:  z:=z-stapel;
        geteilt,mal:case vorprodukt of
              plus:  z:=z+stapel;
              minus: z:=z-stapel;
              nichts:z:=stapel;
            end;
      end;
      inc(aktpos);
    end;
    rechne:=z;
  end;

begin
  for aktpos:=1 to length(f) do begin
    f[aktpos]:=upcase(f[aktpos]);
  end;
  aktpos:=1;
  berechne:=rechne(klammer);
end;

{Hier endet BERECHNE.INC}

procedure entergraphic;
begin
  ingraphicmode:=true;
  DoneSysError;
  DoneEvents;
  DoneVideo;
  DoneMemory;
end;

procedure leavegraphic;
begin
  ingraphicmode:=false;
  InitMemory;
  InitVideo;
  InitEvents;
  InitSysError;
  Application^.Redraw;
end;

var filename:fnamestr;
    
  procedure sichere;
  var n:byte;
      f:text;
  begin
    with fundata do begin
      FileName := FExpand(FileName);
      assign(f,filename);
      rewrite(f);
      for n:=1 to 4 do writeln(f,funktion[n]);
      writeln(f,grenzen[6]);
      writeln(f,grenzen[9]);
      writeln(f,grenzen[5]);
      writeln(f,grenzen[8]);
      writeln(f,grenzen[7]);
      writeln(f,grenzen[10]);
      writeln(f,VRP.x:6:3);
      writeln(f,VRP.y:6:3);
      writeln(f,VRP.z:6:3);
      writeln(f,NRP.x:6:3);
      writeln(f,NRP.y:6:3);
      writeln(f,NRP.z:6:3);
      writeln(f,VUP.x:6:3);
      writeln(f,VUP.y:6:3);
      writeln(f,VUP.z:6:3);
      writeln(f,xmin :6:3);
      writeln(f,ymin :6:3);
      writeln(f,xsize:6:3);
      writeln(f,VPD  :6:3);
      writeln(f,FPD  :6:3);
      writeln(f,BPD  :6:3);
      for n:=1 to 5 do writeln(f,bemerkung[n]);
      writeln(f,flipareaenabled);
      writeln(f,wireframe);
      writeln(f,grafmode);
      with mater do begin
        writeln(f,ka);
        writeln(f,kd);
        writeln(f,ks);
        writeln(f,spec.r);
        writeln(f,spec.g);
        writeln(f,spec.b);
        writeln(f,oe);
        writeln(f,difc.r);
        writeln(f,difc.g);
        writeln(f,difc.b);
        writeln(f,alpha);
      end;
      close(f);
    end;
  end;

function ExecDialog(P: PDialog; Data: Pointer): Word;
var
  Result: Word;
begin
  Result := cmCancel;
  P := PDialog(Application^.ValidView(P));
  if P <> nil then
  begin
    if Data <> nil then P^.SetData(Data^);
    Result := DeskTop^.ExecView(P);
    if (Result <> cmCancel) and (Data <> nil) then P^.GetData(Data^);
    Dispose(P, Done);
  end;
  ExecDialog := Result;
end;

procedure visionerror(s:string);far;
var c:char;
    hilfdia:prechnedialog;
begin
{$IFopt D-}
  if ingraphicmode then begin
    if grafmode<0 then vgaende else closegraph;
    leavegraphic;
  end;
{$EndIf}
  while keypressed do readkey;
  hilfdia:=message(desktop,evbroadcast,cmrechenda,nil);
  if hilfdia<>nil then dispose(hilfdia,done);
  if s<>'' then begin
    MessageBox(s,nil, mfError + mfOkButton);
  end else MessageBox('Berechnung unterbrochen.',nil, mfError + mfOkButton);
  if message(Desktop,evbroadcast,cmfunda,nil)<>nil then begin
    d^.getdata(fundata);
    filename:=fundata.name+'.EBN';
    if ExecDialog(New(PFileDialog, Init('*.EBN',
       'Sichere Datei als', '~N~ame', fdOkButton, 101)), @filename)
    <> cmCancel then sichere;
  end;
  halt(1);
end;

procedure clearfundata;
var n:byte;
begin
  for n:=1 to 5 do with fundata do bemerkung[n]:='';
  fundata.name:='NONAME';
  fundata.funktion[1]:='Sin(x)*cos(y)';
  fundata.funktion[2]:='x/10';
  fundata.funktion[3]:='y/10';
  fundata.funktion[4]:='fx1';
  fundata.grenzen[5]:='-10';
  fundata.grenzen[6]:='10';
  fundata.grenzen[7]:='20';
  fundata.grenzen[8]:='-10';
  fundata.grenzen[9]:='10';
  fundata.grenzen[10]:='20';
  fundata.ansicht:=0;
end;

procedure Tfun.fundialog;
var
  R: TRect;
  bruce:PView;
  l:word;
  n:byte;
  s:string;
begin
  R.Assign(0, 0, 80, 23);
  D := New(PFunDialog, Init(R, '4D Funktion'));
  with D^ do
  begin
    Options := Options or ofCentered;
    r.assign(8,2,18,3);
    bruce:=new(pinputline,init(r,8));
    insert(bruce);
    r.assign(2,2,8,3);
    insert(new(plabel,init(r,'~N~ame:',bruce)));
    for n:=1 to 5 do begin
      r.assign(2,3+n,78,4+n);
      bruce:=new(pinputline,init(r,76));
      insert(bruce);
      if n=1 then begin
        r.assign(2,3,14,4);
        insert(new(plabel,init(r,'~B~emerkung:',bruce)));
      end;
    end;
    for n:=1 to 4 do begin
      r.assign(24,9+n,76,10+n);
      bruce:=new(pinputline,init(r,255));
      insert(bruce);
      case n of
        1,2,3:s:='~'+chr(n+48)+'~) x'+chr(n+48)+'=fx'+chr(n+48)+'(x,y) = ';
        4:s:='~'+chr(n+48)+'~) Farbe=fx'+chr(n+48)+'(x,y) = ';
      end;
      r.assign(2,9+n,length(s)+2,10+n);
      insert(new(plabel,init(r,s,bruce)));
    end;
    for n:=5 to 10 do begin
      if n<8 then r.assign(24,9+n,35,10+n)
      else r.assign(65,6+n,76,7+n);
      bruce:=new(pinputline,init(r,8));
      insert(bruce);
      case n of
        5:s:='~5~) XMin =';
        6:s:='~6~) XMax =';
        7:s:='~7~) XAnz =';
        8:s:='~8~) YMin =';
        9:s:='~9~) YMax =';
        10:s:='~0~) YAnz =';
      end;
      if n<8 then r.assign(2,9+n,11,10+n)
      else r.assign(43,6+n,52,7+n);
      insert(new(plabel,init(r,s,bruce)));
    end;
    R.Assign(4, 18, 34, 19);
    insert(new(PCheckBoxes,init(r,newsitem('~A~nsicht von 4 Seiten',nil))));
    R.Assign(2, 20, 19, 22);
    Insert(New(PButton, Init(R, '~P~osition', cmPosition, bfNormal)));
    R.Assign(21, 20, 38, 22);
    Insert(New(PButton, Init(R, '~M~aterial', cmmaterial, bfNormal)));
    R.Assign(61, 20, 78, 22);
    Insert(New(PButton, Init(R, '~Z~eichnen', cmzeichnen, bfNormal)));
    R.Assign(61, 18, 78, 20);
    Insert(New(PButton, Init(R, '~S~ichern', cmobtsichern, bfnormal)));
    R.Assign(41, 20, 58, 22);
    Insert(New(PButton, Init(R, '~R~endern', cmrender, bfDefault)));
  end;
  if ValidView(D) <> nil then
  begin
    d^.setdata(fundata);
    Desktop^.insert(D);
{    d^.getdata(fundata);
    dispose(d,done);}
  end else error('Nicht genug Hauptspeicher !');
end;

procedure tfun.neufundialog;
begin
  clearfundata;
  if message(Desktop,evbroadcast,cmfunda,nil)=nil then begin
    fundialog;
  end else d^.redraw;
end;

procedure Tfun.sichern;
begin
  d^.getdata(fundata);
  if fundata.name='NONAME' then begin
    filename:='';
    if ExecDialog(New(PFileDialog, Init('*.EBN',
       'Sichere Datei als', '~N~ame', fdOkButton, 101)), @filename)
    <> cmCancel then sichere;
  end else begin
    filename:=fundata.name+'.EBN';
    sichere;
  end;  
end;

procedure tfun.sichernals;
begin
  filename:='';
  if ExecDialog(New(PFileDialog, Init('*.EBN',
       'Sichere Datei als', '~N~ame', fdOkButton, 101)), @filename)
    <> cmCancel then sichere;
end;

procedure Tfun.laden;
var
  FileName: FNameStr;
  n:byte;
  f:text;
  dir:dirstr;
  ext:extstr;
  s:string[5];
begin
  FileName := '*.EBN';
  if ExecDialog(New(PFileDialog, Init('*.EBN', 'ffne Datei',
    '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then begin
    FileName := FExpand(FileName);
    with fundata do begin
      assign(f,filename);
      reset(f);
      for n:=1 to 4 do readln(f,funktion[n]);
      readln(f,grenzen[6]);
      readln(f,grenzen[9]);
      readln(f,grenzen[5]);
      readln(f,grenzen[8]);
      readln(f,grenzen[7]);
      readln(f,grenzen[10]);
      readln(f,VRP.x);
      readln(f,VRP.y);
      readln(f,VRP.z);
      readln(f,NRP.x);
      readln(f,NRP.y);
      readln(f,NRP.z);
      readln(f,VUP.x);
      readln(f,VUP.y);
      readln(f,VUP.z);
      readln(f,xmin );
      readln(f,ymin );
      readln(f,xsize);
      readln(f,VPD  );
      readln(f,FPD  );
      readln(f,BPD  );
      for n:=1 to 5 do Readln(f,bemerkung[n]);
      readln(f,s);flipareaenabled:=s='TRUE';
      readln(f,s);wireframe:=s='TRUE';
      readln(f,grafmode);
      with mater do begin
        readln(f,ka);
        readln(f,kd);
        readln(f,ks);
        readln(f,spec.r);
        readln(f,spec.g);
        readln(f,spec.b);
        readln(f,oe);
        readln(f,difc.r);
        readln(f,difc.g);
        readln(f,difc.b);
        readln(f,alpha);
        close(f);
      end;
      fsplit(filename,dir,name,ext);
      if message(Desktop,evbroadcast,cmfunda,nil)<>nil then begin
        d^.setdata(fundata);
        d^.redraw;
      end else fundialog;
    end;
  end;
end;

procedure position;
begin
{$IFopt D-}
  entergraphic;
  while abfrage do ;
  leavegraphic;
{$ENDIF}
end;

procedure retteparam;
begin
  VPDh:=vpd;FPDh:=FPD;BPDh:=BPD;
  flipareaenabledh:=flipareaenabled;
  nrph:=nrp;vrph:=vrp;vuph:=vup;
  xminh:=xmin;yminh:=ymin;xsizeh:=xsize;
  wireframeh:=wireframe;
  grafmodeh:=grafmode;
end;

procedure holeparam;
begin
  VPD:=vpdh;FPD:=FPDh;BPD:=BPDh;
  flipareaenabled:=flipareaenabledh;
  nrp:=nrph;vrp:=vrph;vup:=vuph;
  xmin:=xminh;ymin:=yminh;xsize:=xsizeh;
  wireframe:=wireframeh;
  grafmode:=grafmodeh;
end;

procedure material;
begin
  retteparam;
{$IFopt D-}
  entergraphic;
  materialmischen(false);
  with mater do
    changesurfacepropertybyte(ka,kd,ks,spec.r,spec.g,spec.b,oe,
                          difc.r,difc.g,difc.b,alpha);
  leavegraphic;
{$ENDIF}
  holeparam;
end;

procedure render(neurechnen:boolean);
var x,y:byte;

  function wert(s:string):single;
  var h:single;
      code:integer;
  begin
    val(s,h,code);
    if code<>0 then wert:=0 else wert:=h;
  end;

  procedure funk3d(n1,n2:byte;xmin,ymin,xmax,ymax:single;fx1,fx2,fx3,fx4:string);
  var p:vertex;
      x,y:byte;
      xdist,ydist,xf,yf,xfd,yfd:single;

    procedure putcolor(x,y:word;c:single);
    var z:single;
    begin
      with _wrkarr.m[x]^[y] do begin
        z:=round((c+1)*127.5);
        a.c.r:=(cos(z / 40)   *31+32)/63;
        a.c.g:=(cos((z+ 84) / 40)   *31+32)/63;
        a.c.b:=(cos((z+168) / 40)   *31+32)/63;
      end;
    end;

    procedure rechnedialog;
    var
      R: TRect;
      bruce:PView;
      
    begin
      R.Assign(0, 0, 25, 5);
      rechne:=new(prechnedialog,Init(R, 'Information'));
      with rechne^ do
      begin
        Options := Options or ofCentered;
        r.assign(3,2,16,3);
        bruce:=new(pstatictext,init(r,'Ich rechne !'));
        insert(bruce);
      end;
      Desktop^.insert(rechne);
    end;

  begin
    rechnedialog;
    _wrkarr.volume.x:=1;
    _wrkarr.volume.y:=1;
    _wrkarr.volume.z:=1;
    _wrkarr.xmax:=n1;
    _wrkarr.ymax:=n2;
    xf:=xmin;
    xfd:=(xmax-xmin) / n1;
    yfd:=(ymax-ymin) / n2;
    p.nrm.x:=0;p.nrm.y:=0;p.nrm.z:=1;
    for x:=0 to n1 do begin
      yf:=ymin;
      for y:=0 to n2 do begin
        p.crd.x:=berechne(fx1,xf,yf);
        p.crd.y:=berechne(fx2,xf,yf);
        p.crd.z:=berechne(fx3,xf,yf);
        putinmesh(x,y,p.crd,p.nrm);
        if ((upcase(fx4[1])='F') and (upcase(fx4[2])='X')) then begin
          case fx4[3] of
            '1':putcolor(x,y,p.crd.x);
            '2':putcolor(x,y,p.crd.y);
            '3':putcolor(x,y,p.crd.z);
            else error('Fehler in fx4:'+fx4);
          end;
        end else putcolor(x,y,berechne(fx4,xf,yf));
        yf:=yf+yfd;
      end;
      xf:=xf+xfd;
    end;
{$IFOPT D-}
    norm(flaeche);
{$ENDIF}
    dispose(rechne,done);
  end;

  procedure zeichnen;
  var x,y:byte;
  begin
{$IFOPT D-}
    MC_WC:=E;
    matschanged:=true;
    gezeichnet:=false;
    setviewglobal(VRP,NRP,VUP,xMin,yMin,xSize,vpd,FPd,bpd);
    setscreenglobal(0,_ymaxglobal div 2,_xmaxglobal div 2,0);
    for x:=0 to _Wrkarr.xmax do
     for y:=0 to _wrkarr.ymax do with _wrkarr.m[x]^[y] do flags:=1;
    while dolocalinit do begin
      pushtrafs;
      mesh;
      poptrafs;
    end;
{$ENDIF}
  end;

  procedure rucksetzen;
  begin
    nrp.x:=0;nrp.y:=0;nrp.z:=0;
    vrp.x:=0;vrp.y:=0;vrp.z:=0;
    vup.x:=0;vup.y:=0;vup.z:=0;
    xmin:=-xsize/2;
    ymin:=xmin*pysscrsizey/pysscrsizex;
    wireframe:=true;
  end;

begin
  retteparam;
  if message(Desktop,evbroadcast,cmfunda,nil)<>nil then d^.getdata(fundata);
  with fundata do if (pred(round(wert(grenzen[7])))<2) or
     (pred(round(wert(grenzen[10])))<2) then begin
    error('Die Punktanzahl ist zu klein.');
    exit;
  end;
  if neurechnen then with fundata do funk3d(pred(round(wert(grenzen[7]))),
         pred(round(wert(grenzen[10]))),
         wert(grenzen[5]),
         wert(grenzen[8]),
         wert(grenzen[6]),
         wert(grenzen[9]),
         funktion[1],
         funktion[2],
         funktion[3],
         funktion[4]);
{$IFOPT D-}
  entergraphic;
  if fundata.ansicht<>0 then begin
    wireframe:=true;
    grafmode:=0;
    frame:=true;
    init;
    setviewport(0,getmaxy div 2,getmaxx div 2,getmaxy,true);
    outtextxy(3,3,'3D');
    zeichnen;
    rucksetzen;
    nrp.z:=100;
    vup.y:=1;
    setviewport(getmaxx div 2,getmaxy div 2,getmaxx,getmaxy,true);
    outtextxy(3,3,'XY');
    zeichnen;
    nrp.z:=0;
    vup.y:=0;
    nrp.y:=100;
    vup.z:=1;
    setviewport(0,0,getmaxx,getmaxy,true);
    outtextxy(3,3,'XZ');
    zeichnen;
    nrp.y:=0;
    vup.z:=0;
    nrp.x:=100;
    vup.y:=1;
    setviewport(getmaxx div 2,0,getmaxx,getmaxy div 2,true);
    outtextxy(3,3,'YZ');
    zeichnen;
  end else begin
    grafikbegin;
    addambls(0,true,1,1,1);
    addinfls(1,true,2,2,2,-1,-1,-1);
{$IFopt D-}
    with mater do changesurfacepropertybyte(ka,kd,ks,
                    spec.r,spec.g,spec.b,oe,
                    difc.r,difc.g,difc.b,alpha);
{$ENDIF}
{$IFOPT D-}
    MC_WC:=E;
    matschanged:=true;
    gezeichnet:=false;
    setviewglobal(VRP,NRP,VUP,xMin,yMin,xSize,vpd,FPd,bpd);
    setscreenglobal(0,_ymaxglobal,_xmaxglobal,0);
    for x:=0 to _Wrkarr.xmax do
     for y:=0 to _wrkarr.ymax do with _wrkarr.m[x]^[y] do flags:=1;
    while dolocalinit do begin
      pushtrafs;
      mesh;
      poptrafs;
    end;
    {$Endif}
  end;
  while maxls<>-1 do clearls(maxls);
  write(^G);
  if name<>'' then savebild;
  repeat until keypressed or mauskeypressed;
  while keypressed do readkey;
  grafikende;
  holeparam;
  leavegraphic;
{$ENDIF}
end;

procedure Tfun.initmenubar;
var r:TRect;
begin
  getextent(r);
  r.b.y:=succ(r.a.y);
  menubar:=new(PMenubar, Init(r,newmenu(
    newsubmenu('~F~ile',hcNoContext,newmenu(
       newitem('~L~ade','F3',kbF3,cmladen,hcnocontext,
       newitem('~N~eu','',kbnokey,cmneufun,hcnocontext,
       newitem('~S~ichern','F2',kbF2,cmsichern,hcnocontext,
       newitem('~S~ichern als','',kbnokey,cmsichernals,hcnocontext,
       newitem('~E~nde','',kbALTx,cmquit,hcnocontext,
       nil)))))),
     newsubmenu('~3~D',hcNoContext,newmenu(
       newitem('~P~osition','F5',kbF5,cmposition,hcnocontext,
       newitem('~M~aterial','',kbnokey,cmmaterial,hcnocontext,
{       newitem('~F~unktion','F8',kbF8,cmfun,hcnocontext,}
       newitem('~R~ender','F9',kbF9,cmrender,hcnocontext,
       newitem('~Z~eichnen','F10',kbF10,cmzeichnen,hcnocontext,
       newitem('~O~bjekt Sichern','',kbnokey,cmObtSichern,hcnocontext,
       nil)))))),
    nil)))));
end;

procedure Tfun.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
    NewStatusDef(0, $FFFF,
      NewStatusKey('~F2~ Sichern', kbF2, cmSichern,
      NewStatusKey('~F3~ Laden', kbF3, cmladen,
      NewStatusKey('~F6~ Next', kbF6, cmNext,
      NewStatusKey('~Alt-F3~ Schlieen', kbAltF3, cmClose,
      NewStatusKey('~F10~ Menu', kbF10, cmMenu,
      nil))))),
    nil)));
end;

procedure trechnedialog.handleevent(var event:tevent);
begin
  TDialog.HandleEvent(Event);
  case Event.What of
    evBroadcast:begin
      case Event.Command of
        cmrechenda:clearevent(Event);
      end;
    end;
  end;
end;

procedure tfundialog.handleevent(var event:tevent);

  procedure obtsichern;
  var name:fnamestr;
      dir:dirstr;
      ext:extstr;
  begin
    fsplit(FunData.name,dir,name,ext);
    name:=dir+name+'.OBT';
    if ExecDialog(New(PFileDialog, Init('*.OBT',
         'Sichere Objekt als', '~N~ame', fdOkButton, 101)), @name)
      <> cmCancel then saveobjekt(Name,xdat+ydat+zdat+texturdat+realdat);
  end;

begin
  TDialog.HandleEvent(Event);
  case Event.What of
    evBroadcast:begin
      case Event.Command of
        cmfunda:ClearEvent(Event);
      end;
    end;
    evCommand:
      begin
        case Event.Command of
          cmposition:position;
          cmmaterial:material;
          cmrender:render(true);
          cmobtsichern:obtsichern;
          cmzeichnen:render(false);
        else
          exit;
        end;
        ClearEvent(Event);
      end;
  end;
end;

procedure tfun.handleevent(var event:tevent);
begin
  TApplication.HandleEvent(Event);
  case Event.What of
    evCommand:
      begin
        case Event.Command of
          cmneufun:neufundialog;
          cmsichern:sichern;
          cmsichernals:sichernals;
          cmladen:laden;
          cmposition:position;
          cmrender:render(true);
          cmrender:render(false);
          cmmaterial:material;
        else
          Exit;
        end;
        ClearEvent(Event);
      end;
  end;
end;

constructor Tfun.init;
begin
  TApplication.init;
  clearfundata;
end;

var fun:Tfun;
    nr:string[4];
    errcode:word;
begin
{$IFOPT D+}
  initmesh;
{$ENDIF}
  error:=visionerror;
  fun.init;
  fun.fundialog;
  seterrorcodes([200,205,206,207,1]);
  errcode:=setexit(cpupointer);
  case errcode of
    200:error('Division durch Null');
    205:error('Fliekomma-berlauf');
    206:error('Fliekomma-Unterlauf');
    207:error('Fliekomma-Fehler');
    1:write(^G);
    0:;
    else begin
      str(errcode:4,nr);
      error('Fehler '+nr+' aufgetreten');
    end;
  end;
  fun.run;
  fun.done;
end.