unit init3d;
interface
uses dreid,crt;

function getreal(r:real;s:string):real;
procedure maske;

implementation

function getreal(r:real;s:string):real;
var s1:string;
    rh:real;
    err:integer;
begin
  textcolor(lightgreen); write(s:55,'? ');
  textcolor(lightmagenta); write('[',r:8:4,']');
  readln(s1);
  if s1='' then getreal:=r else begin
    val(s1,rh,err);
    if err<>0 then begin
      if upcase(s1[1])='Q' then error('Auf Wiedersehen !');
      getreal:=r;
    end else getreal:=rh;
  end;
end;

procedure maske;
var c:char;
begin
  repeat
    textbackground(blue);
    textcolor(yellow);
    clrscr;
    writeln('Beenden mit "q <Return>" ');
    VRP.x:=getreal(VRP.x,'Zentrum der Bildschirmebene x (VRP.x) ');
    VRP.y:=getreal(VRP.y,'Zentrum der Bildschirmebene y (VRP.y) ');
    VRP.z:=getreal(VRP.z,'Zentrum der Bildschirmebene z (VRP.z) ');
    NRP.x:=getreal(NRP.x,'Punkt in Richtung Betrachter x (NRP.x) ');
    NRP.y:=getreal(NRP.y,'Punkt in Richtung Betrachter y (NRP.y) ');
    NRP.z:=getreal(NRP.z,'Punkt in Richtung Betrachter z (NRP.z) ');
    VUP.x:=getreal(VUP.x,'Vertikale Achse des Betrachters x (VUP.x) ');
    VUP.y:=getreal(VUP.y,'Vertikale Achse des Betrachters y (VUP.y) ');
    VUP.z:=getreal(VUP.z,'Vertikale Achse des Betrachters z (VUP.z) ');
    xmin:=getreal(xmin,'Relative linke untere Ecke Bildschirmebene x (ymin) ');
    ymin:=getreal(ymin,'Relative linke untere Ecke Bildschirmebene y (xmin) ');
    xsize:=getreal(xsize,'Breite der Bildschirmebene (xsize) ');
    VPD:=getreal(VPD,'Senkrechter Abstand Betrachters<>Bildschirmebene (VPD) ');
    FPD:=getreal(FPD,'Vordere Clip Ebene (FPD) ');
    BPD:=getreal(BPD,'Hintere Clip Ebene (BPD) ');
    while keypressed do c:=readkey;
    textcolor(yellow);
    writeln('Soll die Grafik aus Polygonen oder aus Linien zusammengesetzt werden');
    write('(Variable wireframe) ? [P/L]');
    wireframe:=upcase(readkey)='L';
    writeln;
    write('Sollen Rckflchen dargestellt werden (Variable flipAreaEnabled) ? [J/N]');
    flipAreaEnabled:=upcase(readkey)='J';
    if not wireframe then begin
      writeln;
      write('Sollen die Flchen ausgefllt werden (Variable TriFillEnable) ? [J/N]');
      TriFillEnable:=upcase(readkey)<>'N';
      writeln;
      write('Soll gleichmig schattiert werden (Variable ShadingMethod) ? [J/N]');
      if upcase(readkey)='N' then shadingmethod:=flat else shadingmethod:=gouraud;
      writeln;
    end else begin
      trifillenable:=false;
      shadingmethod:=flat;
      writeln;
      write('Soll die 3D-Brille benutzt werden knnen ? [J/N]');
      brille:=upcase(readkey)='J';
      writeln;
      if brille then begin
        augendist:=getreal(augendist,'Augenabstand ');
      end;
      textcolor(yellow);
      write('Soll ein Ramen gezogen werden ? [J/N]');
      frame:=upcase(readkey)='J';
      writeln;
    end;
    write('Sollen nur die Clip-Wrfel der Objekte gezeigt werden ? [J/N]');
    clipcube:=upcase(readkey)='J';
    writeln;
    wireframe:=wireframe or (not VGAvorhanden);
    if wireframe then grafmode:=0 else begin
      write('Soll der SCQ Modus verwendet werden ? (360*480*256) [J/N]');
      if upcase(readkey)='N' then grafmode:=-1 else grafmode:=-2;
      writeln;
    end;
    repeat
      write('Welcher Grafik Modus ? 0=rgb 1=sw64 2=sw256');
      farbig:=byte(readkey)-48;
    until farbig<3;
    if grafmode<0 then begin
      write('Wie soll das Bild heien (ohne Erweiterung) ? :');
      readln(name);
    end;
    write('Sind diese Angaben in Ordnung ? [J/N]');
  until upcase(readkey)<>'N';
end;

end.