unit LeseWiz;
interface
uses dos;
const maxtable=100;
type TLableTable=record
                   case boolean of
                     true:(l:array[1..maxtable] of longint;);
                     false:(w:array[1..2*maxtable] of word;);
                 end;
     PLeseWiz=^TLeseWiz;
     TLeseWiz=object
       varint:array[65..90] of integer;
       varreal:array[65..90] of real;
       befehl,argumente:string;
       intermodus:boolean;
       labletable:TLableTable;
       aktlable,maxlable:byte;
       buf:pointer;
       lange,bufpos:word;
       Zeile:Word;
       name:pathstr;
       gepuffert:boolean;
       f:text;
       constructor Reset(var aname:pathstr;platz:word);{Gibt ''in AName zurck falls Fehler}
       destructor close;
       procedure NewLabel(lablenr:longint);
       procedure SetMode(ainter:boolean);{Setzt auch BufPos zurck}
       procedure lesezeile;
       function NextToken:byte;
       function zahl:integer;
       function realzahl:real;
       function GetMeshExt(nr:byte):byte;virtual;
       function GetMCPos(nr:byte):single;virtual;
       procedure error(s:string);virtual;
       procedure zeilenerror(s:string);
     end;

implementation
type Bytearray=array[0..65534] of byte;
     Chararray=array[0..65534] of char;

function posof(p:pointer;anf,lange:word):word;assembler;
asm
  push ds
  lds si,p
  mov bx,si
  inc bx
  add si,anf
  mov cx,lange
  sub cx,anf
  cld
@1: lodsb
    cmp al,13
    loopne @1
  mov ax,si
  sub ax,bx
  pop ds
end;

constructor TLeseWiz.Reset(var aname:pathstr;platz:word);{Gibt ''in AName zurck falls Fehler}
var such:searchrec;
    d:file;
    letztZeilAnf:word;
    h:byte;
    fehler:boolean;
begin
  fillchar(varint,sizeof(varint),#0);
  fillchar(varreal,sizeof(varreal),#0);
  randomize;
  befehl:='';
  argumente:='';
  zeile:=0;
  intermodus:=false;
  aktlable:=0;
  maxlable:=0;
  name:=aname;
  such.name:=name;
  findfirst(such.name,anyfile,such);
  if doserror=0 then begin
    if (succ(such.size)>platz) or (maxavail<succ(such.size)) then begin
      gepuffert:=false;
      assign(f,name);
      system.reset(f);
    end else if such.size>0 then begin
      lange:=succ(such.size);
      assign(d,name);
      system.reset(d,1);
      gepuffert:=true;
      getmem(buf,Lange);
      blockread(d,bytearray(buf^)[1],pred(Lange));
      system.close(d);
      letztZeilAnf:=0;
      bytearray(buf^)[0]:=0;
      fehler:=false;
      while not fehler and (letztZeilAnf<lange) do begin
        h:=posof(buf,succ(letztZeilAnf),succ(lange));
        if h<lange then begin
          bytearray(buf^)[h]:=byte(' ');
          inc(h);
        end;
        if h<lange then begin
          bytearray(buf^)[h]:=byte(' ');
          while (bytearray(buf^)[succ(h)]=byte(' ')) and (h<lange) do inc(h);
        end;
        if pred(h-letztZeilAnf)<255 then begin
          bytearray(buf^)[letztZeilAnf]:=pred(h-letztZeilAnf);
          if chararray(buf^)[succ(letztZeilAnf)]=':' then newlabel(letztZeilAnf);
        end else fehler:=true;
        letztZeilAnf:=h;
      end;
      if fehler then aname:='';
    end else aname:='';
    bufpos:=0;
  end else aname:='';
end;

destructor TLeseWiz.close;
begin
  if gepuffert then freemem(buf,lange)
  else system.close(f);
end;

procedure SetMode(ainter:boolean);{Setzt auch BufPos zurck}
begin
  intermodus:=ainter;
  bufpos:=0;
  zeile:=0;
  befehl:='';
  argumente:='';
  if not gepuffert then begin
    system.close(f);
    system.reset(f);
  end;
end;

procedure TLeseWiz.NewLabel(lablenr:longint);
begin
  if gepuffert then begin
    if maxlable<2*maxtable then begin
      inc(maxlable);
      LableTable.w[maxlable]:=lablenr;
    end else begin
      inc(aktlable);
      if aktlable>2*maxtable then aktlable:=1;
      LableTable.w[aktlable]:=lablenr;
    end;
  end else begin
    if maxlable<maxtable then begin
      inc(maxlable);
      LableTable.l[maxlable]:=lablenr;
    end else begin
      inc(aktlable);
      if aktlable>maxtable then aktlable:=1;
      LableTable.l[aktlable]:=lablenr;
    end;
  end;
end;

procedure TLeseWiz.lesezeile;
begin
  while pos(' ',argumente)=1 do delete(argumente,1,1);
  if length(argumente)<>0 then befehl:=argumente else begin
    readln(f,befehl);
    inc(zeile);
  end;
  while pos(' ',befehl)=1 do delete(befehl,1,1);
  argumente:=befehl;
  argumente:=argumente+' ';
  delete(argumente,1,pos(' ',argumente));
  befehl:=befehl+' ';
  delete(befehl,pos(' ',befehl),length(befehl)-pos(' ',befehl));
end;

function TLeseWiz.NextToken:byte;
begin


end;

function TLeseWiz.zahl:integer;
begin
end;

function TLeseWiz.realzahl:real;
begin
end;

function TLeseWiz.GetMeshExt(nr:byte):byte;
begin
end;

function TLeseWiz.GetMCPos(nr:byte):single;
begin
end;

procedure TLeseWiz.zeilenerror(s:string);
var buf:string[4];
begin
  str(zeile,buf);
  error(s+' in Zeile '+buf);
end;

procedure TLeseWiz.error(s:string);
begin
end;

end.