unit obtfast;
interface
uses dreid,dos,BufFile;

function loadobjekt(name:string;daten:byte):byte;
function saveobjekt(name:string;daten:byte):byte;

implementation

function loadobjekt(name:string;daten:byte):byte;
Type ByteArray=array[0..65534] of byte;
var gelesen,dateidaten,maxxdaten,maxydaten:byte;
    dirinfo:searchrec;
    realdaten:boolean;
    surface:surfacepropertytyp;
    hilf:shortint;
    x,y,hilfb:byte;
    dir:dirstr;
    ext:extstr;
    buf:TFileBuf;
begin
  gelesen:=0;
  fsplit(name,dir,name,ext);
  name:=dir+name;
  FindFirst(name+'.OBT', $3f, DirInfo);
  if (DosError = 0) then begin
    buf.Reset(name+'.OBT',1,1000);
    buf.Read(dateidaten,1);
    buf.Read(maxxdaten,1);
    buf.Read(maxydaten,1);
    {$IFopt N+}
      buf.Read(_wrkarr.volume.x,4);
      buf.Read(_wrkarr.volume.y,4);
      buf.Read(_wrkarr.volume.z,4);
    {$else}
      buf.Read(_wrkarr.volume.x,6);
      buf.Read(_wrkarr.volume.y,6);
      buf.Read(_wrkarr.volume.z,6);
    {$endif}
    realdaten:=(dateidaten and realdat)>0;
    if ((dateidaten and xdat)>0) then begin
      if ((daten and xdat)>0) then begin
        _wrkarr.xmax:=maxxdaten;
        _wrkarr.ymax:=maxydaten;
        gelesen:=gelesen or xdat;
        for x:=0 to maxxdaten do
        for y:=0 to maxydaten do
        if realdaten then
         {$IFopt N+}
           buf.Read(_wrkarr.m[x]^[y].a.crd.x,4)
         {$else}
           buf.Read(_wrkarr.m[x]^[y].a.crd.x,6)
         {$endif}
        else begin
          buf.Read(hilf,1);
          _wrkarr.m[x]^[y].a.crd.x:=hilf/255;
        end
      end else if realdaten then
      {$IFopt N+}
        buf.Seek(buf.FilePos+4*succ(maxxdaten)*succ(maxydaten))
      {$else}
        buf.Seek(buf.FilePos+6*succ(maxxdaten)*succ(maxydaten))
      {$endif}
      else buf.Seek(buf.FilePos+succ(maxxdaten)*succ(maxydaten));
    end;
    if ((dateidaten and ydat)>0) then begin
      if ((daten and ydat)>0) then begin
        _wrkarr.xmax:=maxxdaten;
        _wrkarr.ymax:=maxydaten;
        gelesen:=gelesen or ydat;
        for x:=0 to maxxdaten do
        for y:=0 to maxydaten do
        if realdaten then
        {$IFopt N+}
          buf.Read(_wrkarr.m[x]^[y].a.crd.y,4)
        {$else}
          buf.Read(_wrkarr.m[x]^[y].a.crd.y,6)
        {$endif}
        else begin
          buf.Read(hilf,1);
          _wrkarr.m[x]^[y].a.crd.y:=hilf/255;
        end
      end else if realdaten then
      {$IFopt N+}
        buf.Seek(buf.FilePos+2*4*succ(maxxdaten)*succ(maxydaten))
      {$else}
        buf.Seek(buf.FilePos+2*6*succ(maxxdaten)*succ(maxydaten))
      {$endif}
      else buf.Seek(buf.FilePos+2*succ(maxxdaten)*succ(maxydaten));
    end;
    if ((dateidaten and zdat)>0) then begin
      if ((daten and zdat)>0) then begin
        _wrkarr.xmax:=maxxdaten;
        _wrkarr.ymax:=maxydaten;
        gelesen:=gelesen or zdat;
        for x:=0 to maxxdaten do
        for y:=0 to maxydaten do
        if realdaten then
        {$IFopt N+}
          buf.Read(_wrkarr.m[x]^[y].a.crd.z,4)
        {$else}
          buf.Read(_wrkarr.m[x]^[y].a.crd.z,6)
        {$endif}
        else begin
          buf.Read(hilf,1);
          _wrkarr.m[x]^[y].a.crd.z:=hilf/255;
        end
      end else if realdaten then
      {$IFopt N+}
       buf.Seek(buf.FilePos+3*4*succ(maxxdaten)*succ(maxydaten))
      {$else}
       buf.Seek(buf.FilePos+3*6*succ(maxxdaten)*succ(maxydaten))
      {$endif}
      else buf.Seek(buf.FilePos+3*succ(maxxdaten)*succ(maxydaten));
    end;
    if ((dateidaten and nrmdat)>0) then begin
      if ((daten and nrmdat)>0) then begin
        gelesen:=gelesen or nrmdat;
        for x:=0 to maxxdaten do
        for y:=0 to maxydaten do
        if realdaten then
        {$IFopt N+}
          buf.Read(_wrkarr.m[x]^[y].a.nrm,3*4)
        {$else}
          buf.Read(_wrkarr.m[x]^[y].a.nrm,3*6)
        {$endif}
        else begin
          buf.Read(hilf,1);
          _wrkarr.m[x]^[y].a.nrm.x:=hilf/255;
          buf.Read(hilf,1);
          _wrkarr.m[x]^[y].a.nrm.y:=hilf/255;
          buf.Read(hilf,1);
          _wrkarr.m[x]^[y].a.nrm.z:=hilf/255;
        end
      end else if realdaten then
      {$IFopt N+}
        buf.Seek(buf.FilePos+6*4*succ(maxxdaten)*succ(maxydaten))
      {$else}
        buf.Seek(buf.FilePos+6*6*succ(maxxdaten)*succ(maxydaten))
      {$endif}
      else buf.Seek(buf.FilePos+6*succ(maxxdaten)*succ(maxydaten));
    end;
    if ((dateidaten and texturdat)>0) then begin
      if ((daten and texturdat)>0) then begin
        gelesen:=gelesen or texturdat;
        for x:=0 to maxxdaten do
         for y:=0 to maxydaten do begin
          buf.Read(hilfb,1);
          _wrkarr.m[x]^[y].a.c.r:=hilfb/255;
          buf.Read(hilfb,1);
          _wrkarr.m[x]^[y].a.c.g:=hilfb/255;
          buf.Read(hilfb,1);
          _wrkarr.m[x]^[y].a.c.b:=hilfb/255;
        end
      end else buf.Seek(buf.FilePos+3*succ(maxxdaten)*succ(maxydaten));
    end;
    overwriteflags:=true;
    if ((dateidaten and sichtdat)>0) then
     if ((daten and sichtdat)>0) then begin
      gelesen:=gelesen or sichtdat;
      overwriteflags:=false;
      for x:=0 to maxxdaten do
       for y:=0 to maxydaten do
         if (ByteArray(buf.buf^)[buf.FilePos+((x*succ(maxydaten)+y) div 8)] and
             ($80 shr ((x*succ(maxydaten)+y) mod 8)) >0)
         then _wrkarr.m[x]^[y].flags:=notused
         else _wrkarr.m[x]^[y].flags:=isVis;
     end;
     buf.Seek(buf.FilePos+((succ(maxxdaten)*succ(maxydaten)+7) div 8));
    if ((dateidaten and materialdat)>0) then
     if ((daten and materialdat)>0) then begin
       gelesen:=gelesen or materialdat;
       buf.Read(surface,sizeof(surfaceproperty));
       with surface do changesurfaceproperty(ka,kd,ks,os.r,os.g,os.b,oe,od.r,od.g,od.b,alpha);
     end;
    Buf.Close;
  end else error('Objekt '+name+'.OBT nicht gefunden');
  loadobjekt:=gelesen;
  if overwriteFlags and (daten and sichtdat>0) then
    for x:=0 to maxxdaten do
       for y:=0 to maxydaten do
         _wrkarr.m[x]^[y].flags:=isVis;
end;

function saveobjekt(name:string;daten:byte):byte;
var geschrieben:byte;
    dirinfo:searchrec;
    realdaten:boolean;
    hilf:shortint;
    x,y,hilfb:byte;
    dir:dirstr;
    ext:extstr;
    buf:tFileBuf;
begin
  fsplit(name,dir,name,ext);
  name:=dir+name;
  geschrieben:=0;
  buf.rewrite(name+'.OBT',succ(_wrkarr.xmax)*succ(_wrkarr.ymax)*(sizeof(real)*6+4)+100,1000);
  buf.write(daten,1);
  buf.write(_wrkarr.xmax,1);
  buf.write(_wrkarr.ymax,1);
  {$IFopt N+}
    buf.write(_wrkarr.volume.x,4);
    buf.write(_wrkarr.volume.y,4);
    buf.write(_wrkarr.volume.z,4);
  {$else}
    buf.write(_wrkarr.volume.x,6);
    buf.write(_wrkarr.volume.y,6);
    buf.write(_wrkarr.volume.z,6);
  {$endif}
  realdaten:=(daten and realdat)>0;
  if ((daten and xdat)>0) then begin
    for x:=0 to _wrkarr.xmax do
     for y:=0 to _wrkarr.ymax do
      if realdaten then
       {$IFopt N+}
        buf.write(_wrkarr.m[x]^[y].a.crd.x,4)
       {$else}
         buf.write(_wrkarr.m[x]^[y].a.crd.x,6)
       {$endif}
      else begin
        hilf:=round(_wrkarr.m[x]^[y].a.crd.x*255);
        buf.write(hilf,1);
      end;
    geschrieben:=geschrieben or xdat;
  end;
  if ((daten and ydat)>0) then begin
    for x:=0 to _wrkarr.xmax do
     for y:=0 to _wrkarr.ymax do
      if realdaten then
       {$IFopt N+}
         buf.write(_wrkarr.m[x]^[y].a.crd.y,4)
       {$else}
         buf.write(_wrkarr.m[x]^[y].a.crd.y,6)
       {$endif}
      else begin
        hilf:=round(_wrkarr.m[x]^[y].a.crd.y*255);
        buf.write(hilf,1);
      end;
    geschrieben:=geschrieben or ydat;
  end;
  if ((daten and zdat)>0) then begin
    for x:=0 to _wrkarr.xmax do
     for y:=0 to _wrkarr.ymax do
      if realdaten then
       {$IFopt N+}
         buf.write(_wrkarr.m[x]^[y].a.crd.z,4)
       {$else}
         buf.write(_wrkarr.m[x]^[y].a.crd.z,6)
       {$endif}
      else begin
        hilf:=round(_wrkarr.m[x]^[y].a.crd.z*255);
        buf.write(hilf,1);
      end;
    geschrieben:=geschrieben or zdat;
  end;
  if ((daten and nrmdat)>0) then begin
    for x:=0 to _wrkarr.xmax do
     for y:=0 to _wrkarr.ymax do
      if realdaten then
       {$IFopt N+}
         buf.write(_wrkarr.m[x]^[y].a.nrm,3*4)
       {$else}
         buf.write(_wrkarr.m[x]^[y].a.nrm,3*6)
       {$endif}
      else begin
        hilf:=round(_wrkarr.m[x]^[y].a.nrm.x*255);
        buf.write(hilf,1);
        hilf:=round(_wrkarr.m[x]^[y].a.nrm.y*255);
        buf.write(hilf,1);
        hilf:=round(_wrkarr.m[x]^[y].a.nrm.z*255);
        buf.write(hilf,1);
      end;
    geschrieben:=geschrieben or nrmdat;
  end;
  if ((daten and texturdat)>0) then begin
    for x:=0 to _wrkarr.xmax do
     for y:=0 to _wrkarr.ymax do begin
       hilfb:=round(_wrkarr.m[x]^[y].a.c.r*255);
       buf.write(hilfb,1);
       hilfb:=round(_wrkarr.m[x]^[y].a.c.g*255);
       buf.write(hilfb,1);
       hilfb:=round(_wrkarr.m[x]^[y].a.c.b*255);
       buf.write(hilfb,1);
     end;
    if doserror=0 then geschrieben:=geschrieben or texturdat;
  end;
   if ((daten and sichtdat)>0) then begin
    hilfb:=0;
    for x:=0 to _wrkarr.xmax do
     for y:=0 to _wrkarr.ymax do begin
       if (_wrkarr.m[x]^[y].flags and notused)>0
       then hilfb:=hilfb+($80 shr ((x*succ(_wrkarr.ymax)+y) mod 8));
       if (((x*succ(_wrkarr.ymax)+y) mod 8)=7)
       then begin
         buf.write(hilfb,1);
         hilfb:=0;
       end;
     end;
   end;
  if ((daten and materialdat)>0) then begin
    buf.write(surfaceproperty,sizeof(surfaceproperty));
    geschrieben:=geschrieben or materialdat;
  end;
  buf.close;
  saveobjekt:=geschrieben;
end;

end.