program showpicture;
uses crt,printer,dos,vga,farbreg,wizinfo,adlib,playunit,playrol,instr,ULoadPic;
const zip:boolean=false;
      breite=960;
      ramen:boolean=false;
var datei : file;
    name:pathstr;
    nam:namestr;
    dir:dirstr;
    ext:extstr;
    ein:char;
    suche:searchrec;
    n:byte;
    aktpal,pblack,pnormal,prgb,psw256,p3d:ppalette;

function id(bef,s:string):boolean;
var gleich:boolean;
    n,k:byte;
begin
  gleich:=true;
  while (' '=bef[length(bef)]) do delete(bef,length(bef),1);
  K:=length(bef);
  if k=0 then k:=1;
  n:=length(s);
  if n<k then k:=n;
  n:=1;
  repeat
    bef[n]:=upcase(bef[n]);
    case bef[n] of
      '':bef[n]:='';
      '':bef[n]:='';
      '':bef[n]:='';
    end;
    gleich:=gleich and (s[n]=bef[n]);
    inc(n);
  until (not gleich) or (n>k);
  id:=gleich;
end;

procedure druck;
const dm:array[0..1,0..3] of byte =
         ((3,6,1,4),(7,2,5,0));
type palettentyp=array[0..255] of record r,g,b:byte; end;
     druckpaltyp=array[0..255] of byte;
     drucktyp=array[0..1,0..959] of byte;
var palette:palettentyp;
    druckpal:druckpaltyp;
    c1,c2,c3,c4,x2,y2:byte;
    zeile:drucktyp;
    n,x,y:word;
    a,zeilenr,bitnr:byte;
    regs:registers;
begin
  with regs do begin
    bx:=0;cx:=256;es:=seg(palette);dx:=ofs(palette);
    ax:=$1017;intr($10,regs);
  end;
  for n:=0 to 255 do
    druckpal[n]:=round((palette[n].r*0.30+palette[n].g*0.59+palette[n].b*0.11)) div 8;
  for x:=0 to 89 do begin
    fillchar(zeile,sizeof(zeile),#0);
    for y:=479 downto 0 do begin
      c1:=druckpal[scqgetpixel(x*4,y)];
      c2:=druckpal[scqgetpixel(succ(x*4),y)];
      c3:=druckpal[scqgetpixel(x*4+2,y)];
      c4:=druckpal[scqgetpixel(x*4+3,y)];
      for x2:=0 to 1 do begin
        for y2:=0 to 3 do begin
          zeilenr:=y2 and 1;
          bitnr:=y2 shr 1;
          if dm[x2,y2]>c1 then zeile[zeilenr,y*2+x2]:=zeile[zeilenr,y*2+x2] or ($80 shr bitnr);
          inc(bitnr,2);
          if dm[x2,y2]>c2 then zeile[zeilenr,y*2+x2]:=zeile[zeilenr,y*2+x2] or ($80 shr bitnr);
          inc(bitnr,2);
          if dm[x2,y2]>c3 then zeile[zeilenr,y*2+x2]:=zeile[zeilenr,y*2+x2] or ($80 shr bitnr);
          inc(bitnr,2);
          if dm[x2,y2]>c4 then zeile[zeilenr,y*2+x2]:=zeile[zeilenr,y*2+x2] or ($80 shr bitnr);
        end;
      end;
    end;
    for a:=0 to 1 do begin
      write(lst,chr(27)+'*'+chr(1)+chr(breite mod 256)+chr(breite div 256));
      for n:=pred(breite) downto 0 do write(lst,chr(zeile[a,n]));
      if a=1 then write(lst,chr(27)+'J'+chr(22))
      else write(lst,chr(27)+'J'+chr(2));
      write(lst,chr(13));
      if keypressed then exit;
    end;
  end;
end;

procedure setfarbe(var p:ppalette;register:word;rot,gruen,blau:byte);
begin
  p^[register,0]:=rot;p^[register,1]:=gruen;p^[register,2]:=blau;
end;

procedure calcclutrgb;
var r,b,g,redi,greeni,bluei,colorindex:integer;
begin
  new(prgb);
  for r:=0 to 7 do begin
    redi:=r*9;
    for g:=0 to 7 do begin
      greeni:=g*9;
      for b:=0 to 3 do begin
        bluei:=b*21;
        colorindex:=(r shl 3 or g) shl 2 or b;
        setfarbe(prgb,colorindex,redi,greeni,bluei);
      end;
    end;
  end;
end;

procedure calcclutnormal;
var f:byte;
begin
  new(pnormal);
  for f:=0 to 63 do setfarbe(pnormal,f,f,0,0);
  for f:=0 to 63 do setfarbe(pnormal,f+64,0,f,0);
  for f:=0 to 63 do setfarbe(pnormal,f+128,0,0,f);
  for f:=0 to 63 do setfarbe(pnormal,f+192,f,f,f);
end;

procedure calcclutsw256;
var n,f,m:byte;
begin
  new(psw256);
  for n:=0 to 62 do begin
    f:=n*4;
    setfarbe(psw256,f,n,n,n);
    setfarbe(psw256,succ(f),succ(n),n,n);
    if n<62 then setfarbe(psw256,f+2,succ(n),n,n+2) else setfarbe(psw256,f+2,succ(n),n,n+1);
    setfarbe(psw256,f+3,n,succ(n),succ(n));
  end;
  for m:=0 to 3 do setfarbe(psw256,63*4+m,n,n,n);
end;

procedure calcclut3d;
var n,m:byte;
begin
  new(p3d);
  for m:=0 to 15 do for n:=0 to 15 do setfarbe(p3d,m*16+n,
       round(m*63/15),
       round(n*63/15),
       0);
end;

procedure calcclutblack;
begin
  new(pblack);
  fillchar(pblack^,sizeof(pblack^),#0);
end;

procedure ladebild(name:string);
var palnr:byte;
begin
  findfirst(name+'.PIC',$3f,suche);
  if doserror<>0 then begin
    findfirst(name+'.ZIP',$3f,suche);
    if doserror<>0 then begin
      writeln(name+'.PIC oder '+name+'.ZIP nicht gefunden !');
      repeat until keypressed;
      halt(1);
    end;
    swapvectors;
    exec('PKUNZIP.EXE',name+'.ZIP');
    swapvectors;
    suche.name:=name+'.PIC';
    findfirst(name+'.PIC',$3f,suche);
    if doserror<>0 then begin
      writeln('Ausfhren von:');
      writeln('PKUNZIP.EXE ',name+'.ZIP');
      writeln('fehlerhaft !');
      repeat until keypressed;
      halt(2);
    end;
    zip:=true;
  end;
  if aktpal<>nil then shadeout(0,aktpal);
  LoadBild(name,palnr);
  if zip then erase(datei);
  case palnr of
    1:aktpal:=pnormal;
    2:aktpal:=prgb;
    3:aktpal:=psw256;
    4:aktpal:=p3d;
  end;
  shadein(0,aktpal);
end;

procedure slideshow;
var music:(NoMusic,RolMusic);
    datei,ende:boolean;
    suche,musiksuche:searchrec;
    n:byte;
    f:text;
    nam,mus,spr:pathstr;
    del:byte;
    song:roltp;
    bank:bnktp;

  function NurName(aname:string):string;
  var dir:dirstr;
      ext:extstr;
  begin
    fsplit(aname,dir,aname,ext);
    nurname:=dir+aname;
  end;

  procedure musiknam(nam:string);
  var such:searchrec;
  begin
    if adgetstatus=0 then begin
      adclear;
      adinit;
      such.name:=nurname(nam)+'.ROL';
      findfirst(such.name,$3f,such);
      if doserror=0 then begin
        loadrol(nam+'.ROL',song);
        spielerol(song,bank);
        entfernerol(song);
      end;
    end;
  end;

  procedure musik(var suche:searchrec);
  begin
    if adgetstatus=0 then begin
      adclear;
      adinit;
      loadrol(nurname(suche.name)+'.ROL',song);
      spielerol(song,bank);
      entfernerol(song);
      findnext(suche);
      if doserror<>0 then begin
        suche.name:='*.ROL';
        findfirst('*.ROL',$3f,suche);
        if (Doserror<>0) then music:=NoMusic;
      end;
    end;
  end;

  procedure lese(var f:text;var nam,mus,spr:string;var del:byte);
  var hilf:string;
      code:integer;

    procedure losch;
    begin
      if hilf<>'' then begin
        delete(hilf,1,pos(' ',hilf));
        while (length(hilf)>0) and (hilf[1]=' ') do delete(hilf,1,1);
      end;
    end;

  begin
    if eof(f) then begin
      close(f);
      assign(f,paramstr(2)+'.SOW');
      reset(f);
    end;
    readln(f,hilf);
    while (length(hilf)>0) and (hilf[1]=' ') do delete(hilf,1,1);
    hilf:=hilf+' ';
    nam:=copy(hilf,1,pred(pos(' ',hilf)));
    losch;
    if hilf<>'' then mus:=copy(hilf,1,pred(pos(' ',hilf))) else mus:='_';
    losch;
    val(mus,del,code);
    if code<>0 then del:=70;
    if hilf<>'' then mus:=copy(hilf,1,pred(pos(' ',hilf))) else mus:='_';
    losch;
    spr:=hilf;
    while (spr[length(spr)]=' ') and (length(spr)>0) do delete(spr,length(spr),1);
  end;

begin
  ende:=false;
  datei:=false;
  if paramcount>1 then begin
    music:=RolMusic;
    datei:=true;
    suche.name:='STANDARD.BNK';
    findfirst(suche.name,anyfile,suche);
    if doserror<>0 then music:=nomusic;
  end else music:=NoMusic;
  if not advorhanden then music:=NoMusic;

  if music=RolMusic then loadbnk('STANDARD.BNK',bank);
  if datei then begin
    suche.name:=paramstr(2)+'.SOW';
    findfirst(suche.name,anyfile,suche);
    datei:=doserror=0;
  end;

  if datei then begin
    assign(f,paramstr(2)+'.SOW');
    reset(f);
    repeat
      lese(f,nam,mus,spr,del);
      if (mus<>'_') and (music<>NoMusic) then musiknam(mus);
      ladebild(nam);
      if (spr<>'') and (spr[1]<>';') then spiele(nurname(spr));
      n:=1;
      while (not keypressed) and (n<del) do begin
        delay(100);
        inc(n);
        if (mus<>'_') and (music<>NoMusic) then musiknam(mus);
      end;
    until keypressed;
    close(f);
  end else begin
    if music<>NoMusic then begin
      musiksuche.name:='*.ROL';
      findfirst(musiksuche.name,anyfile,musiksuche);
      if (Doserror<>0) then music:=NoMusic;
    end;
    repeat
      suche.name:='*.PIC';
      findfirst('*.PIC',$3f,suche);
      if (Doserror<>0) then ende:=true;
      while (doserror=0) and (not ende) do begin
        if music<>NoMusic then musik(musiksuche);
        ladebild(nurname(suche.name));
        n:=1;
        while (not ende) and (n<70) do begin
          delay(100);
          inc(n);
          if music<>NoMusic then musik(musiksuche);
          while keypressed do ein:=readkey;
          case ein of
            #27:ende:=true;
            ' ':if music<>NoMusic then begin
                  adclear;
                  adinit;
                  musik(Musiksuche);
                end;
            #13:n:=100;
          end;
          ein:='^';
        end;
        if not ende then findnext(suche);
        if doserror<>0 then begin
          suche.name:='*.PIC';
          findfirst('*.PIC',$3f,suche);
        end;
      end;
    until ende;
  end;
  vgaende;
  halt(0);
end;

begin
  aktpal:=nil;
  calcclutrgb;
  calcclutnormal;
  calcclutsw256;
  calcclut3d;
  calcclutblack;
  nosound;
  name:='';
  if paramcount<>0 then begin
    name:=paramstr(1);
    if id(name,'SLIDESHOW') then slideshow;
  end else if getinfo<>'' then begin
    fsplit(getinfo,dir,nam,ext);
    name:=dir+nam;
    suche.name:='*.PIC';
    findfirst(name+'.PIC',$3f,suche);
    if (Doserror<>0) then begin
      suche.name:='*.ZIP';
      findfirst(name+'.ZIP',$3f,suche);
      if (Doserror<>0) then name:='';
    end;
  end;
  if name='' then begin
    textbackground(blue);
    textcolor(yellow);
    clrscr;
    writeln('*** WizArt Bilder anzeigen ***':50);
    writeln;
    writeln('Nachdem ein Bild geladen ist haben Sie drei Mglichkeiten:');
    writeln('Taste ''1'' : Normale Palette');
    writeln('Taste ''2'' : Palette fr 4*64 Graustufen Bilder');
    writeln('Taste ''3'' : Palette fr 256 Graustufen Bilder');
    writeln('Taste ''4'' : Palette fr Rot/Grn 3D Bilder');
    writeln('Taste ''5'' : Aufruf des Unterprogramms zur Farbregelung');
    writeln('Taste ''6'' : Drucken im SCQ Modus auf Star LC-10');
    writeln('Taste ''7'' : Ramen fr Bildschirmfotos an/aus');
    writeln('Dort bedeutet');
    writeln('''H'' : Helligkeit');
    writeln('''K'' : Kontrast');
    writeln('''L'' : Luminanz');
    writeln('Verndert werden die Werte mit ''+'' und ''-''');
    writeln('Zurckgesetzt mit ''=''');
    writeln;
    writeln('Folgende Bilder knnen Sie laden:');
    writeln;
    suche.name:='*.PIC';
    findfirst('*.PIC',$3f,suche);
    if (Doserror<>0) then writeln('keine ungepackten Bilder':10);
    while (doserror=0) do begin
      write(suche.name:20);
      findnext(suche);
    end;
    writeln;
    suche.name:='*.ZIP';
    findfirst('*.ZIP',$3f,suche);
    if (Doserror<>0) then writeln('keine gepackten Bilder':10);
    while (doserror=0) do begin
      write(suche.name:20);
      findnext(suche);
    end;
    writeln;
    write('Geben Sie den Bilddateinamen ein (ohne Extension) : ');
    readln(name);
  end;
  ladebild(name);
  repeat
    repeat until keypressed;
    ein:=readkey;
    if ein=#0 then ein:=readkey;
    case ein of
    '1':setpalette(prgb);
    '2':setpalette(pnormal);
    '3':setpalette(psw256);
    '4':setpalette(p3d);
    '5':farberegeln;
    '6':druck;
    '7':begin
        ramen:=not ramen;
        overscan(255*byte(ramen));
      end;
    end;
  until  ein=#27;
  vgaende;
end.
