program vieleck;
uses graph,dos,crt,maus;
const randunten=40;
      grafikpfad='';
      drei=0;
      vier=1;
      kugel=2;
      snap:real=0.01;
      ausschnitt:real=4;
      koorbeginx=120;
      rot=0;
      gruen=1;
      blau=2;
type rgb=record r,g,b:real; end;
     rgbarr=array[0..2] of real;
const weiss:rgbarr=(1,1,1);
      flaechen:boolean=false;
type rgbzeiger=^rgb;
     koortyp=record x,y,z:real; end;
     eckzeiger=^ecktyp;
     ecktyp=object
              gesichert:boolean;
              farbe:rgb;
              nummer:byte;
              procedure init(num:byte;c:rgbzeiger);
              procedure reset;
              procedure setfarbe(col:byte;wert:real);
              function getfarbe:rgbzeiger;
              function farbvergleich(c:rgb):boolean;
              function schongesichert:boolean;
              procedure setzegesichert;
              function getnum:byte;
              procedure setnum(x:byte);
              procedure anzeigen(color:byte); virtual;
              procedure neuekoor(dx,dy,dz:integer;eckenummer:byte);virtual;
              procedure allekoor(dx,dy,dz:integer);virtual;
              procedure sichere(var f:text);virtual;
              procedure quantisieren; virtual;
              procedure allekooranzeigen; virtual;
              procedure kooranzeigen(y:integer;a:byte);virtual;
              function getecke(x,y:integer):byte; virtual;
              procedure invert;virtual;
            end;
     dreieckzeiger=^dreiecktyp;
     dreiecktyp=object(ecktyp)
                  ecke:array[0..2] of koortyp;
                  constructor init(num:byte;x1,y1,z1,x2,y2,z2,x3,y3,z3:real;c:rgbzeiger);
                  procedure anzeigen(color:byte); virtual;
                  procedure neuekoor(dx,dy,dz:integer;eckenummer:byte);virtual;
                  procedure allekoor(dx,dy,dz:integer);virtual;
                  procedure sichere(var f:text);virtual;
                  procedure quantisieren; virtual;
                  procedure allekooranzeigen; virtual;
                  procedure kooranzeigen(y:integer;a:byte);virtual;
                  function getecke(x,y:integer):byte; virtual;
                  procedure invert;virtual;
                end;
     viereckzeiger=^vierecktyp;
     vierecktyp=object(ecktyp)
                  ecke:array[0..3] of koortyp;
                  constructor init(num:byte;x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:real;c:rgbzeiger);
                  procedure anzeigen(color:byte); virtual;
                  procedure neuekoor(dx,dy,dz:integer;eckenummer:byte);virtual;
                  procedure allekoor(dx,dy,dz:integer);virtual;
                  procedure sichere(var f:text);virtual;
                  procedure quantisieren; virtual;
                  procedure allekooranzeigen; virtual;
                  procedure kooranzeigen(y:integer;a:byte);virtual;
                  function getecke(x,y:integer):byte; virtual;
                  procedure invert;virtual;
                end;
     kugelzeiger=^kugeltyp;
     kugeltyp=object(ecktyp)
                  ecke:array[0..1] of koortyp;
                  constructor init(num:byte;x1,y1,z1,x2,y2,z2:real;c:rgbzeiger);
                  procedure anzeigen(color:byte); virtual;
                  procedure neuekoor(dx,dy,dz:integer;eckenummer:byte);virtual;
                  procedure allekoor(dx,dy,dz:integer);virtual;
                  procedure sichere(var f:text);virtual;
                  procedure quantisieren; virtual;
                  procedure allekooranzeigen; virtual;
                  procedure kooranzeigen(y:integer;a:byte);virtual;
                  function getecke(x,y:integer):byte; virtual;
                end;


     knotenzeiger=^knotentyp;
     knotentyp=object
                 teil:eckzeiger;
                 weiter:knotenzeiger;
               end;

     listzeiger=^listtyp;
     listtyp=object
               knoten,akt:knotenzeiger;
               gespeichert:boolean;
               maxnum:word;
               constructor init;
               destructor done;
               procedure sichern(name:namestr);
               procedure neuaufbau(color:byte);
               procedure bewege(x:byte);
               function weiter:byte;
               function zuruck:byte;
               function loschen:byte;
               function add(teil:eckzeiger):byte;
               function gesichert:boolean;
               function leer:boolean;
               function getmaxnum:word;
               procedure quantisieren;
               function getecke(x,y:integer):byte;
               procedure farbe(col:byte;wert:word);
               function getcolor:rgbzeiger;
               procedure invert;
             end;

var liste:listtyp;
    maussicht_,grafikan,vorhanden:boolean;
    xpos,ypos,altx,alty,tastenzahl,breite,xd,yd,xddiv2,yddiv2:word;
    xende,yende,maxx,maxy:integer;
    oldex:pointer;
    yver:real;
    mauscursor:pointer;

function sgn(w:real):shortint;
begin
  if w>0 then sgn:=1 else if w<0 then sgn:=-1 else sgn:=0;
end;

procedure mausunsicht;
begin
  if maussicht_ then begin
    putimage(altx-5,alty-5,mauscursor^,xorput);
    maussicht_:=false;
  end;
end;

procedure maussicht;
begin
  if not maussicht_ then begin
    putimage(xpos-5,ypos-5,mauscursor^,xorput);
    maussicht_:=true;
    altx:=xpos;alty:=ypos;
  end;
end;

procedure ecktyp.init(num:byte;c:rgbzeiger);
begin
  gesichert:=false;
  farbe:=c^;
  nummer:=num;
end;

procedure ecktyp.anzeigen;
begin
end;

function ecktyp.getecke(x,y:integer):byte;
begin
end;

procedure ecktyp.sichere(var f:text);
begin
end;

procedure ecktyp.neuekoor(dx,dy,dz:integer;eckenummer:byte);
begin
end;

procedure ecktyp.allekoor(dx,dy,dz:integer);
begin
end;

procedure ecktyp.setfarbe(col:byte;wert:real);
begin
  rgbarr(farbe)[col]:=wert;
end;

function ecktyp.farbvergleich(c:rgb):boolean;
begin
  farbvergleich:= (farbe.r=c.r) and (farbe.g=c.g) and (farbe.b=c.b);
end;

function ecktyp.getnum:byte;
begin
  getnum:=nummer;
end;

procedure ecktyp.setnum(x:byte);
begin
  nummer:=x;
end;

function ecktyp.getfarbe:rgbzeiger;
begin
  getfarbe:=@farbe;
end;

procedure ecktyp.quantisieren;
begin
end;

function ecktyp.schongesichert;
begin
  schongesichert:=gesichert;
end;

procedure ecktyp.setzegesichert;
begin
  gesichert:=true;
end;

procedure ecktyp.reset;
begin
  gesichert:=false;
end;

procedure ecktyp.allekooranzeigen;
begin
end;

procedure ecktyp.kooranzeigen(y:integer;a:byte);
begin
end;

procedure ecktyp.invert;
begin
end;

function yztransx(x:real):integer;
begin
  yztransx:=round(-x*breite)+xddiv2;
end;

function yztransy(y:real):integer;
begin
  yztransy:=round(-y*breite)+yddiv2;
end;

function xytransx(x:real):integer;
begin
  xytransx:=round(x*breite)+xddiv2;
end;

function xytransy(y:real):integer;
begin
  xytransy:=round(-y*breite)+yddiv2;
end;

function xztransx(x:real):integer;
begin
  xztransx:=round(x*breite)+xddiv2;
end;

function xztransy(y:real):integer;
begin
  xztransy:=round(y*breite)+yddiv2;
end;

function transx3d(eck:koortyp):integer;
begin
  with eck do transx3d:=(round(x*breite)+xddiv2)-round(z*breite*0.7);
end;

function transy3d(eck:koortyp):integer;
begin
  with eck do transy3d:=(round(-y*breite)+yddiv2)+round(z*breite*yver);
end;


procedure dreiecktyp.anzeigen(color:byte);
var xh,yh:array[0..3] of integer;
    n:byte;

  procedure dreieck;
  begin
    setcolor(color);
    moveto(xh[0],yh[0]);
    if color=lightgray then setlinestyle(solidln,$FF,normwidth);
    lineto(xh[1],yh[1]);
    if color=lightgray then setlinestyle(dottedln,$FF,normwidth);
    lineto(xh[2],yh[2]);
    if color=lightgray then setlinestyle(centerln,$FF,normwidth);
    lineto(xh[0],yh[0]);
  end;

begin
  setcolor(color);
  setlinestyle(solidln,$FF,normwidth);
  if color<>yellow then setwritemode(xorput);

  setviewport(0,0,xd,yd,true);
  for n:=0 to 2 do begin
    xh[n]:=yztransx(ecke[n].z);
    yh[n]:=yztransy(ecke[n].y);
  end;
  xh[3]:=yztransx((ecke[0].z-ecke[1].z)/2+ecke[1].z);
  yh[3]:=yztransy((ecke[0].y-ecke[1].y)/2+ecke[1].y);
  setlinestyle(solidln,$FF,normwidth);
  if flaechen then begin
    if ((ecke[1].y-ecke[0].y)*(ecke[2].z-ecke[0].z)-
        (ecke[1].z-ecke[0].z)*(ecke[2].y-ecke[0].y))>=0 then
     setcolor(green) else setcolor(red);
    line(xh[2],yh[2],xh[3],yh[3]);
  end;
  dreieck;

  setviewport(xd,0,xende,yd,true);
  for n:=0 to 2 do begin
    xh[n]:=xytransx(ecke[n].x);
    yh[n]:=xytransy(ecke[n].y);
  end;
  xh[3]:=xytransx((ecke[0].x-ecke[1].x)/2+ecke[1].x);
  yh[3]:=xytransy((ecke[0].y-ecke[1].y)/2+ecke[1].y);
  setlinestyle(solidln,$FF,normwidth);
  if flaechen then begin
    if ((ecke[1].x-ecke[0].x)*(ecke[2].y-ecke[0].y)-
        (ecke[1].y-ecke[0].y)*(ecke[2].x-ecke[0].x))>=0 then
     setcolor(green) else setcolor(red);
    line(xh[2],yh[2],xh[3],yh[3]);
  end;
  dreieck;

  setviewport(xd,yd,xende,yende,true);
  for n:=0 to 2 do begin
    xh[n]:=xztransx(ecke[n].x);
    yh[n]:=xztransy(ecke[n].z);
  end;
  xh[3]:=xztransx((ecke[0].x-ecke[1].x)/2+ecke[1].x);
  yh[3]:=xztransy((ecke[0].z-ecke[1].z)/2+ecke[1].z);
  setlinestyle(solidln,$FF,normwidth);
  if flaechen then begin
    if (-(ecke[1].x-ecke[0].x)*(ecke[2].z-ecke[0].z)+
        (ecke[1].z-ecke[0].z)*(ecke[2].x-ecke[0].x))>=0 then
     setcolor(green) else setcolor(red);
    line(xh[2],yh[2],xh[3],yh[3]);
  end;
  dreieck;

  setviewport(0,yd,xd,yende,true);
  for n:=0 to 2 do begin
    xh[n]:=transx3d(ecke[n]);
    yh[n]:=transy3d(ecke[n]);
  end;
  dreieck;
  setviewport(0,0,maxx,maxy,true);
  setlinestyle(solidln,$FF,normwidth);
  setwritemode(normalput);
end;

constructor dreiecktyp.init(num:byte;x1,y1,z1,x2,y2,z2,x3,y3,z3:real;c:rgbzeiger);
begin
  ecktyp.init(num,c);
  ecke[0].x:=x1;  ecke[0].y:=y1;   ecke[0].z:=z1;
  ecke[1].x:=x2;  ecke[1].y:=y2;   ecke[1].z:=z2;
  ecke[2].x:=x3;  ecke[2].y:=y3;   ecke[2].z:=z3;
end;

procedure dreiecktyp.sichere(var f:text);
var buf:string[8];
    n:byte;
begin
  write(f,'  Textur 2 2');
  for n:=0 to 2 do begin
    str(rgbarr(farbe)[n]:5:2,buf);
    write(f,buf+' ');
  end;
  writeln(f);
  write(f,'  Dreieck ');
  for n:=0 to 2 do begin
    str(ecke[n].x:5:2,buf);
    write(f,buf+' ');
    str(ecke[n].y:5:2,buf);
    write(f,buf+' ');
    str(ecke[n].z:5:2,buf);
    write(f,buf+'  ');
  end;
  writeln(f);
end;

procedure dreiecktyp.quantisieren;
var n:byte;
begin
  for n:=0 to 2 do begin
    ecke[n].x:=trunc(ecke[n].x/snap+sgn(ecke[n].x)*snap/2)*snap;
    ecke[n].y:=trunc(ecke[n].y/snap+sgn(ecke[n].y)*snap/2)*snap;
    ecke[n].z:=trunc(ecke[n].z/snap+sgn(ecke[n].z)*snap/2)*snap;
  end;
end;

procedure dreiecktyp.neuekoor(dx,dy,dz:integer;eckenummer:byte);
begin
  dreiecktyp.anzeigen(lightgray);
  ecke[eckenummer].x:=trunc((ecke[eckenummer].x+dx*0.01+sgn(ecke[eckenummer].x)*snap/2)/snap)*snap;
  ecke[eckenummer].y:=trunc((ecke[eckenummer].y+dy*0.01+sgn(ecke[eckenummer].y)*snap/2)/snap)*snap;
  ecke[eckenummer].z:=trunc((ecke[eckenummer].z+dz*0.01+sgn(ecke[eckenummer].z)*snap/2)/snap)*snap;
  dreiecktyp.anzeigen(lightgray);
end;

procedure dreiecktyp.allekoor(dx,dy,dz:integer);
var n:byte;
    xp,yp,zp:real;
begin
  dreiecktyp.anzeigen(lightgray);
  xp:=trunc((dx*0.01+sgn(dx)*snap/2)/snap)*snap;
  yp:=trunc((dy*0.01+sgn(dy)*snap/2)/snap)*snap;
  zp:=trunc((dz*0.01+sgn(dz)*snap/2)/snap)*snap;
  for n:=0 to 2 do begin
    ecke[n].x:=ecke[n].x+xp;
    ecke[n].y:=ecke[n].y+yp;
    ecke[n].z:=ecke[n].z+zp;
  end;
  dreiecktyp.anzeigen(lightgray);
end;

procedure dreiecktyp.kooranzeigen(y:integer;a:byte);
var buf:string[7];
begin
  setcolor(lightmagenta);
  setfillstyle(solidfill,blue);
  bar(koorbeginx+2*8,y,koorbeginx+ 9*8,y+8);
  str(ecke[a].x:7:2,buf);
  outtextxy(koorbeginx+2*8,y,buf);
  bar(koorbeginx+13*8,y,koorbeginx+20*8,y+8);
  str(ecke[a].y:7:2,buf);
  outtextxy(koorbeginx+13*8,y,buf);
  bar(koorbeginx+24*8,y,koorbeginx+31*8,y+8);
  str(ecke[a].z:7:2,buf);
  outtextxy(koorbeginx+24*8,y,buf);
end;

procedure dreiecktyp.allekooranzeigen;
var n:byte;
begin
  for n:=0 to 2 do dreiecktyp.kooranzeigen(maxy-38+n*10,n);
end;

function dreiecktyp.getecke(x,y:integer):byte;
var n,min:byte;
    minab,aktab:real;
begin
  minab:=9999;
  for n:=0 to 2 do begin
    if x>xd then begin
      if y>yd then begin
        aktab:=sqrt(sqr(longint(x-(xztransx(ecke[n].x)+xd)))+sqr(longint(y-(xztransy(ecke[n].z)+yd))));
      end else begin
        aktab:=sqrt(sqr(longint(x-(xytransx(ecke[n].x)+xd)))+sqr(longint(y-xytransy(ecke[n].y))));
      end;
    end else begin
      if y>yd then begin
        aktab:=sqrt(sqr(longint(x-transx3d(ecke[n])))+sqr(longint(y-(transy3d(ecke[n])+yd))));
      end else begin
        aktab:=sqrt(sqr(longint(x-yztransx(ecke[n].z)))+sqr(longint(y-yztransy(ecke[n].y))));
      end;
    end;
    if aktab<minab then begin
      min:=n;
      minab:=aktab;
    end;
  end;
  getecke:=min;
end;

procedure dreiecktyp.invert;
var h:koortyp;
begin
  h:=ecke[0];ecke[0]:=ecke[2];ecke[2]:=h;
end;

procedure kugeltyp.anzeigen(color:byte);
var radius:word;

procedure circle(x,y,r:word);
var rd2:word;
begin
  rd2:=r div 2;
  moveto(x-r,y-rd2);
  lineto(x-rd2,y-r);lineto(x+rd2,y-r);
  lineto(x+r,y-rd2);lineto(x+r,y+rd2);
  lineto(x+rd2,y+r);lineto(x-rd2,y+r);
  lineto(x-r,y+rd2);lineto(x-r,y-rd2);
end;

begin
  setcolor(color);
  setlinestyle(solidln,$FF,normwidth);
  if color<>yellow then setwritemode(xorput);
  setviewport(0,0,xd,yd,true);
  radius:=round(sqrt(sqr(ecke[0].x-ecke[1].x)+sqr(ecke[0].y-ecke[1].y)+sqr(ecke[0].z-ecke[1].z))*yd/ausschnitt);
  circle(yztransx(ecke[0].z),yztransy(ecke[0].y),radius);
  setviewport(xd,0,xende,yd,true);
  circle(xytransx(ecke[0].x),xytransy(ecke[0].y),radius);
  setviewport(xd,yd,xende,yende,true);
  circle(xztransx(ecke[0].x),xztransy(ecke[0].z),radius);
  setviewport(0,yd,xd,yende,true);
  circle(transx3d(ecke[0]),transy3d(ecke[0]),radius);
  setviewport(0,0,maxx,maxy,true);
  setlinestyle(solidln,$FF,normwidth);
  setwritemode(normalput);
end;

constructor kugeltyp.init(num:byte;x1,y1,z1,x2,y2,z2:real;c:rgbzeiger);
begin
  ecktyp.init(num,c);
  ecke[0].x:=x1;  ecke[0].y:=y1;   ecke[0].z:=z1;
  ecke[1].x:=x2;  ecke[1].y:=y2;   ecke[1].z:=z2;
end;

procedure kugeltyp.sichere(var f:text);
var buf:string[8];
    n:byte;
begin
  write(f,'  Textur 2 2');
  for n:=0 to 2 do begin
    str(rgbarr(farbe)[n]:5:2,buf);
    write(f,buf+' ');
  end;
  writeln(f);
  writeln(f,'  PushTrafs');
  write(f,'    Verschieben ');
  str(ecke[0].x:5:2,buf);
  write(f,buf+' ');
  str(ecke[0].y:5:2,buf);
  write(f,buf+' ');
  str(ecke[0].z:5:2,buf);
  writeln(f,buf+'  ');
  str(sqrt(sqr(ecke[0].x-ecke[1].x)+sqr(ecke[0].y-ecke[1].y)+sqr(ecke[0].z-ecke[1].z)):5:2,buf);
  writeln(f,'    Vergrern '+buf+' '+buf+' '+buf);
  writeln(f,'    Kugel 10 10');
  writeln(f,'  PopTrafs');
end;

procedure kugeltyp.quantisieren;
var n:byte;
begin
  for n:=0 to 1 do begin
    ecke[n].x:=trunc(ecke[n].x/snap+sgn(ecke[n].x)*snap/2)*snap;
    ecke[n].y:=trunc(ecke[n].y/snap+sgn(ecke[n].y)*snap/2)*snap;
    ecke[n].z:=trunc(ecke[n].z/snap+sgn(ecke[n].z)*snap/2)*snap;
  end;
end;

procedure kugeltyp.neuekoor(dx,dy,dz:integer;eckenummer:byte);
begin
  kugeltyp.anzeigen(lightgray);
  ecke[eckenummer].x:=trunc((ecke[eckenummer].x+dx*0.01+sgn(ecke[eckenummer].x)*snap/2)/snap)*snap;
  ecke[eckenummer].y:=trunc((ecke[eckenummer].y+dy*0.01+sgn(ecke[eckenummer].y)*snap/2)/snap)*snap;
  ecke[eckenummer].z:=trunc((ecke[eckenummer].z+dz*0.01+sgn(ecke[eckenummer].z)*snap/2)/snap)*snap;
  kugeltyp.anzeigen(lightgray);
end;

procedure kugeltyp.allekoor(dx,dy,dz:integer);
var n:byte;
    xp,yp,zp:real;
begin
  kugeltyp.anzeigen(lightgray);
  xp:=trunc((dx*0.01+sgn(dx)*snap/2)/snap)*snap;
  yp:=trunc((dy*0.01+sgn(dy)*snap/2)/snap)*snap;
  zp:=trunc((dz*0.01+sgn(dz)*snap/2)/snap)*snap;
  for n:=0 to 1 do begin
    ecke[n].x:=ecke[n].x+xp;
    ecke[n].y:=ecke[n].y+yp;
    ecke[n].z:=ecke[n].z+zp;
  end;
  kugeltyp.anzeigen(lightgray);
end;

procedure kugeltyp.kooranzeigen(y:integer;a:byte);
var buf:string[7];
begin
  setcolor(lightmagenta);
  setfillstyle(solidfill,blue);
  bar(koorbeginx+2*8,y,koorbeginx+ 9*8,y+8);
  str(ecke[a].x:7:2,buf);
  outtextxy(koorbeginx+2*8,y,buf);
  bar(koorbeginx+13*8,y,koorbeginx+20*8,y+8);
  str(ecke[a].y:7:2,buf);
  outtextxy(koorbeginx+13*8,y,buf);
  bar(koorbeginx+24*8,y,koorbeginx+31*8,y+8);
  str(ecke[a].z:7:2,buf);
  outtextxy(koorbeginx+24*8,y,buf);
end;

procedure kugeltyp.allekooranzeigen;
var n:byte;
begin
  for n:=0 to 1 do kugeltyp.kooranzeigen(maxy-38+n*10,n);
end;

function kugeltyp.getecke(x,y:integer):byte;
var n,min:byte;
    minab,aktab:real;
begin
  minab:=9999;
  for n:=0 to 1 do begin
    if x>xd then begin
      if y>yd then begin
        aktab:=sqrt(sqr(longint(x-(xztransx(ecke[n].x)+xd)))+sqr(longint(y-(xztransy(ecke[n].z)+yd))));
      end else begin
        aktab:=sqrt(sqr(longint(x-(xytransx(ecke[n].x)+xd)))+sqr(longint(y-xytransy(ecke[n].y))));
      end;
    end else begin
      if y>yd then begin
        aktab:=sqrt(sqr(longint(x-transx3d(ecke[n])))+sqr(longint(y-(transy3d(ecke[n])+yd))));
      end else begin
        aktab:=sqrt(sqr(longint(x-yztransx(ecke[n].z)))+sqr(longint(y-yztransy(ecke[n].y))));
      end;
    end;
    if aktab<minab then begin
      min:=n;
      minab:=aktab;
    end;
  end;
  getecke:=min;
end;

procedure vierecktyp.anzeigen(color:byte);
var xh,yh:array[0..3] of integer;
    n:byte;

  procedure viereck;
  begin
    setcolor(color);
    moveto(xh[0],yh[0]);
    if color=lightgray then setlinestyle(solidln,$FF,normwidth);
    lineto(xh[1],yh[1]);
    if color=lightgray then setlinestyle(dottedln,$FF,normwidth);
    lineto(xh[2],yh[2]);
    if color=lightgray then setlinestyle(centerln,$FF,normwidth);
    lineto(xh[3],yh[3]);
    if color=lightgray then setlinestyle(dashedln,$FF,normwidth);
    lineto(xh[0],yh[0]);
  end;

begin
  if color<>yellow then setwritemode(xorput);
  setviewport(0,0,xd,yd,true);
  for n:=0 to 3 do begin
    xh[n]:=yztransx(ecke[n].z);
    yh[n]:=yztransy(ecke[n].y);
  end;
  setlinestyle(solidln,$FF,normwidth);
  if flaechen then begin
    if ((ecke[1].y-ecke[0].y)*(ecke[3].z-ecke[0].z)-
        (ecke[1].z-ecke[0].z)*(ecke[3].y-ecke[0].y))>=0 then
     setcolor(green) else setcolor(red);
    line(xh[0],yh[0],xh[2],yh[2]);
    line(xh[1],yh[1],xh[3],yh[3]);
  end;
  viereck;
  setviewport(xd,0,xende,yd,true);
  for n:=0 to 3 do begin
    xh[n]:=xytransx(ecke[n].x);
    yh[n]:=xytransy(ecke[n].y);
  end;
  setlinestyle(solidln,$FF,normwidth);
  if flaechen then begin
    if ((ecke[1].x-ecke[0].x)*(ecke[3].y-ecke[0].y)-
        (ecke[1].y-ecke[0].y)*(ecke[3].x-ecke[0].x))>=0 then
     setcolor(green) else setcolor(red);
    line(xh[0],yh[0],xh[2],yh[2]);
    line(xh[1],yh[1],xh[3],yh[3]);
  end;
  viereck;
  setviewport(xd,yd,xende,yende,true);
  for n:=0 to 3 do begin
    xh[n]:=xztransx(ecke[n].x);
    yh[n]:=xztransy(ecke[n].z);
  end;
  setlinestyle(solidln,$FF,normwidth);
  if flaechen then begin
    if (-(ecke[1].x-ecke[0].x)*(ecke[3].z-ecke[0].z)+
        (ecke[1].z-ecke[0].z)*(ecke[3].x-ecke[0].x))>=0 then
     setcolor(green) else setcolor(red);
    line(xh[0],yh[0],xh[2],yh[2]);
    line(xh[1],yh[1],xh[3],yh[3]);
  end;
  viereck;
  setviewport(0,yd,xd,yende,true);
  for n:=0 to 3 do begin
    xh[n]:=transx3d(ecke[n]);
    yh[n]:=transy3d(ecke[n]);
  end;
  setlinestyle(solidln,$FF,normwidth);
  viereck;
  setviewport(0,0,maxx,maxy,true);
  setlinestyle(solidln,$FF,normwidth);
  setwritemode(normalput);
end;

constructor vierecktyp.init(num:byte;x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:real;c:rgbzeiger);
begin
  ecktyp.init(num,c);
  ecke[0].x:=x1;  ecke[0].y:=y1;ecke[0].z:=z1;
  ecke[1].x:=x2;  ecke[1].y:=y2;ecke[1].z:=z2;
  ecke[2].x:=x3;  ecke[2].y:=y3;ecke[2].z:=z3;
  ecke[3].x:=x4;  ecke[3].y:=y4;ecke[3].z:=z4;
end;

procedure vierecktyp.quantisieren;
var n:byte;
begin
  for n:=0 to 3 do begin
    ecke[n].x:=trunc(ecke[n].x/snap+sgn(ecke[n].x)*snap/2)*snap;
    ecke[n].y:=trunc(ecke[n].y/snap+sgn(ecke[n].y)*snap/2)*snap;
    ecke[n].z:=trunc(ecke[n].z/snap+sgn(ecke[n].z)*snap/2)*snap;
  end;
end;

procedure vierecktyp.sichere(var f:text);
var buf:string[8];
    n:byte;
begin
  write(f,'  Textur 2 2');
  for n:=0 to 2 do begin
    str(rgbarr(farbe)[n]:5:2,buf);
    write(f,buf+' ');
  end;
  writeln(f);
  write(f,'  Viereck ');
  for n:=0 to 3 do begin
    str(ecke[n].x:5:2,buf);
    write(f,buf+' ');
    str(ecke[n].y:5:2,buf);
    write(f,buf+' ');
    str(ecke[n].z:5:2,buf);
    write(f,buf+'  ');
  end;
  writeln(f);
end;

procedure vierecktyp.neuekoor(dx,dy,dz:integer;eckenummer:byte);
var e:array[0..3] of shortint;
    n:byte;
begin
  vierecktyp.anzeigen(lightgray);
  ecke[eckenummer].x:=trunc((ecke[eckenummer].x+dx*0.01+sgn(ecke[eckenummer].x)*snap/2)/snap)*snap;
  ecke[eckenummer].y:=trunc((ecke[eckenummer].y+dy*0.01+sgn(ecke[eckenummer].y)*snap/2)/snap)*snap;
  ecke[eckenummer].z:=trunc((ecke[eckenummer].z+dz*0.01+sgn(ecke[eckenummer].z)*snap/2)/snap)*snap;
  if flaechen then begin
    e[0]:=eckenummer;
    for n:=1 to 3 do begin
      e[n]:=succ(e[pred(n)]);
      if e[n]>3 then e[n]:=0;
    end;
    ecke[e[2]].x:=ecke[e[3]].x+(ecke[e[1]].x-ecke[e[0]].x);
    ecke[e[2]].y:=ecke[e[3]].y+(ecke[e[1]].y-ecke[e[0]].y);
    ecke[e[2]].z:=ecke[e[3]].z+(ecke[e[1]].z-ecke[e[0]].z);
  end;
  vierecktyp.anzeigen(lightgray);
end;

procedure vierecktyp.allekoor(dx,dy,dz:integer);
var n:byte;
    xp,yp,zp:real;
begin
  vierecktyp.anzeigen(lightgray);
  xp:=trunc((dx*0.01+sgn(dx)*snap/2)/snap)*snap;
  yp:=trunc((dy*0.01+sgn(dy)*snap/2)/snap)*snap;
  zp:=trunc((dz*0.01+sgn(dz)*snap/2)/snap)*snap;
  for n:=0 to 3 do begin
    ecke[n].x:=ecke[n].x+xp;
    ecke[n].y:=ecke[n].y+yp;
    ecke[n].z:=ecke[n].z+zp;
  end;
  vierecktyp.anzeigen(lightgray);
end;

procedure vierecktyp.kooranzeigen(y:integer;a:byte);
var buf:string[7];
begin
  setcolor(lightmagenta);
  setfillstyle(solidfill,blue);
  bar(koorbeginx+2*8,y,koorbeginx+ 9*8,y+8);
  str(ecke[a].x:7:2,buf);
  outtextxy(koorbeginx+2*8,y,buf);
  bar(koorbeginx+13*8,y,koorbeginx+20*8,y+8);
  str(ecke[a].y:7:2,buf);
  outtextxy(koorbeginx+13*8,y,buf);
  bar(koorbeginx+24*8,y,koorbeginx+31*8,y+8);
  str(ecke[a].z:7:2,buf);
  outtextxy(koorbeginx+24*8,y,buf);
end;

procedure vierecktyp.allekooranzeigen;
var n:byte;
begin
  for n:=0 to 3 do vierecktyp.kooranzeigen(maxy-38+n*10,n);
end;

function vierecktyp.getecke(x,y:integer):byte;
var n,min:byte;
    minab,aktab:real;
begin
  min:=1;
  minab:=9999;
  for n:=0 to 3 do begin
    if x>xd then begin
      if y>yd then begin
        aktab:=sqrt(sqr(longint(x-(xztransx(ecke[n].x)+xd)))+sqr(longint(y-(xztransy(ecke[n].z)+yd))));
      end else begin
        aktab:=sqrt(sqr(longint(x-(xytransx(ecke[n].x)+xd)))+sqr(longint(y-xytransy(ecke[n].y))));
      end;
    end else begin
      if y>yd then begin
        aktab:=sqrt(sqr(longint(x-transx3d(ecke[n])))+sqr(longint(y-(transy3d(ecke[n])+yd))));
      end else begin
        aktab:=sqrt(sqr(longint(x-yztransx(ecke[n].z)))+sqr(longint(y-yztransy(ecke[n].y))));
      end;
    end;
    if aktab<minab then begin
      min:=n;
      minab:=aktab;
    end;
  end;
  getecke:=min;
end;

procedure vierecktyp.invert;
var h:koortyp;
begin
  h:=ecke[0];ecke[0]:=ecke[3];ecke[3]:=h;h:=ecke[1];ecke[1]:=ecke[2];ecke[2]:=h;
end;

procedure farbeanzeigen(col:rgbzeiger);
var n:byte;
begin
  setrgbpalette(3,trunc(col^.r*63),0,0);
  setrgbpalette(5,0,trunc(col^.g*63),0);
  setrgbpalette(59,0,0,trunc(col^.b*63));
  setrgbpalette(7,trunc(col^.r*63),trunc(col^.g*63),trunc(col^.b*63));
  for n:=0 to 2 do begin
    case n of
      0:setfillstyle(solidfill,cyan);
      1:setfillstyle(solidfill,magenta);
      2:setfillstyle(solidfill,lightcyan);
    end;
    mausunsicht;
    bar(koorbeginx+50*8,maxy-29+n*10,koorbeginx+50*8+trunc(rgbarr(col^)[n]*64),maxy-21+n*10);
    setfillstyle(solidfill,blue);
    bar(koorbeginx+50*8+trunc(rgbarr(col^)[n]*64),maxy-29+n*10,koorbeginx+58*8,maxy-21+n*10);
    maussicht;
  end;
end;

constructor listtyp.init;
begin
  gespeichert:=true;
  knoten:=nil;
  maxnum:=0;
  akt:=nil;
end;

function listtyp.getmaxnum:word;
begin
  getmaxnum:=maxnum;
end;

procedure listtyp.sichern(name:namestr);
var n:knotenzeiger;
    f:text;
begin
  assign(f,name+'.WIZ');
  rewrite(f);
  writeln(f,'Koordinaten');
  writeln(f,'Achsenrichtung 0 1 0');
  writeln(f,'Rckflchen');
  writeln(f,'Licht');
  writeln(f,'Pushtrafs');
  writeln(f,'  Gosub '+name);
  writeln(f,'Pop');
  writeln(f,'Ende');
  writeln(f);
  writeln(f,':'+name);
  n:=knoten;
  while n<>nil do begin
    n^.teil^.sichere(f);
    n:=n^.weiter;
  end;
  writeln(f,'Return');
  close(f);
  gespeichert:=true;
end;


destructor listtyp.done;
var n:knotenzeiger;
begin
  while knoten<>nil do begin
    n:=knoten;
    dispose(n^.teil);
    knoten:=n^.weiter;
    dispose(n);
  end;
  gespeichert:=true;
end;

procedure listtyp.quantisieren;
var n:knotenzeiger;
begin
  n:=knoten;
  while n<>nil do begin
    n^.teil^.quantisieren;
    n:=n^.weiter;
  end;
end;

procedure lade(name:namestr);
var n:knotenzeiger;
    f:text;
    befehl,argumente:string;
    fehler:boolean;
    farbe:rgb;
    x1,y1,z1,x0,y0,z0:real;

  procedure lesezeile;
  begin
    readln(f,befehl);
    while pos(' ',befehl)=1 do delete(befehl,1,1);
    argumente:=befehl;
    argumente:=argumente+' ';
    delete(argumente,1,pos(' ',argumente));
    befehl:=befehl+' ';
    delete(befehl,pos(' ',befehl),length(befehl)-pos(' ',befehl));
  end;

  procedure upword(var tex:string);
  var n:byte;
  begin
    for n:=1 to length(tex) do begin
      tex[n]:=upcase(tex[n]);
      case tex[n] of
        '':tex[n]:='';
        '':tex[n]:='';
        '':tex[n]:='';
      end;
    end;
  end;

  function id(s:string):boolean;
  var gleich:boolean;
      n,k:byte;
  begin
    gleich:=true;
    K:=pred(length(befehl));
    if k=0 then k:=1;
    n:=length(s);
    if n<k then k:=n;
    for n:=1 to k do begin
      befehl[n]:=upcase(befehl[n]);
      case befehl[n] of
        '':befehl[n]:='';
        '':befehl[n]:='';
        '':befehl[n]:='';
      end;
      gleich:=gleich and (s[n]=befehl[n]);
    end;
    id:=gleich;
  end;

  function getreal:real;
  var h:real;
      err:integer;
  begin
    while pos(' ',argumente)=1 do delete(argumente,1,1);
    argumente:=argumente+' ';
    val(copy(argumente,1,pred(pos(' ',argumente))),h,err);
    fehler:=err<>0;
    getreal:=h;
    delete(argumente,1,pos(' ',argumente));
  end;

begin
  rgbarr(farbe):=weiss;
  assign(f,name+'.WIZ');
  reset(f);
  fehler:=false;
  while name[1]=' ' do delete(name,1,1);
  if pos(' ',name)<>0 then name:=copy(name,1,pos(' ',name));
  upword(name);
  name:=':'+name;
  liste.done;
  repeat lesezeile until (eof(f) or id(name));
  repeat
    lesezeile;
    if id('DREIECK') then liste.add(new(dreieckzeiger,init(succ(liste.getmaxnum),
      getreal,getreal,getreal,getreal,getreal,getreal,
      getreal,getreal,getreal,@farbe)))
    else if id('VIERECK') then liste.add(new(viereckzeiger,init(succ(liste.getmaxnum),
      getreal,getreal,getreal,getreal,getreal,getreal,
      getreal,getreal,getreal,getreal,getreal,getreal,@farbe)))
    else if id('VERSCHIEBEN') then begin
      x0:=getreal;y0:=getreal;z0:=getreal;
    end else if id('VERGRERN') then begin
      z1:=1+getreal/sqrt(sqr(x0)+sqr(y0)+sqr(z0));
      x1:=z1*x0;y1:=z1*y0;z1:=z1*z0;
    end else if id('KUGEL') then liste.add(new(kugelzeiger,init(succ(liste.getmaxnum),
      x0,y0,z0,x1,y1,z1,@farbe)))
    else if id('TEXTUR') then begin
      farbe.r:=getreal;farbe.r:=getreal;farbe.r:=getreal;farbe.g:=getreal;farbe.b:=getreal;
    end;
  until eof(f) or fehler;
  if fehler then begin
    setcolor(red);
    delete(name,1,1);
    writeln('Fehler beim Interpretieren der Datei '+name+'.WIZ');
    delay(1000);
  end;
  close(f);
end;

procedure listtyp.neuaufbau(color:byte);
var n:knotenzeiger;
begin
  n:=knoten;
  while n<>nil do begin
    if n<>akt then n^.teil^.anzeigen(color) else begin
      n^.teil^.anzeigen(lightgray);
      n^.teil^.allekooranzeigen;
      farbeanzeigen(akt^.teil^.getfarbe);
    end;
    n:=n^.weiter;
  end;
end;

function listtyp.weiter:byte;
begin
  if knoten<>nil then begin
    akt^.teil^.anzeigen(lightgray);
    akt^.teil^.anzeigen(darkgray);
    if akt^.weiter<>nil then akt:=akt^.weiter else
    akt:=knoten;
    akt^.teil^.anzeigen(darkgray);
    akt^.teil^.anzeigen(lightgray);
    weiter:=akt^.teil^.getnum;
    akt^.teil^.allekooranzeigen;
    farbeanzeigen(akt^.teil^.getfarbe);
  end else weiter:=0;
end;

function listtyp.zuruck:byte;
var n:knotenzeiger;
begin
  if knoten<>nil then begin
    akt^.teil^.anzeigen(lightgray);
    akt^.teil^.anzeigen(darkgray);
    n:=knoten;
    while (n^.weiter<>nil) and (n^.weiter<>akt) do n:=n^.weiter;
    akt:=n;
    akt^.teil^.anzeigen(darkgray);
    akt^.teil^.anzeigen(lightgray);
    zuruck:=akt^.teil^.getnum;
    akt^.teil^.allekooranzeigen;
    farbeanzeigen(akt^.teil^.getfarbe);
  end else zuruck:=0;
end;

function listtyp.loschen:byte;
var n:knotenzeiger;
    x:byte;
begin
  if knoten<>nil then begin
    akt^.teil^.anzeigen(lightgray);
    n:=knoten;
    if akt<>knoten then begin
      while (n^.weiter<>nil) and (n^.weiter<>akt) do n:=n^.weiter;
      if n^.weiter<>nil then n^.weiter:=akt^.weiter;
      dispose(akt);
      akt:=n;
    end else begin
      knoten:=knoten^.weiter;
      dispose(akt);
      akt:=knoten;
      n:=knoten;
    end;
    if akt<>nil then begin
      x:=akt^.teil^.getnum;
      akt^.teil^.anzeigen(darkgray);
      akt^.teil^.anzeigen(lightgray);
      akt^.teil^.allekooranzeigen;
      farbeanzeigen(akt^.teil^.getfarbe);
      loschen:=x;
    end else loschen:=0;
    n:=knoten;
    x:=maxnum;
    dec(maxnum);
    while (n<>nil) do begin
      dec(x);
      n^.teil^.setnum(x);
      n:=n^.weiter;
    end;
  end else loschen:=0;
end;

function listtyp.leer:boolean;
begin
  leer:=knoten=nil;
end;

function listtyp.gesichert:boolean;
begin
  gesichert:=gespeichert;
end;

procedure listtyp.bewege(x:byte);
var tasten,xpos,ypos:word;
begin
  if akt<>nil then repeat
    maussetpos(200,200);
    repeat
      maustastpos(tasten,xpos,ypos);
    until ((integer(ypos)>200+snap*110) or (integer(ypos)<200-snap*110) or
           (integer(xpos)>200+snap*110) or (integer(xpos)<200-snap*110) or
           (tasten=1));
    if ((integer(ypos)>200+snap*110) or (integer(ypos)<200-snap*110) or
        (integer(xpos)>200+snap*110) or (integer(xpos)<200-snap*110)) then begin
      if x<4 then begin
        if (tasten=0) then akt^.teil^.neuekoor(integer(xpos)-200,200-integer(ypos),0,x)
        else akt^.teil^.neuekoor(0,200-integer(ypos),200-integer(xpos),x);
        akt^.teil^.kooranzeigen(maxy-38+x*10,x);
      end else begin
        if (tasten=0) then akt^.teil^.allekoor(integer(xpos)-200,200-integer(ypos),0)
        else akt^.teil^.allekoor(0,200-integer(ypos),200-integer(xpos));
        akt^.teil^.allekooranzeigen;
      end;
    end;
  until (tasten=1);
end;

function listtyp.add(teil:eckzeiger):byte;
var n:knotenzeiger;
begin
  gespeichert:=false;
  if (akt<>nil) and grafikan then begin
    akt^.teil^.anzeigen(lightgray);
    akt^.teil^.anzeigen(darkgray);
  end;
  new(n);
  n^.teil:=teil;
  n^.weiter:=knoten;
  knoten:=n;
  akt:=knoten;
  inc(maxnum);
  add:=maxnum;
  if grafikan then begin
    akt^.teil^.anzeigen(lightgray);
    akt^.teil^.allekooranzeigen;
    farbeanzeigen(akt^.teil^.getfarbe);
  end;
end;

function listtyp.getecke(x,y:integer):byte;
begin
  if akt<>nil then getecke:=akt^.teil^.getecke(x,y) else getecke:=0;
end;

procedure listtyp.farbe(col:byte;wert:word);
begin
  if akt<>nil then begin
    if wert>koorbeginx+58*8 then wert:=koorbeginx+58*8;
    if wert<koorbeginx+50*8 then wert:=koorbeginx+50*8;
    akt^.teil^.setfarbe(col,(integer(wert)-koorbeginx-50*8)/63);
    farbeanzeigen(akt^.teil^.getfarbe);
  end;
end;

function listtyp.getcolor:rgbzeiger;
begin
  if akt<>nil then getcolor:=akt^.teil^.getfarbe else
  getcolor:=@weiss;
end;

procedure listtyp.invert;
begin
  if akt<>nil then begin
    akt^.teil^.anzeigen(lightgray);
    akt^.teil^.invert;
    akt^.teil^.anzeigen(lightgray);
  end;
end;

procedure editor;
var aktiv:byte;
    tasten:word;

  procedure bewegezeiger;
  begin
    if maussicht_ then begin
      putimage(altx-5,alty-5,mauscursor^,xorput);
      putimage(xpos-5,ypos-5,mauscursor^,xorput);
    end;
    altx:=xpos; alty:=ypos;
  end;


  function mausin(x,y,xe,ye:integer):boolean;
  begin
    mausin := (xpos >= x) and (xpos <= xe) and (ypos >= y) and (ypos <= ye);
  end;

  procedure mauswarte;
  begin
    repeat until not mauskeypressed;
  end;

  procedure grafikinit;
  var error,gd,gm:integer;
  begin
    gd:=detect;
    initgraph(gd,gm,grafikpfad);
    error:=graphresult;
    if error<>0 then begin
      writeln('Grafikfehler : '+grapherrormsg(error),^G);
      halt(1);
    end;
    grafikan:=true;
    setbkcolor(blue);
    setcolor(yellow);
    maxx:=getmaxx;
    maxy:=getmaxy;
    xd:=maxx div 2;
    yd:=(maxy-randunten) div 2;
    yende:=2*yd;
    xende:=2*xd;
    xddiv2:=xd div 2;
    yddiv2:=yd div 2;
    yver:=0.7 * yd / xd
  end;

  procedure gitterberechnen;
  begin
    breite:=round(yd/ausschnitt);
  end;

  procedure gitter;
  var zx,zy:integer;
      n:byte;
  begin
    setcolor(green);
    zx:=(xddiv2)-breite*round((round(ausschnitt+0.5) / 2)+0.5);
    zy:=(yddiv2)-breite*round((round(ausschnitt+0.5) / 2)+0.5);
    for n:=1 to round(xd/breite+0.5) do begin
      line(zx,1,zx,yd-2);
      line(1,zy,xd-2,zy);
      zx:=zx+breite;
      zy:=zy+breite;
    end;
    setcolor(red);
    line(1,yddiv2,xd-2,yddiv2);
    line(xddiv2,1,xddiv2,yd-2);
  end;

  procedure koor3d;
  begin
    setcolor(red);
    line(1,yddiv2,xd-2,yddiv2);
    line(xddiv2,1,xddiv2,yd-2);
    line(1,yd-2,xd-2,1);
    outtextxy(xddiv2 + 3,3,'Y');
    outtextxy(xd-12,yddiv2+ 3,'X');
    outtextxy(22,yd-12,'Z');
  end;

  procedure aktivanzeigen(akt:byte);
  begin
    mausunsicht;
    if akt=drei then setcolor(lightmagenta) else setcolor(lightblue);
    moveto(5,maxy-5);lineto(20,maxy-35);lineto(35,maxy-5);lineto(5,maxy-5);
    if akt=vier then setcolor(lightmagenta) else setcolor(lightblue);
    rectangle(40,maxy-35,70,maxy-5);
    if akt=kugel then setcolor(lightmagenta) else setcolor(lightblue);
    circle(95,maxy-20,15);
    aktiv:=akt;
    maussicht;
  end;

  procedure flaechenzustandanzeigen;
  begin
    mausunsicht;
    if flaechen then setcolor(lightmagenta) else setcolor(lightgreen);
    line(koorbeginx+42*8,maxy-18,koorbeginx+45*8,maxy-10);
    line(koorbeginx+45*8,maxy-18,koorbeginx+42*8,maxy-10);
    setcolor(lightgray);
    rectangle(koorbeginx+42*8,maxy-18,koorbeginx+45*8,maxy-10);
    maussicht;
  end;

  procedure outnum(num:byte);
  var buf:string[3];
  begin
    setfillstyle(solidfill,blue);
    mausunsicht;
    bar(koorbeginx+8*35,maxy-30,koorbeginx+8*38,maxy-20);
    setcolor(yellow);
    str(num:3,buf);
    outtextxy(koorbeginx+8*35,maxy-27,buf);
    maussicht;
  end;

  procedure maske;
  begin
    gitterberechnen;
    setviewport(0,0,xd,yd,true);         gitter;
    setviewport(xd,0,xende,yd,true);     gitter;
    setviewport(xd,yd,xende,yende,true); gitter;
    setviewport(0,yd,xd,yende,true);     koor3d;
    setviewport(0,0,maxx,maxy,false);
    setcolor(red);
    outtextxy(3,yddiv2 + 3 , 'Z');
    outtextxy(xddiv2 + 3,3,'Y');
    outtextxy((xddiv2)*3 + 3,3,'Y');
    outtextxy(xende-12,yddiv2 + 3 , 'X');
    outtextxy(xende-12,(yddiv2)*3 + 3 , 'X');
    outtextxy((xddiv2)*3 + 3,yende -12,'Z');
    aktivanzeigen(drei);
    flaechenzustandanzeigen;
    setcolor(white);
    rectangle(0,0,xende,yende);
    line(xd,0,xd,yende);
    line(0,yd,xende,yd);
    outtextxy(3,3,'YZ');outtextxy(xd+3,3,'YX');
    outtextxy(3,yd+3,'3D');outtextxy(xd+3,yd+3,'XZ');
    setcolor(lightgreen);
    outtextxy(koorbeginx,maxy-38,'X1:        Y1:        Z1:        Alles bewegen');
    outtextxy(koorbeginx,maxy-28,'X2:        Y2:        Z2:        <<     >> Inv');
    outtextxy(koorbeginx,maxy-18,'X3:        Y3:        Z3:        Lschen      ');
    outtextxy(koorbeginx,maxy- 8,'X4:        Y4:        Z4:        Ende    Plan ');
    outnum(0);
    setfillstyle(solidfill,lightgray);
    bar(koorbeginx+50*8,maxy-39,koorbeginx+58*8,maxy-31);
    farbeanzeigen(@weiss);
  end;

  procedure mausinit;
  begin
    setcolor(white);
    line(5,0,5,10);
    line(0,5,10,5);
    getmem(mauscursor,imagesize(0,0,10,10));
    getimage(0,0,10,10,mauscursor^);
    setfillstyle(solidfill,blue);
    bar(0,0,10,10);
  end;

  procedure bewege(x:byte);
  begin
    mausunsicht;
    mauswarte;
    liste.bewege(x);
    maussetpos(xpos,ypos);
    maussicht;
    mauswarte;
  end;

  procedure mausneu;
  begin
    maussetpos(xpos,ypos);
    mausminmaxx(5,maxx-5);
    mausminmaxy(5,maxy-5);
    maussicht;
  end;

  procedure plananzeigen;
  begin
    liste.neuaufbau(darkgray);
    liste.neuaufbau(yellow);
  end;

begin
  aktiv:=drei;
  grafikinit;
  mausinit;
  maussicht_:=false;
  maus.mausunsicht;
  xpos:=100;ypos:=100;
  maske;
  liste.neuaufbau(darkgray);
  mausneu;
  repeat
    repeat
      maustastpos(tasten,xpos,ypos);
    until ((xpos<>altx) or (ypos<>alty) or (tasten<>0));
    if ((xpos<>altx) or (ypos<>alty)) then bewegezeiger;
    if (tasten=1) then begin
      if ypos>maxy-40 then begin
        if mausinxy(0,maxy-40,40,maxy) then begin
          outnum(liste.add(new(dreieckzeiger,init(succ(liste.getmaxnum),1,0,0,0,1,0,0,0,1,liste.getcolor))));
          aktivanzeigen(drei);
          mauswarte;
        end else if mausinxy(41,maxy-40,79,maxy) then begin
          outnum(liste.add(new(viereckzeiger,init(succ(liste.getmaxnum),0,1,0,1,1,0,1,0,1,0,0,1,liste.getcolor))));
          aktivanzeigen(vier);
          mauswarte;
        end else if mausinxy(80,maxy-40,119,maxy) then begin
          outnum(liste.add(new(kugelzeiger,init(succ(liste.getmaxnum),0,0,0,1,0,0,liste.getcolor))));
          aktivanzeigen(kugel);
          mauswarte;
        end else if mausinxy(koorbeginx,maxy-40,koorbeginx+32*8,maxy-30) then bewege(0)
        else if mausinxy(koorbeginx,maxy-30,koorbeginx+32*8,maxy-20) then bewege(1)
        else if mausinxy(koorbeginx,maxy-20,koorbeginx+32*8,maxy-10) and (aktiv<>kugel) then bewege(2)
        else if mausinxy(koorbeginx,maxy-10,koorbeginx+32*8,maxy) and (aktiv=vier) then bewege(3)
        else if mausinxy(koorbeginx+33*8,maxy-40,koorbeginx+45*8,maxy-30) then bewege(4)
        else if mausinxy(koorbeginx+49*8,maxy-30,koorbeginx+59*8,maxy-20) then liste.farbe(rot,xpos)
        else if mausinxy(koorbeginx+49*8,maxy-20,koorbeginx+59*8,maxy-10) then liste.farbe(gruen,xpos)
        else if mausinxy(koorbeginx+49*8,maxy-10,koorbeginx+59*8,maxy   ) then liste.farbe(blau,xpos)
        else if mausinxy(koorbeginx+33*8,maxy-30,koorbeginx+35*8,maxy-20) then begin
          outnum(liste.weiter);
          mauswarte;
        end else if mausinxy(koorbeginx+40*8,maxy-30,koorbeginx+42*8,maxy-20) then begin
          outnum(liste.zuruck);
          mauswarte;
        end else if mausinxy(koorbeginx+33*8,maxy-20,koorbeginx+42*8,maxy-10) then begin
          outnum(liste.loschen);
          mauswarte;
        end else if mausinxy(koorbeginx+41*8,maxy-10,koorbeginx+45*8,maxy) then plananzeigen
        else if mausinxy(koorbeginx+43*8,maxy-30,koorbeginx+46*8,maxy-20) then begin
          liste.invert;
          mauswarte;
        end else if mausinxy(koorbeginx+41*8,maxy-20,koorbeginx+45*8,maxy-10) then begin
          liste.neuaufbau(darkgray);
          flaechen:=not flaechen;
          flaechenzustandanzeigen;
          liste.neuaufbau(darkgray);
          mauswarte;
        end
      end else bewege(liste.getecke(xpos,ypos));
    end;
  until (tasten=1) and mausinxy(koorbeginx+33*8,maxy-10,koorbeginx+37*8,maxy);
  freemem(mauscursor,imagesize(0,0,10,10));
  closegraph;
  grafikan:=false;
end;

procedure laden;
var name:namestr;
    suche:searchrec;
begin
  suche.name:='*.WIZ';
  findfirst('*.WIZ',$3f,suche);
  while (doserror=0) do begin
    write(suche.name:20);
    findnext(suche);
  end;
  writeln;
  write('Geben Sie den Bilddateinamen ein (ohne Extension) : ');
  readln(name);
  suche.name:=name+'.WIZ';
  findfirst(name+'.WIZ',$3f,suche);
  if doserror=0 then lade(name) else begin
    textcolor(red);
    writeln(name+'.WIZ nicht gefunden !',^G);
    delay(1000);
  end;
end;

procedure sichern;
var name:namestr;
    suche:searchrec;
begin
  write('Wie soll der Umriss heien (ohne Erweiterung) ? ');
  readln(name);
  suche.name:=name+'.WIZ';
  findfirst(name+'.WIZ',$3f,suche);
  if doserror=0 then begin
    writeln(name+'.WIZ existiert schon. berschreiben (J/N) ?');
    repeat until keypressed;
    if upcase(readkey)<>'J' then exit;
  end;
  liste.sichern(name);
end;

procedure sicherabfrage;
var ein:char;
begin
  if not liste.gesichert then begin
    writeln;
    writeln('Das Objekt ist nicht gesichert. Sichern ? [J/N]');
    repeat
      ein:=upcase(readkey);
    until (ein='J') or (ein='N');
    if ein='J' then sichern;
  end;
end;

procedure menu;
var ein:char;

  function getreal(r:real;s:string):real;
  var s1:string;
      rh:real;
      err:integer;
  begin
    textcolor(lightgreen); write(s:55,'? ');
    textcolor(lightmagenta); write('[',r:8:4,']');
    readln(s1);
    if s1='' then getreal:=r else begin
      val(s1,rh,err);
      if err<>0 then
        getreal:=r
      else getreal:=rh;
    end;
  end;

begin
  repeat
    textbackground(blue);
    textcolor(yellow);
    clrscr;
    writeln('CAD fr Krper aus Drei- und Vierecken':50);
    writeln;
    writeln('A) Objekt edieren');
    writeln('B) Objekt laden');
    if liste.leer then textcolor(lightgray);
    writeln('C) Objekt sichern');
    textcolor(yellow);
    writeln('D) Snap einstellen   :',snap:7:2);
    writeln('E) Breite einstellen :',ausschnitt:7:2);
    writeln('F) Quantisieren');
    writeln('G) Neu');
    writeln('H) Ende');
    repeat until keypressed;
    ein:=upcase(readkey);
    if ein=#0 then ein:=readkey;
    case ein of
      'A':editor;
      'B':laden;
      'C':if not liste.leer then sichern else begin
            textcolor(red);
            writeln('Kein Objekt vorhanden !',^G);
            delay(1000);
          end;
      'D':snap:=getreal(snap,'Gebe die Snap Raster Breite ein');
      'E':ausschnitt:=getreal(ausschnitt,'Gebe die Breite ein');
      'F':liste.quantisieren;
      'G':begin
            sicherabfrage;
            liste.done;
            liste.init;
          end;
    end;
  until ein='H';
end;

{$F+}
procedure ownex;
var ein:char;
begin
  if grafikan then closegraph;
  exitproc:=oldex;
  sicherabfrage;
end;
{$F-}

{$L EGAVGA}
procedure EGAVGAdriver;external;

begin
  if (registerbgidriver(@EGAVGAdriver)<0) then begin
    writeln('Fehler beim Anmelden der Grafiktreiber!');
    halt(1);
  end;
  grafikan:=false;
  oldex:=exitproc;
  exitproc:=@ownex;
  liste.init;
  mausinit(tastenzahl);
  if tastenzahl=0 then begin
    writeln('Ich habe keine Maus gefunden !');
    halt(2);
  end;
  menu;
end.