unit koords;
interface
uses grafik,maus,graph,crt;

function abfrage:boolean;

const koordlange:real=2.0;
var ende:boolean;
implementation

type bildpunkttyp=record x,y:integer; end;
type opunkttyp=record
                 p:vct3;
                 x,z,y:bildpunkttyp;
                 sprite:pointer;
                 xpos:word;
               end;

var xmin__,ymin__,xsize__,augendist__:real;
    firsttime,frame__,clipcube__,brille__,flipareaenabled__:boolean;
    vrp__,nrp__:vct3;
    mauscursor:pointer;
    _vrp,_eye,_vup:opunkttyp;
    augendist_,xmin_,ymin_,xsize_,FPD_,BPD_:real;
    wireframe_,flipareaenabled_,trifillenabled_,brille_,
    frame_,clipcube_,scqmode_,lichtgesch_:boolean;
    shadingmethod_:shadingmeth;
    maxx,maxy:word;
    oben:byte;

function abfrage:boolean;
var neuzeichnen:boolean;


  procedure koord_system;
  var P,Q:vct3;
      n,x,y:integer;
  begin
    if not brille then setcolor(yellow);
    p.x:=-koordlange;p.y:=0;p.z:=0;
    q.x:=koordlange;q.y:=0;q.z:=0;
    linie3d(p,q);
    p.x:=0;p.y:=-koordlange;p.z:=0;
    q.x:=0;q.y:=koordlange;q.z:=0;
    linie3d(p,q);
    p.x:=0;p.y:=0;p.z:=-koordlange;
    q.x:=0;q.y:=0;q.z:=koordlange;
    linie3d(p,q);
    if not brille then setcolor(white);
    for n:=-round(koordlange-1) to round(koordlange-1) do begin
      setcolor(red);
      p.y:=0;p.x:=0;p.z:=n;
      mctodci(p,x,y);
      line(x,y-3,x,y+3);
      setcolor(brown);
      p.y:=n;p.x:=0;p.z:=0;
      mctodci(p,x,y);
      line(x,y-3,x,y+3);
      setcolor(green);
      p.y:=0;p.x:=n;p.z:=0;
      mctodci(p,x,y);
      line(x,y-3,x,y+3);
    end;
    setcolor(green);
    p.y:=0;p.x:=koordlange;p.z:=0;
    mctodci(p,x,y);
    line(x-4,y-4,x,y);
    line(x-4,y+4,x,y);
    outtextxy(x+5,y-5,'X');
    setcolor(brown);
    p.y:=koordlange;p.x:=0;p.z:=0;
    mctodci(p,x,y);
    line(x-4,y-4,x,y);
    line(x-4,y+4,x,y);
    outtextxy(x+5,y-5,'Y');
    setcolor(red);
    p.y:=0;p.x:=0;p.z:=koordlange;
    mctodci(p,x,y);
    line(x-4,y-4,x,y);
    line(x-4,y+4,x,y);
    outtextxy(x+5,y-5,'Z');
    if brille then setcolor(15) else setcolor(lightblue);
  end;

  procedure zeichne_koord_system;
  var vpn:vct3;
  begin
    wireframe_:=wireframe;
    flipareaenabled_:=flipareaenabled;
    trifillenabled_:=trifillenable;
    shadingmethod_:=shadingmethod;
    brille_:=brille;
    augendist_:=augendist;
    frame_:=frame;
    lichtgesch_:=lichtgesch;
    clipcube_:=clipcube;
    xmin_:=xmin; ymin_:=ymin;
    xsize_:=xsize; fpd_:=fpd;bpd_:=bpd;
    _vrp.p:=vrp;
    _vup.p:=vup;
    vpn.x:=nrp.x - vrp.x;
    vpn.y:=nrp.y - vrp.y;
    vpn.z:=nrp.z - vrp.z;
    if donorm(vpn) then error('calcWC_VRC: VRP und NRP sind identisch!');
    _eye.p.x:=vpn.x*vpd+vrp.x;
    _eye.p.y:=vpn.y*vpd+vrp.y;
    _eye.p.z:=vpn.z*vpd+vrp.z;
    xmin:=xmin__; ymin:=ymin__;
    xsize:=xsize__;
    clipcube:=clipcube__;flipareaenabled:=flipareaenabled__;
    brille:=brille__;
    augendist:=augendist__;
    frame:=frame__;
    vrp:=vrp__;
    nrp:=nrp__;
    lichtgesch:=false;
    
    VPD:=3*koordlange; FPD:=vpd-0.1; BPD:=-koordlange*2;
    vup.x:=0; vup.y:=0; vup.z:=0;
    case oben of
      1:begin vrp.z:=vrp.z/2;nrp.z:=nrp.z/2; vup.x:=1; end;
      2:begin vrp.x:=vrp.x/2;nrp.x:=nrp.x/2; vup.y:=1; end;
      else begin vrp.y:=vrp.y/2;nrp.y:=nrp.y/2; vup.z:=1; end;
    end;
    wireframe:=true;
    trifillenable:=false;
    shadingmethod:=flat;
    grafmode:=0;

    grafikbegin;

    maxx:=getmaxx;maxy:=getmaxy;
    if brille then setbkcolor(black) else setbkcolor(blue);
    if brille then setfillstyle(solidfill,black)
    else setfillstyle(solidfill,blue);

    setcolor(white);
    line(5,0,5,10);
    line(0,5,10,5);
    getmem(mauscursor,imagesize(0,0,10,10));
    getimage(0,0,10,10,mauscursor^);
    bar(0,0,10,10);

    setcolor(lightgreen);
    line(0,0,10,10);
    line(10,0,0,10);
    outtextxy(12,1,'VRP');
    getmem(_vrp.sprite,imagesize(0,0,36,10));
    getimage(0,0,36,10,_vrp.sprite^);

    setcolor(lightcyan);
    line(0,0,10,10);
    line(10,0,0,10);
    bar(12,1,36,9);
    outtextxy(12,1,chr(1));
    getmem(_eye.sprite,imagesize(0,0,20,10));
    getimage(0,0,20,10,_eye.sprite^);

    setcolor(lightred);
    line(0,0,10,10);
    line(10,0,0,10);
    bar(12,1,20,9);
    outtextxy(12,1,'VUP');
    getmem(_vup.sprite,imagesize(0,0,36,10));
    getimage(0,0,36,10,_vup.sprite^);

    _vrp.xpos:=10+8*4;
    _eye.xpos:=10+8*30;
    _vup.xpos:=10+8*56;

    bar(0,0,36,10);
  end;

  function abgefragt:boolean;
  var okpressed:boolean;
      tasten:word;
      xpos,ypos,altx,alty:word;
      maussicht_,ziehen:boolean;
      punktzeiger:^opunkttyp;
      abstand1,abstand2:real;

    procedure uebernahme;
    begin
      xmin__:=xmin_; ymin__:=ymin_;
      xsize__:=xsize_;
      clipcube__:=clipcube_;flipareaenabled__:=flipareaenabled_;
      brille__:=brille_;
      augendist__:=augendist_;
      frame__:=frame_;
      vrp__:=_vrp.p;
      nrp__:=_eye.p;
      {if _vup.p.x>_vup.p.y then begin
        if _vup.p.x>_vup.p.z then oben:=1 else oben:=3;
      end else begin
        if _vup.p.y>_vup.p.z then oben:=2 else oben:=3;
      end;}
      neuzeichnen:=true;
    end;

    procedure bedingttextxy(x,y:integer;schalter:boolean;a,b:string);
    begin
      if brille then setfillstyle(solidfill,black)
      else setfillstyle(solidfill,blue);
      setcolor(lightgreen);
      bar(x,y,x+length(a)*8,y+8);
      if schalter then outtextxy(x,y,a) else outtextxy(x,y,b);
    end;

    procedure bewegezeiger;
    begin
      if maussicht_ then begin
        putimage(altx-5,alty-5,mauscursor^,xorput);
        putimage(xpos-5,ypos-5,mauscursor^,xorput);
      end;
      altx:=xpos; alty:=ypos;
    end;

    procedure mausunsicht;
    begin
      if maussicht_ then begin
        putimage(altx-5,alty-5,mauscursor^,xorput);
        maussicht_:=false;
      end;
    end;

    procedure maussicht;
    begin
      if not maussicht_ then begin
        putimage(xpos-5,ypos-5,mauscursor^,xorput);
        maussicht_:=true;
        altx:=xpos;alty:=ypos;
      end;
    end;

    function mausin(x,y,xe,ye:integer):boolean;
    begin
      mausin := (xpos >= x) and (xpos <= xe) and (ypos >= y) and (ypos <= ye);
    end;

    procedure schalte(x,y,xe,ye:integer;var schalter:boolean;a,b:string);
    begin
      if mausin(x,y,xe,ye) then begin
        schalter:=not schalter;
        mausunsicht;
          bedingttextxy(x,y,schalter,a,b);
        maussicht;
      end;
    end;

    procedure zeigek(p:opunkttyp);
    begin
      setcolor(white);
      setwritemode(xorput);
      line(p.x.x,p.x.y,p.z.x,p.z.y);
      line(p.z.x,p.z.y,p.y.x,p.y.y);
      setwritemode(copyput);
      putimage(p.y.x-5,p.y.y-5,p.sprite^,xorput);
    end;

    procedure zeigep(p:opunkttyp);
    var buffer:string[6];
    begin
      if brille then setfillstyle(solidfill,black)
      else setfillstyle(solidfill,blue);
      setcolor(lightmagenta);

      str(p.p.x:6:3,buffer);
      bar(p.xpos,maxy-30,p.xpos+length(buffer)*8,maxy-30+8);
      outtextxy(p.xpos,maxy-30,buffer);

      str(p.p.y:6:3,buffer);
      bar(p.xpos+8*7,maxy-30,p.xpos+8*7+length(buffer)*8,maxy-30+8);
      outtextxy(p.xpos+8*7,maxy-30,buffer);

      str(p.p.z:6:3,buffer);
      bar(p.xpos+8*14,maxy-30,p.xpos+8*14+length(buffer)*8,maxy-30+8);
      outtextxy(p.xpos+8*14,maxy-30,buffer);
    end;

    procedure zeiger(p:real;x:word);
    var buffer:string[6];
    begin
      if brille then setfillstyle(solidfill,black)
      else setfillstyle(solidfill,blue);
      setcolor(lightmagenta);
      str(p:6:3,buffer);
      bar(x,maxy-20,x+length(buffer)*8,maxy-20+8);
      outtextxy(x,maxy-20,buffer);
    end;

    procedure berechne(var o:opunkttyp);
    var hilf:vct3;
    begin
      hilf.x:=o.p.x; hilf.y:=0; hilf.z:=0;
      mctodci(hilf,o.x.x,o.x.y);
      hilf.z:=o.p.z;
      mctodci(hilf,o.z.x,o.z.y);
      hilf.y:=o.p.y;
      mctodci(hilf,o.y.x,o.y.y);
    end;

    procedure getreal(var s:real;x:word);
    begin
      mausunsicht;
      maussetpos(320,240);
      repeat
        repeat
          maustastpos(tasten,xpos,ypos);
        until (tasten=0) or (xpos<>320) or (ypos<>240);
        if (tasten<>0) then begin
          s:=s+(integer(xpos-320)+integer(240-ypos))/100;
          zeiger(s,x);
        end;
        maussetpos(320,240);
      until (tasten=0);
      maussetpos(x,maxy-20);
      maussicht;
    end;

    procedure getstring(var s:string;x,y:word;l:byte);
    var ein:char;
        s2:string;
    begin
      mausunsicht;
      setcolor(white);
      if brille then setfillstyle(solidfill,black)
      else setfillstyle(solidfill,blue);
      bar(x,y,x+8*l,y+8);
      s2:='';
      repeat
        repeat until keypressed;
        while keypressed do ein:=upcase(readkey);
        if (ein>#32) then begin
          s2:=s2+ein;
          outtextxy(x+pred(length(s2))*8,y,ein);
        end;
      until (length(s2)=l) or (ein=#13) or (ein=#27);
      if (ein<>#27) then s:=s2 else begin
        bar(x,y,x+8*l,y+8);
        outtextxy(x,y,s);
      end;
      maussicht;
    end;

    procedure getzahl(var zahl:real;x:word);
    var text:string[6];
        hilf:real;
        code:integer;
    begin
      hilf:=zahl;
      setcolor(brown);
      mausunsicht;
      bar(x,maxy-20,x+6*8,maxy-11);
      getstring(text,x,maxy-20,6);
      val(text,zahl,code);
      if code<>0 then zahl:=hilf;
      mausunsicht;
      bar(x,maxy-20,x+6*8,maxy-11);
      zeiger(zahl,x);
      maussicht;
    end;

    procedure ziehenvorbereiten;
    begin
      ziehen:=true;
      mausunsicht;
      maussetpos(320,240);
      repeat until not mauskeypressed;
    end;

    procedure savepos;
    var f:text;
    begin
      if name<>'' then begin
        assign(f,name+'.POS');
        rewrite(f);
        writeln(f,'Standpunkt ',_eye.p.x:7:3,_eye.p.y:7:3,_eye.p.z:7:3);
        writeln(f,'Blickpunkt ',_vrp.p.x:7:3,_vrp.p.y:7:3,_vrp.p.z:7:3);
        writeln(f,'Achsenrichtung ',_vup.p.x:7:3,_vup.p.y:7:3,_vup.p.z:7:3);
        writeln(f,'Abstand ',sqrt(sqr(_eye.p.x-_vrp.p.x)+sqr(_eye.p.y-_vrp.p.y)+sqr(_eye.p.z-_vrp.p.z)):7:3);
        writeln(f,'XSize ',xsize_:7:3);
        writeln(f,'XMin ',xmin_:7:3);
        writeln(f,'YMin ',ymin_:7:3);
        writeln(f,'BPD ',bpd_:7:3);
        writeln(f,'FPD ',fpd_:7:3);
        close(f);
      end;
    end;

  begin
    setcolor(lightgreen);
    outtextxy(10,maxy-30,'VRP(      /      /      ) EYE(      /      /      ) VUP(      /      /      )');
    outtextxy(10,maxy-20,   'X:       Y:       Xsize:       FPD:       BPD:       Augen:       Lnge:');
    bedingttextxy(10,maxy-10,wireframe_,'Draht ','Flche');
    bedingttextxy(10+56,maxy-10,flipareaenabled_,'Alles','Flip ');
    bedingttextxy(10+104,maxy-10,trifillenabled_,'Fill','Line');
    bedingttextxy(10+144,maxy-10,shadingmethod_=gouraud,'Schatt','Flach');
    bedingttextxy(10+200,maxy-10,brille_,'Brille','Normal');
    bedingttextxy(10+256,maxy-10,frame_,'Ramen ','Normal');
    bedingttextxy(10+312,maxy-10,clipcube_,'Umriss','Alles ');
    bedingttextxy(10+368,maxy-10,scqmode_,'SCQ','IBM');
    outtextxy(10+400,maxy-10,'Name:');
    outtextxy(10+520,maxy-10,'OK Ende >< ');
    setcolor(white);
    outtextxy(458,maxy-10,name);
    zeigep(_vrp);
    zeigep(_eye);
    zeigep(_vup);
    zeiger(xmin_,10+8*2);
    zeiger(ymin_,10+8*11);
    zeiger(xsize_,10+8*24);
    zeiger(FPD_,10+8*35);
    zeiger(BPD_,10+8*46);
    zeiger(augendist_,10+8*59);
    zeiger(koordlange,10+8*72);
    berechne(_vrp);
    berechne(_eye);
    berechne(_vup);
    zeigek(_vrp);
    zeigek(_eye);
    zeigek(_vup);
    okpressed:=false;
    ziehen:=false;
    neuzeichnen:=false;
    maussicht_:=false;
    mausinit(tasten);
    if tasten=0 then error('Keine Maus vorhanden');
    maus.mausunsicht;
    xpos:=100;ypos:=100;
    mausminmaxx(5,maxx-5);
    mausminmaxy(5,maxy);
    maussicht;
    ende:=false;
    repeat
      maustastpos(tasten,xpos,ypos);
      if ((xpos<>altx) or (ypos<>alty)) and (not ziehen) then bewegezeiger;
      if (ypos>(maxy-30)) then begin
        if (tasten=1) then begin
          schalte(10,maxy-10,66,maxy,wireframe_,'Draht ','Flche');
          schalte(10+56,maxy-10,114,maxy,flipareaenabled_,'Alles','Flip ');
          schalte(10+104,maxy-10,154,maxy,trifillenabled_,'Fill','Line');
          schalte(10+144,maxy-10,210,maxy,boolean(shadingmethod_),'Schatt','Flach');
          schalte(10+200,maxy-10,266,maxy,brille_,'Brille','Normal');
          schalte(10+256,maxy-10,322,maxy,frame_,'Ramen ','Normal');
          schalte(10+312,maxy-10,378,maxy,clipcube_,'Umriss','Alles ');
          schalte(10+368,maxy-10,402,maxy,scqmode_,'SCQ','IBM');
          if mausin(530,maxy-10,553,maxy) then okpressed:=true else
          if mausin(554,maxy-10,593,maxy) then begin ende:=true;okpressed:=true end else
          if mausin(594,maxy-10,610,maxy) then uebernahme else
          if mausin(619,maxy-10,627,maxy) then savepos else
          if mausin(10     ,maxy-20,10+8*8 ,maxy-10) then getreal(xmin_,10+8*2) else
          if mausin(10+8*9 ,maxy-20,10+8*17,maxy-10) then getreal(ymin_,10+8*11) else
          if mausin(10+8*18,maxy-20,10+8*30,maxy-10) then getreal(xsize_,10+8*24) else
          if mausin(10+8*31,maxy-20,10+8*41,maxy-10) then getreal(FPD_,10+8*35) else
          if mausin(10+8*42,maxy-20,10+8*52,maxy-10) then getreal(BPD_,10+8*46) else
          if mausin(10+8*53,maxy-20,10+8*65,maxy-10) then getreal(augendist_,10+8*59) else
          if mausin(10+8*66,maxy-20,10+8*78,maxy-10) then getreal(koordlange,10+8*72) else
          if mausin(10     ,maxy-30,10+3*8 ,maxy-20) then begin
            punktzeiger:=@_vrp;
            ziehenvorbereiten;
          end else if mausin(10+26*8,maxy-30,10+29*8 ,maxy-20) then begin
            punktzeiger:=@_eye;
            ziehenvorbereiten;
          end else if mausin(10+52*8,maxy-30,10+55*8 ,maxy-20) then begin
            punktzeiger:=@_vup;
            ziehenvorbereiten;
          end else if mausin(10+400,maxy-10,10+519,maxy) then getstring(name,10+400+6*8,maxy-10,8);
          repeat until not mauskeypressed;
        end else if (tasten=2) then begin
          if mausin(10     ,maxy-20,10+8*8 ,maxy-10) then getzahl(xmin_,10+8*2) else
          if mausin(10+8*9 ,maxy-20,10+8*17,maxy-10) then getzahl(ymin_,10+8*11) else
          if mausin(10+8*18,maxy-20,10+8*30,maxy-10) then getzahl(xsize_,10+8*24) else
          if mausin(10+8*31,maxy-20,10+8*41,maxy-10) then getzahl(FPD_,10+8*35) else
          if mausin(10+8*42,maxy-20,10+8*52,maxy-10) then getzahl(BPD_,10+8*46) else
          if mausin(10+8*53,maxy-20,10+8*65,maxy-10) then getzahl(augendist_,10+8*59) else
          if mausin(10+8*66,maxy-20,10+8*78,maxy-10) then getzahl(koordlange,10+8*72);
        end;
      end else begin
        if ziehen then begin
          if (tasten=1) then begin
            ziehen:=false;
            maussetpos(punktzeiger^.y.x,punktzeiger^.y.y);
            maussicht;
            repeat until not mauskeypressed;
          end else begin
            if (xpos<>320) or (ypos<>240) then begin
              if (tasten=2) then begin
                punktzeiger^.p.x:=punktzeiger^.p.x+(integer(xpos)-320)*koordlange/320;
                punktzeiger^.p.y:=punktzeiger^.p.y+(240-integer(ypos))*koordlange/320;
              end else begin
                punktzeiger^.p.x:=punktzeiger^.p.x+(integer(xpos)-320)*koordlange/320;
                punktzeiger^.p.z:=punktzeiger^.p.z+(integer(ypos)-240)*koordlange/320;
              end;
              zeigek(punktzeiger^);
              berechne(punktzeiger^);
              zeigek(punktzeiger^);
              zeigep(punktzeiger^);
              maussetpos(320,240);
            end;
          end;
        end else if (tasten=1) then begin
          abstand1:=sqrt(sqr(xpos-_vrp.y.x)+sqr(ypos-_vrp.y.y));
          abstand2:=sqrt(sqr(xpos-_eye.y.x)+sqr(ypos-_eye.y.y));
          if abstand1>abstand2 then begin
            abstand1:=abstand2;
            punktzeiger:=@_eye;
          end else punktzeiger:=@_vrp;
          abstand2:=sqrt(sqr(xpos-_vup.y.x)+sqr(ypos-_vup.y.y));
          if abstand1>abstand2 then punktzeiger:=@_vup;
          ziehenvorbereiten;
        end;
      end;
    until okpressed or neuzeichnen;
    xmin:=xmin_; ymin:=ymin_;
    xsize:=xsize_; fpd:=fpd_;bpd:=bpd_;
    wireframe:=wireframe_;
    flipareaenabled:=flipareaenabled_;
    trifillenable:=trifillenabled_;
    shadingmethod:=shadingmethod_;
    brille:=brille_;
    augendist:=augendist_;
    frame:=frame_;
    lichtgesch:=lichtgesch_;
    clipcube:=clipcube_;
    if wireframe_ then grafmode:=0 else begin
      if scqmode_ then grafmode:=-2 else grafmode:=-1;
    end;
    if neuzeichnen then grafmode:=0;
    vrp:=_vrp.p;
    vup:=_vup.p;
    nrp:=_eye.p;
    vpd:=sqrt(sqr(_eye.p.x-_vrp.p.x)+sqr(_eye.p.y-_vrp.p.y)+sqr(_eye.p.z-_vrp.p.z));
    if fpd>vpd then fpd:=vpd-0.1;
    if okpressed then begin
      abgefragt:=false;
      firsttime:=true;
      freemem(mauscursor,imagesize(0,0,10,10));
      freemem(_vrp.sprite,imagesize(0,0,36,10));
      freemem(_eye.sprite,imagesize(0,0,20,10));
      freemem(_vup.sprite,imagesize(0,0,36,10));
    end else begin
      if neuzeichnen then abgefragt:=true;
    end;
    grafikende;
  end;

begin
  if firsttime then begin
    zeichne_koord_system;
    if dolocalinit then koord_system;
    abfrage:=true;
    firsttime:=false;
  end else begin
    if dolocalinit then begin
      koord_system;
      abfrage:=true;
    end else begin
      abfrage:=abgefragt;
      if neuzeichnen then begin
        zeichne_koord_system;
        if dolocalinit then koord_system;
        abfrage:=true;
      end else abfrage:=false;
    end;
  end;
end;

begin
  XMIN:=-koordlange*0.7;YMIN:=-koordlange*0.6; XSIZE:=1.8*koordlange;
  FPD:=5;BPD:=-5;
  oben:=2;
  shadingmethod:=gouraud;
  wireframe:=true;
  flipAreaEnabled:=false;
  TriFillEnable:=true;
  brille:=false;
  mapcolor:=15;
  augendist:=0.5;
  frame:=false;
  clipcube:=false;
  scqmode_:=true;
  xmin__:=xmin; ymin__:=ymin;
  xsize__:=xsize;
  brille__:=false;augendist__:=augendist;
  frame__:=frame;clipcube__:=true;flipareaenabled__:=flipareaenabled;
  VRP__.x:=koordlange; VRP__.y:=koordlange; VRP__.z:=koordlange;
  NRP__.x:=koordlange+2; NRP__.y:=koordlange+2; NRP__.z:=koordlange+2;
  firsttime:=true;
end.