unit transobt;
interface
uses trans3d,dos;
function loadobjekt(name:namestr;daten:byte):byte;
function saveobjekt(name:namestr;daten:byte):byte;
implementation

function loadobjekt(name:namestr;daten:byte):byte;
var gelesen,dateidaten,maxxdaten,maxydaten:byte;
    objektfile:file;
    dirinfo:searchrec;
    realdaten:boolean;
    surface:surfacepropertytyp;
    hilf:shortint;
    x,y,hilfb:byte;

begin
  gelesen:=0;
  FindFirst(name+'.OBT', $3f, DirInfo);
  if (DosError = 0) then begin
    assign(objektfile,name+'.OBT');
    reset(objektfile,1);
    blockread(objektfile,dateidaten,1);
    blockread(objektfile,maxxdaten,1);
    blockread(objektfile,maxydaten,1);
    {$IFopt N+}
      blockread(objektfile,_wrkarr.volume.x,4);
      blockread(objektfile,_wrkarr.volume.y,4);
      blockread(objektfile,_wrkarr.volume.z,4);
    {$else}
      blockread(objektfile,_wrkarr.volume.x,6);
      blockread(objektfile,_wrkarr.volume.y,6);
      blockread(objektfile,_wrkarr.volume.z,6);
    {$endif}
    realdaten:=(dateidaten and realdat)>0;
    if ((dateidaten and xdat)>0) then
     if ((daten and xdat)>0) then begin
       _wrkarr.xmax:=maxxdaten;
       _wrkarr.ymax:=maxydaten;
       gelesen:=gelesen or xdat;
       for x:=0 to maxxdaten do
        for y:=0 to maxydaten do
         if realdaten then
          {$IFopt N+}
            blockread(objektfile,_wrkarr.m[x]^[y].a.crd.x,4)
          {$else}
            blockread(objektfile,_wrkarr.m[x]^[y].a.crd.x,6)
          {$endif}
         else begin
           blockread(objektfile,hilf,1);
           _wrkarr.m[x]^[y].a.crd.x:=hilf/255;
         end
       end
     else if realdaten then
     {$IFopt N+}
       seek(objektfile,3+4*succ(maxxdaten)*succ(maxydaten))
     {$else}
       seek(objektfile,3+6*succ(maxxdaten)*succ(maxydaten))
     {$endif}
     else seek(objektfile,3+succ(maxxdaten)*succ(maxydaten));
    if ((dateidaten and ydat)>0) then
     if ((daten and ydat)>0) then begin
       _wrkarr.xmax:=maxxdaten;
       _wrkarr.ymax:=maxydaten;
       gelesen:=gelesen or ydat;
       for x:=0 to maxxdaten do
        for y:=0 to maxydaten do
         if realdaten then
          {$IFopt N+}
            blockread(objektfile,_wrkarr.m[x]^[y].a.crd.y,4)
          {$else}
            blockread(objektfile,_wrkarr.m[x]^[y].a.crd.y,6)
          {$endif}
         else begin
           blockread(objektfile,hilf,1);
           _wrkarr.m[x]^[y].a.crd.y:=hilf/255;
         end
       end
     else if realdaten then
     {$IFopt N+}
       seek(objektfile,3+2*4*succ(maxxdaten)*succ(maxydaten))
     {$else}
       seek(objektfile,3+2*6*succ(maxxdaten)*succ(maxydaten))
     {$endif}
     else seek(objektfile,3+2*succ(maxxdaten)*succ(maxydaten));
    if ((dateidaten and zdat)>0) then
     if ((daten and zdat)>0) then begin
       _wrkarr.xmax:=maxxdaten;
       _wrkarr.ymax:=maxydaten;
       gelesen:=gelesen or zdat;
       for x:=0 to maxxdaten do
        for y:=0 to maxydaten do
         if realdaten then
          {$IFopt N+}
            blockread(objektfile,_wrkarr.m[x]^[y].a.crd.z,4)
          {$else}
            blockread(objektfile,_wrkarr.m[x]^[y].a.crd.z,6)
          {$endif}
         else begin
           blockread(objektfile,hilf,1);
           _wrkarr.m[x]^[y].a.crd.z:=hilf/255;
         end
       end
     else if realdaten then
     {$IFopt N+}
       seek(objektfile,3+3*4*succ(maxxdaten)*succ(maxydaten))
     {$else}
       seek(objektfile,3+3*6*succ(maxxdaten)*succ(maxydaten))
     {$endif}
     else seek(objektfile,3+3*succ(maxxdaten)*succ(maxydaten));
    if ((dateidaten and nrmdat)>0) then
     if ((daten and nrmdat)>0) then begin
       gelesen:=gelesen or nrmdat;
       for x:=0 to maxxdaten do
        for y:=0 to maxydaten do
         if realdaten then
          {$IFopt N+}
            blockread(objektfile,_wrkarr.m[x]^[y].a.nrm,3*4)
          {$else}
            blockread(objektfile,_wrkarr.m[x]^[y].a.nrm,3*6)
          {$endif}
         else begin
           blockread(objektfile,hilf,1);
           _wrkarr.m[x]^[y].a.nrm.x:=hilf/255;
           blockread(objektfile,hilf,1);
           _wrkarr.m[x]^[y].a.nrm.y:=hilf/255;
           blockread(objektfile,hilf,1);
           _wrkarr.m[x]^[y].a.nrm.z:=hilf/255;
         end
       end
     else if realdaten then
     {$IFopt N+}
       seek(objektfile,3+6*4*succ(maxxdaten)*succ(maxydaten))
     {$else}
       seek(objektfile,3+6*6*succ(maxxdaten)*succ(maxydaten))
     {$endif}
     else seek(objektfile,3+6*succ(maxxdaten)*succ(maxydaten));
    if ((dateidaten and texturdat)>0) then
     if ((daten and texturdat)>0) then begin
       gelesen:=gelesen or texturdat;
       for x:=0 to maxxdaten do
        for y:=0 to maxydaten do begin
          blockread(objektfile,hilfb,1);
          _wrkarr.m[x]^[y].a.c.r:=hilfb/255;
          blockread(objektfile,hilfb,1);
          _wrkarr.m[x]^[y].a.c.g:=hilfb/255;
          blockread(objektfile,hilfb,1);
          _wrkarr.m[x]^[y].a.c.b:=hilfb/255;
        end
      end
     else if realdaten then
     {$IFopt N+}
       seek(objektfile,3+(3+6*4)*succ(maxxdaten)*succ(maxydaten))
     {$else}
       seek(objektfile,3+(3+6*6)*succ(maxxdaten)*succ(maxydaten))
     {$endif}
     else seek(objektfile,3+9*succ(maxxdaten)*succ(maxydaten));
    if ((dateidaten and materialdat)>0) then
     if ((daten and materialdat)>0) then begin
       gelesen:=gelesen or materialdat;
       {$IFopt N+}
        blockread(objektfile,surface,40);
       {$else}
        blockread(objektfile,surface,60);
       {$endif}
       with surface do changesurfaceproperty(ka,kd,ks,os.r,os.g,os.b,oe,od.r,od.g,od.b,alpha);
     end;
    close(objektfile);
  end;
  loadobjekt:=gelesen;
end;

function saveobjekt(name:namestr;daten:byte):byte;
var geschrieben:byte;
    objektfile:file;
    dirinfo:searchrec;
    realdaten:boolean;
    hilf:shortint;
    x,y,hilfb:byte;
begin
  geschrieben:=0;
  assign(objektfile,name+'.OBT');
  rewrite(objektfile,1);
  blockwrite(objektfile,daten,1);
  blockwrite(objektfile,_wrkarr.xmax,1);
  blockwrite(objektfile,_wrkarr.ymax,1);
  {$IFopt N+}
    blockwrite(objektfile,_wrkarr.volume.x,4);
    blockwrite(objektfile,_wrkarr.volume.y,4);
    blockwrite(objektfile,_wrkarr.volume.z,4);
  {$else}
    blockwrite(objektfile,_wrkarr.volume.x,6);
    blockwrite(objektfile,_wrkarr.volume.y,6);
    blockwrite(objektfile,_wrkarr.volume.z,6);
  {$endif}
  realdaten:=(daten and realdat)>0;
  if ((daten and xdat)>0) then begin write(^G);
    for x:=0 to _wrkarr.xmax do
     for y:=0 to _wrkarr.ymax do
      if realdaten then
       {$IFopt N+}
        blockwrite(objektfile,_wrkarr.m[x]^[y].a.crd.x,4)
       {$else}
         blockwrite(objektfile,_wrkarr.m[x]^[y].a.crd.x,6)
       {$endif}
      else begin
        hilf:=round(_wrkarr.m[x]^[y].a.crd.x*255);
        blockwrite(objektfile,hilf,1);
      end;
    geschrieben:=geschrieben or xdat;
  end;
  if ((daten and ydat)>0) then begin
    for x:=0 to _wrkarr.xmax do
     for y:=0 to _wrkarr.ymax do
      if realdaten then
       {$IFopt N+}
         blockwrite(objektfile,_wrkarr.m[x]^[y].a.crd.y,4)
       {$else}
         blockwrite(objektfile,_wrkarr.m[x]^[y].a.crd.y,6)
       {$endif}
      else begin
        hilf:=round(_wrkarr.m[x]^[y].a.crd.y*255);
        blockwrite(objektfile,hilf,1);
      end;
    geschrieben:=geschrieben or ydat;
  end;
  if ((daten and zdat)>0) then begin
    for x:=0 to _wrkarr.xmax do
     for y:=0 to _wrkarr.ymax do
      if realdaten then
       {$IFopt N+}
         blockwrite(objektfile,_wrkarr.m[x]^[y].a.crd.z,4)
       {$else}
         blockwrite(objektfile,_wrkarr.m[x]^[y].a.crd.z,6)
       {$endif}
      else begin
        hilf:=round(_wrkarr.m[x]^[y].a.crd.z*255);
        blockwrite(objektfile,hilf,1);
      end;
    geschrieben:=geschrieben or zdat;
  end;
  if ((daten and nrmdat)>0) then begin
    for x:=0 to _wrkarr.xmax do
     for y:=0 to _wrkarr.ymax do
      if realdaten then
       {$IFopt N+}
         blockwrite(objektfile,_wrkarr.m[x]^[y].a.nrm,3*4)
       {$else}
         blockwrite(objektfile,_wrkarr.m[x]^[y].a.nrm,3*6)
       {$endif}
      else begin
        hilf:=round(_wrkarr.m[x]^[y].a.nrm.x*255);
        blockwrite(objektfile,hilf,1);
        hilf:=round(_wrkarr.m[x]^[y].a.nrm.y*255);
        blockwrite(objektfile,hilf,1);
        hilf:=round(_wrkarr.m[x]^[y].a.nrm.z*255);
        blockwrite(objektfile,hilf,1);
      end;
    geschrieben:=geschrieben or nrmdat;
  end;
  if ((daten and texturdat)>0) then begin
    for x:=0 to _wrkarr.xmax do
     for y:=0 to _wrkarr.ymax do begin
       hilfb:=round(_wrkarr.m[x]^[y].a.c.r*255);
       blockwrite(objektfile,hilfb,1);
       hilfb:=round(_wrkarr.m[x]^[y].a.c.g*255);
       blockwrite(objektfile,hilfb,1);
       hilfb:=round(_wrkarr.m[x]^[y].a.c.b*255);
       blockwrite(objektfile,hilfb,1);
     end;
    if doserror=0 then geschrieben:=geschrieben or texturdat;
  end;
  if ((daten and materialdat)>0) then begin
    {$IFopt N+}
     blockwrite(objektfile,surfaceproperty,40);
    {$else}
     blockwrite(objektfile,surfaceproperty,60);
    {$endif}
    geschrieben:=geschrieben or materialdat;
  end;
  close(objektfile);
  saveobjekt:=geschrieben;
end;

end.