unit transwrt;
interface
uses trans3d,dos;
procedure schreibe3d(text:string;r,g,b,r2,g2,b2:real);
procedure ladeschrift(zsname:namestr);

implementation
type zeichensatztyp=array[0..255,1..16] of byte;
var zs:zeichensatztyp;
    zsdatei:file of zeichensatztyp;
    aktzs:namestr;

procedure ladeschrift(zsname:namestr);
var suche:searchrec;
begin
  if aktzs<>zsname then begin
    FindFirst(zsname+'.ZS', $3f, suche);
    if (DosError <> 0) then error('Konnte Zeichensatz '+zsname+'.ZS nicht laden');
    assign(zsdatei,zsname+'.ZS');
    reset(zsdatei);
    read(zsdatei,zs);
    close(zsdatei);
    aktzs:=zsname;
  end;
end;

{procedure schreibe3d(text:string;n1,n2:byte;r,g,b:real);
var x,y:byte;
begin
  textur(4,3,r,g,b);
  pushtrafs;
    repeat
      for x:=7 downto 0 do begin
        pushtrafs;
          for y:=1 to 16 do begin
            if (((zs[byte(text[1]),y] shr x) and 1)=1) then kugel(n1,n2,r,g,b);
            translate(0,-2,0);
          end;
        poptrafs;
        translate(2,0,0);
      end;
      delete(text,1,1);
    until text='';
  poptrafs;
end;}

procedure schreibe3d(text:string;r,g,b,r2,g2,b2:real);
var x,y,xx,yy:byte;
begin
  textur(8,16,r,g,b);
  pushtrafs;
    repeat
      defineclipvolume(0.5,1,1/8,r,g,b);
      if clipmode<>outside then begin
        _wrkarr.xmax:=8;
        _wrkarr.ymax:=16;
        for x:=0 to 8 do for y:=0 to 16 do
         with _wrkarr.m[x]^[y].a do begin
          nrm.x:=0; nrm.y:=0; nrm.z:=1;
          crd.x:=-0.5+x*1/8; crd.y:=1-y*2/16; crd.z:=1/8;
          _wrkarr.m[x]^[y].flags:=notused;
        end;
        for x:=0 to 7 do for y:=0 to 15 do
         if boolean((zs[byte(text[1]),succ(y)] shr (7-x)) and 1) then
          _wrkarr.m[x]^[y].flags:=isvis;
        mesh;
        for x:=0 to 8 do for y:=0 to 16 do
         with _wrkarr.m[x]^[y].a do begin
          nrm.x:=0; nrm.y:=0; nrm.z:=-1;
          crd.x:=-0.5+x*1/8; crd.y:=1-y*2/16; crd.z:=-1/8;
          _wrkarr.m[x]^[y].flags:=notused;
        end;
        for x:=0 to 7 do for y:=0 to 15 do
         if boolean((zs[byte(text[1]),succ(y)] shr (7-x)) and 1) then
          _wrkarr.m[x]^[y].flags:=isvis;
        mesh;
        _wrkarr.xmax:=1;
        _wrkarr.ymax:=1;
        textur(1,1,r2,g2,b2);
        for x:=0 to 7 do for y:=0 to 15 do begin
          if boolean((zs[byte(text[1]),succ(y)] shr (7-x)) and 1) then begin
            if (y=1) or (0=((zs[byte(text[1]),y] shr (7-x)) and 1)) then begin
              for xx:=0 to 1 do for yy:=0 to 1 do
              with _wrkarr.m[xx]^[yy].a,_wrkarr.m[xx]^[yy] do begin
                nrm.x:=0; nrm.y:=1; nrm.z:=0;
                crd.x:=-0.5+(x+xx)*1/8; crd.y:=1-y*2/16;
                if boolean(yy) then crd.z:=-1/8 else crd.z:=1/8;
                flags:=isvis;
              end;
              mesh;
             end;
            if (x=8) or (0=((zs[byte(text[1]),succ(y)] shr (6-x)) and 1)) then begin
              for xx:=0 to 1 do for yy:=0 to 1 do
              with _wrkarr.m[xx]^[yy].a,_wrkarr.m[xx]^[yy] do begin
                nrm.x:=1; nrm.y:=0; nrm.z:=0;
                crd.x:=-0.5+succ(x)*1/8; crd.y:=1-(y+xx)*2/16;
                if boolean(yy) then crd.z:=-1/8 else crd.z:=1/8;
                flags:=isvis;
              end;
              mesh;
            end;
            if (y=16) or (0=((zs[byte(text[1]),y+2] shr (7-x)) and 1)) then begin
              for xx:=0 to 1 do for yy:=0 to 1 do
              with _wrkarr.m[xx]^[yy].a,_wrkarr.m[xx]^[yy] do begin
                nrm.x:=0; nrm.y:=-1; nrm.z:=0;
                crd.x:=-0.5+(x+xx)*1/8; crd.y:=1-succ(y)*2/16;
                if boolean(yy) then crd.z:=-1/8 else crd.z:=1/8;
                flags:=isvis;
              end;
              mesh;
            end;
            if (x=1) or (0=((zs[byte(text[1]),succ(y)] shr (8-x)) and 1)) then begin
              for xx:=0 to 1 do for yy:=0 to 1 do
              with _wrkarr.m[xx]^[yy].a,_wrkarr.m[xx]^[yy] do begin
                nrm.x:=-1; nrm.y:=0; nrm.z:=0;
                crd.x:=-0.5+x*1/8; crd.y:=1-(y+xx)*2/16;
                if boolean(yy) then crd.z:=-1/8 else crd.z:=1/8;
                flags:=isvis;
              end;
              mesh;
            end;
          end;
        end;
      end;
      undefclipvolume;
      delete(text,1,1);
      translate(1,0,0);
    until text='';
  poptrafs;
end;

begin
{  aktzs:='';}
  ladeschrift('ROM_8x16');
end.