unit tgdriver;
interface
uses dos,graph,vga,maus,objects,drivers;
const evMouseDown = $0001;
      evMouseUp = $0002;
      evMouseMove = $0004;
      evMouseAuto = $0008;
      evKeyDown = $0010;
      evCommand = $0100;
      evBroadcast = $0200;
      evNothing = $0000;
      evKeyboard = $0010;
      evMouse = $000F;
      evMessage = $FF00;
      mbLeftButton = $01;
      mbRightButton= $02;
      kbRightShift = $0001;
      kbLeftShift = $0002;
      kbCtrlShift = $0004;
      kbAltShift = $0008;
      kbScrollState= $0010;
      kbNumState = $0020;
      kbCapsState = $0040;
      kbInsState = $0080;
      kbAltA = $1E00;
      kbAltN = $3100;
      kbAltB = $3000;
      kbAltO = $1800;
      kbAltC = $2E00;
      kbAltP = $1900;
      kbAltD = $2000;
      kbAltQ = $1000;
      kbAltE = $1200;
      kbAltR = $1300;
      kbAltF = $2100;
      kbAltS = $1F00;
      kbAltG = $2200;
      kbAltT = $1400;
      kbAltH = $2300;
      kbAltU = $1600;
      kbAltI = $1700;
      kbAltV = $2F00;
      kbAltJ = $2400;
      kbAltW = $1100;
      kbAltK = $2500;
      kbAltX = $2D00;
      kbAltL = $2600;
      kbAltY = $1500;
      kbAltM = $3200;
      kbAltZ = $2C00;
      kbAltEqual = $8300;
      kbEnd = $4F00;
      kbAltMinus = $8200;
      kbEnter = $1C0D;
      kbAltSpace = $0200;
      kbEsc = $011B;
      kbBack = $0E08;
      kbGrayMinus= $4A2D;
      kbCtrlBack = $0E7F;
      kbHome = $4700;
      kbCtrlDel = $0600;
      kbIns = $5200;
      kbCtrlEnd = $7500;
      kbLeft = $4B00;
      kbCtrlEnter= $1C0A;
      kbNoKey = $0000;
      kbCtrlHome = $7700;
      kbPgDn = $5100;
      kbCtrlIns = $0400;
      kbPgUp = $4900;
      kbCtrlLeft = $7300;
      kbGrayPlus = $4E2B;
      kbCtrlPgDn = $7600;
      kbRight = $4D00;
      kbCtrlPgUp = $8400;
      kbShiftDel = $0700;
      kbCtrlPrtSc= $7200;
      kbShiftIns = $0500;
      kbCtrlRight= $7400;
      kbShiftTab = $0F00;
      kbDel = $5300;
      kbTab = $0F09;
      kbDown = $5000;
      kbUp = $4800;
      kbAlt1 = $7800;
      kbAlt6 = $7D00;
      kbAlt2 = $7900;
      kbAlt7 = $7E00;
      kbAlt3 = $7A00;
      kbAlt8 = $7F00;
      kbAlt4 = $7B00;
      kbAlt9 = $8000;
      kbAlt5 = $7C00;
      kbAlt0 = $8100;
      kbF1 = $3B00;
      kbF6 = $4000;
      kbF2 = $3C00;
      kbF7 = $4100;
      kbF3 = $3D00;
      kbF8 = $4200;
      kbF4 = $3E00;
      kbF9 = $4300;
      kbF5 = $3F00;
      kbF10 = $4400;
      kbShiftF1 = $5400;
      kbShiftF6 = $5900;
      kbShiftF2 = $5500;
      kbShiftF7 = $5A00;
      kbShiftF3 = $5600;
      kbShiftF8 = $5B00;
      kbShiftF4 = $5700;
      kbShiftF9 = $5C00;
      kbShiftF5 = $5800;
      kbShiftF10= $5D00;
      kbCtrlF1 = $5E00;
      kbCtrlF6 = $6300;
      kbCtrlF2 = $5F00;
      kbCtrlF7 = $6400;
      kbCtrlF3 = $6000;
      kbCtrlF8 = $6500;
      kbCtrlF4 = $6100;
      kbCtrlF9 = $6600;
      kbCtrlF5 = $6200;
      kbCtrlF10 = $6700;
      kbAltF1 = $6800;
      kbAltF6 = $6D00;
      kbAltF2 = $6900;
      kbAltF7 = $6E00;
      kbAltF3 = $6A00;
      kbAltF8 = $6F00;
      kbAltF4 = $6B00;
      kbAltF9 = $7000;
      kbAltF5 = $6C00;
      kbAltF10 = $7100;
      cmValid = 0;
      cmQuit = 1;
      cmError = 2;
      cmMenu = 3;
      cmClose = 4;
      cmZoom = 5;
      cmResize = 6;
      cmNext = 7;
      cmPrev = 8;
      cmOK = 10;
      cmCancel = 11;
      cmYes = 12;
      cmNo = 13;
      cmDefault = 14;
      wnnonumber = 0;
      buttoncount :byte=0;
      mouseevents:boolean=false;
      doubledelay:word=8;
      repeatdelay:word=8;
      mousebuttons:byte=0;
      mousewhere:Tpoint=(x:0;y:0);
      mouseintflag:boolean=false;
      syscolorattr:word=$4F4E;
var screenwidth,screenheight,maxcolor:word;
    cursorlines:word; {Nur zur Kompatibilitt mit TVision implementiert}
    graphdriver,graphmode:integer;
type PEvent = ^TEvent;
     TEvent = record
        What: Word;
        case Word of
          evNothing: ();
          evMouse: (
            Buttons: Byte;
            Double: Boolean;
            Where: TPoint);
          evKeyDown: (
            case Integer of
              0: (KeyCode: Word);
              1: (CharCode: Char; ScanCode: Byte));
          evMessage: (
            Command: Word;
            case Word of
              0: (InfoPtr: Pointer);
              1: (InfoLong: Longint);
              2: (InfoWord: Word);
              3: (InfoInt: Integer);
              4: (InfoByte: Byte);
              5: (InfoChar: Char));
      end;
type TColorPalette= array[0..15,0..2] of byte;

procedure initevents;
procedure doneevents;
procedure showmouse;
procedure hidemouse;
procedure getmouseevent(var event:tevent);
procedure getkeyevent(var event:tevent);
procedure initvideo;
procedure donevideo;
procedure clearscreen;
procedure SetNewPalette(var Palette:TColorPalette;ovcol:byte);
procedure initdrivers;
procedure donedrivers;
procedure initmouse;
procedure donemouse;
function getSelectChar(s:Pstring):char;
function PositionIn(where:TPoint;r:TRect):boolean;
Function InsertMode:Boolean;

implementation

type Tmausereignis=array[0..15] of record
       zeit,tasten:word;
       where:tpoint;
     end;
var oldexit:pointer;
    mausereignis:Tmausereignis;
const maske=$FF;
      hidelevel:byte=1;
      drdone:boolean=true;
      eventeintrage:byte=0;
      eventposition:word=ofs(mausereignis);
      ereignisschlangeanfang:word=ofs(mausereignis);
      ereignisschlangeende:word=ofs(mausereignis)+16*8;
      lasttasten:byte=0;
      lastzeit:word=$FFFF;
      lastwhere:TPoint=(x:320;y:200);
      lastdownzeit:word=$FFFF;
      ereignisabzufragen:byte=0;
      lastdouble:boolean=false;

procedure interrupts_aus;
begin
  asm
    cli
  end
end;

procedure interrupts_ein;
begin
  asm
    sti
  end
end;

procedure getmouseevent(var event:tevent);
begin
  interrupts_aus;
  if eventeintrage>0 then with mausereignis[ereignisabzufragen] do begin
    lastzeit:=zeit;
    if tasten<lasttasten then begin
      event.what:=evmouseup;
      event.double:=lastdouble;
    end else begin
      event.double:=zeit<=lastdownzeit+doubledelay;
      event.what:=evmousedown;
      lastdownzeit:=zeit;
    end;
    lastdouble:=event.double;
    lasttasten:=tasten;
    event.buttons:=tasten;
    event.where:=where;
    if ereignisabzufragen<15 then inc(ereignisabzufragen) else ereignisabzufragen:=0;
    dec(eventeintrage);
  end else begin
    if (lasttasten>0) and (lastzeit+repeatdelay<memw[$40:$6c]) then begin
      event.what:=evmouseauto;
      lastzeit:=memw[$40:$6c]-repeatdelay;
    end else begin
      if (lastwhere.x<>mousewhere.x) or (lastwhere.y<>mousewhere.y)
      then event.what:=evmousemove
      else event.what:=evnothing;
    end;
    with event do begin
      buttons:=mousebuttons;
      where:=mousewhere;
      double:=lastdouble;
    end;
  end;
  lastwhere:=mousewhere;
  interrupts_ein;
end;

procedure mouseinterrupt;far;
assembler;
asm
  Mov   si,seg(buttoncount)
  Mov   ds,si
  MOV	SI,CX
  MOV	mousebuttons,BL
  MOV	mousewhere.x,SI
  MOV	mousewhere.y,DX
  TEST	AX,$7E
  JZ	@raus
  CMP	eventeintrage,$10
  JZ	@raus
  MOV	AX,$0040
  MOV	ES,AX
  MOV	AX,ES:[$006C]
  PUSH  DS
  POP   ES
  MOV	DI,eventposition
  CLD
  STOSW
  XCHG	AX,BX
  STOSW
  XCHG	AX,SI
  STOSW
  XCHG	AX,DX
  STOSW
  CMP	DI,ereignisschlangeende
  JNZ	@posspeichern
  MOV	DI,ereignisschlangeanfang
@posspeichern:
  MOV	eventposition,DI
  INC   eventeintrage
@raus:
  MOV	mouseintflag,01
  RETF
end;

procedure initevents;
begin
  eventeintrage:=0;
  eventposition:=ereignisschlangeanfang;
  lasttasten:=0;
  lastzeit:=$FFFF;
  lastdownzeit:=$FFFF;
  ereignisabzufragen:=0;
end;

procedure doneevents;
begin
  eventeintrage:=0;
end;

procedure showmouse;
begin
  if hidelevel>0 then dec(hidelevel);
  if hidelevel=0 then maussicht;
end;

procedure hidemouse;
begin
  if hidelevel=0 then mausunsicht;
  inc(hidelevel);
end;

procedure getkeyevent(var event:tevent);
var code:word;
    keypressed:boolean;
begin
  asm
    mov ah,1
    int $16
    jz @keinzeichen
    mov ah,0
    int $16
    mov code,ax
    mov keypressed,1
    jmp @exit
@keinzeichen:
    mov keypressed,0
    @exit:
  end;
  if keypressed then with event do begin
    what:=evkeydown;
    keycode:=code;
  end else event.what:=evnothing;
end;

procedure donevideo;
begin
  closegraph;
  screenwidth:=0;
  screenwidth:=0;
  maxcolor:=0;
  graphdriver:=-1;
  graphmode:=-1;
end;

procedure initvideo;
var grapherror:integer;
begin
  graphdriver:=detect;
  initgraph(graphdriver,graphmode,'');
  grapherror:=graphresult;
  if grapherror<>0 then begin
    writeln(grapherrormsg(graphresult));
    halt(11);
  end;
  screenwidth:=succ(getmaxx);
  screenheight:=succ(getmaxy);
  maxcolor:=getmaxcolor;
end;

procedure clearscreen;
begin
  setviewport(0,0,pred(screenwidth),pred(screenwidth),false);
  cleardevice;
end;

procedure initmouse;
var tasten:word;
    event:TEvent;
begin
  mausinit(tasten);
  if tasten<>0 then begin
    maussetpos(screenwidth div 2,screenwidth div 2);
    maustastpos(tasten,word(mousewhere.x),word(mousewhere.y));
    mausminmaxx(0,screenwidth-2);
    mausminmaxy(0,screenheight-2);
    buttoncount:=tasten;
    mouseevents:=true;
    mausinterrupt(maske,@mouseinterrupt);
    getmouseevent(event);
  end;
end;

procedure donemouse;
begin
  if mouseevents then begin
    mausunsicht;
    mausinterrupt(0,@mouseinterrupt);
  end;
end;

function GraphicSystemError(ErrorCode:Integer;Drive:Byte):integer;far;
var buf:pointer;
    laufwerk:string[4];
    event:Tevent;
    maxx,maxy:word;
    ViewPort: ViewPortType;
begin
  hidemouse;
  getviewsettings(viewport);
  maxx:=pred(screenwidth);
  maxy:=pred(screenheight);
  setviewport(0,0,maxx,maxy,false);
  getmem(buf,imagesize(0,maxy-10,maxx,maxy));
  getimage(0,maxy-10,maxx,maxy,buf^);
  setfillstyle(solidfill,hi(syscolorattr) shr 4);
  bar(0,maxy-10,maxx,maxy);
  setcolor(hi(syscolorattr) and $F);
  laufwerk:=' '+char(65+drive)+': ';
  case errorcode of
    0:outtextxy(8,maxy-9,'Diskette im Laufwerk'+laufwerk+'ist schreibgeschtzt');
    1,3,5:outtextxy(8,maxy-9,'Kritischer Fehler im Laufwerk'+laufwerk+'aufgetreten');
    2:outtextxy(8,maxy-9,'Laufwerk'+laufwerk+'nicht bereit');
    4:outtextxy(8,maxy-9,'Datenfehler in Laufwerk'+laufwerk);
    6:outtextxy(8,maxy-9,'Zugriffsfehler in Laufwerk'+laufwerk);
    7:outtextxy(8,maxy-9,'Unbekannter Medientyp in Laufwerk'+laufwerk);
    8:outtextxy(8,maxy-9,'Sektor nicht gefunden in Laufwerk'+laufwerk);
    9:outtextxy(8,maxy-9,'Kein Papier im Drucker');
   10:outtextxy(8,maxy-9,'Schreibfehler in Laufwerk'+laufwerk);
   11:outtextxy(8,maxy-9,'Lesefehler in Laufwerk'+laufwerk);
   12:outtextxy(8,maxy-9,'Hardwarefehler in Laufwerk'+laufwerk);
   13:outtextxy(8,maxy-9,'Fehlerhafte FAT ermittelt');
   14:outtextxy(8,maxy-9,'Zugriffsfehler');
   15:outtextxy(8,maxy-9,'Legen Sie Diskette in Laufwerk'+laufwerk+'ein');
  end;
  outtextxy(maxx-8*32,maxy-9,'      Wiederholen     Abbrechen');
  setcolor(lo(syscolorattr) and $F);
  outtextxy(maxx-8*32,maxy-9,'ENTER             ESC');
  repeat
    getkeyevent(event);
  until (event.what=evkeydown) and ((event.charcode=#13) or (event.charcode=#27));
  putimage(0,maxy-10,buf^,normalput);
  freemem(buf,imagesize(0,maxy-10,maxx,maxy));
  graphicsystemerror:=byte(event.charcode=#27);
  with viewport do setviewport(x1,y1,x2,y2,clip);
  showmouse;
end;

procedure initdrivers;
begin
  initvideo;
  initevents;
  initmouse;
  syserrorfunc:=GraphicSystemError;
  initsyserror;
  drdone:=false;
end;

procedure donedrivers;
begin
  drdone:=true;
  donesyserror;
  donemouse;
  doneevents;
  donevideo;
end;

procedure myexit;far;
begin
  exitproc:=oldexit;
  if not drdone then donedrivers;
end;

procedure SetNewPalette(var Palette:TColorPalette;ovcol:byte);
var c:byte;
Type TTransLate=array[0..15] of byte;
const TransLate:TTransLate= (0,1,2,3,4,5,20,7,56,57,58,59,60,61,62,63);
begin
  for c:=0 to 15 do farbe(Translate[c],palette[c,0],palette[c,1],palette[c,2]);
  overscan(ovcol);
end;

function getSelectChar(s:Pstring):char;
begin
  if s<>nil then getselectchar:=s^[succ(pos('~',s^))] else getselectchar:=#0;
end;

function PositionIn(where:TPoint;r:TRect):boolean;
begin
  PositionIn:=(where.x>=r.a.x) and (where.x<=r.b.x) and
           (where.y>=r.a.y) and (where.y<=r.b.y);
end;

Function InsertMode:Boolean;
begin
  InsertMode:=mem[$40:$17] and $80>0;
end;

{$L EGAVGA}
procedure EGAVGAdriver;external;

begin
  if (registerbgidriver(@EGAVGAdriver)<0) then begin
    writeln('Fehler beim Anmelden der Grfaiktreiber! (TGDRIVER)');
    halt(10);
  end;
  oldexit:=exitproc;
  exitproc:=@myexit;
end.
