unit UObjekte;
interface
uses Objects,Drivers,TGDriver,TGViews,TGDialog,TGApp,dos,maus,Matrizen,
     U3DViews,WizView,UUtils,UObtFast;
type PKugel=^TKugel;
     TKugel=object(T3dview)
       constructor Init(var pos: T3DRect;aszene:PSzeneAbstract;ax,ay:byte);
       function CalcObjekt:Boolean; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
     end;

     PTorus=^TTorus;
     TTorus=object(T3dview)
       r1,r2:single;
       constructor Init(var pos: T3DRect;aszene:PSzeneAbstract;ar1,ar2:single;ax,ay:byte);
       function CalcObjekt:Boolean; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
       function ObjektDialog(pfad:pathstr;hohe:byte):PObjektParameterDialog; virtual;
       function ExecObjektDialog(Hpara:PParamData):boolean; virtual;
     end;

     PEbene=^TEbene;
     TEbene=object(T3dview)
       constructor Init(var pos: T3DRect;aszene:PSzeneAbstract;ax,ay:byte);
       function CalcObjekt:Boolean; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
     end;

     PSaule=^TSaule;
     TSaule=object(T3dview)
       constructor Init(var pos: T3DRect;aszene:PSzeneAbstract;ax,ay:byte);
       function CalcObjekt:Boolean; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
     end;

     PDose=^TDose;
     TDose=object(T3dview)
       n3:byte;
       constructor Init(var pos: T3DRect;aszene:PSzeneAbstract;ax,ay,an3:byte);
       function CalcObjekt:Boolean; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
       function ObjektDialog(pfad:pathstr;hohe:byte):PObjektParameterDialog; virtual;
       function ExecObjektDialog(Hpara:PParamData):boolean; virtual;
     end;

     PDreieck=^TDreieck;
     TDreieck=object(T3dview)
       nr:word;
       constructor Init(var pos: T3DRect;aszene:PSzeneAbstract;p1,p2,p3:T3DPoint);
       constructor Kopie(Original:PDreieck;NeueSzene:PSzeneAbstract);
       function CalcObjekt:Boolean; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
       procedure Meshpressed(anr:integer); virtual;
       function KopierDich(NeueSzene:PSzeneAbstract):P3DView; virtual;
       function MeshNeuErlaubt:boolean; virtual;
     end;

     PViereck=^TViereck;
     TViereck=object(TDreieck)
       constructor Init(var pos: T3DRect;aszene:PSzeneAbstract;p1,p2,p3,p4:T3DPoint);
       constructor Kopie(Original:PViereck;NeueSzene:PSzeneAbstract);
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
       function KopierDich(NeueSzene:PSzeneAbstract):P3DView; virtual;
     end;

     PRotationskoerper=^TRotationskoerper;
     TRotationskoerper=object(T3dview)
       Pfad:pathstr;
       Winkel:word;
       nr:word;
       constructor Init(var pos: T3DRect;aszene:PSzeneAbstract;aPfad:Pathstr;ay:byte;awinkel:word);
       function CalcObjekt:Boolean; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
       function ObjektDialog(apfad:pathstr;hohe:byte):PObjektParameterDialog; virtual;
       function ExecObjektDialog(Hpara:PParamData):boolean; virtual;
     end;

     PZiehKoerper=^TZiehKoerper;
     TZiehKoerper=object(T3dview)
       pfad:pathstr;
       nr:word;
       constructor Init(var pos: T3DRect;aszene:PSzeneAbstract;apfad:Pathstr;ay:byte);
       {constructor Kopie(Original:PZiehkoerper;NeueSzene:PSzeneAbstract);}
       function CalcObjekt:Boolean; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
       {function KopierDich(NeueSzene:PSzeneAbstract):P3DView; virtual;}
     end;

     PObjekt=^TObjekt;
     TObjekt=object(T3dview)
       pfad:pathstr;
       Laden:word;
       nr:word;
       constructor Init(var pos: T3DRect;aszene:PSzeneAbstract;apfad:Pathstr;ALaden:word);
       function CalcObjekt:Boolean; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
     end;

     PMeshObj=^TMeshObj;
     TMeshObj=object(T3dview)
       pfad:pathstr;
       nr:word;
       constructor Init(var pos: T3DRect;aszene:PSzeneAbstract;apfad:pathstr);
       function CalcObjekt:Boolean; virtual;
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
       function valid(Command:word):boolean; virtual;
       procedure LadeMesh(apfad:pathstr);
       function KopierDich(NeueSzene:PSzeneAbstract):P3DView; virtual;
       procedure Meshpressed(anr:integer); virtual;
       procedure SetParam(AData:TData); virtual;
       function MeshNeuErlaubt:boolean; virtual;
     end;

const Sonne=0;
      Lampe=1;
      Spot=2;

type TLichtDaten=Record
       LichtArt:word;
       Farbe:TRGB;
       c1,c2,exponent,winkel:single;
     end;

     PLicht=^TLicht;
     TLicht=object(T3DView)
       LichtDaten:TLichtDaten;
       nr:word;
       constructor Init(var pos: T3DRect;aszene:PSzeneAbstract;Art:word;
         AFarbe:TRGB;
         Ac1,Ac2,Aexponent,Awinkel:single);
       function RegNr:Word; virtual;
       procedure sichern(var f:text); virtual;
       function sichereLicht(var f:text):boolean; virtual;
       function ObjektDialog(pfad:pathstr;hohe:byte):PObjektParameterDialog; virtual;
       function ExecObjektDialog(HPara:PParamData):boolean; virtual;
       function CalcObjekt:Boolean; virtual;
     end;

implementation

const e_z: T3DPoint=(x:0.0;y:0.0;z:1.0);
      me_z:T3DPoint=(x:0.0;y:0.0;z:-1.0);
      maxrotationskoerper:word=0;
      maxLicht:word=0;
      maxObjekt:word=0;
      maxziehkoerper:word=0;
      maxdreieck:word=0;
      maxviereck:word=0;
      maxMesh:word=0;

constructor TKugel.Init(var pos: T3DRect;aszene:PSzeneAbstract;ax,ay:byte);
begin
  T3DView.Init(pos,aszene,ax,ay,'Kugel');
  Helpctx:=cmKugel;
end;

{constructor TKugel.Kopie(Original:PKugel;NeueSzene:PSzeneAbstract);
var pos:T3DRect;
begin
  with original^ do begin
    makepos(paramdata,pos);
    TKugel.Init(pos,NeueSzene,paramdata.x,paramdata.y);
  end;
end;

function TKugel.KopierDich(NeueSzene:PSzeneAbstract):P3DView;
begin
  KopierDich:=New(PKugel,Kopie(@self,NeueSzene));
end;}

function TKugel.RegNr:Word;
begin
  RegNr:=obKugel;
end;

function TKugel.CalcObjekt:Boolean;
var st,ct,sa,ca,
    cth,cah,dct,dst,dca,dsa:real;
    ps,p,pn:T3dPoint;
    a,t:integer;
begin
  CalcObjekt:=True;
  mesh^.Erzeuger:=obKugel;
  dct:=cos(2*PI/mesh^.x); dst:=sqrt(1-dct*dct);
  dca:=cos(2*PI/(2*mesh^.y)); dsa:=sqrt(1-dca*dca);
  ca:=dct; sa:=dst; ct:=sa; st:=0.0;
  for a:=1 to pred(mesh^.y) do begin
    for t:=0 to mesh^.x do with p do begin
      x:=ct; y:=st; z:=ca;
      mesh^.putin(t,a,p);
      cth:=ct;
      ct:=ct*dct-st*dst;
      st:=st*dct+cth*dst;
    end;
    cah:=ca;
    ca:=ca*dca-sa*dsa;
    sa:=sa*dca+cah*dsa;
    ct:=sa; st:=0.0;
  end;
  pn:=e_z;
  ps:=me_z;
  for t:=0 to mesh^.x do begin
    mesh^.putin(t,0,pn);
    mesh^.putin(t,mesh^.y,ps);
  end;
end;

procedure TKugel.sichern(var f:text);
begin
  T3DView.Sichern(f);
  with paramdata do writeln(f,'  Kugel ',x:2,' ',y:2,' ;',name);
  writeln(f,'Pop');
end;

constructor TTorus.Init(var pos: T3DRect;aszene:PSzeneAbstract;ar1,ar2:single;ax,ay:byte);
begin
  T3DView.Init(pos,aszene,ax,ay,'Torus');
  r1:=ar1;
  r2:=ar2;
  Helpctx:=cmTorus;
end;

{constructor TTorus.Kopie(Original:PTorus;NeueSzene:PSzeneAbstract);
var pos:T3DRect;
begin
  with original^ do begin
    makePos(paramdata,pos);
    TTorus.Init(pos,NeueSzene,r1,r2,paramdata.x,paramdata.y);
  end;
end;

function TTorus.KopierDich(NeueSzene:PSzeneAbstract):P3DView;
begin
  KopierDich:=New(PTorus,Kopie(@self,NeueSzene));
end;}

function TTorus.RegNr:Word;
begin
  RegNr:=obTorus;
end;

function TTorus.CalcObjekt:Boolean;
var cth,cah,dct,dst,st,ct,ct1,st1,dca,dsa,ca,sa: real;
    p: T3DPoint;
    a,t: integer;
begin
  CalcObjekt:=True;
  mesh^.Erzeuger:=obTorus;
  dct:=cos(2.0*pi/mesh^.x);  dst:=sqrt(1.0-(dct*dct));
  dca:=cos(2.0*pi/mesh^.y);  dsa:=sqrt(1.0-(dca*dca));
  ca:=r2; sa:=0.0;
  for a:=0 to mesh^.y do begin
    ct:=r1+sa; st:=0.0;
    for t:=0 to mesh^.x do with p do begin
      x:=ct; y:=st; z:=ca;
      mesh^.putin(t,a,p);
      cth:=ct;
      ct:=ct * dct - st * dst;
      st:=st * dct + cth * dst;
    end;
    cah:=ca;
    ca:=ca*dca-sa*dsa;
    sa:=sa*dca+cah*dsa;
  end;
end;

procedure TTorus.sichern(var f:text);
begin
  T3DView.Sichern(f);
  with paramdata do writeln(f,'  Torus ',r1:3:2,' ',r2:3:2,' ',x:2,' ',y:2,' ;',name);
  writeln(f,'Pop');
end;

{procedure TTorus.SetParam(Adata:TData);
begin
  T3dView.Setparam(adata);
  r1:=adata.r1;
  r2:=adata.r2;
end;
}

function TTorus.ObjektDialog(pfad:pathstr;hohe:byte):PObjektParameterDialog;
var h:PObjektParameterDialog;

  procedure radien(x,ho:word);
  var r:trect;
  begin
    r.assign(x,ho,x+80,ho+14);
    h^.insert(new(PLabel,init(r,'~R~adien',zahl(h,'~G~esamt  ',x,ho+15,1,2,0,1,TypSingle))));
    zahl(h,'~S~chlauch',x+150,ho+15,1,2,0,1,TypSingle);
  end;

begin
  h:=T3DView.ObjektDialog('Torus Parameter',hohe+3);
  radien(20,300);
  ObjektDialog:=h;
end;

function TTorus.ExecObjektDialog(Hpara:PParamdata):boolean;
var h:boolean;
type TParaTorus=record
       Data:TParamData;
       r1,r2:single;
     end;
var HParaTorus:TParaTorus;
begin
  HParaTorus.r1:=r1;
  HParaTorus.r2:=r2;
  h:=T3dView.ExecObjektDialog(PParamData(@HParaTorus));
  if (hparatorus.r1<>r1) or (hparatorus.r2<>r2) then begin
    r2:=HParaTorus.r2;
    r1:=HParaTorus.r1;
    meshneu;
    ExecObjektDialog:=true;
  end else ExecObjektDialog:=h;
end;


constructor TEbene.Init(var pos: T3DRect;aszene:PSzeneAbstract;ax,ay:byte);
begin
  T3DView.Init(pos,aszene,ax,ay,'Ebene');
  Helpctx:=cmEbene;
end;

{constructor TEbene.Kopie(Original:PEbene;NeueSzene:PSzeneAbstract);
var pos:T3DRect;
begin
  with original^ do begin
    makePos(paramdata,pos);
    TEbene.Init(pos,NeueSzene,paramdata.x,paramdata.y);
  end;
end;

function TEbene.KopierDich(NeueSzene:PSzeneAbstract):P3DView;
begin
  KopierDich:=New(PEbene,Kopie(@self,NeueSzene));
end;}


function TEbene.RegNr:Word;
begin
  RegNr:=obEbene;
end;

function TEbene.CalcObjekt:Boolean;
begin
  CalcObjekt:=True;
  mesh^.Erzeuger:=obEbene; {Braucht nichts zu berechnen, da Mesh
                            automatisch mit Ebene gefllt wird}
end;

procedure TEbene.sichern(var f:text);
begin
  T3DView.Sichern(f);
  with paramdata do writeln(f,'  Ebene ',x:2,' ',y:2,' ;',name);
  writeln(f,'Pop');
end;

constructor TSaule.Init(var pos: T3DRect;aszene:PSzeneAbstract;ax,ay:byte);
begin
  T3DView.Init(pos,aszene,ax,ay,'Sule');
  Helpctx:=cmSaule;
end;

{constructor TSaule.Kopie(Original:PSaule;NeueSzene:PSzeneAbstract);
var pos:T3DRect;
begin
  with original^ do begin
    makePos(paramdata,pos);
    TSaule.Init(pos,NeueSzene,paramdata.x,paramdata.y);
  end;
end;

function TSaule.KopierDich(NeueSzene:PSzeneAbstract):P3DView;
begin
  KopierDich:=New(PSaule,Kopie(@self,NeueSzene));
end;}


function Tsaule.RegNr:Word;
begin
  RegNr:=obsaule;
end;

function Tsaule.CalcObjekt:Boolean;
var p:T3DPoint;
    a,t:byte;      {n1:sttzpunkte im kreis;n2:sp von S zu N}
    dc,ds,st,ct,sn,cn,ch:real;
    crdx,crdy,nrmx,nrmy:real;
begin
  CalcObjekt:=True;
  mesh^.Erzeuger:=obsaule;
  dc:=cos(2*PI/mesh^.x); ds:=sqrt(1-dc*dc);
  ct:={ds}1;st:=0;
  for a:=0 to mesh^.x do begin
    p.x:=ct; p.y:=st;
    for t:=0 to mesh^.y do with p do begin
      z:=(2*t/mesh^.y)-1;
      mesh^.putin(a,t,p);
    end;
    ch:=ct;
    ct:=ct*dc-st*ds;
    st:=st*dc+ch*ds;
  end;
end;

procedure Tsaule.sichern(var f:text);
begin
  T3DView.Sichern(f);
  with paramdata do writeln(f,'  sule ',x:2,' ',y:2,' ;',name);
  writeln(f,'Pop');
end;

constructor TDose.Init(var pos: T3DRect;aszene:PSzeneAbstract;ax,ay,an3:byte);
begin
  if an3*2>=ax then ax:=an3*2+1;
  T3DView.Init(pos,aszene,ax,ay,'Dose');
  n3:=an3;
  HelpCtx:=cmDose;
end;

{constructor TDose.Kopie(Original:PDose;NeueSzene:PSzeneAbstract);
var pos:T3DRect;
begin
  with original^ do begin
    makePos(paramdata,pos);
    TDose.Init(pos,NeueSzene,paramdata.x,paramdata.y,n3);
  end;
end;

function TDose.KopierDich(NeueSzene:PSzeneAbstract):P3DView;
begin
  KopierDich:=New(PDose,Kopie(@self,NeueSzene));
end;}

function TDose.RegNr:Word;
begin
  RegNr:=obDose;
end;

function TDose.CalcObjekt:Boolean;
var p:T3DPoint;
    a,t:byte; {n1:sttzpunkte im kreis;n2:sp von S zu N;n3:sp im deckel}
    dc,ds,st,ct,ch:real;
    crdx,crdy,nrmx,nrmy:real;
begin
  CalcObjekt:=True;
  mesh^.Erzeuger:=obDose;
  dc:=cos(2*PI/mesh^.x); ds:=sqrt(1-dc*dc);
  for a:=0 to mesh^.x do begin
    if a<=n3 then begin
      crdy:=1; crdx:=a/n3;
    end else if a<(mesh^.x-n3) then begin
      crdy:=1-(a-n3)*2/(succ(mesh^.x)-2*succ(n3)); crdx:=1;
    end else begin
      crdy:=-1; crdx:=(mesh^.x-a)/n3;
    end;
    p.z:=crdy;
    st:=0;
    ct:=crdx;
    for t:=0 to mesh^.y do with p do begin
      x:=ct; y:=st;
      mesh^.putin(a,t,p);
      ch:=ct;
      ct:=ct*dc-st*ds;
      st:=st*dc+ch*ds;
    end;
  end;
end;

procedure TDose.sichern(var f:text);
begin
  T3DView.Sichern(f);
  with paramdata do writeln(f,'  Zylinder ',x:2,' ',y:2,' ',n3:2,' ;',name);
  writeln(f,'Pop');
end;

function TDose.ObjektDialog(pfad:pathstr;hohe:byte):PObjektParameterDialog;
var h:PObjektParameterDialog;
begin
  h:=T3DView.ObjektDialog('Dose Parameter',hohe+3);
  zahl(h,'~D~eckel',20,300,3,0,1,100,TypByte);
  ObjektDialog:=h;
end;

function TDose.ExecObjektDialog(Hpara:PParamdata):boolean;
var h:boolean;
type TParaDose=record
       Data:TParamData;
       n3:byte;
     end;
var HParaDose:TParaDose;
begin
  HParaDose.n3:=n3;
  h:=T3dView.ExecObjektDialog(PParamData(@HParaDose));
  if (hparaDose.n3<>n3) then begin
    n3:=HParaDose.n3;
    meshneu;
    ExecObjektDialog:=true;
  end else ExecObjektDialog:=h;
end;

constructor TDreiEck.Init(var pos: T3DRect;aszene:PSzeneAbstract;p1,p2,p3:T3DPoint);
begin
  T3DView.Init(pos,aszene,1,1,'Dreieck');
  HelpCtx:=cmDreieck;
  paramdata.darstellung:=dsObjekt or dsMeshEcken or dsKoorecken;
  nr:=obDreieck+(maxdreieck shl 6);
  inc(maxdreieck);
  mesh:=objektcollection^.neu(paramdata.x,paramdata.y,Nr);
  if mesh<>nil then begin
    mesh^.putin(0,0,p1);
    mesh^.putin(0,1,p2);
    mesh^.putin(1,1,p3);
    mesh^.putin(1,0,p3);
  end else Application^.OutOfMemory;
end;

constructor TDreiEck.Kopie(Original:PDreieck;NeueSzene:PSzeneAbstract);
begin
  with original^ do begin
    TDreieck.Init(paramdata.pos,NeueSzene,mesh^.PointAt(0,0)^,mesh^.PointAt(0,1)^,mesh^.PointAt(1,1)^);
    Paramdata:=ORiginal^.paramdata;
  end;
end;

function TDreieck.KopierDich(NeueSzene:PSzeneAbstract):P3DView;
begin
  KopierDich:=New(PDreiEck,Kopie(@self,NeueSzene));
end;

function TDreieck.RegNr:Word;
begin
  RegNr:=Nr;
end;

function TDreieck.CalcObjekt:Boolean;
begin
  CalcObjekt:=True;
end;

procedure TDreieck.sichern(var f:text);
var p1:P3DPoint;
begin
  T3DView.Sichern(f);
  p1:=mesh^.pointat(0,0);
  with paramdata do write(f,'  Dreieck ',p1^.x:5:3,' ',p1^.y:5:3,' ',p1^.z:5:3);
  p1:=mesh^.pointat(0,1);
  write(f,' ',p1^.x:5:3,' ',p1^.y:5:3,' ',p1^.z:5:3);
  p1:=mesh^.pointat(1,1);
  writeln(f,' ',p1^.x:5:3,' ',p1^.y:5:3,' ',p1^.z:5:3,' ;',name);
  writeln(f,'Pop');
end;

procedure TDreieck.Meshpressed(anr:integer);
var event:TEvent;
    o:TPoint;
begin
  Focus;
  Szene^.setobjekt(@self);
  Hidemouse;
  o:=MouseWhere;
  repeat
    repeat
      getmouseevent(event);
    until event.what<>evnothing;
    if event.what and evmousemove>0
    then with mesh^.pointat((anr) div succ(mesh^.y),(anr) mod succ(mesh^.y))^ do begin
      redraw(@OC_MC,nil,false);
      y:=y+(o.y-event.where.y)/100;
      if mouseButtons and 2>0 then begin
        z:=z+(o.x-event.where.x)/100;
      end else begin
        x:=x-(o.x-event.where.x)/100;
      end;
      if (Typeof(self)=TypeOf(TDreiEck)) and (anr=3) then begin
        mesh^.Pointat(1,0)^.y:=y;
        mesh^.Pointat(1,0)^.x:=x;
        mesh^.Pointat(1,0)^.z:=z;
      end;
      maussetpos(o.x,o.y);
      Redraw(nil,@Oc_MC,false);
    end;
  until Mousebuttons=0;
  szene^.gesichert:=false;
  ShowMouse;
end;

function TDreiEck.MeshNeuErlaubt:boolean;
begin
  MeshNeuErlaubt:=false;
end;

constructor TViereck.Init(var pos: T3DRect;aszene:PSzeneAbstract;p1,p2,p3,p4:T3DPoint);
begin
  T3DView.Init(pos,aszene,1,1,'Viereck');
  HelpCtx:=cmViereck;
  paramdata.darstellung:=dsObjekt or dsMeshEcken or dsKoorEcken;
  nr:=obViereck+(maxViereck shl 6);
  inc(maxViereck);
  mesh:=objektcollection^.neu(paramdata.x,paramdata.y,Nr);
  if mesh<>nil then begin
    mesh^.putin(0,0,p1);
    mesh^.putin(1,0,p2);
    mesh^.putin(1,1,p3);
    mesh^.putin(0,1,p4);
  end else Application^.OutOfMemory;
end;

constructor TViereck.Kopie(Original:PViereck;NeueSzene:PSzeneAbstract);
begin
  with original^ do begin
    TViereck.Init(paramdata.pos,NeueSzene,mesh^.PointAt(0,0)^,
    mesh^.PointAt(1,0)^,mesh^.PointAt(1,1)^,mesh^.PointAt(0,1)^);
    Paramdata:=ORiginal^.paramdata;
  end;
end;

function TViereck.KopierDich(NeueSzene:PSzeneAbstract):P3DView;
begin
  KopierDich:=New(PVierEck,Kopie(@self,NeueSzene));
end;

function TViereck.RegNr:Word;
begin
  RegNr:=Nr;
end;

procedure TViereck.sichern(var f:text);
var p1:P3DPoint;
begin
  T3DView.Sichern(f);
  p1:=mesh^.pointat(0,0);
  with paramdata do write(f,'  Viereck ',p1^.x:5:3,' ',p1^.y:5:3,' ',p1^.z:5:3);
  p1:=mesh^.pointat(1,0);
  write(f,' ',p1^.x:5:3,' ',p1^.y:5:3,' ',p1^.z:5:3);
  p1:=mesh^.pointat(1,1);
  writeln(f,' ',p1^.x:5:3,' ',p1^.y:5:3,' ',p1^.z:5:3);
  p1:=mesh^.pointat(0,1);
  writeln(f,' ',p1^.x:5:3,' ',p1^.y:5:3,' ',p1^.z:5:3,' ;',name);
  writeln(f,'Pop');
end;


constructor TRotationskoerper.Init(var pos: T3DRect;aszene:PSzeneAbstract;apfad:Pathstr;ay:byte;awinkel:word);
var dir:dirstr;
    nam:namestr;
    ext:extstr;
begin
  fsplit(apfad,dir,nam,ext);
  T3DView.Init(pos,aszene,10,ay,'R-'+nam);
  HelpCtx:=cmRotationskoerper;
  if length(ext)<4 then pfad:=nam+'.RIS' else pfad:=apfad;
  nr:=obRotationskoerper+(maxrotationskoerper shl 6);
  inc(maxrotationskoerper);
  winkel:=awinkel;
end;

{constructor TRotationskoerper.Kopie(Original:PRotationsKoerper;NeueSzene:PSzeneAbstract);
var pos:T3DRect;
begin
  with original^ do begin
    makePos(paramdata,pos);
    TRotationsKoerper.Init(pos,NeueSzene,pfad,paramdata.y,winkel);
    Paramdata:=ORiginal^.paramdata;
    mesh:=original^.mesh;
    if mesh<>nil then mesh^.incnutzer;
  end;
end;

function TRotationsKoerper.KopierDich(NeueSzene:PSzeneAbstract):P3DView;
begin
  KopierDich:=New(PRotationsKoerper,Kopie(@self,NeueSzene));
end;}


function TRotationskoerper.RegNr:Word;
begin
  RegNr:=nr;
end;

function TRotationskoerper.CalcObjekt:Boolean;
type koord2d=record x,y:single; end;
     umrisstyp=record
                 punkt:array[0..maxpnts] of record
                         crd,nrm:koord2d;
                         color:array[0..2] of byte;
                       end;
                 xmax,ymin,ymax:single;
                 punktanzahl:shortint;
                 ka,kd,ks,osr,osg,osb,oe,odr,odg,odb,otrans:single;
                 color:array[0..2] of byte;
               end;
var umriss:^umrisstyp;
    yvol,betrag,dc,ds,st,ct,ch:single;
    p:T3DPoint;
    a,t:integer;
    umrissfile:file of umrisstyp;
    suche:searchrec;
begin
  CalcObjekt:=false;
  findfirst(pfad,$3f,suche);
  if doserror=0 then begin
    if maxavail>sizeof(umriss^) then new(umriss) else begin
      Application^.outofmemory;
      exit;
    end;
    assign(umrissfile,pfad);
    reset(umrissfile);
    read(umrissfile,umriss^);
    close(umrissfile);
    with umriss^ do begin
      mesh^.Erzeuger:=nr;
      if punktanzahl>0 then begin
        if mesh^.x<>punktanzahl then mesh^.changesize(punktanzahl,mesh^.y);
        paramdata.x:=punktanzahl;
        dc:=cos(2*PI*winkel/360/mesh^.y); ds:=sqrt(1-dc*dc);
        for a:=0 to mesh^.x do with punkt[a] do begin
          p.z:=crd.y;st:=0;ct:=crd.x;
          for t:=0 to mesh^.y do with p do begin
            x:=ct; y:=st;
            mesh^.putin(a,t,p);
            ch:=ct;
            ct:=ct*dc-st*ds;
            st:=st*dc+ch*ds;
          end;
        end;
        CalcObjekt:=true;
      end else szene^.error('Der Umriss fr den Rotationskrper'#13'besteht nur aus einem Punkt !');
    end;
    dispose(umriss);
  end else begin
    paramdata.darstellung:=paramdata.darstellung and not (dsobjekt or dsmeshecken);
    szene^.error('Ich konnte '+pfad+#13'nicht laden !');
  end;
end;

procedure TRotationskoerper.sichern(var f:text);
var nam:namestr;
    dir:dirstr;
    ext:extstr;
begin
  T3DView.Sichern(f);
  fsplit(pfad,dir,nam,ext);
  writeln(f,'  Laderotationskrper ',nam);
  writeln(f,'  Rotationskrper ',paramdata.y:2,' ',winkel:3,' ;',name);
  writeln(f,'Pop');
end;

function TRotationskoerper.ObjektDialog(apfad:pathstr;hohe:byte):PObjektParameterDialog;
var h:PObjektParameterDialog;
begin
  h:=T3DView.ObjektDialog('Rotationskrper Parameter',hohe+3);
  zahl(h,'~W~inkel',20,300,3,0,0,360,TypWord);
  ObjektDialog:=h;
end;

function TRotationskoerper.ExecObjektDialog(Hpara:PParamdata):boolean;
var h:boolean;
type TParaRotationskoerper=record
       Data:TParamData;
       winkel:word;
     end;
var HParaRotationskoerper:TParaRotationskoerper;
begin
  HParaRotationskoerper.winkel:=winkel;
  h:=T3dView.ExecObjektDialog(PParamData(@HParaRotationskoerper));
  if (hparaRotationskoerper.winkel<>winkel) then begin
    winkel:=HParaRotationskoerper.winkel;
    meshneu;
    ExecObjektDialog:=true;
  end else ExecObjektDialog:=h;
end;

constructor TZiehKoerper.Init(var pos: T3DRect;aszene:PSzeneAbstract;apfad:Pathstr;ay:byte);
var dir:dirstr;
    nam:namestr;
    ext:extstr;
begin
  fsplit(apfad,dir,nam,ext);
  T3DView.Init(pos,aszene,10,ay,'Z-'+nam);
  HelpCtx:=cmZiehkoerper;
  
  if length(ext)<4 then pfad:=nam+'.RIS' else pfad:=apfad;
  nr:=obZiehKoerper+(maxZiehKoerper shl 6);
  inc(maxZiehKoerper);
end;

{constructor TZiehKoerper.Kopie(Original:PZiehKoerper;NeueSzene:PSzeneAbstract);
var pos:T3DRect;
begin
  with original^ do begin
    makePos(paramdata,pos);
    TZiehKoerper.Init(pos,NeueSzene,pfad,paramdata.y);
    Paramdata:=ORiginal^.paramdata;
    mesh:=original^.mesh;
    if mesh<>nil then mesh^.incnutzer;
  end;
end;

function TZiehKoerper.KopierDich(NeueSzene:PSzeneAbstract):P3DView;
begin
  KopierDich:=New(PZiehKoerper,Kopie(@self,NeueSzene));
end;}

function TZiehKoerper.RegNr:Word;
begin
  RegNr:=nr;
end;

function TZiehKoerper.CalcObjekt:Boolean;
type koord2d=record x,y:single; end;
     umrisstyp=record
                 punkt:array[0..maxpnts] of record
                         crd,nrm:koord2d;
                         color:array[0..2] of byte;
                       end;
                 xmax,ymin,ymax:single;
                 punktanzahl:shortint;
                 ka,kd,ks,osr,osg,osb,oe,odr,odg,odb,otrans:single;
                 color:array[0..2] of byte;
               end;
var umriss:^umrisstyp;
    yvol,betrag,ch,dc,ds,st,ct,sn,cn:single;
    p:T3DPoint;
    a,t:integer;
    umrissfile:file of umrisstyp;
    suche:searchrec;
begin
  CalcObjekt:=false;
  findfirst(pfad,$3f,suche);
  if doserror=0 then begin
    if maxavail>sizeof(umriss^) then new(umriss) else begin
      Application^.outofmemory;
      exit;
    end;
    assign(umrissfile,pfad);
    reset(umrissfile);
    read(umrissfile,umriss^);
    close(umrissfile);
    with umriss^ do begin
      mesh^.Erzeuger:=nr;
      if punktanzahl>0 then begin
        if mesh^.x<>punktanzahl then mesh^.changesize(punktanzahl,mesh^.y);
        paramdata.x:=punktanzahl;
        for a:=0 to punktanzahl do with punkt[a].crd do begin
          p.x:=x;
          p.y:=y;
          for t:=0 to mesh^.Y do with p do begin
            z:=2*(t/mesh^.y)-1;
            mesh^.putin(a,t,p);
          end;
        end;
        CalcObjekt:=true;
      end else szene^.error('Der Umriss fr den Ziehkrper'#13'besteht nur aus einem Punkt !');
    end;
    dispose(umriss);
  end else begin
    paramdata.darstellung:=paramdata.darstellung and not (dsobjekt or dsmeshecken);
    szene^.error('Ich konnte '+pfad+#13'nicht laden !');
  end;
end;

procedure TZiehKoerper.sichern(var f:text);
var nam:namestr;
    dir:dirstr;
    ext:extstr;
begin
  T3DView.Sichern(f);
  fsplit(pfad,dir,nam,ext);
  writeln(f,'  Laderotationskrper ',nam);
  writeln(f,'  Ziehkrper ',paramdata.y:2,' ;',name);
  writeln(f,'Pop');
end;

constructor TObjekt.Init(var pos: T3DRect;aszene:PSzeneAbstract;apfad:Pathstr;aLaden:word);
var dir:dirstr;
    nam:namestr;
    ext:extstr;
begin
  fsplit(apfad,dir,nam,ext);
  T3DView.Init(pos,aszene,10,10,'O-'+nam);
  HelpCtx:=cmObjekt;
  
  if length(ext)<4 then pfad:=nam+'.OBT' else pfad:=nam+ext;
  nr:=obObjekt+(maxObjekt shl 6);
  laden:=(aladen and not Materialdat) or Sichtdat;
  inc(maxObjekt);
  if laden and texturdat>0 then paramdata.textur:='MyOwn';
end;

{constructor TObjekt.Kopie(Original:PObjekt;NeueSzene:PSzeneAbstract);
var pos:T3DRect;
begin
  with original^ do begin
    makePos(paramdata,pos);
    TObjekt.Init(pos,NeueSzene,pfad,Laden);
    Paramdata:=ORiginal^.paramdata;
    mesh:=original^.mesh;
    if mesh<>nil then mesh^.incnutzer;
  end;
end;

function TObjekt.KopierDich(NeueSzene:PSzeneAbstract):P3DView;
begin
  KopierDich:=New(PObjekt,Kopie(@self,NeueSzene));
end;}

function TObjekt.RegNr:Word;
begin
  RegNr:=nr;
end;

function TObjekt.CalcObjekt:Boolean;
var suche:searchrec;
    ok:boolean;
    return:Byte;
begin
  CalcObjekt:=false;
  findfirst(pfad,$3f,suche);
  if doserror=0 then begin
    if (maxavail<suche.size+5000) or (suche.size>65536) then begin
      paramdata.darstellung:=paramdata.darstellung and not (dsobjekt or dsmeshecken);
      Application^.outofmemory;
      exit;
    end;
    mesh^.Erzeuger:=nr;
    return:=LoadObjekt(pfad,laden,mesh,paramdata);
    ok:=(return and (xdat or ydat or zdat))=(xdat or ydat or zdat);
    CalcObjekt:=ok;
    laden:=(laden and not Materialdat) or SichtDat;
    if (return and Texturdat>0) then Paramdata.Textur:='MyOwn';
    if not ok then begin
      paramdata.darstellung:=paramdata.darstellung and not (dsobjekt or dsmeshecken);
      szene^.error(pfad+#13'enthlt keine Koordinaten !');
    end;
  end else begin
    paramdata.darstellung:=paramdata.darstellung and not (dsobjekt or dsmeshecken);
    szene^.error('Ich konnte '+pfad+#13'nicht laden !');
  end;
end;

procedure TObjekt.sichern(var f:text);
var nam:namestr;
    dir:dirstr;
    ext:extstr;
begin
  T3DView.Sichern(f);
  fsplit(pfad,dir,nam,ext);
  if Paramdata.Textur<>'MyOwn' then laden:=laden and not TexturDat;
  writeln(f,'  Ladeobjekt ',laden,' ',nam);
  writeln(f,'  Normieren Flche');
  writeln(f,'  Mesh ;Starr ',nam+ext);
  writeln(f,'Pop');
end;

constructor TMeshObj.Init(var pos: T3DRect;aszene:PSzeneAbstract;apfad:pathstr);
var dir:dirstr;
    nam:namestr;
    ext:extstr;
begin
  fsplit(apfad,dir,nam,ext);
  T3DView.Init(pos,aszene,10,10,'M-'+nam);
  HelpCtx:=cmMesh;
  nr:=obMesh+(maxMesh shl 6);
  inc(maxMesh);
  pfad:='';
  paramdata.darstellung:=paramdata.darstellung or dsmeshecken;
  mesh:=objektcollection^.neu(paramdata.x,paramdata.y,Nr);
end;

function TMeshObj.valid(Command:word):boolean;
begin
  if command=cmvalid then valid:=pfad<>'' else valid:=true;
end;

procedure TMeshObj.LadeMesh(apfad:pathstr);
var dir:dirstr;
    nam:namestr;
    ext:extstr;
    suche:searchrec;
begin
  fsplit(apfad,dir,nam,ext);
  pfad:=dir+nam+'.OBT';
  findfirst(pfad,$3f,suche);
  if doserror=0 then begin
    if (maxavail<suche.size+5000) or (suche.size>65536) then begin
      pfad:='';
      Application^.outofmemory;
      exit;
    end;
    if not (LoadObjekt(pfad,xdat+ydat+zdat,mesh,paramdata) and
            (xdat or ydat or zdat))=(xdat or ydat or zdat) then begin
      szene^.error(pfad+#13'enthlt keine Koordinaten !');
      pfad:='';
    end;
    mesh^.Erzeuger:=nr;
  end;{ansonsten steht Ebene im Mesh}
end;

function TMeshObj.RegNr:Word;
begin
  RegNr:=nr;
end;

function TMeshObj.CalcObjekt:Boolean;
begin
  CalcObjekt:=Mesh<>nil;
  paramdata.darstellung:=paramdata.darstellung or dsMeshEcken;
end;

procedure TMeshObj.sichern(var f:text);
var nam:namestr;
begin
  T3DView.Sichern(f);
  nam:=name;
  if (nam[1]='M') and (nam[2]='-') then delete(nam,1,2);
  writeln(f,'  LadeObjekt 135 ',nam);
  writeln(f,'  Normieren Flche');
  writeln(f,'  Mesh ;Frei ',nam+'.OBT');
  writeln(f,'Pop');
  SaveObjekt(nam,xdat+ydat+zdat,mesh);
end;

function TMeshObj.KopierDich(NeueSzene:PSzeneAbstract):P3DView;
var h:PMeshObj;
begin
  h:=New(PMeshObj,init(paramdata.pos,NeueSzene,pfad));
  if h<>nil then begin
    h^.paramdata:=paramdata;
    Objektcollection^.Losche(h^.mesh^.x,h^.mesh^.y,h^.regnr);
    h^.mesh:=Objektcollection^.kopiere(mesh^.x,mesh^.y,regnr,h^.regnr);
    h^.pfad:=pfad;
  end;
  KopierDich:=h;
end;

procedure TMeshObj.Meshpressed(anr:integer);
var event:TEvent;
    o:TPoint;
    breite:byte;
    xn,yn,seite,_x1,_x2,_y1,_y2,xz,x1,yz,y1,x2,y2:integer;
    maxdist,fak:single;
begin
  Focus;
  Szene^.setobjekt(@self);
  Hidemouse;
  o:=MouseWhere;
  if MeshMenu<>nil then begin
    MeshMenu^.breite^.getdata(breite);
    dec(breite);
  end else breite:=0;
  repeat
    repeat
      getmouseevent(event);
    until event.what<>evnothing;
    if event.what and evmousemove>0 then begin
      seite:=breite div 2;
      xz:=anr div succ(mesh^.y);
      if odd(breite) then x2:=xz+succ(seite) else x2:=xz+seite;
      if x2>mesh^.x then x2:=mesh^.x;
      x1:=xz-seite;
      if x1<0 then x1:=0;
      yz:=anr mod succ(mesh^.y);
      if odd(breite) then y2:=yz+succ(seite) else y2:=yz+seite;
      if y2>mesh^.y then y2:=mesh^.y;
      y1:=yz-seite;
      if y1<0 then y1:=0;

      _x1:=pred(x1);
      if _x1<0 then _x1:=0;
      _y1:=pred(y1);
      if _y1<0 then _y1:=0;
      _x2:=succ(x2);
      if _x2>mesh^.x then _x2:=mesh^.x;
      _y2:=succ(y2);
      if _y2>mesh^.y then _y2:=mesh^.y;
      DrawPartMesh(_x1,_y1,_x2,_y2,true);

      if odd(breite) then maxdist:=sqrt(2)*(seite+2)
      else maxdist:=sqrt(2)*succ(seite);
      for xn:=x1 to x2 do for yn:=y1 to y2 do with mesh^.pointat(xn,yn)^ do begin
        fak:=(maxdist-sqrt(sqr(xn-xz)+sqr(yn-yz)))/maxdist;
        y:=y-(o.y-event.where.y)/300*fak;
        if mouseButtons and 2>0 then begin
          z:=z-(o.x-event.where.x)/300*fak;
        end else begin
          x:=x+(o.x-event.where.x)/300*fak;
        end;
      end;
      maussetpos(o.x,o.y);

      DrawPartMesh(_x1,_y1,_x2,_y2,false);

    end;
  until Mousebuttons=0;
  szene^.gesichert:=false;
  ShowMouse;
end;

procedure TMeshObj.SetParam(AData:TData);
begin
  T3DView.SetParam(AData);
  Paramdata.darstellung:=paramdata.darstellung or dsmeshecken;
end;

function TMeshObj.MeshNeuErlaubt:boolean;
begin
  MeshNeuErlaubt:=false;
end;

constructor TLicht.Init(var pos: T3DRect;aszene:PSzeneAbstract;Art:word;
       AFarbe:TRGB;
       Ac1,Ac2,Aexponent,Awinkel:single);
begin
  case art of
    spot:name:='Spot';
    Lampe:name:='Glhlampe';
    Sonne:name:='Sonnenlicht';
  end;
  T3DView.Init(pos,aszene,4,4,Name);
  Helpctx:=cmLicht;
  with LichtDaten do begin
    LichtArt:=Art;
    Farbe:=AFarbe;
    c1:=Ac1;
    c2:=Ac2;
    exponent:=Aexponent;
    winkel:=Awinkel;
  end;
  nr:=obLicht+(maxLicht shl 6);
  inc(maxLicht);
end;

function TLicht.RegNr:Word;
begin
  RegNr:=nr;
end;

function TLicht.CalcObjekt:Boolean;
var p:T3DPoint;
    a,t:byte;
    ch,dc,ds,st,ct,maxhohe,maxbreite:real;
begin
  CalcObjekt:=true;
  maxhohe:=sin(Lichtdaten.winkel/360*pi);
  if maxhohe<>0 then begin
    maxhohe:=cos(Lichtdaten.winkel/360*pi)/maxhohe;
    if maxhohe>1 then begin
      maxbreite:=1/maxhohe;
      maxhohe:=1;
    end else maxbreite:=1;
  end else begin
    maxhohe:=1;
    maxbreite:=0.001;
  end;
  mesh^.Erzeuger:=nr;
  dc:=cos(2*PI/mesh^.x); ds:=sqrt(1-dc*dc);
  for t:=0 to mesh^.y do with p do begin
    y:=(t/mesh^.y-1)*maxhohe;
    ct:=(t/mesh^.y-1)*maxbreite;st:=0;
    for a:=0 to mesh^.x do begin
      p.x:=ct; p.z:=st;
      mesh^.putin(a,t,p);
      ch:=ct;
      ct:=ct*dc-st*ds;
      st:=st*dc+ch*ds;
    end;
  end;
end;

procedure TLicht.sichern(var f:text);
begin
  {Lichter werden nicht hiermit gesichert}
end;

function TLicht.sichereLicht(var f:text):boolean;
var Ort,Richtung:T3DPoint;
    path:string;
begin
  with Lichtdaten do begin
    SichereLicht:=true;
    case LichtArt of
      Sonne:write(f,'Sonnenlicht ');
      Lampe:write(f,'Glhlampe ');
      Spot:write(f,'Spot ');
    end;
    write(f,farbe.r:5:2,' ',farbe.g:5:2,' ',farbe.b:5:2,' ');
    P3DGroup(owner)^.CorrectMC_WC;
    MulMC_WC(OC_MC);
    CalcOrtRichtung(Ort,Richtung);
    if LichtArt<>Lampe then write(f,Richtung.x:5:2,' ',Richtung.y:5:2,' ',Richtung.z:5:2,' ');
    if LichtArt<>Sonne then write(f,Ort.x:5:2,' ',Ort.y:5:2,' ',Ort.z:5:2,' ',c1:5:2,' ',c2:5:2,' ');
    if LichtArt=Spot then write(f,Exponent:5:2,' ',Winkel:5:2,' ');
    P3DGroup(owner)^.getpfad(path);
    with paramdata do writeln(f,';'+path+name+' ',
       pos.t.x:3:2,' ',pos.t.y:3:2,' ',pos.t.z:3:2,' ',
       pos.r.x:3:2,' ',pos.r.y:3:2,' ',pos.r.z:3:2);
  end;
  sichereLicht:=true;
end;

function TLicht.ObjektDialog(pfad:pathstr;hohe:byte):PObjektParameterDialog;
var h:PObjektParameterDialog;
    r:Trect;
    hview:PView;

  procedure farbe(x,ho:word);
  var r:trect;
  begin
    r.assign(x,ho+25,x+80,ho+55);
    hview:=new(PFarbRegler,init(r));
    h^.insert(hview);
    r.assign(x,ho,x+80,ho+14);
    h^.insert(new(PLabel,init(r,'~F~arbe',hview)));
    r.assign(x,ho+15,x+80,ho+24);
    h^.insert(new(PMischFarbe,init(r)));
  end;

  procedure abschwachung(x,ho:word);
  var r:trect;
  begin
    r.assign(x,ho,x+90,ho+14);
    h^.insert(new(PLabel,init(r,'A~b~schwchung',zahl(h,'C~1~',x,ho+15,1,2,0,1,TypSingle))));
    zahl(h,'C~2~',x,ho+30,1,2,0,1,TypSingle);
  end;

  function zahlunten(h:PDialog;s:pathstr;x,ho:word;a,b:byte;min,max:single):Pinputzahl;
  var hzahl:PInputZahl;
      r:Trect;
  begin
    with h^ do begin
      r.assign(x,ho+10,x+60,ho+25);
      hzahl:=new(PInputZahl,init(r,typsingle,a,b,min,max));
      insert(hzahl);
      r.assign(x,ho,x+succ(cstrlen(s))*8,ho+10);
      insert(new(PLabel,init(r,s,hzahl)));
    end;
    zahlunten:=hzahl;
  end;

begin
  r.assign(0,0,350,hohe*10);
  new(h,init(r,pfad));
  with h^ do begin
    options:=options or ofcentered;
    r.assign(20,30,330,45);
    hview:=new(PRadioButtons,init(r,NewSItem('~S~onnenlicht',NewSItem('G~l~hlampe',NewSItem('S~p~ot',nil)))));
    insert(hview);
    r.assign(20,20,330,35);
    insert(new(Plabel,init(r,'~A~rt der Lichtquelle',hview)));
    Farbe(20,55);
    Abschwachung(150,55);
    zahlunten(h,'~E~xponent',250,55,1,2,0,30);
    zahlunten(h,'~W~inkel  ',250,85,1,2,0,180);
    r.assign(20,130,100,150);
    Insert(new(PButton,init(r,'~O~k',cmOk,bfdefault)));
    r.assign(120,130,200,150);
    Insert(new(PButton,init(r,'~C~ancel',cmCancel,bfnormal)));
  end;
  ObjektDialog:=h;
end;

function TLicht.ExecObjektDialog(Hpara:PParamData):boolean;
var hwinkel:single;
begin
  hwinkel:=lichtdaten.winkel;
  ExecDialog(Objektdialog('Licht Eigenschaften',17),@LichtDaten);
  if hwinkel<>lichtdaten.winkel then begin
    meshNeu;
    ExecObjektDialog:=true;
  end else ExecObjektDialog:=false;
  if (name='Glhlampe') or (name='Spot') or (name='Sonnenlicht') then begin
    case Lichtdaten.LichtArt of
      Sonne:name:='Sonnenlicht';
      Lampe:name:='Glhlampe';
      Spot:name:='Spot';
    end;
    Szene^.SetObjekt(@self);
  end;
end;

end.