unit Uobtfast;
interface
uses dos,U3DViews,UUtils,BufFile;

function loadobjekt(name:string;daten:byte;Mesh:PMesh;var param:TParamdata):byte;
function saveobjekt(name:string;daten:byte;Mesh:PMesh):byte;

const xdat=1;
      ydat=2;
      zdat=4;
      nrmdat=8;
      texturdat=16;
      materialdat=32;
      realdat=64;
      sichtdat=128;
implementation

function loadobjekt(name:string;daten:byte;Mesh:PMesh;var param:TParamdata):byte;
type surfacepropertytyp=record
                          ka,kd,ks,oe:single;os,od:Trgb;
                          alpha:single;
                        end;
var gelesen,dateidaten,maxxdaten,maxydaten:byte;
    realdaten:boolean;
    surface:surfacepropertytyp;
    hilf:shortint;
    x,y,hilfb:byte;
    dir:dirstr;
    ext:extstr;
    Buf:PFileBuf;
begin
  gelesen:=0;
  new(buf,reset(name,2,10000));
  Buf^.Read(dateidaten,1);
  Buf^.Read(maxxdaten,1);
  Buf^.Read(maxydaten,1);
  if (mesh^.x<>maxxdaten) or (mesh^.y<>maxydaten)
  then mesh^.changesize(maxxdaten,maxydaten);
  param.x:=maxxdaten;
  param.y:=maxydaten;
  Buf^.Seek(Buf^.FilePos+3*sizeof(single));
  realdaten:=(dateidaten and realdat)>0;
  if ((dateidaten and xdat)>0) then begin
    if ((daten and xdat)>0) then begin
      gelesen:=gelesen or xdat;
      for x:=0 to maxxdaten do
      for y:=0 to maxydaten do
      if realdaten then
         Buf^.Read(Mesh^.PointAt(x,y)^.x,sizeof(single))
      else begin
        Buf^.Read(hilf,1);
        Mesh^.PointAt(x,y)^.x:=hilf/255;
      end
    end else if realdaten then
      Buf^.Seek(Buf^.FilePos+sizeof(single)*succ(maxxdaten)*succ(maxydaten))
    else Buf^.Seek(Buf^.FilePos+succ(maxxdaten)*succ(maxydaten));
  end;
  if ((dateidaten and ydat)>0) then begin
    if ((daten and ydat)>0) then begin
      gelesen:=gelesen or ydat;
      for x:=0 to maxxdaten do
      for y:=0 to maxydaten do
      if realdaten then
        Buf^.Read(Mesh^.PointAt(x,y)^.y,sizeof(single))
      else begin
        Buf^.Read(hilf,1);
        Mesh^.PointAt(x,y)^.y:=hilf/255;
      end
    end else if realdaten then
      Buf^.Seek(Buf^.FilePos+2*sizeof(single)*succ(maxxdaten)*succ(maxydaten))
    else Buf^.Seek(Buf^.FilePos+2*succ(maxxdaten)*succ(maxydaten));
  end;
  if ((dateidaten and zdat)>0) then begin
    if ((daten and zdat)>0) then begin
      gelesen:=gelesen or zdat;
      for x:=0 to maxxdaten do
      for y:=0 to maxydaten do
      if realdaten then
        Buf^.Read(Mesh^.PointAt(x,y)^.z,sizeof(single))
      else begin
        Buf^.Read(hilf,1);
        Mesh^.PointAt(x,y)^.z:=hilf/255;
      end
    end else if realdaten then
     Buf^.Seek(Buf^.FilePos+3*sizeof(single)*succ(maxxdaten)*succ(maxydaten))
    else Buf^.Seek(Buf^.FilePos+3*succ(maxxdaten)*succ(maxydaten));
  end;
  if ((dateidaten and nrmdat)>0) then begin
    if realdaten then
      Buf^.Seek(Buf^.FilePos+6*sizeof(single)*succ(maxxdaten)*succ(maxydaten))
    else Buf^.Seek(Buf^.FilePos+6*succ(maxxdaten)*succ(maxydaten));
  end;
  if ((dateidaten and texturdat)>0) then begin
    if ((daten and texturdat)>0) then begin
      fsplit(name,dir,param.textur,ext);
      gelesen:=gelesen or texturdat;
    end;
    Buf^.Seek(Buf^.FilePos+3*succ(maxxdaten)*succ(maxydaten));
  end;
  if ((dateidaten and sichtdat)>0) then
   if ((daten and sichtdat)=0) then
   Buf^.Seek(Buf^.FilePos+((succ(maxxdaten)*succ(maxydaten)+7) div 8));
  if ((dateidaten and materialdat)>0) then
   if ((daten and materialdat)>0) then begin
     gelesen:=gelesen or materialdat;
     Buf^.Read(surface,sizeof(surfacepropertytyp));
     fsplit(name,dir,param.MaterialName,ext);
     with surface,param do begin
       Material.ka:=ka;
       Material.kd:=kd;
       Material.ks:=ks;
       Material.alpha:=alpha;
       Material.oe:=oe;
       Material.od:=od;
       Material.os:=os;
     end;
   end;
   dispose(Buf,Close);
  loadobjekt:=gelesen;
end;

function saveobjekt(name:string;daten:byte;Mesh:PMesh):byte;
var geschrieben:byte;
    dirinfo:searchrec;
    hilf:shortint;
    x,y,hilfb:byte;
    dir:dirstr;
    ext:extstr;
    s:single;
    buf:PFileBuf;
begin
  fsplit(name,dir,name,ext);
  name:=dir+name;
  geschrieben:=0;
  new(buf,rewrite(name+'.OBT',succ(Mesh^.x)*succ(Mesh^.y)*sizeof(s)*3+100,2000));
  daten:=daten or realdat;
  buf^.write(daten,1);
  buf^.write(Mesh^.x,1);
  buf^.write(Mesh^.y,1);
  s:=1;
  for x:=1 to 3 do buf^.write(s,sizeof(s));
  if ((daten and xdat)>0) then begin
    for x:=0 to Mesh^.x do
     for y:=0 to Mesh^.y do
      buf^.write(Mesh^.PointAt(x,y)^.x,sizeof(single));
    geschrieben:=geschrieben or xdat;
  end;
  if ((daten and ydat)>0) then begin
    for x:=0 to Mesh^.x do
     for y:=0 to Mesh^.y do
      buf^.write(Mesh^.PointAt(x,y)^.y,sizeof(single));
    geschrieben:=geschrieben or ydat;
  end;
  if ((daten and zdat)>0) then begin
    for x:=0 to Mesh^.x do
     for y:=0 to Mesh^.y do
      buf^.write(Mesh^.PointAt(x,y)^.z,sizeof(single));
    geschrieben:=geschrieben or zdat;
  end;
  dispose(buf,close);
  saveobjekt:=geschrieben;
end;

end.