program PrWizCAD;
uses dos,Memory,Objects,Drivers,TGDriver,TGViews,TGMenus,TGApp,TGdialog,
     tgStdDlg,tgMsgBox,U3DViews,USzene,WizInfo,UBlockDlg{,UWizJoy},UUtils,
     exits,errorhdl{,sichern},WizView;
const cmOpen=2000;
      cmChangeDir=2001;
      cmNeu=2002;
      cmVerschiebenXYZ=2100;
      cmDrehenXYZ=2101;
      cmDehnenXYZ=2102;
      cmOptionen=2103;
      cmChangeObj=2104;
      cmDarstMenu=2105;
      cmSpeicher=2106;
      cmAbout=2107;
      cmRefresh=2108;
      cmMeshMenu=2109;
      cmSaveOptions= 2110;
      cmSichereAlle= 2111;

      cmMalebild   = 2201;
      cmumriss  =    2202;
      cmEditor  =    2203;
      cmshowpick =   2204;
      cmmaterial =   2205;
      cmpacken =     2206;
      cmfunktion =   2207;
      cmtrans =      2208;
      cmradio =      2209;
      cmanimation=   2210;

      DosCode:byte=0;

{schwarz}    { 0 }
{grau0}      { 1 }
{grau1}      { 2 }
{grau2}      { 3 }
{rot}        { 4 }
{grn}       { 5 }
{blau}       { 6 }
{cyan}       { 7 }
{gelb}       { 8 }
{magenta}    { 9 }
{dunkelgrn} { A }
             { B }
             { C }
             { D }
{MischFarbe} { E }

{wei}       { F }

  CWizColor = CColor+
      {79}  #$4a#$68{#$2C#$EE};{Rot Grn Blau fr x,y,z der Koordinatenachsen(ber Xor mit blau verknpft)}
             {4A  88 xor 66}
  CWizBlackWhite = CBlackWhite+
      {79}  #0;
  CWizMonochrome = CMonochrome+
      {79}  #0;

type TWizArt = object(TApplication)
       procedure initMenuBar; virtual;
       procedure HandleEvent(var Event: TEvent); virtual;
       procedure InitStatusLine; virtual;
       function getpalette:PPalette; virtual;
       procedure OutOfMemory; virtual;
       procedure RestoreDesktop;
       procedure SaveDesktop;
       procedure run; virtual;
       procedure error(s:string);
     end;

     POptionDialog=^TOptionDialog;
     TOptionDialog = object(TDialog)
       constructor init;
       procedure Handleevent(var event:TEvent); virtual;
     end;

     PAboutDialog=^TAboutDialog;
     TAboutDialog = object(TDialog)
       constructor init;
     end;

     PDarstMenu=^TDarstMenu;
     TDarstMenu = object(TDialog)
       constructor init(var Bounds:TRect);
       destructor done; virtual;
     end;

constructor TOptionDialog.Init;
var b:PView;
    r:TRect;
begin
  r.assign(0,0,300,200);
  TDialog.init(r,'Optionen');
  options:=options or ofcentered;

  r.assign(10,28,290,48);
  b:=New(PRadioButtons,init(r,newsItem('~A~usfhrlich',newsitem('~K~urz',nil))));
  Insert(b);
  r.assign(10,18,290,28);
  insert(new(PLabel,init(r,'~D~ateiformat beim abspeichern:',b)));
{
  r.assign(10,68,290,88);
  b:=New(PRadioButtons,init(r,newsItem('A~u~sfhrlich',newsitem('~S~chnell',nil))));
  Insert(b);
  r.assign(10,58,290,68);
  insert(new(PLabel,init(r,'A~l~gorithmus beim laden:',b)));
}
  r.assign(10,68,290,88);
  b:=New(PRadioButtons,init(r,newsItem('~~berschreiben',newsitem('~I~nvertieren',nil))));
  Insert(b);
  r.assign(10,58,290,68);
  insert(new(PLabel,init(r,'Da~r~stellung:',b)));

  r.assign(10,108,290,128);
  b:=New(PCheckBoxes,init(r,newsItem('S~z~enen',newsitem('~B~enutzeroberflche',nil))));
  Insert(b);
  r.assign(10,98,290,108);
  insert(new(PLabel,init(r,'Au~t~omatisch abspeichern:',b)));

  r.assign(10,145,290,157);
  b:=New(PInputLine,init(r,pred(sizeof(WizOpt.Verzeichnis))));
  Insert(b);
  r.assign(10,135,290,145);
  insert(new(PLabel,init(r,'Sz~e~nen Verzeichnis:',b)));

  r.assign(10,165,90,185);
  Insert(new(PButton,init(r,'~O~k',cmOk,bfnormal)));
  r.assign(100,165,190,185);
  Insert(new(PButton,init(r,'~C~ancel',cmCancel,bfnormal)));
  r.assign(200,165,290,185);
  Insert(new(PButton,init(r,'Si~c~hern',cmsaveOptions,bfdefault)));
end;

procedure TOptionDialog.Handleevent(var event:TEvent);
var f:file;
begin
  TDialog.handleevent(event);
  if (event.what=evcommand) and (event.command=cmSaveOptions) then begin
    if infoda then begin
      GetData(WizOpt);
      with wizopt do begin
        info^.speichermodus:=speichermodus or smInfoDa {or (lademodus shl 4)};
        info^.anzeigemodus:=anzeigemodus;
        info^.Autosave:=Autosave;
        info^.Verzeichnis:=Verzeichnis;
      end;
      assign(f,'WIZART.PCK');
      rewrite(f);
      blockwrite(f,WizOpt,SizeOf(WizOpt));
      system.close(f);
    end;
  end;
end;

constructor TDarstMenu.init(var Bounds:TRect);
var r:TRect;
    b:PView;
begin
  TDialog.Init(Bounds,'Anzeige');
  getextent(bounds);
  r.assign(8,20,bounds.b.x-8,32);
  b:=new(PButton,init(r,'~M~esh an',cms3Dan,bfdefault));
  insert(b);
  b^.options:=b^.options and (not ofselectable);
  r.move(0,14);
  b:=new(PButton,init(r,'~K~oords an',cmsXYZan,bfnormal));
  insert(b);
  b^.options:=b^.options and (not ofselectable);
  r.move(0,14);
  b:=new(PButton,init(r,'M~e~sh aus',cms3Daus,bfnormal));
  insert(b);
  b^.options:=b^.options and (not ofselectable);
  r.move(0,14);
  b:=new(PButton,init(r,'K~o~ords aus',cmsXYZaus,bfnormal));
  insert(b);
  b^.options:=b^.options and (not ofselectable);
  r.move(0,14);
  b:=new(PButton,init(r,'~G~ruppieren',cmGruppieren,bfnormal));
  insert(b);
  b^.options:=b^.options and (not ofselectable);
  r.move(0,14);
  b:=new(PButton,init(r,'~E~ntgrupp',cmEntGruppieren,bfnormal));
  insert(b);
  b^.options:=b^.options and (not ofselectable);
  r.move(0,14);
  b:=new(PButton,init(r,'~R~ev an',cmRevan,bfnormal));
  insert(b);
  b^.options:=b^.options and (not ofselectable);
  r.move(0,14);
  b:=new(PButton,init(r,'Re~v~ aus',cmRevaus,bfnormal));
  insert(b);
  b^.options:=b^.options and (not ofselectable);
end;

destructor TDarstMenu.done;
var r:trect;
begin
  if correctViewPort then begin
    getextent(r);
    clearfeld(r.a.x,r.a.y,r.b.x,r.b.y,$2222);
  end;
  setstate(sfvisible,false);
  TDialog.Done;
end;

procedure TWizArt.OutOfMemory;
begin
  MessageBox('Nicht gengend Hauptspeicher'#13'fr diese Operation.',
    nil, mfError + mfOkButton);
end;

function TWizArt.getpalette:PPalette;
const
  P: array[apColor..apMonochrome] of string[Length(CWizColor)] =
    (CWizColor, CWizBlackWhite, CWizMonochrome);
begin
  GetPalette := @P[AppPalette];
end;

procedure TWizArt.initMenuBar;
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 12;
  MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu('~~', hcNoContext, NewMenu(
      NewItem('~I~nfo...', '', kbNoKey, cmAbout, hcNoContext,
      NewItem('~R~efresh', '', kbNoKey, cmRefresh, hcNoContext,
      nil))),
    NewSubMenu('~D~atei', hcNoContext, NewMenu(
      NewItem('~~ffnen...', 'F3', kbF3, cmOpen, hcNoContext,
      NewItem('~N~eu', '', kbNoKey, cmNeu, hcNoContext,
      NewItem('~S~ichern', 'F2', kbF2, cmSave, hcNoContext,
      NewItem('S~i~chern als...', '', kbNoKey, cmSaveAs, hcNoContext,
      NewItem('~A~lle Sichern', '', kbNoKey, cmSichereAlle, hcNoContext,
      NewLine(
      NewItem('~V~erzeichnis...', '', kbNoKey, cmChangeDir, hcNoContext,
      NewItem('E~n~de', 'Alt-X', kbAltX, cmQuit, hcNoContext,
      nil))))))))),
    NewSubMenu('~O~bjekte', hcNoContext, NewMenu(
      NewItem('~K~ugel', '', kbNoKey, cmKugel, hcNoContext,
      NewItem('~T~orus', '', kbNoKey, cmTorus, hcNoContext,
      NewItem('~E~bene', '', kbNoKey, cmEbene, hcNoContext,
      NewItem('~S~ule', '', kbNoKey, cmSaule, hcNoContext,
      NewItem('~D~ose', '', kbNoKey, cmDose, hcNoContext,
      NewItem('D~r~eieck', '', kbNoKey, cmDreieck, hcNoContext,
      NewItem('~V~iereck', '', kbNoKey, cmViereck, hcNoContext,
      NewItem('~R~otationskrper...', '', kbNoKey, cmRotationskoerper, hcNoContext,
      NewItem('~Z~iehkrper...', '', kbNoKey, cmZiehkoerper, hcNoContext,
      NewItem('~O~bjekt...', '', kbNoKey, cmObjekt, hcNoContext,
      NewItem('~M~esh...', '', kbNoKey, cmMesh, hcNoContext,
      NewLine(
      NewItem('~L~icht', '', kbNoKey, cmLicht, hcNoContext,
      nil)))))))))))))),
    NewSubMenu('~E~ditieren', hcNoContext, NewMenu(
      NewItem('~V~erschieben XYZ', 'F5', kbF5, cmVerschiebenXYZ, hcNoContext,
      NewItem('~D~rehen XYZ', 'F6', kbF6, cmDrehenXYZ, hcNoContext,
      NewItem('D~e~hnen XYZ', 'F7', kbF7, cmDehnenXYZ, hcNoContext,
      NewItem('~M~esh bewegen', 'F9', kbF9, cmMeshMenu, hcNoContext,
      NewLine(
      NewItem('~O~bjektparameter...', '', kbNoKey, cmObjektParameter, hcNoContext,
      NewItem('~S~zenenparameter...', '', kbNoKey, cmSzenenParameter, hcNoContext,
      NewLine(
      NewItem('~G~ruppenbefehle...', '', kbNoKey, cmChangeObj, hcNoContext,
      NewLine(
      NewItem('G~r~uppe auf E', '', kbNoKey, cmGruppeE, hcNoContext,
      NewItem('Gr~u~ppe auf Rev', '', kbNoKey, cmGruppeAufRev, hcNoContext,
      NewItem('Re~v~ auf Objekt', '', kbNoKey, cmRevAufObj, hcNoContext,
      NewLine(
      NewItem('~L~schen', '', kbNoKey, cmLoeschen, hcNoContext,
      nil)))))))))))))))),
    NewSubMenu('D~a~rstellung', hcNoContext, NewMenu(
      NewItem('~M~esh an', '', kbNoKey, cms3Dan, hcNoContext,
      NewItem('M~e~sh aus', '', kbNoKey, cms3Daus, hcNoContext,
      NewItem('~K~oords an', '', kbNoKey, cmsXYZan, hcNoContext,
      NewItem('K~o~ords aus', '', kbNoKey, cmsXYZaus, hcNoContext,
      NewItem('~G~ruppieren', 'F4', kbF4, cmGruppieren, hcNoContext,
      NewItem('~E~ntgruppieren', 'F8', kbF8, cmEntGruppieren, hcNoContext,
      NewItem('~R~ev an', '', kbNoKey, cmRevAn, hcNoContext,
      NewItem('Re~v~ aus', '', kbNoKey, cmRevAus, hcNoContext,
      NewItem('Me~n~u','',kbNoKey,cmDarstMenu,hcNoContext,
      nil)))))))))),
    NewSubMenu('~O~ptionen', hcNoContext, NewMenu(
      NewItem('~O~ptionen...', '', kbNoKey, cmOptionen, hcNoContext,
      NewItem('~S~peicher', '', kbNoKey, cmSpeicher, hcNoContext,
      nil))),
    NewSubMenu('~B~efehle', hcNoContext, NewMenu(
      NewItem('~B~ild berechnen', '', kbNoKey, cmMalebild , hcNoContext,
      NewItem('CAD fr ~R~otationskrper', '', kbNoKey, cmumriss, hcNoContext,
      NewItem('~E~ditor',  '', kbNoKey,cmEditor , hcNoContext,
      NewItem('Bild ~A~nzeigen',  '', kbNoKey,cmshowpick , hcNoContext,
      NewItem('~M~aterial Editor',  '', kbNoKey,cmmaterial , hcNoContext,
      NewItem('~P~acken',  '', kbNoKey, cmpacken, hcNoContext,
      NewItem('~3~D Funktionen',  '', kbNoKey,cmfunktion , hcNoContext,
      NewItem('~~bersetze .WIZ -> .SCN',  '', kbNoKey,cmtrans , hcNoContext,
      NewItem('Radio~s~ity',  '', kbNoKey,cmradio , hcNoContext,
      NewItem('A~n~imation',  '', kbNoKey,cmanimation , hcNoContext,
      nil))))))))))),
    nil))))))))));
end;

procedure TWizArt.InitStatusLine;
var
  R: TRect;

  function NewStatusKeyRetText(AText: String; AKeyCode: Word;
    ACommand: Word; var TextZeiger:PPString;ANext: PStatusItem): PStatusItem;
  var StatusItem:PStatusItem;
  begin
    new(StatusItem);
    with StatusItem^ do begin
      Text:=newstr(AText);
      TextZeiger:=@Text;
      KeyCode:=AKeyCode;
      Command:=ACommand;
      Next:=ANext;
    end;
    newStatusKeyRetText:=StatusItem;
  end;

begin
  GetExtent(R);
  R.A.Y := R.B.Y - 12;
  New(StatusLine, Init(R,
    NewStatusDef(0, 1000,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('~F2~ Sichern', kbF2, cmSave,
      NewStatusKey('~F3~ ffnen', kbF3, cmOpen,
      NewStatusKey('~F10~ Menu', kbF10, cmMenu,
      NewStatusKey('', kbAltF3, cmClose,
      NewStatusKey('', kbF6, cmNext, nil)))))),
    NewStatusDef(cmKugel, cmMesh,
      NewStatusKey('<', kbLeft, cmLastObj,
      NewStatusKey(#24, kbUp, cmUpObj,
      NewStatusKey('>', kbRight, cmNextObj,
      NewStatusKeyRetText('', kbEnter, cmBewege,ObjektText,
      NewStatusKey('~F5~ Verschieben', kbF5, cmVerschiebenXYZ,
      NewStatusKey('~F6~ Drehen', kbF6, cmDrehenXYZ,
      NewStatusKey('~F7~ Dehnen', kbF7, cmDehnenXYZ,
      NewStatusKey('', kbAltF3, cmClose,
      nil)))))))),
    NewStatusDef(hcGruppe, hcGruppe,
      NewStatusKey('<', kbLeft, cmLastObj,
      NewStatusKey(#25, kbDown, cmDownObj,
      NewStatusKey(#24, kbUp, cmUpObj,
      NewStatusKey('>', kbRight, cmNextObj,
      NewStatusKeyRetText('', kbEnter, cmBewege,GruppeText,
      NewStatusKey('~F4~ Gruppieren', kbF4, cmGruppieren,
      NewStatusKey('~F8~ EntGruppieren', kbF8, cmentGruppieren,
      NewStatusKey('', kbAltF3, cmClose,
      nil)))))))),
    NewStatusDef(hcWurzel, hcWurzel,
      NewStatusKey('<', kbLeft, cmLastObj,
      NewStatusKey(#25, kbDown, cmDownObj,
      NewStatusKey('>', kbRight, cmNextObj,
      NewStatusKeyRetText('', kbEnter, cmValid,WurzelText,
      NewStatusKey('~F2~ Sichern', kbF2, cmSave,
      NewStatusKey('~F3~ ffnen', kbF3, cmOpen,
      NewStatusKey('~F10~ Menu', kbF10, cmMenu,
      NewStatusKey('', kbAltF3, cmClose,
      nil)))))))),
    NewStatusDef(1050, $FFFF,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('~F2~ Sichern', kbf2, cmSave,
      NewStatusKey('~F3~ ffnen', kbF3, cmOpen,
      NewStatusKey('~F10~ Menu', kbF10, cmMenu,
      NewStatusKey('', kbAltF3, cmClose,
      NewStatusKey('', kbF6, cmNext, nil)))))),
    nil)))))));
end;

constructor TAboutDialog.init;
var r:TRect;
    n:byte;
Const s:String=
{#3'Programmiert von: Florian Schreck, 23.7.1993'+

           #13#13'Ausschlieliches Nutzungsrecht:'+
            #13'IDL Software GmbH, Darmstadt'+

         #13#13'Entgeltliche Weitergabe nicht erlaubt.'+
  #13'Verbreitung in Mailboxen und DF-Netzen nicht erlaubt.'}
#$13#$60#$82#$7F#$77#$82#$71#$7D#$7D#$79#$75#$82#$84#$30+
#$86#$7F#$7E#$4A#$30#$56#$7C#$7F#$82#$79#$71#$7E#$30#$63+
#$73#$78#$82#$75#$73#$7B#$3C#$30#$42#$43#$3E#$47#$3E#$41+
#$49#$49#$43#$1D#$1D#$51#$85#$83#$83#$73#$78#$7C#$79#$75+
#$F1#$7C#$79#$73#$78#$75#$83#$30#$5E#$85#$84#$8A#$85#$7E+
#$77#$83#$82#$75#$73#$78#$84#$4A#$1D#$59#$54#$5C#$30#$63+
#$7F#$76#$84#$87#$71#$82#$75#$30#$57#$7D#$72#$58#$3C#$30+
#$54#$71#$82#$7D#$83#$84#$71#$74#$84#$1D#$1D#$55#$7E#$84+
#$77#$75#$7C#$84#$7C#$79#$73#$78#$75#$30#$67#$75#$79#$84+
#$75#$82#$77#$71#$72#$75#$30#$7E#$79#$73#$78#$84#$30#$75+
#$82#$7C#$71#$85#$72#$84#$3E#$1D#$66#$75#$82#$72#$82#$75+
#$79#$84#$85#$7E#$77#$30#$79#$7E#$30#$5D#$71#$79#$7C#$72+
#$7F#$88#$75#$7E#$30#$85#$7E#$74#$30#$54#$56#$AA#$3D#$5E+
#$75#$84#$8A#$75#$7E#$30#$7E#$79#$73#$78#$84#$30#$75#$82+
#$7C#$71#$85#$72#$84#$3E;
begin
  r.assign(0,0,464,310);
  TDialog.init(r,'Information');
  options:=options or ofcentered;
  r.assign(50,30,415,180);
  insert(new(PPool,init(r)));
  r.assign(10,195,455,270);
  if s[1]=#$13 then for n:=1 to length(s) do dec(s[n],$10);
  insert(new(PStaticText,init(r,s)));
  r.assign(190,275,270,295);
  Insert(new(PButton,init(r,'~O~k',cmOk,bfnormal)));
end;

procedure TWizArt.HandleEvent(var Event: TEvent);
var myevent:boolean;

  procedure neueszene;
  begin
    DeskTop^.Insert(ValidView(New(PSzene, Init(AddSubGroups))));
  end;

  procedure VerschiebenXYZ;
  var r:TRect;
  begin
    r.assign(0,screenheight-340, 99,screenheight-27);
    DeskTop^.Insert(ValidView(New(PVerschiebe, Init(r))));
  end;

  procedure DehnenXYZ;
  var r:TRect;
  begin
    r.assign(0,screenheight-340, 99,screenheight-27);
    DeskTop^.Insert(ValidView(New(PDehne, Init(r))));
  end;

  procedure DrehenXYZ;
  var r:TRect;
  begin
    r.assign(0,screenheight-340, 99,screenheight-27);
    DeskTop^.Insert(ValidView(New(PDrehe, Init(r))));
  end;

  procedure DarstMenu;
  var r:TRect;
  begin
    r.assign(0,1, 99,screenheight-341);
    DeskTop^.Insert(ValidView(New(PDarstMenu, Init(r))));
  end;

  procedure MeshObjMenu;
  var r:TRect;
  begin
    r.assign(0,1, 99,60);
    DeskTop^.Insert(ValidView(New(PMeshObjMenu, Init(r))));
  end;

  procedure FileOpen;
  var
    FileName: FNameStr;
  begin
    FileName := '*.WIZ';
    if ExecDialog(New(PFileDialog, Init('*.WIZ', 'ffne ein Bild',
      '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then begin
      DeskTop^.Insert(ValidView(New(PSzene, Lade(FileName))));
    end;
  end;

  procedure ChangeDir;
  begin
    ExecDialog(New(PChDirDialog, Init(cdNormal, 0)), nil);
  end;

  procedure ChangeObj;
  var aktszene:pszene;
  begin
    aktszene:=message(desktop,evCommand,cmGetSzene,nil);
    if aktszene=nil then exit;
    ExecDialog(New(PBlockDialog, Init(aktszene)), @aktszene);
    if aktszene<>nil then begin
      if aktszene^.aktobjekt<>nil then begin
        aktszene^.aktobjekt^.focus;
      end else aktszene^.focus;
    end;
  end;

  procedure Optionen;
  begin
    ExecDialog(New(POptionDialog, Init), @WizOpt);
  end;

  procedure Speicher;
  var s:String;
      buf:String[7];
  begin
    str(MemAvail,buf);
    s:='MemAvail: '+buf+#13#13+'MaxAvail: ';
    str(MaxAvail,buf);
    s:=s+buf;
    MessageBox(s,nil, mfInformation + mfOkButton);
  end;


  procedure Refresh;
  begin
    InitScreen;
    Draw;
  end;

begin
  TApplication.Handleevent(event);
  if event.what=evcommand then begin
    myevent:=true;
    case event.command of
      cmSichereAlle:message(desktop,evbroadcast,cmSaveAll,nil);
      cmAbout:ExecDialog(New(PAboutDialog, Init), nil);
      cmRefresh:Refresh;
      cmNeu: neueszene;
      cmChangeDir: ChangeDir;
      cmChangeObj: ChangeObj;
      cmOpen: FileOpen;
      cmVerschiebenXYZ:VerschiebenXYZ;
      cmDrehenXYZ:DrehenXYZ;
      cmDehnenXYZ:DehnenXYZ;
      cmDarstMenu:DarstMenu;
      cmMeshMenu:MeshObjMenu;
      cmOptionen:Optionen;
      cmSpeicher:Speicher;
      cmValid:;
      cmmalebild..cmanimation: begin
        doscode:=event.command-2200;
        endmodal(cmquit);
      end;
      else myevent:=false;
    end;
    if myevent then clearevent(event) else
    write(^G);
  end;
end;

var WizArt:TWizArt;

procedure TWizArt.RestoreDeskTop;
var dir:dirstr;
    nam:namestr;
    ext:extstr;

  procedure getpickfile;
  var suche:searchrec;
      f:file;
  begin
    suche.name:='WIZART.PCK';
    findfirst(suche.name,anyfile,suche);
    if doserror=0 then begin
      assign(f,'WIZART.PCK');
      reset(f,1);
      blockread(f,WizOpt,Sizeof(wizOpt));
      close(f);
      if infoda then with wizopt do begin
        info^.speichermodus:=speichermodus or smInfoDa {or (lademodus shl 4)};
        info^.anzeigemodus:=anzeigemodus;
        info^.Autosave:=Autosave;
        info^.Verzeichnis:=Verzeichnis;
      end;
    end else ExecDialog(New(PAboutDialog, Init), nil);
  end;

begin
  if infoda then begin
    if getinfo<>'' then begin
      fsplit(getinfo,dir,nam,ext);
      if not gleich(nam,'NONAME') then
      DeskTop^.Insert(ValidView(New(PSzene, Lade(GetInfo))));
    end else getpickfile;
    if info^.speichermodus and smInfoDa >0 then begin
      with wizopt do begin
        speichermodus:=info^.speichermodus and (not smInfoDa);
        {lademodus:=info^.speichermodus shr 4;}
        anzeigemodus:=info^.anzeigemodus;
        Autosave:=info^.Autosave;
        Verzeichnis:=info^.Verzeichnis;
      end;
    end;
  end else getpickfile;
end;

procedure TWizArt.savedesktop;
var hilfszene:PSzene;
begin
  if InfoDa then begin
    hilfszene:=message(desktop,evcommand,cmGetSzene,nil);
    if (hilfszene<>nil) then setinfo(copy(hilfszene^.name,1,52))
    else setinfo('');
  end;
end;

Procedure TWizArt.Run;
begin
  repeat
    TProgram.Run;
  until message(desktop,evbroadcast,cmSaveAll,nil)=nil;
end;

procedure TWizArt.error(s:string);
begin
  MessageBox(s,nil, mfError + mfOkButton);
  message(desktop,evbroadcast,cmSaveAll,nil);
end;

var errcode:word;
    nr:string[4];
begin
  TypeOfTSzene:=TypeOf(TSzene);
  Randomize;
  WizArt.Init;
  WizArt.RestoreDeskTop;
  WizArt.State:=WizArt.State and not sffocused;

  seterrorcodes([200,201,205,206,207]);
  errcode:=setexit(cpupointer);
  case errcode of
    200:wizart.error('Division durch Null');
    201:wizart.error('Bereichs-berlauf');
    205:wizart.error('Fliekomma-berlauf');
    206:wizart.error('Fliekomma-Unterlauf');
    207:wizart.error('Fliekomma-Fehler');
    0:;
    else begin
      str(errcode:4,nr);
      wizart.error('Fehler '+nr+' aufgetreten');
    end;
  end;

  WizArt.Run;
  WizArt.SaveDeskTop;
  WizArt.PutState(sfvisible,false);
  WizArt.Done;
  Halt(DosCode);
end.